import numpy
from PIL import Image, ImageDraw


#%%  Function that actually draws the circle at a given coordinate with given radius and colour
def CircThis(x, y, r, colour):
    
    x0 = x - r
    y0 = y - r
    x1 = x + r - 1
    y1 = y + r - 1
    
    draw.ellipse((x0,y0,x1,y1), fill=(colour))
#%%   Defines array size, spacing, hole sizes and hole colour


radius = 100
spacing = 430    ## spacing must be >= 3 radius to limit interference between adjacent beams for bright trap or >= 6a for dark traps
diskSize = 25400
N = 10

filterRadius = 500

clearHoles = True

if clearHoles:
    mask = 0
    holes = 255
else:
    mask = 255
    holes = 0 

arrayLength = radius *2* N + spacing * (N-1) #21620 (r = 10810)
#%%   Creates the Mask


img = Image.new(mode ="L", size = (diskSize, diskSize), color = (mask))
draw = ImageDraw.Draw(img)

if N%2 == 0:
    position = numpy.arange(-N/2,N/2+1,1)
else:    
    position = numpy.arange(-(N-1)/2, (N+1)/2, 1)
    
x = y = (position*(2*radius + spacing))+diskSize/2


for i in x:
    for iy in y:

        CircThis(i, iy, radius, holes)

img2 = Image.new(mode ="L", size = (diskSize, diskSize), color = (mask))
draw = ImageDraw.Draw(img2)

CircThis(diskSize/2, diskSize/2, filterRadius, 255)


img.show()
img2.show()

img.save("Mask.BMP", format="BMP")
img2.save("Filter.BMP", format="BMP")
#%%
