(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16239,        411]
NotebookOptionsPosition[     14012,        369]
NotebookOutlinePosition[     14413,        385]
CellTagsIndexPosition[     14370,        382]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "=", 
     RowBox[{
      RowBox[{"Entity", "[", 
       RowBox[{"\"\<PhysicalConstant\>\"", ",", "\"\<PlanckConstant\>\""}], 
       "]"}], "[", "\"\<Value\>\"", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"c", "=", 
     RowBox[{
      RowBox[{"Entity", "[", 
       RowBox[{"\"\<PhysicalConstant\>\"", ",", "\"\<SpeedOfLight\>\""}], 
       "]"}], "[", "\"\<Value\>\"", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Lambda]", " ", "=", " ", 
     RowBox[{"Quantity", "[", 
      RowBox[{"632.8", ",", "\"\<Nanometers\>\""}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"For", " ", "HeNe", " ", "Laser"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"f", " ", "=", " ", 
     RowBox[{"UnitConvert", "[", 
      RowBox[{
       FractionBox["c", "\[Lambda]"], ",", "\"\<Hertz\>\""}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"EoP", "=", 
    RowBox[{"UnitConvert", "[", 
     RowBox[{
      RowBox[{"h", " ", "*", "f"}], ",", "\"\<Joules\>\""}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.9023180218349886`*^9, 3.9023180980951185`*^9}, {
  3.9023182142518144`*^9, 3.9023182675786943`*^9}, {3.9023183650415134`*^9, 
  3.902318398864671*^9}, {3.9023184737258377`*^9, 3.9023184748240604`*^9}, {
  3.902318721953455*^9, 3.9023187293797407`*^9}, {3.902318825321519*^9, 
  3.902318826914566*^9}, {3.9023192198544035`*^9, 3.902319265408033*^9}, {
  3.902319300046208*^9, 
  3.9023193079099135`*^9}},ExpressionUUID->"e8090b34-ea51-4935-9f55-\
5405ea3d1092"],

Cell[BoxData[
 TemplateBox[{"3.1391369423971695`*^-19", "\"J\"", "joules", "\"Joules\""},
  "Quantity"]], "Output",
 CellChangeTimes->{
  3.902318073168466*^9, {3.902318247873094*^9, 3.9023182680706844`*^9}, {
   3.902318375849963*^9, 3.9023183993365145`*^9}, 3.902318475332466*^9, 
   3.902318594870905*^9, 3.902318729942092*^9, 3.9023188274544954`*^9, 
   3.902319222215207*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"0ca17b82-ab34-4300-81c5-bf03a141c657"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PmW", "[", "Power_", "]"}], ":=", 
  RowBox[{"Quantity", "[", 
   RowBox[{"Power", ",", "\"\<Milliwatts\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P\[Mu]W", "[", "Power_", "]"}], ":=", 
  RowBox[{"Quantity", "[", 
   RowBox[{"Power", ",", "\"\<Microwatts\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PnW", "[", "Power_", "]"}], ":=", 
  RowBox[{"Quantity", "[", 
   RowBox[{"Power", ",", "\"\<Nanowatts\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PhotonsPerSecond", "[", "Power_", "]"}], ":=", 
   RowBox[{"UnitConvert", "[", 
    RowBox[{"Divide", "[", 
     RowBox[{"Power", ",", "EoP"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CountPerSecond", "[", "ku01_", "]"}], ":=", 
  RowBox[{"ku01", "*", 
   RowBox[{"1000", "/", 
    RowBox[{"Quantity", "[", 
     RowBox[{"1", ",", "\"\<Seconds\>\""}], 
     "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MegacountPerSecond", "[", "ku01_", "]"}], ":=", 
  RowBox[{"ku01", "*", 
   RowBox[{"1000", "/", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["10", "6"], "*", 
      RowBox[{"Quantity", "[", 
       RowBox[{"1", ",", "\"\<Seconds\>\""}], "]"}]}], 
     ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CountPerMicrosecond", "[", "ku01_", "]"}], ":=", 
  RowBox[{"UnitConvert", "[", 
   RowBox[{
    RowBox[{"ku01", "*", 
     RowBox[{"1000", "/", 
      RowBox[{"Quantity", "[", 
       RowBox[{".01", ",", "\"\<Seconds\>\""}], "]"}]}]}], ",", 
    RowBox[{"1", "/", "\"\<Microseconds\>\""}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.9023182709940805`*^9, 3.90231835860821*^9}, {
   3.902318403774053*^9, 3.9023184182500505`*^9}, {3.9023184502138767`*^9, 
   3.9023185987410765`*^9}, {3.9023186921320367`*^9, 
   3.9023188052084093`*^9}, {3.902318876699789*^9, 3.9023189035966473`*^9}, {
   3.9023189426057158`*^9, 3.902318945595518*^9}, {3.902319325570136*^9, 
   3.902319427328803*^9}, {3.902319462179841*^9, 3.9023195981813517`*^9}, {
   3.9023211053684673`*^9, 3.902321152835536*^9}, 3.9023211891121187`*^9, {
   3.9023212215845227`*^9, 3.902321238353495*^9}, {3.9023212762552567`*^9, 
   3.9023212950415463`*^9}, {3.902321325754484*^9, 3.902321375743935*^9}, {
   3.9023216486148853`*^9, 3.902321703587889*^9}, {3.902323203556219*^9, 
   3.9023232045650854`*^9}, {3.9023235999621983`*^9, 3.9023236009602394`*^9}},
 CellLabel->
  "In[420]:=",ExpressionUUID->"30d37e42-02d8-478b-abac-380cc392f0b4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MegacountPerSecond", "[", "500", "]"}], "\[IndentingNewLine]", 
   RowBox[{"CountPerSecond", "[", "500", "]"}], "\[IndentingNewLine]", 
   RowBox[{"CountPerMicrosecond", "[", "500", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.902319429209197*^9, 3.902319450001878*^9}, {
  3.902319514411828*^9, 3.902319518989225*^9}},
 CellLabel->
  "In[231]:=",ExpressionUUID->"386a6dd6-e1a5-4b3c-beef-56b96b4a1216"],

Cell[BoxData[
 TemplateBox[{"50.`", 
   RowBox[{"\"per \"", "\[InvisibleSpace]", "\"second\""}], 
   "reciprocal seconds", 
   FractionBox["1", "\"Seconds\""]},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902319435709899*^9, 3.902319450743693*^9}, {
  3.9023195195932884`*^9, 3.9023196011590953`*^9}},
 CellLabel->
  "Out[231]=",ExpressionUUID->"66cd768c-a321-4f42-96c9-7563b881cfe9"],

Cell[BoxData[
 TemplateBox[{"5.`*^7", 
   RowBox[{"\"per \"", "\[InvisibleSpace]", "\"second\""}], 
   "reciprocal seconds", 
   FractionBox["1", "\"Seconds\""]},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902319435709899*^9, 3.902319450743693*^9}, {
  3.9023195195932884`*^9, 3.9023196011633325`*^9}},
 CellLabel->
  "Out[232]=",ExpressionUUID->"edffd2f0-ecc8-4edc-a3df-444a33f07191"],

Cell[BoxData[
 TemplateBox[{"50.`", 
   RowBox[{"\"/\"", "\[InvisibleSpace]", "\"\[Mu]s\""}], 
   "reciprocal microseconds", 
   FractionBox["1", "\"Microseconds\""]},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902319435709899*^9, 3.902319450743693*^9}, {
  3.9023195195932884`*^9, 3.9023196011679106`*^9}},
 CellLabel->
  "Out[233]=",ExpressionUUID->"550bbca2-ca1e-4631-851e-f051ec13cbfe"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Reduction", "[", 
   RowBox[{"Original_", ",", "Attenuated_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"Quantity", "[", 
      RowBox[{"Original", ",", "\"\<Microwatts\>\""}], "]"}], "/", 
     RowBox[{"Quantity", "[", 
      RowBox[{"Attenuated", ",", "\"\<Nanowatts\>\""}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Quantity", "[", 
      RowBox[{"2.5", ",", "\"\<Nanowatts\>\""}], "]"}], "/", 
     RowBox[{"Quantity", "[", 
      RowBox[{"82", ",", "\"\<Microwatts\>\""}], "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.9023201081784925`*^9, 3.902320132213703*^9}, {
   3.9023201693886952`*^9, 3.902320304716691*^9}, {3.9023203401877017`*^9, 
   3.9023204236147785`*^9}, {3.9023204888006306`*^9, 3.902320492605686*^9}, 
   3.9023205271118555`*^9, {3.9023205971308813`*^9, 3.9023206523450274`*^9}},
 CellLabel->
  "In[250]:=",ExpressionUUID->"cffe01c7-f1b5-486d-8852-404e9ba50bd0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"x", "=", 
    RowBox[{"Reduction", "[", 
     RowBox[{"91", ",", "2.7"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"91", "*", 
    RowBox[{"x", "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.9023203078881607`*^9, 3.902320326011664*^9}, 
   3.902320373222712*^9, {3.902320681730897*^9, 3.9023207617921567`*^9}},
 CellLabel->
  "In[366]:=",ExpressionUUID->"def8c2ea-cf1c-4914-9774-c800889c2d9c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"33703.7037037037`", ",", "0.00003048780487804878`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.9023203737489653`*^9, {3.9023206595082083`*^9, 3.902320759673579*^9}, 
   3.9023229719793186`*^9},
 CellLabel->
  "Out[366]=",ExpressionUUID->"1c3f9fd8-9b05-4ad0-a038-46209ec697c2"],

Cell[BoxData["0.002774390243902439`"], "Output",
 CellChangeTimes->{
  3.9023203737489653`*^9, {3.9023206595082083`*^9, 3.902320759673579*^9}, 
   3.90232297198332*^9},
 CellLabel->
  "Out[367]=",ExpressionUUID->"cbe08f06-bf0b-46fe-82a0-e3d4f184af07"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"CalculatedPower", ",", "MeasuredPower"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"reducedPower", "=", 
  RowBox[{"UnitConvert", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"P\[Mu]W", "[", ".135", "]"}], "*", 
     RowBox[{"x", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<Nanowatts\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"CalculatedPpS", "=", 
  RowBox[{
   RowBox[{"PpS", "[", "reducedPower", "]"}], "*", ".65"}]}]}], "Input",
 CellChangeTimes->{{3.9023208021040545`*^9, 3.9023208688947935`*^9}, {
  3.902321305024898*^9, 3.902321320643386*^9}, {3.902321514483379*^9, 
  3.902321556500448*^9}, {3.9023215991758895`*^9, 3.902321625031885*^9}, {
  3.902321719281722*^9, 3.9023217339353795`*^9}, {3.9023217799106073`*^9, 
  3.9023217914863143`*^9}, {3.902321935549556*^9, 3.90232193812934*^9}, {
  3.902323154019493*^9, 3.902323155390396*^9}, {3.9023233529156847`*^9, 
  3.902323375142779*^9}},
 CellLabel->
  "In[404]:=",ExpressionUUID->"7bcc4fc7-b242-4cd4-8826-595058635bdf"],

Cell[BoxData[
 TemplateBox[{
  "0.0041158536585365856`", "\"nW\"", "nanowatts", "\"Nanowatts\""},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902320839159068*^9, 3.90232086933492*^9}, {
   3.9023213097388086`*^9, 3.902321381906106*^9}, {3.9023215160239286`*^9, 
   3.902321527646743*^9}, {3.902321588787565*^9, 3.9023216255922956`*^9}, {
   3.9023217252354517`*^9, 3.9023217346186075`*^9}, 3.902321801696618*^9, 
   3.902321955476617*^9, 3.9023229745337286`*^9, 3.902323158218461*^9, 
   3.902323264438961*^9, 3.9023233757180185`*^9},
 CellLabel->
  "Out[405]=",ExpressionUUID->"41f15253-b4bd-48ea-a1c4-fbed00540072"],

Cell[BoxData[
 TemplateBox[{"8.52242169468979`*^6", 
   RowBox[{"\"per \"", "\[InvisibleSpace]", "\"second\""}], 
   "reciprocal seconds", 
   FractionBox["1", "\"Seconds\""]},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902320839159068*^9, 3.90232086933492*^9}, {
   3.9023213097388086`*^9, 3.902321381906106*^9}, {3.9023215160239286`*^9, 
   3.902321527646743*^9}, {3.902321588787565*^9, 3.9023216255922956`*^9}, {
   3.9023217252354517`*^9, 3.9023217346186075`*^9}, 3.902321801696618*^9, 
   3.902321955476617*^9, 3.9023229745337286`*^9, 3.902323158218461*^9, 
   3.902323264438961*^9, 3.902323375722373*^9},
 CellLabel->
  "Out[406]=",ExpressionUUID->"989e3ed6-7c85-4010-a0ad-410a3bde14bd"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.9023212547420206`*^9, 
  3.902321255619303*^9}},ExpressionUUID->"53ff62da-e890-40c1-bab6-\
2f6b7e680b98"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"MeasuredPpS", "=", 
     RowBox[{"CountPerSecond", "[", "716", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MegacountPerSecond", "[", "716", "]"}], "//", "N"}], 
   "\[IndentingNewLine]", 
   RowBox[{"ScientificForm", "[", 
    RowBox[{"N", "[", "MeasuredPpS", "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Divide", "[", 
     RowBox[{"MeasuredPpS", ",", "CalculatedPpS"}], "]"}], "//", 
    "Simplify"}]}]}]], "Input",
 CellChangeTimes->{{3.9023209765455437`*^9, 3.902321077574682*^9}, {
  3.902321405058483*^9, 3.902321433526718*^9}, {3.902321796022467*^9, 
  3.9023217989088316`*^9}, {3.9023219416055727`*^9, 3.902321943293801*^9}, {
  3.9023229054236784`*^9, 3.90232291070436*^9}, {3.902322962915492*^9, 
  3.902322963181569*^9}, {3.902323227722148*^9, 3.9023233387852583`*^9}, {
  3.9023233848715005`*^9, 3.902323442311471*^9}, {3.9023235885122223`*^9, 
  3.902323609517086*^9}},
 CellLabel->
  "In[431]:=",ExpressionUUID->"524b2084-c8bd-474a-9cd5-d2f510fc7302"],

Cell[BoxData[
 TemplateBox[{"0.716`", 
   RowBox[{"\"per \"", "\[InvisibleSpace]", "\"second\""}], 
   "reciprocal seconds", 
   FractionBox["1", "\"Seconds\""]},
  "Quantity"]], "Output",
 CellChangeTimes->{{3.902323424707424*^9, 3.9023234428524094`*^9}, {
  3.9023236043522243`*^9, 3.9023236100474415`*^9}},
 CellLabel->
  "Out[432]=",ExpressionUUID->"5c36f669-af52-4262-9179-d5027dbd4a66"],

Cell[BoxData[
 TagBox[
  TemplateBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{"\"7.16\"", "\[Times]", 
        SuperscriptBox["10", "\"5\""]}], ShowStringCharacters -> False], 
     716000., AutoDelete -> True], 
    RowBox[{"\"per \"", "\[InvisibleSpace]", "\"second\""}], 
    "reciprocal seconds", 
    FractionBox["1", "\"Seconds\""]},
   "Quantity"],
  ScientificForm]], "Output",
 CellChangeTimes->{{3.902323424707424*^9, 3.9023234428524094`*^9}, {
  3.9023236043522243`*^9, 3.9023236100517273`*^9}},
 CellLabel->
  "Out[433]//ScientificForm=",ExpressionUUID->"70431633-0c9b-4232-9fa7-\
b94f75120ec7"],

Cell[BoxData["0.0840136789342553`"], "Output",
 CellChangeTimes->{{3.902323424707424*^9, 3.9023234428524094`*^9}, {
  3.9023236043522243`*^9, 3.90232361005584*^9}},
 CellLabel->
  "Out[434]=",ExpressionUUID->"c155209a-7aa6-4eb5-b47e-a7ab2df445a7"]
}, Open  ]]
},
WindowSize->{1440, 741.75},
WindowMargins->{{-6, Automatic}, {Automatic, -6}},
FrontEndVersion->"13.3 for Microsoft Windows (64-bit) (June 3, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"9ce2f33a-0e93-4fdb-bffa-d6bbf3cc2b60"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 1619, 39, 278, "Input",ExpressionUUID->"e8090b34-ea51-4935-9f55-5405ea3d1092"],
Cell[2202, 63, 463, 9, 75, "Output",ExpressionUUID->"0ca17b82-ab34-4300-81c5-bf03a141c657"]
}, Open  ]],
Cell[2680, 75, 2548, 61, 392, "Input",ExpressionUUID->"30d37e42-02d8-478b-abac-380cc392f0b4"],
Cell[CellGroupData[{
Cell[5253, 140, 470, 9, 171, "Input",ExpressionUUID->"386a6dd6-e1a5-4b3c-beef-56b96b4a1216"],
Cell[5726, 151, 388, 9, 74, "Output",ExpressionUUID->"66cd768c-a321-4f42-96c9-7563b881cfe9"],
Cell[6117, 162, 390, 9, 80, "Output",ExpressionUUID->"edffd2f0-ecc8-4edc-a3df-444a33f07191"],
Cell[6510, 173, 395, 9, 72, "Output",ExpressionUUID->"550bbca2-ca1e-4631-851e-f051ec13cbfe"]
}, Open  ]],
Cell[6920, 185, 981, 22, 133, "Input",ExpressionUUID->"cffe01c7-f1b5-486d-8852-404e9ba50bd0"],
Cell[CellGroupData[{
Cell[7926, 211, 523, 12, 171, "Input",ExpressionUUID->"def8c2ea-cf1c-4914-9774-c800889c2d9c"],
Cell[8452, 225, 320, 8, 64, "Output",ExpressionUUID->"1c3f9fd8-9b05-4ad0-a038-46209ec697c2"],
Cell[8775, 235, 251, 5, 64, "Output",ExpressionUUID->"cbe08f06-bf0b-46fe-82a0-e3d4f184af07"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9063, 245, 1055, 23, 133, "Input",ExpressionUUID->"7bcc4fc7-b242-4cd4-8826-595058635bdf"],
Cell[10121, 270, 621, 11, 68, "Output",ExpressionUUID->"41f15253-b4bd-48ea-a1c4-fbed00540072"],
Cell[10745, 283, 698, 13, 80, "Output",ExpressionUUID->"989e3ed6-7c85-4010-a0ad-410a3bde14bd"]
}, Open  ]],
Cell[11458, 299, 154, 3, 56, "Input",ExpressionUUID->"53ff62da-e890-40c1-bab6-2f6b7e680b98"],
Cell[CellGroupData[{
Cell[11637, 306, 1091, 24, 209, "Input",ExpressionUUID->"524b2084-c8bd-474a-9cd5-d2f510fc7302"],
Cell[12731, 332, 392, 9, 74, "Output",ExpressionUUID->"5c36f669-af52-4262-9179-d5027dbd4a66"],
Cell[13126, 343, 620, 17, 108, "Output",ExpressionUUID->"70431633-0c9b-4232-9fa7-b94f75120ec7"],
Cell[13749, 362, 247, 4, 75, "Output",ExpressionUUID->"c155209a-7aa6-4eb5-b47e-a7ab2df445a7"]
}, Open  ]]
}
]
*)

