(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   1411872,      29004]
NotebookOptionsPosition[   1378735,      28455]
NotebookOutlinePosition[   1379139,      28471]
CellTagsIndexPosition[   1379096,      28468]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Initialization", "Chapter",
 CellChangeTimes->{{3.932046446726764*^9, 
  3.932046488031919*^9}},ExpressionUUID->"49b7a2a3-31ae-a847-952e-\
7a54602de5ae"],

Cell[BoxData[{
 RowBox[{"MF", ":=", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Q", ":=", "Quantity"}], "\[IndentingNewLine]", 
 RowBox[{"UC", ":=", "UnitConvert"}], "\[IndentingNewLine]", 
 RowBox[{"FS", ":=", "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.937567602308462*^9, 3.937567608515694*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"94d0ae31-7e0e-b546-8ad5-6082cf2a0823"],

Cell[CellGroupData[{

Cell["Image  Height", "Subsection",
 CellChangeTimes->{{3.9334349627894373`*^9, 
  3.9334349792677574`*^9}},ExpressionUUID->"d0873a22-6a31-bb41-8f74-\
55162f8575c1"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "f_", "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", "0"},
       {
        FractionBox[
         RowBox[{"-", "1"}], "f"], "1"}
      }], ")"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TM", "[", "L_", "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", "L"},
       {"0", "1"}
      }], ")"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"\[ScriptF]1_", ",", "\[ScriptF]2_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Clear", "[", 
       RowBox[{"Mag", ",", "\[ScriptF]"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Mag", " ", "=", " ", 
       FractionBox["\[ScriptF]1", "\[ScriptF]2"]}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"\[ScriptF]", "=", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "\[ScriptF]1"], "+", 
          FractionBox["1", "\[ScriptF]2"], "+", 
          FractionBox[
           RowBox[{"\[ScriptF]1", "+", "\[ScriptF]2"}], 
           RowBox[{"\[ScriptF]1", " ", "\[ScriptF]2"}]]}], ")"}], 
        RowBox[{"-", "1"}]]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Magnification: \>\"", ",", " ", 
        RowBox[{"Mag", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\[ScriptF]: \>\"", ",", " ", 
        RowBox[{"\[ScriptF]", "//", "N"}], ",", "\"\< mm\>\""}], "]"}], ";"}],
      "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FringeHeight", "[", 
     RowBox[{"L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{
        "FH", ",", "\[Phi]", ",", "\[ScriptCapitalL]", ",", "\[ScriptD]"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[ScriptCapitalL]", "=", 
        RowBox[{"Q", "[", 
         RowBox[{"L", ",", "\"\<mm\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[ScriptD]", "=", 
        RowBox[{"Q", "[", 
         RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FH", "=", 
        RowBox[{
         FractionBox[
          RowBox[{"\[ScriptCapitalL]", "*", 
           RowBox[{"Q", "[", 
            RowBox[{"\[Lambda]", ",", "\"\<nm\>\""}], "]"}]}], 
          RowBox[{"2", "\[ScriptD]"}]], "//", "N"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\[Phi]", "=", 
        RowBox[{
         RowBox[{"ArcTan", "[", 
          FractionBox[
           RowBox[{"FH", "-", 
            RowBox[{"\[ScriptD]", "/", "2"}]}], 
           RowBox[{"Q", "[", 
            RowBox[{"L", ",", "\"\<mm\>\""}], "]"}]], "]"}], "//", "N"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Fringe Height: \>\"", ",", " ", 
         RowBox[{"UC", "[", 
          RowBox[{"FH", ",", "\"\<mm\>\""}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Angle: \>\"", ",", " ", "\[Phi]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(", 
        RowBox[{"FH", "/", 
         RowBox[{"Q", "[", 
          RowBox[{"1", ",", "\"\<mm\>\""}], "]"}]}], ")"}]}], ",", "\[Phi]"}],
      "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FHG", "[", 
     RowBox[{"L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{
        "FH", ",", "\[Phi]", ",", "\[ScriptCapitalL]", ",", "\[ScriptD]"}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[ScriptCapitalL]", "=", "L"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[ScriptD]", "=", 
        RowBox[{"d", "*", ".001"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FH", "=", 
        RowBox[{
         FractionBox[
          RowBox[{"\[ScriptCapitalL]", "*", 
           RowBox[{"(", 
            RowBox[{"\[Lambda]", "*", 
             SuperscriptBox["10", 
              RowBox[{"-", "6"}]]}], ")"}]}], 
          RowBox[{"2", "\[ScriptD]"}]], "//", "N"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\[Phi]", "=", 
        RowBox[{
         RowBox[{"ArcTan", "[", 
          FractionBox[
           RowBox[{"FH", "-", 
            RowBox[{"\[ScriptD]", "/", "2"}]}], "\[ScriptCapitalL]"], "]"}], "//",
          "N"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", "FH"}], 
      ",", "\[Phi]"}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"GraphIPMag", "[", 
     RowBox[{"Initialh_", ",", "M_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "<", "0"}], ",", 
        RowBox[{"T", "=", 
         RowBox[{
          RowBox[{"(", GridBox[{
             {
              RowBox[{"-", "1"}], "0"},
             {"0", "1"}
            }], ")"}], ".", "M"}]}], ",", 
        RowBox[{"T", "=", "M"}]}], "]"}], ";", "\[IndentingNewLine]", 
      FractionBox["Initialh", 
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}]]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BeamSize", "[", "M_", "]"}], ":=", 
    RowBox[{"2", "*", 
     RowBox[{"M", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.927723781100146*^9, 3.927723870616926*^9}, {
   3.927723921472137*^9, 3.927723926164758*^9}, 3.927723989615659*^9, {
   3.927724024881095*^9, 3.927724045812355*^9}, {3.927728518181854*^9, 
   3.927728536224549*^9}, {3.928333223553387*^9, 3.928333236875123*^9}, {
   3.9283332734842305`*^9, 3.928333323980523*^9}, {3.928333410643749*^9, 
   3.9283334218487525`*^9}, {3.928333457333039*^9, 3.928333557728894*^9}, {
   3.928334734633545*^9, 3.928334785023736*^9}, {3.928334818628117*^9, 
   3.928334879027727*^9}, {3.9283349275496454`*^9, 3.9283350046394653`*^9}, {
   3.9283351034553385`*^9, 3.928335200480512*^9}, {3.928335233047886*^9, 
   3.928335296290135*^9}, {3.928335446493693*^9, 3.928335455477382*^9}, {
   3.928336490331446*^9, 3.9283364993148537`*^9}, {3.928336679072534*^9, 
   3.9283366797707887`*^9}, {3.928336719470459*^9, 3.928336719540803*^9}, {
   3.928338386385177*^9, 3.928338411322696*^9}, {3.928338529124342*^9, 
   3.9283385360692186`*^9}, {3.931877509923584*^9, 3.93187757749011*^9}, {
   3.93187764004376*^9, 3.931877721810993*^9}, {3.931877757237885*^9, 
   3.9318777783857274`*^9}, {3.931878258091575*^9, 3.9318782586068707`*^9}, {
   3.931879475773764*^9, 3.931879532865328*^9}, {3.932041620414613*^9, 
   3.932041667258425*^9}, {3.9320438625475*^9, 3.932043956012209*^9}, {
   3.932044131586645*^9, 3.932044148280639*^9}, {3.932044224326536*^9, 
   3.93204435611568*^9}, {3.932044425067127*^9, 3.932044469162834*^9}, {
   3.932044520092327*^9, 3.932044525111828*^9}, {3.932044627911941*^9, 
   3.932044631868576*^9}, {3.932044664922823*^9, 3.932044672938907*^9}, {
   3.932044738415674*^9, 3.9320448045338*^9}, {3.93204487175609*^9, 
   3.932044914191452*^9}, {3.93204661880316*^9, 3.9320466489066315`*^9}, {
   3.932046693525*^9, 3.932046698548927*^9}, {3.932046801542549*^9, 
   3.932046889920423*^9}, {3.932046941750051*^9, 3.932047065475818*^9}, {
   3.932047096239092*^9, 3.932047165689623*^9}, {3.932047427024656*^9, 
   3.932047455625444*^9}, {3.9320475365871143`*^9, 3.932047602480455*^9}, {
   3.932047672211866*^9, 3.932047830517878*^9}, {3.932047930628853*^9, 
   3.932048114494104*^9}, {3.932048220541767*^9, 3.932048286426166*^9}, {
   3.93204834773183*^9, 3.932048348178743*^9}, {3.93204842593277*^9, 
   3.932048453894211*^9}, {3.932048499354567*^9, 3.932048622451999*^9}, {
   3.932048961862814*^9, 3.932049007469876*^9}, {3.932049099647131*^9, 
   3.93204912343515*^9}, {3.932049343492206*^9, 3.9320493440338*^9}, {
   3.932049384699793*^9, 3.932049396175188*^9}, {3.932049440154102*^9, 
   3.932049497314125*^9}, {3.932049644405422*^9, 3.932049651947847*^9}, {
   3.93204974880616*^9, 3.932049756956564*^9}, {3.932050026191969*^9, 
   3.932050030662927*^9}, {3.932050099371486*^9, 3.932050127159756*^9}, {
   3.932051030494743*^9, 3.9320511623772163`*^9}, {3.932052400675398*^9, 
   3.93205245076626*^9}, 3.9320531688351765`*^9, {3.932124120948143*^9, 
   3.9321241410185966`*^9}, {3.932133878044636*^9, 3.93213390376555*^9}, {
   3.9321340436550922`*^9, 3.9321340795182133`*^9}, {3.9321344653820496`*^9, 
   3.932134467052002*^9}, {3.932135944417774*^9, 3.932135948978115*^9}, 
   3.932136399399931*^9, {3.9321366590887337`*^9, 3.932136672391037*^9}, {
   3.932136717047703*^9, 3.932136731573408*^9}, {3.932136762866939*^9, 
   3.93213678206737*^9}, {3.9321368158552647`*^9, 3.932136870479725*^9}, {
   3.9321376616734276`*^9, 3.932137663583961*^9}, {3.932137922112139*^9, 
   3.932137997285738*^9}, 3.9321384226709633`*^9, 3.9321386059002533`*^9, {
   3.932139031842097*^9, 3.932139060495268*^9}, {3.9321391248329487`*^9, 
   3.9321391344722767`*^9}, 3.932139320795183*^9, {3.932228124829779*^9, 
   3.932228136393328*^9}, {3.9322288021220913`*^9, 3.932228804569092*^9}, {
   3.9324819037629833`*^9, 3.932481940214283*^9}, {3.932566793661255*^9, 
   3.9325668321989975`*^9}, {3.932566880720108*^9, 3.9325669090645123`*^9}, {
   3.932567065900007*^9, 3.932567080186807*^9}, {3.932573183850481*^9, 
   3.932573189431293*^9}, {3.932575472345741*^9, 3.932575553954*^9}, {
   3.932575602216287*^9, 3.932575602639845*^9}, {3.93257568169462*^9, 
   3.9325757428492146`*^9}, {3.9325768590166683`*^9, 3.9325768601951504`*^9}, 
   3.9325769710147533`*^9, {3.932728122962661*^9, 3.932728212145613*^9}, 
   3.932728318174206*^9, {3.932728720998455*^9, 3.932728730449911*^9}, {
   3.932729065185812*^9, 3.932729086307329*^9}, {3.9327294745214825`*^9, 
   3.932729476529043*^9}, {3.932735228473553*^9, 3.932735245930111*^9}, {
   3.932735310960041*^9, 3.932735318586418*^9}, {3.933087825196125*^9, 
   3.933087834710188*^9}, {3.933420595054558*^9, 3.9334205954526424`*^9}, {
   3.9334206311978703`*^9, 3.933420705043417*^9}, {3.9334208219172516`*^9, 
   3.933420869244978*^9}, {3.9334349229549656`*^9, 3.93343492413628*^9}, {
   3.9334351772600536`*^9, 3.9334351776728578`*^9}, {3.9334352201890526`*^9, 
   3.9334352207860775`*^9}, {3.933435361460327*^9, 3.933435384045503*^9}, {
   3.9334356996213913`*^9, 3.933435700641651*^9}, 3.933435787703636*^9, {
   3.9334358980501385`*^9, 3.9334359219079285`*^9}, {3.9334359797764874`*^9, 
   3.933436004241241*^9}, {3.933436052458212*^9, 3.933436111010618*^9}, {
   3.93343657271179*^9, 3.933436614933144*^9}, {3.933436648067078*^9, 
   3.933436672067978*^9}, 3.9334368223038025`*^9, {3.935146672061268*^9, 
   3.935146696380295*^9}, 3.937492827973625*^9, 3.937567598793427*^9},
 CellLabel->"In[26]:=",ExpressionUUID->"b1a920e6-41a0-4653-8f38-866faed145d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Full Mask", "Subsection",
 CellChangeTimes->{{3.933435230056909*^9, 
  3.93343523597817*^9}},ExpressionUUID->"2974aa56-2387-274c-801b-\
2f6091763d78"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MaskFH", "[", 
    RowBox[{"n_", ",", "L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Clear", "[", 
       RowBox[{
       "FH", ",", "\[Phi]", ",", "\[ScriptCapitalL]", ",", "\[ScriptD]"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[ScriptCapitalL]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"L", ",", "\"\<mm\>\""}], "]"}]}], ";", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"\[ScriptD]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FH", "=", 
       RowBox[{
        FractionBox[
         RowBox[{"\[ScriptCapitalL]", " ", "*", 
          RowBox[{"Q", "[", 
           RowBox[{"\[Lambda]", ",", "\"\<nm\>\""}], "]"}]}], 
         RowBox[{"2", "\[ScriptD]"}]], "//", "N"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Phi]", "=", 
       RowBox[{
        RowBox[{"ArcTan", "[", 
         FractionBox[
          RowBox[{"FH", "-", 
           RowBox[{"\[ScriptD]", "/", "2"}]}], "\[ScriptCapitalL]"], "]"}], "//",
         "N"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"n", ">", "1"}], ",", 
        RowBox[{"FH", "=", 
         RowBox[{"UC", "[", 
          RowBox[{
           RowBox[{"FH", "+", 
            RowBox[{"\[ScriptD]", " ", 
             RowBox[{"(", 
              RowBox[{"n", "-", "1"}], ")"}]}]}], ",", "\"\<mm\>\""}], 
          "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Fringe Width: \>\"", ",", " ", "FH"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Angle: \>\"", ",", " ", "\[Phi]"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"FH", "/", 
       RowBox[{"Q", "[", 
        RowBox[{"1", ",", "\"\<mm\>\""}], "]"}]}]}], ",", "\[Phi]"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MaskFirstLensMax\[ScriptF]", "[", 
   RowBox[{"n_", ",", "d_", ",", "\[Lambda]_", ",", "LensSize_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"Q", "[", 
           RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "n"}], "-", "1"}], ")"}]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"Q", "[", 
           RowBox[{"L", ",", "\"\<mm\>\""}], "]"}], " ", "*", 
          RowBox[{"Q", "[", 
           RowBox[{"\[Lambda]", ",", "\"\<nm\>\""}], "]"}]}], 
         RowBox[{"2", 
          RowBox[{"Q", "[", 
           RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}]}]]}], ")"}], "==", 
      RowBox[{"Q", "[", 
       RowBox[{"LensSize", ",", "\"\<Inches\>\""}], "]"}]}], ",", "L"}], 
    "]"}], "//", "N"}]}]}], "Input",
 CellChangeTimes->{{3.9334352218833714`*^9, 3.933435223065998*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"5050bf6b-da81-fb40-8429-67c560ee19b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Vergence", "Subsection",
 CellChangeTimes->{{3.933434941465225*^9, 
  3.933434948250492*^9}},ExpressionUUID->"fb0bdda2-b75d-554a-b0e1-\
98024afd388d"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{"L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Clear", "[", 
       RowBox[{"h", ",", "\[ScriptCapitalL]", ",", "\[ScriptD]"}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"\[ScriptCapitalL]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"L", ",", "\"\<mm\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[ScriptD]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"h", "=", 
       RowBox[{
        FractionBox[
         RowBox[{"\[ScriptCapitalL]", "*", 
          RowBox[{"Q", "[", 
           RowBox[{"\[Lambda]", ",", "\"\<nm\>\""}], "]"}]}], 
         RowBox[{"2", "\[ScriptD]"}]], "//", "N"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"ArcTan", "[", 
         FractionBox[
          RowBox[{"h", "-", "\[ScriptD]"}], "\[ScriptCapitalL]"], "]"}]}], "//",
        "N"}]}], "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SP", "[", 
     RowBox[{"n1_", ",", "n2_", ",", "R_"}], "]"}], ":=", " ", 
    FractionBox[
     RowBox[{"n2", "-", "n1"}], "R"]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SPPC", "[", 
     RowBox[{"n_", ",", "R1_", ",", "R2_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"n", "-", "1"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "R1"], "-", 
       FractionBox["1", "R2"]}], ")"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TLVM", "[", 
     RowBox[{"R1_", ",", "R2_", ",", "d_", ",", "n1_", ",", "n2_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", GridBox[{
         {"1", 
          RowBox[{"SP", "[", 
           RowBox[{"n2", ",", "n1", ",", "R2"}], "]"}]},
         {"0", "1"}
        }], ")"}], ".", 
      RowBox[{"(", GridBox[{
         {"1", "0"},
         {
          FractionBox[
           RowBox[{"-", "d"}], "n2"], "1"}
        }], ")"}], ".", 
      RowBox[{"(", GridBox[{
         {"1", 
          RowBox[{"SP", "[", 
           RowBox[{"n1", ",", "n2", ",", "R1"}], "]"}]},
         {"0", "1"}
        }], ")"}]}], "//", "N"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LVM", "[", 
     RowBox[{"n_", ",", "R1_", ",", "R2_"}], "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", 
        RowBox[{"SPPC", "[", 
         RowBox[{"n", ",", "R1", ",", "R2"}], "]"}]},
       {"0", "1"}
      }], ")"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TVM", "[", "d_", "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", "0"},
       {
        FractionBox[
         RowBox[{"-", "d"}], "nair"], "1"}
      }], ")"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"VM", "[", 
     RowBox[{"n_", ",", "r_"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{"-", "n"}], "r"], ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"kSolver", "[", "M_", "]"}], ":=", 
    FractionBox["M", 
     RowBox[{"M", "[", 
      RowBox[{"[", "2", "]"}], "]"}]]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{"L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Clear", "[", 
       RowBox[{
       "h", ",", "\[Phi]", ",", "\[ScriptCapitalL]", ",", "\[ScriptD]"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[ScriptCapitalL]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"L", ",", "\"\<mm\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[ScriptD]", "=", 
       RowBox[{"Q", "[", 
        RowBox[{"d", ",", "\"\<\[Mu]m\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"h", "=", 
       RowBox[{
        FractionBox[
         RowBox[{"\[ScriptCapitalL]", "*", 
          RowBox[{"Q", "[", 
           RowBox[{"\[Lambda]", ",", "\"\<nm\>\""}], "]"}]}], 
         RowBox[{"2", "\[ScriptD]"}]], "//", "N"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Phi]", "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"ArcTan", "[", 
          FractionBox[
           RowBox[{"h", "-", "\[ScriptD]"}], "\[ScriptCapitalL]"], "]"}]}], "//",
         "N"}]}]}], "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nair", "=", "1.000293"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nnbk7", "=", "1.517"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nECO550", "=", "1.595"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LMEPC", "[", 
     RowBox[{"n_", ",", "\[ScriptF]_"}], "]"}], ":=", 
    RowBox[{"\[ScriptF]", 
     RowBox[{"(", 
      RowBox[{"n", "-", "1"}], ")"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AL1V", "=", 
     RowBox[{
      RowBox[{"TLVM", "[", 
       RowBox[{"\[Infinity]", ",", 
        RowBox[{"-", "\[Infinity]"}], ",", ".25", ",", "nair", ",", "nnbk7"}],
        "]"}], ".", 
      RowBox[{"(", GridBox[{
         {"1", "0"},
         {
          FractionBox[
           RowBox[{"-", "5"}], "nair"], "1"}
        }], ")"}], ".", 
      RowBox[{"TLVM", "[", 
       RowBox[{"5.069", ",", 
        RowBox[{"-", "61.172"}], ",", "3.69", ",", "nair", ",", "nECO550"}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AL2V", "=", 
     RowBox[{
      RowBox[{"TLVM", "[", 
       RowBox[{"61.172", ",", 
        RowBox[{"-", "5.069"}], ",", "3.69", ",", "nair", ",", "nECO550"}], 
       "]"}], ".", 
      RowBox[{"(", GridBox[{
         {"1", "0"},
         {
          FractionBox[
           RowBox[{"-", "5"}], "nair"], "1"}
        }], ")"}], ".", 
      RowBox[{"TLVM", "[", 
       RowBox[{"\[Infinity]", ",", 
        RowBox[{"-", "\[Infinity]"}], ",", ".25", ",", "nair", ",", "nnbk7"}],
        "]"}]}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.93343493360141*^9, 3.933434934826803*^9}, 
   3.933435218245617*^9, {3.933435513188089*^9, 3.933435540421198*^9}, {
   3.933435932792759*^9, 3.933435937523104*^9}, {3.933436032252356*^9, 
   3.933436032611231*^9}, 3.933436927995924*^9, 3.9334372722231483`*^9, {
   3.9345601577006073`*^9, 3.934560205668148*^9}, {3.9345605256173897`*^9, 
   3.9345605317417736`*^9}, {3.9345605769861145`*^9, 3.934560632735987*^9}, {
   3.93456066765658*^9, 3.934560674753889*^9}, {3.934561050955897*^9, 
   3.934561079976324*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"0e4bff7f-536c-254d-ad7d-654b76caf7b2"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pinhole", "Chapter",
 CellChangeTimes->{{3.932571936903351*^9, 
  3.9325719415292377`*^9}},ExpressionUUID->"6d3c128e-6c1c-7449-8ba2-\
9aabecee55a4"],

Cell[CellGroupData[{

Cell["Lens Simulations", "Section",
 CellChangeTimes->{{3.932044257572943*^9, 3.9320442590649433`*^9}, {
  3.932046478197998*^9, 
  3.932046481432409*^9}},ExpressionUUID->"80f6f11b-bf74-b745-9ea7-\
191353ed1eb3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"500", ",", "8"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"8", ",", "8"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"8", ",", "43"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"500", ",", "43"}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.9318775797124257`*^9, 3.93187758050042*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"53e0791d-82a3-4d0c-b675-78e47eea0364"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", "62.5`"}],
  SequenceForm["Magnification: ", 62.5],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530733175*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"9dc6d8d2-e57e-2947-bc92-beb38abb7671"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "3.937007874015748`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 3.937007874015748, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530737909*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"fa5849d9-5bbf-1e4e-92c6-8039958ed7ed"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", "1.`"}],
  SequenceForm["Magnification: ", 1.],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530745796*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"91b0fc5e-d553-8e43-a759-27b02296b819"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "2.`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 2., " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530747921*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"3025dbc9-1230-7b4e-9919-af6cb96ff204"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "0.18604651162790697`"}],
  SequenceForm["Magnification: ", 0.18604651162790697`],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530751383*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"b3c27ca9-d116-fa49-8117-4d7c0bf194f7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "3.372549019607843`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 3.372549019607843, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530754341*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"bbbf560e-ebf3-0043-b1bb-d38bc3f83896"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "11.627906976744185`"}],
  SequenceForm["Magnification: ", 11.627906976744185`],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.932044530757509*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"d88ee3a3-2066-8a44-9f74-8dbe4a2dcc51"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "19.79742173112339`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 19.79742173112339, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{3.9320444963692083`*^9, 3.9320445307610188`*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"2fb1cdab-066a-7947-9af4-4d6d18e865f8"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LM", "[", "43", "]"}], ".", 
      RowBox[{"TM", "[", "20", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "16", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "500", "]"}], ".", 
      RowBox[{"LM", "[", "500", "]"}], ".", 
      RowBox[{"(", GridBox[{
         {"500"},
         {"0"}
        }], ")"}]}], "//", "MF"}], "//", "N"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LM", "[", "43", "]"}], ".", 
      RowBox[{"TM", "[", "20", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "8", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "508", "]"}], ".", 
      RowBox[{"LM", "[", "500", "]"}], ".", 
      RowBox[{"(", GridBox[{
         {"500"},
         {"0"}
        }], ")"}]}], "//", "MF"}], "//", "N"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"LM", "[", "43", "]"}], ".", 
      RowBox[{"TM", "[", "20", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "24", "]"}], ".", 
      RowBox[{"LM", "[", "8", "]"}], ".", 
      RowBox[{"TM", "[", "492", "]"}], ".", 
      RowBox[{"LM", "[", "500", "]"}], ".", 
      RowBox[{"(", GridBox[{
         {"500"},
         {"0"}
        }], ")"}]}], "//", "MF"}], "//", "N"}]}]}]], "Input",
 CellChangeTimes->{{3.9277238747832007`*^9, 3.92772389807929*^9}, {
   3.9277240507074447`*^9, 3.927724081143724*^9}, {3.9277285064521656`*^9, 
   3.92772850750263*^9}, {3.927728579191657*^9, 3.92772864146871*^9}, {
   3.92772928916971*^9, 3.92772942826002*^9}, {3.927729775222669*^9, 
   3.927729793582432*^9}, {3.927729929837394*^9, 3.927730005663388*^9}, 
   3.93204078368051*^9, {3.932044008855028*^9, 3.932044016013519*^9}, {
   3.932044098970682*^9, 3.932044100798126*^9}, {3.9325768897798347`*^9, 
   3.9325768898016777`*^9}, {3.93257696372707*^9, 
   3.9325769637459793`*^9}},ExpressionUUID->"5bcb484c-3eb6-4552-aa42-\
f5989cd40979"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FringeHeight", "[", 
  RowBox[{"60", ",", "50", ",", "780"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Q", "[", 
   RowBox[{".050", ",", "\"\<mm\>\""}], "]"}], "*", "39", "*", 
  "2"}]}], "Input",
 CellChangeTimes->{{3.931877604021647*^9, 3.9318776088885765`*^9}, {
   3.931877802628397*^9, 3.931877832870334*^9}, {3.931877877936677*^9, 
   3.931877879809635*^9}, {3.931878250440403*^9, 3.931878250591425*^9}, {
   3.931878406616688*^9, 3.931878423037173*^9}, {3.931878472491177*^9, 
   3.931878473261639*^9}, {3.931879461686875*^9, 3.931879466068258*^9}, {
   3.9318795831949177`*^9, 3.931879591156296*^9}, {3.931879758084259*^9, 
   3.931879850709144*^9}, {3.9320473368729973`*^9, 3.93204733701762*^9}, 
   3.932728316317465*^9},ExpressionUUID->"d64db146-2381-45a9-89ad-\
cbbdb9812174"],

Cell[BoxData[
 TemplateBox[{"0.936`", "\"mm\"", "millimeters", "\"Millimeters\""},
  "Quantity"]], "Output",
 CellChangeTimes->{
  3.931877833814099*^9, 3.931877880291152*^9, {3.931878251055337*^9, 
   3.931878263231528*^9}, {3.931878407281742*^9, 3.931878423486688*^9}, 
   3.93187847389327*^9, {3.9318794631424737`*^9, 3.9318794672667203`*^9}, 
   3.93187958448523*^9, {3.931879781361758*^9, 3.9318798511568923`*^9}, 
   3.932047337669702*^9, 3.9320476518225975`*^9},
 CellLabel->
  "Out[959]=",ExpressionUUID->"06c27c28-0035-7c4b-8a51-b82dd0def797"],

Cell[BoxData[
 TemplateBox[{
  "3.9000000000000004`", "\"mm\"", "millimeters", "\"Millimeters\""},
  "Quantity"]], "Output",
 CellChangeTimes->{
  3.931877833814099*^9, 3.931877880291152*^9, {3.931878251055337*^9, 
   3.931878263231528*^9}, {3.931878407281742*^9, 3.931878423486688*^9}, 
   3.93187847389327*^9, {3.9318794631424737`*^9, 3.9318794672667203`*^9}, 
   3.93187958448523*^9, {3.931879781361758*^9, 3.9318798511568923`*^9}, 
   3.932047337669702*^9, 3.932047651828239*^9},
 CellLabel->
  "Out[960]=",ExpressionUUID->"29ff8833-9890-d244-b6cc-74bc4342894c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "\[Theta]", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Tan", "[", "\[Theta]", "]"}], "==", 
      FractionBox[
       RowBox[{" ", ".936"}], "60"]}], ",", "\[Theta]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ArcTan", "[", 
  FractionBox[
   RowBox[{" ", ".936"}], "60"], "]"}]}], "Input",
 CellChangeTimes->{{3.932040880608389*^9, 3.932040945516689*^9}, 
   3.932047401063329*^9, {3.932047479097908*^9, 3.9320475301963177`*^9}},
 CellLabel->
  "In[948]:=",ExpressionUUID->"11bca0e4-5e91-49a4-aada-fd17b7a9d947"],

Cell[BoxData[
 TemplateBox[{
  "Solve", "ifun", 
   "\"Inverse functions are being used by \
\\!\\(\\*RowBox[{\\\"Solve\\\"}]\\), so some solutions may not be found; use \
Reduce for complete solution information.\"", 2, 949, 35, 
   26771922692581739253, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.932040949878442*^9, 3.932047402174503*^9, {3.932047473677534*^9, 
   3.932047530891683*^9}},
 CellLabel->
  "During evaluation of \
In[948]:=",ExpressionUUID->"0dfb409f-83ee-f644-9978-d5267c523978"],

Cell[BoxData[
 RowBox[{"\[Theta]", "\[Rule]", "0.015598734712747045`"}]], "Output",
 CellChangeTimes->{
  3.932040949890444*^9, 3.9320474021850142`*^9, {3.932047473686176*^9, 
   3.9320475308992815`*^9}},
 CellLabel->
  "Out[949]=",ExpressionUUID->"49cdaf63-337d-aa49-bae1-5703be667bae"],

Cell[BoxData["0.015598734712747047`"], "Output",
 CellChangeTimes->{
  3.932040949890444*^9, 3.9320474021850142`*^9, {3.932047473686176*^9, 
   3.9320475309022613`*^9}},
 CellLabel->
  "Out[950]=",ExpressionUUID->"37fa5998-7c32-f848-bef2-75342f735e77"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Main Track Simulation", "Section",
 CellChangeTimes->{{3.932046408141281*^9, 
  3.932046434983902*^9}},ExpressionUUID->"7b34875f-b1d7-a447-aa78-\
14e87ec3c519"],

Cell[CellGroupData[{

Cell["Course Steps", "Subsection",
 CellChangeTimes->{{3.932135495795217*^9, 
  3.932135501727518*^9}},ExpressionUUID->"f2503128-8ddd-6249-b8e4-\
fd5e41355f86"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"60", ",", "50", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{"60", ",", "500", ",", "8", ",", "43"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M1\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "4", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "512", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M1"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M2\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "8", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "508", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M2"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M3\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "12", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "504", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M3"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M4\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M4", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "16", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "500", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M4"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M5\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M5", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "496", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M5"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M6\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M6", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "24", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "492", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M6"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M7\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M7", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "28", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "488", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ImagePlane", "[", 
   RowBox[{"FH", ",", "M7"}], "]"}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.932040686771068*^9, 3.93204069986482*^9}, {
   3.932040734456939*^9, 3.93204083137298*^9}, {3.932040978502142*^9, 
   3.932040997995867*^9}, {3.932041057839728*^9, 3.932041206088218*^9}, {
   3.9320412780661397`*^9, 3.932041282833945*^9}, {3.932044037497184*^9, 
   3.932044072073463*^9}, 3.932044218464069*^9, {3.9320443663463326`*^9, 
   3.93204440489453*^9}, {3.93204453755262*^9, 3.932044538759163*^9}, {
   3.932044966214761*^9, 3.932044999919183*^9}, {3.932045656733558*^9, 
   3.932045972780844*^9}, 3.932047387912462*^9, {3.932048643492428*^9, 
   3.932048668762127*^9}, 3.9320488355045385`*^9, {3.932050801858782*^9, 
   3.932050900686811*^9}, {3.9320509680745983`*^9, 3.932050969828617*^9}, {
   3.932052766468851*^9, 3.932052774841822*^9}, {3.932133739281391*^9, 
   3.932133770414419*^9}, {3.9321360049312744`*^9, 3.932136126348577*^9}, {
   3.932576889805469*^9, 3.932576889880588*^9}, {3.932576963749492*^9, 
   3.9325769638233547`*^9}, 3.932728316320553*^9, {3.932729474539167*^9, 
   3.932729474568161*^9}, 
   3.9351464895125237`*^9},ExpressionUUID->"2db6999e-cc3b-480b-ad78-\
c4255b6ab7ae"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.936`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.936, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361285934105`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"28fd5a7c-7f8f-c34d-a406-9b8242ea3204"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747047`"}],
  SequenceForm["Angle: ", 0.015598734712747047`],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128606144*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"23aaf81c-02c9-1641-8fff-4033cace41e2"]
}, Open  ]],

Cell[BoxData["\<\"M1\"\>"], "Output",
 CellChangeTimes->{3.932136128619625*^9},
 CellLabel->
  "Out[364]=",ExpressionUUID->"4d903836-18ae-3644-aeba-3d54ef96546c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "21.6327259261210507191`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[21.6327259261210507191`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128631409*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"67fb04f4-6e33-0d4b-9f94-9f308a683059"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "19.1597955078828050546`3."}],
  SequenceForm["Magnification: ", 19.1597955078828050546`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128641257*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"eebeee02-22cd-a449-920b-7aa66e9a9e45"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0022582550644252297`5."}],
  SequenceForm["Angle: ", 0.0022582550644252297`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128657454*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"61bceea0-a418-2248-b00f-2ba83c39abd7"]
}, Open  ]],

Cell[BoxData["\<\"M2\"\>"], "Output",
 CellChangeTimes->{3.9321361286654053`*^9},
 CellLabel->
  "Out[367]=",ExpressionUUID->"16fc79c6-32ac-9b42-8c0e-6c1748097706"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "17.2756691450432491308`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[17.2756691450432491308`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128678283*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"0230ef35-988e-0142-a77d-9693c358216e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "38.9289756207850814462`3."}],
  SequenceForm["Magnification: ", 38.9289756207850814462`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128687763*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"c2a390d5-d896-6345-aa28-79f7130fc570"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0013917707804079749`5."}],
  SequenceForm["Angle: ", 0.0013917707804079749`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128700725*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"b17eeccc-25ed-a142-8d60-f295f161ce34"]
}, Open  ]],

Cell[BoxData["\<\"M3\"\>"], "Output",
 CellChangeTimes->{3.932136128707743*^9},
 CellLabel->
  "Out[370]=",ExpressionUUID->"fa808d37-f82b-824b-896d-9a5ac4844f6e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "8.7218051931037976487`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[8.7218051931037976487`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128720169*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"5ee041c1-f0e3-024b-aaa5-4086aeaa1943"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "89.4293105182222234362`3."}],
  SequenceForm["Magnification: ", 89.4293105182222234362`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128731013*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"6ebb9534-3715-e542-9766-7a29ccba94ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0012000224630349943`5."}],
  SequenceForm["Angle: ", 0.0012000224630349943`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361287443504`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"bddfac44-9880-4d4b-be08-f2270c64f49e"]
}, Open  ]],

Cell[BoxData["\<\"M4\"\>"], "Output",
 CellChangeTimes->{3.932136128750345*^9},
 CellLabel->
  "Out[373]=",ExpressionUUID->"13aa3ee8-2850-1344-97cb-e5a7767978a6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "4.8247057831022379659`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[4.8247057831022379659`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361287618213`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"07443348-3fd8-3240-aecf-8b6c1820c514"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "115.2704208125941676144`3."}],
  SequenceForm["Magnification: ", 115.2704208125941676144`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128773985*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"162f3e33-8900-e941-a516-27c7e9343473"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0016830101123064822`5."}],
  SequenceForm["Angle: ", 0.0016830101123064822`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361287850037`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"c06c5393-6b53-8840-8d44-6eada31d14f9"]
}, Open  ]],

Cell[BoxData["\<\"M5\"\>"], "Output",
 CellChangeTimes->{3.93213612879101*^9},
 CellLabel->
  "Out[376]=",ExpressionUUID->"d9f4cd6c-d25a-dc44-8110-c583cddfefe4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "5.9860410308219673681`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[5.9860410308219673681`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128802983*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"b8f2a631-7472-7947-b3b3-ef6ff52773ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "55.0433000353667978288`3."}],
  SequenceForm["Magnification: ", 55.0433000353667978288`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128811149*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"d80dafec-ab09-8043-a56d-be3e2c4b8a79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0028407337282223555`5."}],
  SequenceForm["Angle: ", 0.0028407337282223555`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128824454*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"47a0db45-bb19-8f48-a4c6-a98a16020a62"]
}, Open  ]],

Cell[BoxData["\<\"M6\"\>"], "Output",
 CellChangeTimes->{3.932136128832382*^9},
 CellLabel->
  "Out[379]=",ExpressionUUID->"a8e65990-b604-4045-9664-44036c79bc52"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "7.9432561004238770863`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[7.9432561004238770863`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128842621*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"14023cf1-6b57-a24c-a957-104f835299c6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "25.2150814814640220618`3."}],
  SequenceForm["Magnification: ", 25.2150814814640220618`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361288540306`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"666efe08-b946-1d4f-84dc-1f6e17386992"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0046731933107826418`5."}],
  SequenceForm["Angle: ", 0.0046731933107826418`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128867214*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"5e76dea5-89c5-8143-9a81-fdadf623a6b3"]
}, Open  ]],

Cell[BoxData["\<\"M7\"\>"], "Output",
 CellChangeTimes->{3.9321361288722153`*^9},
 CellLabel->
  "Out[382]=",ExpressionUUID->"7c78ec65-40ee-7e46-aec7-0aac2845a74f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "9.5351940179115963758`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[9.5351940179115963758`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361288838367`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"19c84bbf-3c03-2149-bc57-76c5ae3e47cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "13.6707041920550800285`3."}],
  SequenceForm["Magnification: ", 13.6707041920550800285`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932136128892437*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"efea75f2-cd3c-2646-951b-fe28a06e46ba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0071803888599872856`5."}],
  SequenceForm["Angle: ", 0.0071803888599872856`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.9321361289056644`*^9},
 CellLabel->
  "During evaluation of \
In[362]:=",ExpressionUUID->"9d64d292-2cfb-6443-b4e8-a5996b839864"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Small Steps", "Subsection",
 CellChangeTimes->{{3.9320487356844606`*^9, 
  3.9320487547437677`*^9}},ExpressionUUID->"9fc6f7c8-8a3a-e645-96c1-\
2b9d8a942df1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"60", ",", "50", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{"60", ",", "500", ",", "8", ",", "43"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M1\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "43", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "496", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M1"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M2\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "43", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "21", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "495", "]"}], ".", 
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M2"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M3\>\"", "\
\[IndentingNewLine]", 
 RowBox[{"M3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "43", "]"}], ".", 
    RowBox[{"TM", "[", "20", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "22", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "494", "]"}], ".", 
    RowBox[{"LM", "[", "L2", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "L2"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M3"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M4\>\"", "\
\[IndentingNewLine]", 
 RowBox[{"M4", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "43", "]"}], ".", 
    RowBox[{"TM", "[", "20", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "23", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "493", "]"}], ".", 
    RowBox[{"LM", "[", "L2", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "L2"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M4"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M5\>\"", "\
\[IndentingNewLine]", 
 RowBox[{"M5", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "43", "]"}], ".", 
    RowBox[{"TM", "[", "20", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "24", "]"}], ".", 
    RowBox[{"LM", "[", "8", "]"}], ".", 
    RowBox[{"TM", "[", "492", "]"}], ".", 
    RowBox[{"LM", "[", "L2", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "L2"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ImagePlane", "[", 
   RowBox[{"FH", ",", "M5"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.9320460103079224`*^9, 3.932046111291601*^9}, 
   3.932046359232088*^9, {3.932048673108677*^9, 3.932048680803097*^9}, 
   3.9320487336681156`*^9, 3.932048782208824*^9, 3.932048830071411*^9, {
   3.932048905174556*^9, 3.93204892463336*^9}, {3.9320509247718697`*^9, 
   3.932050961461281*^9}, {3.9321338066240253`*^9, 3.9321338149050617`*^9}, {
   3.932136137642214*^9, 3.932136166195381*^9}, {3.9325768898846664`*^9, 
   3.9325768899372272`*^9}, {3.9325769638274*^9, 3.932576963881071*^9}, 
   3.9327283163235245`*^9, {3.9327294745721626`*^9, 
   3.932729474596018*^9}},ExpressionUUID->"2b2f3ace-a947-6b4d-9bb5-\
3ad77807d95f"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.936`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.936, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136169984073*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"4c6a26b7-42fe-0248-bfec-0042bba6b60d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747047`"}],
  SequenceForm["Angle: ", 0.015598734712747047`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136169995191*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"d8bcc708-95ef-4e4e-bb90-03d59c6210a6"]
}, Open  ]],

Cell[BoxData["\<\"M1\"\>"], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.9321361700080433`*^9},
 CellLabel->
  "Out[387]=",ExpressionUUID->"8b309280-91c5-1c4a-9539-a0845067a1de"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "5.9860410308219673681`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[5.9860410308219673681`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170022604*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"b2ccbdb0-8521-3f47-ab44-890d9130b5d7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "55.0433000353667978288`3."}],
  SequenceForm["Magnification: ", 55.0433000353667978288`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170037367*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"8887e6bb-f798-ca45-9a37-69ecb95b586c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0028407337282223555`5."}],
  SequenceForm["Angle: ", 0.0028407337282223555`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.9321361700496407`*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"559c3d58-9520-ea40-a326-76ef15e54df0"]
}, Open  ]],

Cell[BoxData["\<\"M2\"\>"], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.932136170055788*^9},
 CellLabel->
  "Out[390]=",ExpressionUUID->"58037777-cce8-464f-aa9d-c8dd58d8a210"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "6.484367478495991044`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[6.484367478495991044`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170068292*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"8d8a9e96-0768-f94d-b70f-fe2d73b53694"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "44.6121284743109853821`3."}],
  SequenceForm["Magnification: ", 44.6121284743109853821`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170078174*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"ccc2bc23-f1be-3d46-b8da-f9c9630ce923"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0032355921269895394`5."}],
  SequenceForm["Angle: ", 0.0032355921269895394`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170092419*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"61cd8fa3-b62b-344c-8f50-0a0418215d09"]
}, Open  ]],

Cell[BoxData["\<\"M3\"\>"], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.932136170099523*^9},
 CellLabel->
  "Out[393]=",ExpressionUUID->"2debda8b-553b-a142-a085-94382685b9f5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.025658831822723105`", ",", "0.0036726215236720927`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.9321361701120205`*^9},
 CellLabel->
  "Out[394]=",ExpressionUUID->"6d44c353-af6d-2d41-9fc5-a18555c69f58"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "6.9864853467349163907`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[6.9864853467349163907`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.9321361701229978`*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"11cd60e7-f44e-934b-b509-97928b7fb21e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "36.4786677143692728009`3."}],
  SequenceForm["Magnification: ", 36.4786677143692728009`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170133281*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"78738fb5-f6d2-1f4a-b868-00ce10b5cdf6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0036726215236720927`5."}],
  SequenceForm["Angle: ", 0.0036726215236720927`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170146431*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"6a34dfeb-6c13-5e4e-8ed6-c2ebb8898d98"]
}, Open  ]],

Cell[BoxData["\<\"M4\"\>"], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.932136170153686*^9},
 CellLabel->
  "Out[396]=",ExpressionUUID->"404d5282-9cf9-c940-814e-261d1466a0a3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.031038765129002055`", ",", "0.0041518219182696825`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.932136170166845*^9},
 CellLabel->
  "Out[397]=",ExpressionUUID->"fa5fdf2a-3c4a-e94d-9acb-3d12edcad2ed"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "7.4758954971907121134`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[7.4758954971907121134`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.9321361701776314`*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"fc49705b-6f79-cf41-bc3a-9e59385a2e51"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "30.1558388714832865674`3."}],
  SequenceForm["Magnification: ", 30.1558388714832865674`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.9321361701879215`*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"2b8a7fe1-8ce3-6741-bf19-f85b3112f1ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0041518219182696825`5."}],
  SequenceForm["Angle: ", 0.0041518219182696825`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.9321361702025833`*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"5db597d8-65d9-524f-b4c9-b1aa5a9f6eb8"]
}, Open  ]],

Cell[BoxData["\<\"M5\"\>"], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.932136170210125*^9},
 CellLabel->
  "Out[399]=",ExpressionUUID->"0b3577e4-cd4b-4045-88a7-3b960fa552c0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.03712064149735417`", ",", "0.004673193310782642`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.932046114601186*^9, 3.932046402841478*^9, 3.93204718273839*^9, {
   3.932048919840727*^9, 3.932048925202631*^9}, 3.932050956224519*^9, 
   3.9321361702228394`*^9},
 CellLabel->
  "Out[400]=",ExpressionUUID->"18e5276e-3aa1-7741-a55b-44f3e0637b14"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "7.9432561004238770863`4.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[7.9432561004238770863`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170233125*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"eb3f7593-312f-0c41-82da-503d0977b6d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "25.2150814814640220618`3."}],
  SequenceForm["Magnification: ", 25.2150814814640220618`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170245407*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"e7cf3681-b1c6-5d4c-acd9-35c4def86a47"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0046731933107826418`5."}],
  SequenceForm["Angle: ", 0.0046731933107826418`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932046114605696*^9, 3.9320464028647566`*^9, 3.932047182756559*^9, {
   3.9320489198171825`*^9, 3.932048925171961*^9}, 3.932050956191574*^9, 
   3.932136170256096*^9},
 CellLabel->
  "During evaluation of \
In[385]:=",ExpressionUUID->"80795f05-1812-e841-a514-1fdb4ca81e8e"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pick off Track", "Section",
 CellChangeTimes->{{3.932046373693001*^9, 3.932046390694628*^9}, 
   3.9320464405200644`*^9},ExpressionUUID->"1f3f89c4-e667-0c4b-8ffa-\
f68a61f97f42"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
    RowBox[{"FringeHeight", "[", 
     RowBox[{"60", ",", "50", ",", "780"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M1\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "4", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "512", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M1"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M2\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "8", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "508", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M2"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M3\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "12", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "504", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M3"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M4\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M4", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "16", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "500", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M4"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M5\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M5", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "496", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M5"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M6\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M6", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "24", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "492", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"FH", ",", "M6"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\"\<M7\>\"", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M7", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "28", "]"}], ".", 
     RowBox[{"LM", "[", "8", "]"}], ".", 
     RowBox[{"TM", "[", "488", "]"}], ".", 
     RowBox[{"LM", "[", "500", "]"}], ".", 
     RowBox[{"TM", "[", "560", "]"}], ".", 
     RowBox[{"LM", "[", "60", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ImagePlane", "[", 
   RowBox[{"FH", ",", "M7"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.932046151444826*^9, 3.932046176909002*^9}, {
   3.93204622141587*^9, 3.932046296586502*^9}, {3.93204633330698*^9, 
   3.932046372421313*^9}, 3.932046571614757*^9, 3.9320473712572117`*^9, {
   3.93204868681876*^9, 3.9320487233826847`*^9}, {3.9320487698926964`*^9, 
   3.932048777258087*^9}, 3.932048822351335*^9, {3.932133821680573*^9, 
   3.932133841069733*^9}, {3.932136243924141*^9, 3.9321362747607384`*^9}, {
   3.932576889944771*^9, 3.932576890000078*^9}, {3.9325769638840714`*^9, 
   3.932576963940443*^9}, 3.9327283163268642`*^9, {3.9327294746001396`*^9, 
   3.9327294746279488`*^9}},ExpressionUUID->"15c58ed4-cc32-944d-94ab-\
0f32bfcde788"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.936`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.936, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279040909*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"85b827ff-9dba-f145-9f38-76e45b2bec3b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747047`"}],
  SequenceForm["Angle: ", 0.015598734712747047`],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362790558357`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"5aacbc85-345e-8b4a-83da-cf4faaa158b0"]
}, Open  ]],

Cell[BoxData["\<\"M1\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.932136279069235*^9},
 CellLabel->
  "Out[403]=",ExpressionUUID->"dcf63b49-5525-d743-99a8-a5790fd2344c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "5.6077606893314779768`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-5.6077606893314779768`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362790814285`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"0070606b-df4f-2743-b0a7-4f2e26cd20ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "49.1730845315655855643`3."}]}],
  SequenceForm["Magnification: ", -49.1730845315655855643`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362790904293`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"fc7888aa-775e-974a-84a1-c32eeb4c42d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0033943549696413555`5."}],
  SequenceForm["Angle: ", 0.0033943549696413555`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362791029835`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"a26c47ba-de85-6c45-a30c-a922060d478b"]
}, Open  ]],

Cell[BoxData["\<\"M2\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.9321362791090336`*^9},
 CellLabel->
  "Out[406]=",ExpressionUUID->"4a3aa5d6-527d-e343-a5d5-208b5dcec1e8"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "7.6757120588652778537`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-7.6757120588652778537`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362791215096`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"c35d2823-d048-8943-8c26-fc81d70645a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "62.5050696710192141836`3."}]}],
  SequenceForm["Magnification: ", -62.5050696710192141836`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362791318264`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"55a6a103-b0cf-d44c-995a-838332bb9562"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.001950928618839276`5."}],
  SequenceForm["Angle: ", 0.001950928618839276`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279144491*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"a7a0a720-6627-d748-a966-9ed207ad4849"]
}, Open  ]],

Cell[BoxData["\<\"M3\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.932136279150774*^9},
 CellLabel->
  "Out[409]=",ExpressionUUID->"0570cad7-926e-d34a-8638-7a88e0fecc8c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "12.7489338487238406117`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-12.7489338487238406117`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279162737*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"ba3d00ae-fff1-3441-b9c8-4625ddc447f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "50.8635947102692611566`3."}]}],
  SequenceForm["Magnification: ", -50.8635947102692611566`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279172018*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"18439bde-9e60-c749-b31d-062e8800e3ca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0014434263508020795`5."}],
  SequenceForm["Angle: ", 0.0014434263508020795`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279184223*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"0d90bec6-e876-c941-a20f-0919a815bcb5"]
}, Open  ]],

Cell[BoxData["\<\"M4\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.93213627919178*^9},
 CellLabel->
  "Out[412]=",ExpressionUUID->"65b9dd67-f1be-b34f-a661-ba9115219a8e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "15.6620036397695194808`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-15.6620036397695194808`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362792028427`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"2f380a9b-a4d7-b24b-8f98-a5d09a899236"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "31.9269478447617238714`3."}]}],
  SequenceForm["Magnification: ", -31.9269478447617238714`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279213433*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"e1c6f2ed-cba6-5849-ae07-23b112db522c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0018718481655296455`5."}],
  SequenceForm["Angle: ", 0.0018718481655296455`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279225748*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"70a5c180-2b6f-5046-be76-914843a4b60a"]
}, Open  ]],

Cell[BoxData["\<\"M5\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.932136279231915*^9},
 CellLabel->
  "Out[415]=",ExpressionUUID->"7c184888-88a1-e044-a544-e4dc2a22d0ae"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "14.7453828009337009064`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-14.7453828009337009064`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279243847*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"174502c3-a57c-c64d-8a65-4c6d037a98e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "19.6147927697473285491`3."}]}],
  SequenceForm["Magnification: ", -19.6147927697473285491`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279253111*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"888b4d7a-5b63-0740-be5b-d3c7083ee074"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0032361940630220576`5."}],
  SequenceForm["Angle: ", 0.0032361940630220576`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279265642*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"02a75893-8da9-5343-b504-feda6e533ea3"]
}, Open  ]],

Cell[BoxData["\<\"M6\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.932136279272232*^9},
 CellLabel->
  "Out[418]=",ExpressionUUID->"b7ee0291-b9a9-1045-947d-8c3c64340ba9"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "13.2951079780586933765`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-13.2951079780586933765`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279284523*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"da3051aa-1383-7142-85e9-2ba940782003"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "12.7158986775673152891`3."}]}],
  SequenceForm["Magnification: ", -12.7158986775673152891`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.93213627929524*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"b3af22a7-74f9-f34b-b817-daebb5cd0194"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0055364640432792322`5."}],
  SequenceForm["Angle: ", 0.0055364640432792322`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279309103*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"eb1fe897-d9c1-ef40-8a88-18de5626c744"]
}, Open  ]],

Cell[BoxData["\<\"M7\"\>"], "Output",
 CellChangeTimes->{3.9320461832028275`*^9, 3.932047372477461*^9, 
  3.9321362793153095`*^9},
 CellLabel->
  "Out[421]=",ExpressionUUID->"4fc903f9-0ff7-d245-9670-f4ecd6e67681"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "12.1950312783183232312`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-12.1950312783183232312`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362793266945`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"443b44ed-d170-0d4b-ba35-5998e508134e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "8.7488422302158461719`3."}]}],
  SequenceForm["Magnification: ", -8.7488422302158461719`3.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.932136279336907*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"936fe6ee-6128-ae4e-946d-5ef58163208c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0087726581063012343`5."}],
  SequenceForm["Angle: ", 0.0087726581063012343`5.],
  Editable->False]], "Print",
 CellChangeTimes->{3.932046183211863*^9, 3.932047372500587*^9, 
  3.9321362793494854`*^9},
 CellLabel->
  "During evaluation of \
In[402]:=",ExpressionUUID->"93633334-555e-f643-9c38-a7b482e9a719"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Main Track Cont.", "Section",
 CellChangeTimes->{{3.932046529917553*^9, 3.932046545119131*^9}, {
  3.932124281617586*^9, 
  3.932124282831719*^9}},ExpressionUUID->"a1cadae2-578f-5342-b46d-\
85b1c1ae2531"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"60", ",", "500", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.932046546722589*^9, 3.932046602950388*^9}, {
   3.9320472452134953`*^9, 3.932047311099512*^9}, {3.9320473459146137`*^9, 
   3.932047357968147*^9}, 3.932048704292515*^9, {3.932048789505436*^9, 
   3.932048848054634*^9}, {3.932049293942993*^9, 3.9320492954092445`*^9}, {
   3.932049372038097*^9, 3.9320493721503677`*^9}, 3.932050285496578*^9, {
   3.932050349199604*^9, 3.932050352313253*^9}, {3.932050476200872*^9, 
   3.93205048105274*^9}, {3.932050552328348*^9, 3.932050553621109*^9}, {
   3.932050616949693*^9, 3.932050668270457*^9}, 3.932052284502071*^9, 
   3.932728316329935*^9, 
   3.9327294746297646`*^9},ExpressionUUID->"39e4c2e7-941f-c042-90da-\
263b3580fb98"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.936`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.936, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932049332363407*^9, 3.9320493726361246`*^9, 3.932049404383127*^9, 
   3.932049505088215*^9, {3.932049947724987*^9, 3.932049960106346*^9}, 
   3.932050042273847*^9, 3.9320501391693525`*^9, 3.9320502860559063`*^9, 
   3.932050354053385*^9, {3.932050548267094*^9, 3.932050554086574*^9}, 
   3.932050775772667*^9, 3.9325668459222775`*^9},
 CellLabel->
  "During evaluation of \
In[31]:=",ExpressionUUID->"147bcbe4-f520-434c-ac88-aeb511e9aa87"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747047`"}],
  SequenceForm["Angle: ", 0.015598734712747047`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932049332363407*^9, 3.9320493726361246`*^9, 3.932049404383127*^9, 
   3.932049505088215*^9, {3.932049947724987*^9, 3.932049960106346*^9}, 
   3.932050042273847*^9, 3.9320501391693525`*^9, 3.9320502860559063`*^9, 
   3.932050354053385*^9, {3.932050548267094*^9, 3.932050554086574*^9}, 
   3.932050775772667*^9, 3.9325668459283047`*^9},
 CellLabel->
  "During evaluation of \
In[31]:=",ExpressionUUID->"d1fb32be-b66f-b744-bcdd-365daf01ce63"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"M", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "L2", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "L2"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ImagePlane", "[", 
   RowBox[{"FH", ",", "M"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.932048951412529*^9, 3.932048951985077*^9}, {
   3.932049167165159*^9, 3.932049205575498*^9}, {3.93204924222406*^9, 
   3.932049304678215*^9}, {3.932049351198477*^9, 3.9320493680183983`*^9}, {
   3.932049586512823*^9, 3.9320495874764*^9}, {3.932049775873905*^9, 
   3.9320498025611763`*^9}, {3.932049837882036*^9, 3.9320498565793304`*^9}, {
   3.932050358135248*^9, 3.932050372152887*^9}, {3.932050600144676*^9, 
   3.9320506247257576`*^9}, 3.932133849992369*^9, 3.9321362918304405`*^9, {
   3.9325768900103264`*^9, 3.9325768900123367`*^9}, {3.932576963945034*^9, 
   3.9325769639460316`*^9}, {3.9327294746336575`*^9, 
   3.932729474634657*^9}},ExpressionUUID->"e1b38662-468a-824e-a15e-\
838e7d090b46"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image Plane Location: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
     RowBox[{"-", "499.6603118812890329536`4."}], "\"mm\"", "millimeters", 
     "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Image Plane Location: ", 
   Quantity[-499.6603118812890329536`4., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9320499870287437`*^9, {3.9320500384113064`*^9, 3.9320500725975857`*^9}, {
   3.93205014124913*^9, 3.932050150337284*^9}, {3.932050369402361*^9, 
   3.932050373584293*^9}, {3.932050605088716*^9, 3.9320506098881454`*^9}, 
   3.9320507774901524`*^9, 3.932136296618782*^9, 3.932566849051899*^9, 
   3.932567091895401*^9},
 CellLabel->
  "During evaluation of \
In[86]:=",ExpressionUUID->"7ffc9973-662e-ec4b-9d46-084e9e1c815d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "1.0007598469360676763`3."}],
  SequenceForm["Magnification: ", 1.0007598469360676763`3.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9320499870287437`*^9, {3.9320500384113064`*^9, 3.9320500725975857`*^9}, {
   3.93205014124913*^9, 3.932050150337284*^9}, {3.932050369402361*^9, 
   3.932050373584293*^9}, {3.932050605088716*^9, 3.9320506098881454`*^9}, 
   3.9320507774901524`*^9, 3.932136296618782*^9, 3.932566849051899*^9, 
   3.932567091908428*^9},
 CellLabel->
  "During evaluation of \
In[86]:=",ExpressionUUID->"f7d060dd-7566-1d44-a27f-02bb4230c52b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Beam Size: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "0.9321716921957960977`5.", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Beam Size: ", 
   Quantity[0.9321716921957960977`5., "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9320499870287437`*^9, {3.9320500384113064`*^9, 3.9320500725975857`*^9}, {
   3.93205014124913*^9, 3.932050150337284*^9}, {3.932050369402361*^9, 
   3.932050373584293*^9}, {3.932050605088716*^9, 3.9320506098881454`*^9}, 
   3.9320507774901524`*^9, 3.932136296618782*^9, 3.932566849051899*^9, 
   3.9325670919149094`*^9},
 CellLabel->
  "During evaluation of \
In[86]:=",ExpressionUUID->"bcc7283f-844b-6643-b500-03ca5d5e1e18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.0018656086716445468`5."}]}],
  SequenceForm["Angle: ", -0.0018656086716445468`5.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9320499870287437`*^9, {3.9320500384113064`*^9, 3.9320500725975857`*^9}, {
   3.93205014124913*^9, 3.932050150337284*^9}, {3.932050369402361*^9, 
   3.932050373584293*^9}, {3.932050605088716*^9, 3.9320506098881454`*^9}, 
   3.9320507774901524`*^9, 3.932136296618782*^9, 3.932566849051899*^9, 
   3.9325670919179993`*^9},
 CellLabel->
  "During evaluation of \
In[86]:=",ExpressionUUID->"610bdc36-8e21-f74d-84d5-6cc8445284c8"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graph", "Section",
 CellChangeTimes->{{3.932050415573849*^9, 3.93205051859913*^9}, {
  3.9320505571796403`*^9, 3.93205058347682*^9}, {3.932050985375044*^9, 
  3.9320510003574715`*^9}},ExpressionUUID->"cd6166ee-10bf-074c-80c9-\
811d95dfa377"],

Cell[CellGroupData[{

Cell["Main  Track", "Subsection",
 CellChangeTimes->{{3.932136614392067*^9, 
  3.93213661950753*^9}},ExpressionUUID->"25c6c617-bddd-864b-8d3f-\
c7c46c1273ad"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"59.8", ",", "500", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
    RowBox[{"FringeHeight", "[", 
     RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "MO", "]"}], ".", 
    RowBox[{"TM", "[", "50", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", "spacing", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"516", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "L2", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "L2"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}]}], "Input",
 CellChangeTimes->{{3.9320510017077827`*^9, 3.932051002351753*^9}, 
   3.932051237954767*^9, {3.932052162654192*^9, 3.932052313081873*^9}, {
   3.932052667429823*^9, 3.932052686462011*^9}, {3.932053304024582*^9, 
   3.932053304979667*^9}, {3.932124256990586*^9, 3.932124294262093*^9}, 
   3.9321243436066265`*^9, 3.932126453519268*^9, {3.932132396186951*^9, 
   3.932132397850413*^9}, {3.932133138187952*^9, 3.9321331592249546`*^9}, {
   3.9321332082142105`*^9, 3.9321332928831635`*^9}, {3.9321333764260216`*^9, 
   3.9321333795740337`*^9}, {3.9321335361644554`*^9, 3.932133560011563*^9}, 
   3.9321335929617825`*^9, 3.932133857441267*^9, {3.932133936862479*^9, 
   3.932133938776638*^9}, {3.932133986059292*^9, 3.932133990552473*^9}, {
   3.932134335592825*^9, 3.932134336937491*^9}, {3.9321343916892166`*^9, 
   3.932134402299572*^9}, {3.932227526263067*^9, 3.932227526654863*^9}, {
   3.9325768900163345`*^9, 3.9325768900245934`*^9}, {3.932576963948539*^9, 
   3.9325769639570503`*^9}, 3.932728316332573*^9, {3.932729474636659*^9, 
   3.932729474637659*^9}},ExpressionUUID->"4377990e-fc65-2a41-90a1-\
917831cb6d14"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.93288`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.93288, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932227542335512*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"051ea527-772b-fc49-bacf-963d3e714e44"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747045`"}],
  SequenceForm["Angle: ", 0.015598734712747045`],
  Editable->False]], "Print",
 CellChangeTimes->{3.9322275423491592`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"d856dab2-c5ee-154f-bf0f-510a027a4aa3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"59.8", ",", "500", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.9327282550680504`*^9, 3.9327282556759377`*^9}, 
   3.9327283163365784`*^9, 
   3.932729474641178*^9},ExpressionUUID->"54e232ec-759f-1443-ad4d-\
283047328f6e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"0.46644`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[0.46644, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.9327282562198544`*^9},
 CellLabel->
  "During evaluation of \
In[618]:=",ExpressionUUID->"06a02f05-771c-d049-b94f-92cf9818b3fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.0069637670293869166`"}],
  SequenceForm["Angle: ", 0.0069637670293869166`],
  Editable->False]], "Print",
 CellChangeTimes->{3.932728256224859*^9},
 CellLabel->
  "During evaluation of \
In[618]:=",ExpressionUUID->"eac7eb70-887b-4d4f-b60c-b6b2b3d8df25"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.932134341712462*^9, 3.932134342425602*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"86bf5893-901b-8148-9c36-667581f91742"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"GraphIPPosition", "[", 
      RowBox[{"F", "[", "x", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MinimalBy", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"GraphIPPosition", "[", 
          RowBox[{"F", "[", "x", "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
     "Last"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"GraphIPMag", "[", 
      RowBox[{"FH", ",", 
       RowBox[{"F", "[", "x", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MaximalBy", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"GraphIPMag", "[", 
          RowBox[{"FH", ",", 
           RowBox[{"F", "[", "x", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
     "Last"}], "]"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
    RowBox[{
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"Callout", "[", 
        RowBox[{
         RowBox[{"GraphIPPosition", "[", 
          RowBox[{"F", "[", "x", "]"}], "]"}], ",", "\"\<Image Plane\>\"", 
         ",", "5", ",", 
         RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
         RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"Callout", "[", 
        RowBox[{
         RowBox[{"GraphIPMag", "[", 
          RowBox[{"FH", ",", 
           RowBox[{"F", "[", "x", "]"}]}], "]"}], ",", 
         "\"\<Magnification\>\"", ",", "25", ",", 
         RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
         RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32"}], "}"}], ",", 
       RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
     RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.932051166711523*^9, 3.93205118524848*^9}, {
   3.932052330949793*^9, 3.932052373032537*^9}, {3.932052455449033*^9, 
   3.93205257614867*^9}, {3.932052614345318*^9, 3.932052628926971*^9}, {
   3.932052694870447*^9, 3.932052701929777*^9}, {3.932052869719055*^9, 
   3.932052879441223*^9}, {3.932053194748825*^9, 3.932053262349428*^9}, 
   3.932053316277729*^9, {3.932053437320964*^9, 3.932053467708384*^9}, {
   3.932053510439743*^9, 3.932053586352867*^9}, {3.93205369582418*^9, 
   3.932053721708118*^9}, {3.932054172159219*^9, 3.932054308935325*^9}, {
   3.9321240888565655`*^9, 3.932124107122906*^9}, {3.932124149552273*^9, 
   3.9321241840010624`*^9}, {3.932124215834198*^9, 3.932124216310107*^9}, 
   3.9321242469154816`*^9, {3.932140246660303*^9, 3.9321402705151577`*^9}, {
   3.9321413007325954`*^9, 3.932141342608963*^9}, {3.932141379214367*^9, 
   3.932141380896313*^9}, 3.932141421175819*^9, {3.9322290784470425`*^9, 
   3.932229091898279*^9}, {3.932574451048712*^9, 3.9325744530862484`*^9}, {
   3.9327294746431828`*^9, 
   3.9327294746498585`*^9}},ExpressionUUID->"ec7e2ce5-2294-7949-b444-\
c7c892aa870d"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV1Hc81V8YB3DJuCH34hpX2aOUpGWFcyT0MyqSUVGiRahfEg1CIpHutGVc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          "]], LineBox[CompressedData["
1:eJwV1Xk81N/3B3DKpwVJ0k5mGIxt5k1CyLySiqIvsqWi1Hvs25CxJJEtZMmS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          "]], 
         LineBox[{{7.170934336913348, -3390.354612845273}, {7.170949219944292,
           2600.642635987214}}]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV1Hc81V8YB3DJuCH34hpX2aOUpGWFcyT0MyqSUVGiRahfEg1CIpHutGVc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              "]], 
             Line[CompressedData["
1:eJwV1Xk81N/3B3DKpwVJ0k5mGIxt5k1CyLySiqIvsqWi1Hvs25CxJJEtZMmS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              "]], 
             
             Line[{{7.170934336913348, -3390.354612845273}, {
              7.170949219944292, 2600.642635987214}}]}, 
            "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-3390.354612845273, 2600.642635987214}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-3390.354612845273, 2600.642635987214}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV1Hc81V8YB3DJuCH34hpX2aOUpGWFcyT0MyqSUVGiRahfEg1CIpHutGVc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          "]], 
         Line[CompressedData["
1:eJwV1Xk81N/3B3DKpwVJ0k5mGIxt5k1CyLySiqIvsqWi1Hvs25CxJJEtZMmS
yhZKlFC2JCRUokVKChWiImkjlfq9f3+9H8/HfTzuPe9z7zmH7uRtSc4REBAw
FRQQ+P/vTyP6BgExGvJj0+ebWBQivpE50L+chn9P5h1U6SlAs5D/T0MpGjJG
y6wPpBTgp0mjxCU6DTKV0+JbzArA7bbexlOlYV1y2Gzv/XwYfogon2dI7Zex
sfhm93kEsR62u2+jYfLWB5++s+dR7rfq3WNTGlwqo703O53H2r9lq87Z0iDn
ejuw7nseZiT6I9ieNMRs8t++STEPhB0zO41Hw/dr+X0LP+WCm+1XM8OnwfzO
rpn4k7noVhQevxNBnf+9QmZLdw7K9bWt7TJpMPWoSVnIz8ZoeIT3rWwa+Pu7
+W/lsrH2bucJ2QIaqlOtBrd3ZSHB4lDDeCkNJtKLjl1clwUXbopi+B0aNluM
/Tw4/xxkksdmiidoUFU5ls8cy0TDgbDia99o4HXdUXpWngmHdUt33/xJQ7j6
l00u/ExkPdet7ZhDR5vReI7a/EyslI4L+LycjqDk5UWlxGlIlDC/aXLoaNlb
51pdlI6KkPr8jUZ0yNBKOFeC0mFuZm651YSO7kdyaVtM05E0ya+w3UXHoTWm
Vdbf0iCqfdc72JmOgPNLDqcbp+G/FnK8MYmO3Wrq/jKLUlGYPnPuXhodK5YF
i0+OnoKR88kdT87Q8SNdv1XnzilECFeVDBbQEbxH9KlSyCn8NRdy/a+Wjg+p
Sk/MJ1Pwsz//3fY3dND4b1NFJpJxukwrfdc7OvYPDTr5PUqGVni70d6PdHx2
3P5rfUUyDjO+Fnh+p6P4nkp86+FkfHXb5JS8QBY6MlP6I3OSMTb9euAZIQvp
weiARXaJqHZOat6uJYub/ypKL9MScazH4GKjniyaEzc9nfhwEstrsj2Lt1Lr
Owtkdh89CcOAPX+O7JVF3ZMK78NXE3D2+/NVjFhZyJXqP65Wigd5KHo286Qs
WgRyXh75HQeie/3bRamy6JTPqWrujEPb9bRL09myuBRwTKXNLw5feJbaD67L
QpC7yyaw9QSMv3Ra8V7LonT01PSCo7FYeiBUZ3RYFs+2SEv8tInFwGNVqb0f
ZSFaK7XelIiFf3n80JYfsjga9/aL9HAMcr1NeKtE5KDjNbZ5k3kMpj61JDVp
yQFiE3ruG6JR+PFmu1iiHP5KudYc3xYJr9P/k3NLlYPDlVC5HSqR0DYaCmnN
lMMS+2xvy8WRaM8WVjtSIAdyZuis9Ivj+GK+O+lDrRxulkYmpHgch0HN1K6W
ITmkpf2t3ZUXgQWH4q7IfJDDdGpC/p2YCHSJr/0vZEIOvnO9j7l4R4B021Kt
PkPF015Xs5MTgQTptJW5YgwMPzgxeuRtOHqPq/cHbWDgW9jnJ+9Y4cgnWtc/
M2BAN9dKyGlVODz67RIJIwZ0MvJOCwuFQ0D7GGd0JwN7XvP+DvQeg8LHh+et
DjFQ+o87ExNzDP7mHlx2EgP3e2/5fe0Og5h00efhYQZu6zYOEpmhgM3x/qEP
DLz6+CtxNDAUvCTHB4MTDHxKypz7fHconguuLHrzk4GFdaLGdlKhyBmJdegT
lcchs/Lc4YIjYJW7dT7VlMe7aKdNlfUhMNvMutwcKY/Uh0rb1SWCcfSI8Jnb
J+TxtuHOtbkzQSivGoluSpTHTlaqn8CbIEgyc50aMuUx+HXrOf7VIPSJiq+u
uyKPbgf2vF1mQfB4/iW2olse01dl9x0+FYgE1ypuHkMB8g5lyaY6fHxEaayI
sgLMX1e6SsrysW3lhZIAtgLEj8iNzhHlY87dtAlTXQWMP4mPt3wTgCCGf8DM
/xRw3vHf4+txAeC+1oi2DFHA2ttKtXojh7HJuvyCUJcCEvp4xv7V/shRvXTX
u0cBRK7tcEShP/7Mzfvwsk8BsftjQ8tO+aP2WpJaxagC9iysaDzg7Q+WuHfV
vlkFaLtztjOU/SH1QK21mqkI84y80C+FfpjC5WGXMEVYffytt+0qD/WFY+f4
kYp40J+vV5THQ8QC1V3RJxSRIzT1bk0qD2KPr9wuSFXEKr2iMsNAHhQcr+YM
FCniuOEX+4jNPNiEVthZPVaE8UU1mdJ+X1TdqOng0JmgLbd481zGF8HSP4/v
VGDCpWqlTKKkLxCuo7dPhYlxN4amzUJfdBjfKA5ez8TZsbyAld98MNxTF11l
woRY0MZjTnd9IDl1Cyo8JgIZUu5TPB/4a7RULr/DhGluz8BYiTe4mrS8lHtM
rEk425+X4Q07rSPxog+ZUPY56xsQ4Q09XU2nOb1MtDd2REfYe2OOYeHiiQkm
au8Z168U9UaSRaRb62olmCdHHFhy2AslPkY0f54Sdr9r93q/1xNZvDyRz3wl
uDJ45Ramnjjp/2fKNVQJw1WPK57pecInsLLTMVYJ0aWJ5mprPKF9jBGyI0cJ
OgmBZ5a/8kBLktBz2XYlrNEbUS9z9MDrqy3xT+jKWNsRoDMV7I7Hn4TGNRSV
UZTAeXbF0x1NqltM01SVIVFd0RO43x15Ja2ittrKGItamma+1R1OF9tO9pkq
Y67A3sLfEu4Yyb6XNMpXhsydzhyFcjd8SuhIne1UhoitqL7YjCsGHoh+d3iq
jJ+p4vG6E654KGxm1fRCGReFi7sDh1xxNbZT8viQMqLVrKeUH7rCJ/Jh+oIZ
6jxMPHUqdMX3kMenlzJUcHXoa5iolSt+u3WfUwpWwa8F3c2XG11gpbUvhRWm
AjvxuYvDa1xwRXAkel2kCv6cWZZ9sMwFDpnTvhsTVaCz8b2Bea4LbreuNrbI
V4Gu6JWB1jAXxNAOfA9sV8GyjvH5yza7YOnzT6b3Vqti39phv1ddzvA4H2DY
KaMKh6DOSr0OZ7R4/NPuYqjC9YHMwaJWZwTMXSLXx1LFE/J7V16tM3oJzZnP
hqogjIyTV+c6Izc++MIKd1V4vn64da2XM1Q2zf/LvamKb297jolLOqO85LLi
iyZVfK5uOWYl5gxNSXMLkzZVBLSoMQoXOEN/NLNQ5YkqPlUJSHNnudh5UnnH
5Igqkl8qmPuNcsHrNcsMklCDYUFOx8VbXEwZfr39cYUaDCyET+XUchFyJWNs
j7QaUtSiZM9f5yIy7LWBAVMN6aFbfduKuciQ9303x0ANCwa9nJIzuLjhm6aR
4KqGWaGX15fzuDB4pbN31ksNRf1mO6o8uWg26o/y8lfDqXOF7/e5ctG+QqHX
PEwNWzZKz+vcz0XfrZqwZelqqJF9HUM350JA+FVHTpMa4r8vrDtDcLEtn+5c
sYKFpKnp68E/SWhmiim0SbEgOR75IPgHCVri7+GXdBYEWVN+EV9J/Ap65iSk
ysIhnXTbS+MkSi1OONiCBVGtwwlmb0ksFfxiPevCQucVr6GpByQEpvslJbxY
WBcht9/jPonx8fanCn4sRFcnfH3fRqLtRaGFeSgLs6f+05u+TSKo3M6sIIWF
3gv7Ep1rSbx2bDIyqWPhvqHU7+SLJDqsS+c6NLKgc8CA519IonbH2WZeCwsr
lPaddMgncUrbH1kPWTghbJe2NYfElsVM/c+DLAxOJDPJDBKXG5LWpYuwceFn
S+7zGBKZlUe+Fouz4Sthp02PJhFZ4lrRsIwN85+tC3mRJBwyNrPfy7CR4jZn
q0I4iSVe08p6mmwUKzt6vggmwZd2lH27lw1bxpE1Dt4knMwJm74DbNjI318r
7kVi53HBuB4uG9Ovgm/f9SCh8KHgS6cPG/YJYo+2uZHornzfVBfJxo8oH14c
SaJp9Mb3qhNs7CxmvXA5RMW7Op5ZkchGnuhshelBEhHH1JKLMtmoKcu8wjhA
gjDlOaZdYaP5yz3lZftISIVtTk2qYGMw5GX22r0k5l+TvBtXzUYLqbNHbQ+J
gRU1rPAmNqI83PLsd5NIGPo969nNxr1tH9u+WZMIXN6p7trLxsAF/l8FygdN
cshDA2wEOIraOVqR0C1Dp/17NgxDTu97bUnifXBU1rY/bPQfDVeSMifx0UbF
5bwAAaUhr/f8/5HYP7l0jsxcAq53E/Jf7CSxQ+7d+tULCOj32v64ZEb9b33n
o9PCBDSPpESupKxlU+26bBEB1hHJPwmmJGRPxGSLSxDoSdyeErmDui9ZH+1E
SQLv31VemE9ZrN7uicgKAo4repKStpOYmVD6b74UgRG7sa5SExJesRK5kWsJ
BKQ0yBpRHqb/1plDJ7B3VETrtTGJx1YdHrPy1PqNxelylLdOVM4LYRLYuOdx
T8c2EvUx2Xk/lQnU/E+mI5iyBj1aN0CNgKhBoqca5aI6r+5vbAJW967XDG+l
8m9l6+WrQeBTtMrFPMqnPnEWfNYkMP4vXfMA5aO0JfofN1D5ud0vM7mFxPcb
M8+c9QnohEr6N1B22zXo/c6AgFrfpE0K5Tfj7QsPbiKwLk+lxYWydfT1gjeb
CRjsiagxotwuk7XRYSuBH/Y1qvKUcSOy55Ux5aIUGWHK1Zaevrt3EAgW6I//
ZkRCddxapMeMQHGrq+dbyrVWpo1x5lS+hxQfdFHefMvQz2AXgXT9F/vuU34o
v0HxqzWBX6vW01op2yeyX12wI/BoyT/RNsojU/JJu/cQCBSbXdtBmecotXmR
AwEf1h/zHsp/70pMN+0nkPX0UfYo5RPEwsv+Bwl8S7AQmKUseeafA5NLYEbk
gN8KKt48wSmJPhcCrYzhL1qUVd3G25LcCZjUtwXsoVzbNRi82YtAYfOvP5GU
jfR6WdM+BIRUA8OuU35U8GiwxI/A1ff6MyOU7UXbMhwCCCzqMiVlqPyP+Ndv
lwgi0Fxe0bCXMq//2t/WECoe5RCBXMqzW4qvBR0lYNrQID9CWXJFxuq3xwn8
UVKcf5y677ywhIdp0QQuDafeeEFZ9X1EhPEJAmt8hPXXUe9n8w3vj2WJBJRd
h7KnKD+kc3MOplD5lr/p50i9P/u4vZYr0ghs2hgzr5Myb49J3dEzBJq4DPNq
6v3mzcrGmRVS96F2a7KJev+q3FUGgkUEXpnuUfkfVR81Dxd/rSwm0GfzYPYt
5Ye5f3ZLlRFo/PvDdhlVb7ObniuN3SDQu9/z4DULErElHf059QQua3sOHKLq
VXLpnRTLRgLuWj6da3ZR+w+XzdxoITAxNvMjg6pv++gT92MfEYj+lDB925bK
10RYqH4XgbTF3zJP25HwtQ1Qn+wmMB3ZFe9L9Y9Y5sEzti8JZHQts9ag+kt1
u76rwjsqH5u4AqMO1DxYPLmg5ReB65meMqucSXTdiosxmaXq17FdSMaFqg8P
+XmP/hFg1C32Z7qSkGi3n/tSSB1eYdFDW9wpR7XOfhZTp/oOp7SE6q/iv89+
XSOnjs3PYtirgqj6LV7ve15eHSu/KenaUP042e7xZwWmOvLcf2VlhJBYXP3f
J3U1dTgXKzrSj1L9wtdndJu2Ok71uUQ4HCchOrqlz2+HOs60Klf6J1LzJf2N
/YyZOqp2Mt+8S6L6o1FI71FzddSl1q63TyEhkl/+/IS1Ou5XWViappEQ3rfm
Sa4jFc9T47k2Z0kseDrZ+sBPHf2pGX1/qHkl1HiuTC6Lis96Y0NUM4mX+kbG
r3PUEfNv7FdoC4myuvE3Z8+r4+D2W3FB1Dy0r94oIVGkDqW/zNPB7SQqSl/7
C1xTx97iOJHCLmoeZcnp9t9VRxEjtjxliKqHoMstGd/UIbnsvtCd+Vy4a97s
XbhDAzWnJxPe2HHR9PjZlVozDbzSyxaI28PFMs/JMGdzDfzbtGp2vQMXjRfk
FVqtNRC2ziwm/SAXS1ck847t14BhZ0sez4uLmzOHRKYPa0Az3nIyP5ILkUax
jcN5Gkh7yq/puMbFZROnvIYpDTQSL6yfLHPGj7HV4iMZ63BLwvpi5pAzqnZt
m5tmpIkNpQm+JX0uCDOOyq0c0cRuQcNf3S9cQe/f/qIgaj3E5i4993HADbra
kWmrNLRw5uLt0oYFHti79tGM4FMtvKhn729geuJH+8lBn3BtNLgFxZS4eiFT
yMHfkqGDhIHnFQ3nvLF0oCp/TosOUlLKknW4PvgvNNxqg+8GLP2YrOSyyBcC
xQ5lgxK6+GVduKGhxBe8s2UnJZp1sfaSdb+KDQ+3VGIXLPHSg6X0ooR/f3lY
sp2nGiGmD4/2sl0FWX7oU3v8NKheH+O8bDvfbf4oz+Ewhh02YkcTqzRpxB/7
yrSWSP/dCLM+W2nRiMM4FnU+vK/EALXrvy0UVA5A6Xvpc2KmHNg0h0qPtAYg
Njtq/8BODp4tPq+VdS8Ahyw/yV+14EAkwW+j5YMASNXXl5vZclD6SFCy4XEA
4pL2tCU4cZCEu0NprwLgonXmi3AQB8MhzHmcLwGQjZQ0nn+Rg34XuVVRUnz8
1TmyqOcSB6+WL+/RkeGj99NQ18XLHDQL5oeP0/lItr2+b2sFBz8cD2XtUuTj
n7KlX1Q9B/YZV0ZpGnz0PUnKmfuUgz+pzIc12/iojZ4++PQZB6t7Xli4becj
Tc9RqeAFB1keebelzPjYcYFVaTjAQX6/NRluyUddYOf98A8cDJiE1pvs4yND
bX2SxTgH751F8n478uE7mGVF/8zBSlGed6kTH0xTj9dN3zmgTRY/EXfhQ0iw
uzB5moO0JvdDzW58vKnSc9v/i1rXHR308+Sj3q2ATcxyUHBN0kzeh4/TMiI/
/v3j4EPUeP5zHh//B0vfSNA=
          "]], 
         Line[{{7.170934336913348, -3390.354612845273}, {7.170949219944292, 
          2600.642635987214}}]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-3390.354612845273, 2600.642635987214}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {-3390.354612845273, 2600.642635987214}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.932053556707613*^9, 3.932053570888408*^9}, {
   3.932053712975181*^9, 3.93205372226054*^9}, 3.932054186558183*^9, {
   3.932054251084337*^9, 3.932054310798679*^9}, {3.932124189825784*^9, 
   3.932124217288397*^9}, 3.932124248170241*^9, 3.932124897633547*^9, 
   3.932124968289675*^9, 3.932136477065859*^9, {3.9321384683656197`*^9, 
   3.9321385026254234`*^9}, 3.932138615519459*^9, {3.93214028013446*^9, 
   3.932140293116358*^9}, 3.932141427044569*^9, 3.9322275658639507`*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"68befb49-8bc2-0543-946e-0c7ad0ff4eab"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"7.17`", ",", 
    RowBox[{"{", 
     RowBox[{"-", "275048.67141865176`"}], "}"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.932053556707613*^9, 3.932053570888408*^9}, {
   3.932053712975181*^9, 3.93205372226054*^9}, 3.932054186558183*^9, {
   3.932054251084337*^9, 3.932054310798679*^9}, {3.932124189825784*^9, 
   3.932124217288397*^9}, 3.932124248170241*^9, 3.932124897633547*^9, 
   3.932124968289675*^9, 3.932136477065859*^9, {3.9321384683656197`*^9, 
   3.9321385026254234`*^9}, 3.932138615519459*^9, {3.93214028013446*^9, 
   3.932140293116358*^9}, 3.932141427044569*^9, 3.932227566659235*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"a118778e-1ef3-d048-b566-6f4d9bea15c4"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV1nk0VP0fB3BbPbInZa9kmzszxlzJErnvUFkqS2knSyQpEUnpESElS1GR
0lSyRSiUUiRLERElJUpSiOSRpTJ+9/fHPfe8zvecu3w/21fN3c/RU0hAQOAT
ff3/buP5raWy/6ZZgFRavLWQJEQslA50K0ZSRWH9fRbiklh6NeXyXcVkqp8w
kjaXk4RtY/udK4oZlM68yHZrLUls3jXx6JxiMVWR/jL0pI0kPuietIhTrKbW
s9Y2lidJgjffLvq0Yht1z6tygyohhXDRu9qnFHupc919ddqu0tiy9VrByM8x
qjZp6fuCRXMhPhO+Y83CGcpQRcO+nScLTYfhb09jRaBWWnBg/ho5BDcZUylj
c3Dg3bjHY+sFkC+e2yUoKI2aqCi5v54KKO2xePHSVBatyj3JzyaVUOVzRXnr
dzmYpVeoNbWo4pfWCun8ffII2/SwoXPXYghN3ZJR1lRCxq/MmRHOEhjMuJZu
uK0CPesh/Z2zNfAiUr+plrkIS8Kkq13+aGJR4uBUzvBiNL0VPbGRYmBworvr
NXcJStyMGwQCmMgYeFgvFa8OcWl18aw2NqRUs3709mqgwEQk1k1CF9h04sPn
fg14Bt0PM5bTRUDCzoaeYQ18Pa0cJqmiizeCClkfJzXg7zcdksPSRXpfjEun
hCaW8aY8Cm10wSn0aWzV18Tu5riFoyd1sc6Cc6sqUhPLj3/3nTWji39DxVKf
nNLExxSDs1rCXBSW9EVXxmtCxz+yu242F3KMq+6PUzTh6eFVLSTFRaeEjNKD
PE20xSZwtqpw4fvmZ0xRmya8ghaGRRpxcWZPiRdPQwsTNxJ+F+/nYgD5MeJM
LewadvZbFcDFGoWbuYd0tZCkIWb0KogLobrk4bXLtZA9/V/+x1AuQjQCD03Z
aaG0wDa2+TQXXt160Y5HtVCj1i85cZOLlU6FN0VeaeHdWcZ7ww4u0tnZdX7t
9PoD6zdrOrn4K8zrf9ephWepCQEburm4fydBp+irFqzNuCHOX7jgyPiVOE9r
oarDjWn6kwuVBp2aUoY2ZNXlTy8SJTGOW73eYdoQttrQsk2PRHnGYFpwpDbm
39Lpy9UnESHK3hB9Shtvg+ZcGzcgIdWc9+RGkjbk3d9PHTchobXzdnpXljYE
d1Y0u1qS2HSsaMvGZm0sG94+ZO1EQuXTT2mP19rwNuu87biZRI+lXp3/O22c
EHb5sGkrif0Sd5cl9Goj3Xb6oIMziei0Ytn6SW0cMzdhSXuSKCm794JSY8BF
UHss5yCJI6qTJ9ZrMeDnYyroHUQC4UYmziwGAlMeWqkFk3hhVZZzZBkDklWr
jkYdIdHb/iC6xJoBxiarhXLhJOTGH4EVwMDr2KOja+JIvNvKnzAOZiB6fuWm
+/EkeI/MCqxCGXReStarJ5JgR1WoekUzcOj+eOvgORKWck9+8y4xoONpoYcU
EoF61cULnjLQ9MFedfIaCS/9xbyzzxiQqPI25t4gscUgNFaiiYEfAf4u7hkk
TJbruwt1MJCaHlNWnElCyDxDeniYgSiJJv+5t0iMWQj88R5jYLuOUpJiHokv
q3b0fZ5iIPTif7nK+SSeWcs96hAh4MoULJUsIJHgEOlTo0QgTUBeKOcOieMb
PjphMYHoc6K843dJBDiZrnyoSaCgjqXpWEzHZ+uYfBGXQKGMZVdPCQmr7fbC
bAMCHa3jUtdLSRg75w1nmhDwzNu0ePs9On5uu2ouryaQKaLe/eA+HX+PykL5
tQSuPSk65VZGQsBT5fI5BwJRinrSQg9IfPZuC4jZQeD93vab3Ick2ny4LsLu
BERVIosf0671PWP9724Ch7vJ1NXlJHIPWC4ODCDw+iT7o8UjEpcDeOI/ggl0
+e5GGe24wL/je44RWOMdFsB4TOLfQ1t6eiPodV5s0FnaBw4XN+6MIbBHqdBq
jLb7EZmyd3EE5B6rDtpXkNgY6pvhlETgpI/sjizahsc1jtqmE3AZe5a5spIE
I+K4V+0NAsIWa8KiaCtFdjqszCGwOqJG/SltiWijFeW3CYTsqkr6TZt/Mplh
WEzv17nnTawnJEZOjcy7U0ZA8dHBtk20P8WunWFXENC75JVxlParuOyBrGoC
Ip82ml2iXZ0g8mZJPQH5zfxrd2iXnnV9cuUlAY863ZfVtLOTyvMUXhMwF39a
00z70nmFlKR3BIoErka9oR17MfCE1EcC/Iv3pP7v0NTm/ae+EAhqlHR7SXt/
GnubyCD9PbyC0CrarldiVoWNEGBp3ncroO14tZf7+xeBimA7mQu0La9BJegP
gQ8VuTGHaC+7cfmfEQEmKjgSDfa0tW5OjvrMZiJqqqpdg7ZC1sauL+JMsF1Y
BaP0fojlFD53ncvErKu3HR7Q/psrUfJ+ARNfBJ9WHKU9nOfN26TChETD4JQB
7e7b1bEtaky0mJQJfKfj0Twk8l1Pm4lFgnbOl2lXsletTWYzofxU9Mlq2rzc
GonNhvT7jLJ5p+j4JvbP2nfflAnz/8QXLqEdzljdqGjORExBws1iOl/cM2vj
OtcysXp+8Js6Or8cv8weXuHIRFj8/XAr2hYaa9Zf3cxE1rXXy5/S+ahxvU7K
3Z2Jldaf3mXS+dt35VnC12AmhgLjRrXofH/TKTpidYx+3pIs9mG6HuqUre1z
I5go9Fr371O6XrJTn8vsi6Pn2pOJfVZ0Pfmcrz87ep3+/8ItOeJ0PW5rExvd
kM1EbbtivU4RCdt5to4l+UzcrZ0lbVNI95ezDbKH7zPxhIqR8L9NYujMi6Tp
RibEQz+IheSS6GqQGHNpZWIrZRPum0OiSWzdxsq3TJwMcGZtyyZxO6ZR7sRn
JgZKxdQ16H5yILLpvOgUE39Mx7sC6H7k+lRqfA+fic/hj7hGPBIOQnabGoRZ
WK3p/2winYTe8ZcL4qVYeNuS0Op5me4/R5svztNgwW70Om/6At0/H8hMBhIs
uNiH7Dl/nsTrKfstbzgshL9YFqedTOdvcItCqjELWZM3R5afJXH44KvUhXYs
kDbRhxfGkvjj05ZGHGEhJ+qywftjdD0aOJ/lhLFQyjfzMAolkSfYF700koXk
Iv2WRLpfu6RM+K+IZ2HONyp0Kd3Pn9QoWTlcZ0FKaL8LDpA4udht7HA9C+wt
D/uOuJH4ONjff+wlC2nTYVFxO0kY3QvojmhjwV93w/k0ep4MrIusP9PFwsv9
03K59LxZdzSLxxtloVIp/0eiA4l5b4bWPlNiQzlqvuApkPC9dsi8cREbZfaj
ZhvN6Hr1nTF8pcHGVcXZGsqmJA4Jz1Xv5LBBlhKjaYYkOrj6Uz/M2ZiKGBf2
4ZC4GnvkpvxeNj4vqjExUSbBWvkP3+shG3uf7xx9Qc/fwtxb2m8r2Tj0auh8
xzAX+nL2Dta1bISUvyn4NMiF6deUDFYLG3nf/27vpef3+jim7UgfG2n/nmUV
0/M/oGNdSoisDtQ6nHZHVHJR5p+sd2aPDq4L7tURiKXPG9fVdhfJc3Ah39uz
So5+foqUVq0KB6LdA37Kc7lYHP+n950aB7e26tT4S3LxO+S1uwibA0rV1mMB
ff7JdzjlshkcJD5LHQgb1sU8wZ9O094c2A14O5F3dNG9s9LS+gEHlxQC1EQM
dBGsunPJpx26KNuSd+MYyQH7u5N4+zou7OL+cvNk2ZgnPSJa/ZsL66Z7foy7
dB+sSCtQp/Ms3uCI/nX6nLFX/2HHHFs9vDVxv2hnqYlb1u68x+N6sFeweXHN
UB2/BpVk+i4sRfaej2+/B6uhZMMa4WRLfcQnqraJRCxCmFXU1eI+fdh46Fps
u6ECtQ82b29ELUPLCf+ccFUlLDeMTFbUM4Dxx+MR7/PksWPhyynBVgPI5wS0
B2bOx6/6uJ4D4YbYMjCg+OXOPKSIuAQ6ahhhddD6vjVyspjXVXJdqNoIA74z
KRnZMph1LHyjsb8x6hPcy18kSkEgx6WgR3Y5zMxl/v60lEDApYI42arl+MrZ
b+4mJoZHrBjRuftNoNCU/409XxRzbQLYEVKm6OA1FX7wm41OnebWkHJTNB2Q
PefVKoLCdEqj12UF2sMYE2rBwnAuMJiryl8BUbduPwsI4XjUtfDOXDMUfIvr
2CEpiPxvqmlSayn8+k+id4eoAGKuRLl2radwalKwV0hEALschzRvO1Dw3cJl
O83MUCrl5YXrNlOYw7qsxB+aoU4nbK89404hI2GO2+GGGcrbIPWnWAgFouau
muTJGWpJpJzVP5kU/lH6Lp0nMEPxjUIl27MphDj/9nGb5FMdQ59fZd6i8Ej7
yLjiCJ9K3HzXeXURBfGV51KSu/nUDNPxYFQ5hZxldz4UPOZTnS0J6cKtFBI7
xOYdO8an7kdPeLS+piAiL1C+K4hPJZvsJG68peCV/yHUbh+fsr3JKTbvouDk
uB4cZz714HDj8/B++n25KhkyK/jUBZ1lCQ7fKaxr9uyRWcan/Hsub1T7QcE5
LJMtp8OnGGt9uyvHKMhaa3Wrq/IpEcG2jMQJCvF7Dlpy5/OpjyUmPq6/Kcxa
3FZASfKpcp8butxpCsaxLYscZ/Gpi4vEf9Hbhlfpv87tnp6m/gchpBhl
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV1nk0VP0fB3BbPbInZa9kmzszxlzJErnvUFkqS2knSyQpEUnpESElS1GR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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0., 17.75717959529783}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0., 17.75717959529783}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV1nk0VP0fB3BbPbInZa9kmzszxlzJErnvUFkqS2knSyQpEUnpESElS1GR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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0., 17.75717959529783}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0., 17.75717959529783}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.932053556707613*^9, 3.932053570888408*^9}, {
   3.932053712975181*^9, 3.93205372226054*^9}, 3.932054186558183*^9, {
   3.932054251084337*^9, 3.932054310798679*^9}, {3.932124189825784*^9, 
   3.932124217288397*^9}, 3.932124248170241*^9, 3.932124897633547*^9, 
   3.932124968289675*^9, 3.932136477065859*^9, {3.9321384683656197`*^9, 
   3.9321385026254234`*^9}, 3.932138615519459*^9, {3.93214028013446*^9, 
   3.932140293116358*^9}, 3.932141427044569*^9, 3.932227566780054*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"7bc3636a-1378-1341-9623-3d31177a40f7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"12.93`", ",", 
    RowBox[{"{", "17.757187287858788`", "}"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.932053556707613*^9, 3.932053570888408*^9}, {
   3.932053712975181*^9, 3.93205372226054*^9}, 3.932054186558183*^9, {
   3.932054251084337*^9, 3.932054310798679*^9}, {3.932124189825784*^9, 
   3.932124217288397*^9}, 3.932124248170241*^9, 3.932124897633547*^9, 
   3.932124968289675*^9, 3.932136477065859*^9, {3.9321384683656197`*^9, 
   3.9321385026254234`*^9}, 3.932138615519459*^9, {3.93214028013446*^9, 
   3.932140293116358*^9}, 3.932141427044569*^9, 3.932227567511912*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"437b5d94-4f5c-804d-963d-f34628fc1f43"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     TagBox[
      TagBox[
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], Opacity[
        1.], LineBox[CompressedData["
1:eJwV1Hc81V8YB3DJuCH34hpX2aOUpGWFcyT0MyqSUVGiRahfEg1CIpHutGVc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         "]], LineBox[CompressedData["
1:eJwV1Xk81N/3B3DKpwVJ0k5mGIxt5k1CyLySiqIvsqWi1Hvs25CxJJEtZMmS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         "]], 
        LineBox[{{7.170934336913348, -3390.354612845273}, {7.170949219944292, 
         2600.642635987214}}]},
       Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
      Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
   GeometricTransformationBox[{{{}, {}, 
      TagBox[
       TagBox[
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
         LineBox[CompressedData["
1:eJwV1nk0VP0fB3BbPbInZa9kmzszxlzJErnvUFkqS2knSyQpEUnpESElS1GR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          "]]},
        Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
       Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
     0., 337.3845050493788}}, {0., -3390.354612845273}}], {GraphicsGroupBox[{
      {EdgeForm[{RGBColor[
       0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
       AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
        NCache[
         Rational[2, 3], 0.6666666666666666]]}], 
       PolygonBox[{
        Offset[{-0.5697376901336724, 2.945403022413257}, {
          6.355370346580744, -3309.6693778042395`}], 
         Offset[{5.979780750509798, 7.854408059768683}, {
          5.000000000000001, -965.0795751868969}], 
         Offset[{41.500174975701405`, 7.854408059768691}, {
          5.000000000000001, -965.0795751868969}], 
         Offset[{41.500174975701405`, 21.85440805976869}, {
          5.000000000000001, -965.0795751868969}], 
         Offset[{-20.499825024298595`, 21.854408059768677`}, {
          5.000000000000001, -965.0795751868969}], 
         Offset[{-20.499825024298595`, 7.8544080597686765`}, {
          5.000000000000001, -965.0795751868969}], 
         Offset[{-1.4191515404848074`, 7.854408059768681}, {
          5.000000000000001, -965.0795751868969}]}]}, {}, InsetBox[
       StyleBox[
        RotationBox["\<\"Image Plane\"\>",
         BoxRotation->0.],
        StripOnInput->False,
        LineOpacity->1,
        FrontFaceOpacity->1,
        BackFaceOpacity->1,
        Opacity->1,
        FontOpacity->1], 
       Offset[{10.500174975701405, 14.854408059768684}, \
{5.000000000000001, -965.0795751868969}], NCache[
       ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
        ImageScaled[{0.5, 0.5}]]]}], 
    GeometricTransformationBox[GraphicsGroupBox[{
       {EdgeForm[{RGBColor[
        0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{1.6925727701206839`, 2.476933066888565}, {25.16618035008954, 
           3.961070920795871}], 
          Offset[{5.59222088021792, 6.605154845036174}, {25.793388397368872`, 
           4.871387651138685}], 
          Offset[{40.866664402547556`, 6.605154845036182}, {
           25.793388397368872`, 4.871387651138685}], 
          Offset[{40.866664402547556`, 20.605154845036182`}, {
           25.793388397368872`, 4.871387651138685}], 
          Offset[{-23.133335597452444`, 20.605154845036168`}, {
           25.793388397368872`, 4.871387651138685}], 
          Offset[{-23.133335597452444`, 6.605154845036168}, {
           25.793388397368872`, 4.871387651138685}], 
          Offset[{-1.2012302716299699`, 6.605154845036172}, {
           25.793388397368872`, 4.871387651138685}]}]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Magnification\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{8.866664402547556, 13.605154845036175}, \
{25.793388397368872, 4.871387651138685}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 337.3845050493788}}, {
      0., -3390.354612845273}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
      FreeQ[#, Rule], 
      Apply[{{{Bottom, 1}, {Right, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, 10.048933967341117` + 0.0029639772575022153` #2}], {{
          Bottom, 1}, {Left, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
    "DisplayFunction" -> Apply[Grid[{{
         Subscript[
          Style["\[RightArrow]", 20], 
          Style[1, 
           GrayLevel[0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, 10.048933967341117` + 0.0029639772575022153` #2}]}, {
         Subscript[
          Style["\[LeftArrow]", 20], 
          Style[1, 
           GrayLevel[0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
       Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
       Spacings -> {0, 0.5}]& ]},
  DisplayFunction->Identity,
  Epilog->{{}, {}},
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->{{None, None}, {None, None}},
  FrameTicks->{{ResourceFunction["CombinePlots"][
      "CustomTicks"[True]][
      SlotSequence[1]]& , ResourceFunction["CombinePlots"][
      "TransformedTicks"[{-1.0215863719791465`, 
       19.410141067603785`}, {-3735.022025320648, 3158.32622418685}, 
       "CustomTicks"[True]]][
      SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
      "CustomTicks"[True]][
      SlotSequence[1]]& , ResourceFunction["CombinePlots"][
      "CustomTicks"[False]][
      SlotSequence[1]]& }},
  FrameTicksStyle->{{None, None}, {None, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->{{49.78762511817777, 14.149074281964971`}, {1., 
   1.6724141286300096`}},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-0.6666666666666667, 32.666666666666664`}, {-3735.022025320648,
    3158.32622418685}},
  PlotRangeClipping->False,
  PlotRangePadding->None,
  Prolog->{{}, {}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.932053556707613*^9, 3.932053570888408*^9}, {
   3.932053712975181*^9, 3.93205372226054*^9}, 3.932054186558183*^9, {
   3.932054251084337*^9, 3.932054310798679*^9}, {3.932124189825784*^9, 
   3.932124217288397*^9}, 3.932124248170241*^9, 3.932124897633547*^9, 
   3.932124968289675*^9, 3.932136477065859*^9, {3.9321384683656197`*^9, 
   3.9321385026254234`*^9}, 3.932138615519459*^9, {3.93214028013446*^9, 
   3.932140293116358*^9}, 3.932141427044569*^9, 3.9322275777280674`*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"47dd44cd-ec4a-c648-b28a-cecb22d3ea7e"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pick off", "Subsection",
 CellChangeTimes->{{3.932124369969839*^9, 3.932124373728895*^9}, 
   3.932132579418812*^9},ExpressionUUID->"309125aa-b490-2546-b759-\
ee6c92e009c8"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"300", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
    RowBox[{"FringeHeight", "[", 
     RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Pickoff", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", "spacing", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L2", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.9321408587508564`*^9, 3.932140859756777*^9}, {
   3.9324819519361897`*^9, 3.932481952608221*^9}, {3.932566948882237*^9, 
   3.932566955094272*^9}, {3.9325671534400787`*^9, 3.932567173950041*^9}, {
   3.932567214231731*^9, 3.9325672459476986`*^9}, {3.932576890028103*^9, 
   3.932576890034107*^9}, {3.932576963960569*^9, 3.932576963965566*^9}, 
   3.932728301837679*^9, {3.932729474653942*^9, 3.932729474654951*^9}, {
   3.9334350288655624`*^9, 3.9334350799962425`*^9}},
 CellLabel->
  "In[1550]:=",ExpressionUUID->"beeac471-b8a8-224f-996d-559bed1108e0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Height: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"2.34`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Height: ", 
   Quantity[2.34, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932481954272564*^9, {3.9325669442677517`*^9, 3.932566949659965*^9}, {
   3.9325671541560936`*^9, 3.9325671744356937`*^9}, 3.9325672168720818`*^9, 
   3.9325672507186985`*^9, 3.933435109519478*^9},
 CellLabel->
  "During evaluation of \
In[1550]:=",ExpressionUUID->"336a35c5-f151-6446-ae5c-09dbc0845319"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.00771651350416508`"}],
  SequenceForm["Angle: ", 0.00771651350416508],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.932481954272564*^9, {3.9325669442677517`*^9, 3.932566949659965*^9}, {
   3.9325671541560936`*^9, 3.9325671744356937`*^9}, 3.9325672168720818`*^9, 
   3.9325672507186985`*^9, 3.9334351095234795`*^9},
 CellLabel->
  "During evaluation of \
In[1550]:=",ExpressionUUID->"857b3d83-2e1c-da41-be75-3677b2daff4a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"GraphIPPosition", "[", 
    RowBox[{"Pickoff", "[", "x", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"MaximalBy", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"GraphIPPosition", "[", 
        RowBox[{"Pickoff", "[", "x", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
   "Last"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"GraphIPMag", "[", 
    RowBox[{"FH", ",", 
     RowBox[{"Pickoff", "[", "x", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"MaximalBy", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"GraphIPMag", "[", 
        RowBox[{"FH", ",", 
         RowBox[{"Pickoff", "[", "x", "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
   "Last"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{
      RowBox[{"Pickoff", "[", "x", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{
     RowBox[{"Pickoff", "[", "x", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MinimalBy", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{
          RowBox[{"Pickoff", "[", "x", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
    "Last"}], "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Callout", "[", 
      RowBox[{
       RowBox[{"GraphIPPosition", "[", 
        RowBox[{"Pickoff", "[", "x", "]"}], "]"}], ",", "\"\<Image Plane\>\"",
        ",", "5", ",", 
       RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
       RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"Callout", "[", 
      RowBox[{
       RowBox[{"GraphIPMag", "[", 
        RowBox[{"FH", ",", 
         RowBox[{"Pickoff", "[", "x", "]"}]}], "]"}], ",", 
       "\"\<Magnification\>\"", ",", "25", ",", 
       RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
       RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}], ",", 
     RowBox[{"Frame", "->", "True"}], ",", 
     RowBox[{"FrameStyle", "->", "Red"}], ",", 
     RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
   RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.932124311103915*^9, 3.9321243309090023`*^9}, {
   3.93213338433752*^9, 3.9321334048199577`*^9}, {3.932133471050049*^9, 
   3.932133471298835*^9}, 3.93213386549074*^9, {3.9321366432824745`*^9, 
   3.9321366458886204`*^9}, {3.9321372223645496`*^9, 3.932137230550642*^9}, {
   3.932139070201908*^9, 3.932139080653017*^9}, {3.932139151465315*^9, 
   3.932139186898653*^9}, {3.9321392236514874`*^9, 3.932139285128425*^9}, {
   3.932140313982855*^9, 3.932140330163654*^9}, {3.932140987292545*^9, 
   3.932141019622612*^9}, {3.932141051332487*^9, 3.932141113297853*^9}, {
   3.9321411484481926`*^9, 3.932141220891102*^9}, {3.932141257334326*^9, 
   3.932141269902649*^9}, {3.932141510636975*^9, 3.93214157161438*^9}, {
   3.932566858980326*^9, 3.9325668608512974`*^9}, {3.93256692152923*^9, 
   3.93256700265315*^9}, {3.9325692210592937`*^9, 3.932569237122612*^9}, {
   3.93272947465937*^9, 3.932729474667017*^9}, 
   3.9334351458191795`*^9},ExpressionUUID->"9156d21a-4d5e-294d-8d4f-\
34f929ddbb7b"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV1nc8lV8cB/CMolLmvdeMwrXuvc9jRAnPN1EyyswqWRHKDlGhkGQV2VJm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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV1nc8lV8cB/CMolLmvdeMwrXuvc9jRAnPN1EyyswqWRHKDlGhkGQV2VJm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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {5.3298992175139395`, 
             15.969581628927273`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 5.329899217513951}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {5.3298992175139395`, 
            15.969581628927273`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 5.329899217513951}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV1nc8lV8cB/CMolLmvdeMwrXuvc9jRAnPN1EyyswqWRHKDlGhkGQV2VJm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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {5.3298992175139395`, 15.969581628927273`}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 5.329899217513951}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 5.329899217513951},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {5.3298992175139395`, 15.969581628927273`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.932567003254272*^9}, {3.932567157578121*^9, 3.932567177205875*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.9325692385210037`*^9},
 CellLabel->
  "Out[194]=",ExpressionUUID->"f79c6a59-7cf3-fd40-b72c-2db628323fba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"16.03`", ",", 
    RowBox[{"{", "15.969581758583987`", "}"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.9325670032542725`*^9}, {3.932567157578121*^9, 3.9325671772058754`*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.932569238610937*^9},
 CellLabel->
  "Out[195]=",ExpressionUUID->"5bb5774b-ed2a-8c4a-ba8f-a419fc1e7f42"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV13k4VfkfB3AiFXXt+13OtRQlIVuo874npDCWSAuKtGAkWhCNiH4KUUnJ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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV13k4VfkfB3AiFXXt+13OtRQlIVuo874npDCWSAuKtGAkWhCNiH4KUUnJ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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0., 37.50089408582606}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0., 37.50089408582606}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV13k4VfkfB3AiFXXt+13OtRQlIVuo874npDCWSAuKtGAkWhCNiH4KUUnJ
HspSoogJZaTRWFrGNspStKhEZggzht93/rjPfV7POc/5nvs5n8/7ey7fO9B5
3wIhIaEx8vnve8u+4Zf1nwo2hPruODB53wCiG1UODyjH0Nt+HJvqqjXA2uyr
GfeUU+gQi2mvBw0GsG3rvpupnE8H+Xo1nHlmADefqbqLyhW01/IfKow+GKBv
zf82Jio30v1d9dtG5NciR97hzDnlDlrSUXtl7fG1iFp8b8VZ5Xd0qg4V37/e
ENt35N75Nj5B/5haLWoqZgyJ+Sj3Tdx5umVS2san1QSaTqPDj+NFofDKe/GO
7HUIebaOvjqxBG1dlS73isyhWCHdLywsCX7MA62TKetxf3Bj63MLGRxzM39y
7BqNBr9M1R0jcuhsNmwJ+hm498nf3/O7HMyzTvmV1wL5B81q9grJY2LlgMfY
IyB2f/fOQ3LyCIrlGu//FbDxlr522kIew+0ZXnQ78HxHrFJpgjwK3ONtM0eA
XpsAeZHVCuhtScqY4AjQ1mS+b7GJApae/ePcDCXAQ2vxymUCBUw4bw6ZVRcg
2/Kmi5IrOf/5Z3pWWwBvvL20+qQCKqSMrIaMBBg2cZXZ3kac5PGbnb0Ak8vX
S94OUMTDwa+c8BMCbBhkms6FKmLu5ZkPx04KcCbTJvLgaUW0vx8fDTglgIKc
y5h6miKEhKbLXc8IYCzs//xaoyKMTqjli1wUIPT11aQ4VSWExd/e3lUowGzS
hKTPb0qo9q11Q4cAlrZ/Nwk6lBDwq2hzb5cACWJCp3gDSpi/KyN/vEcAzkmJ
b68mlHCBpaGd3U/ux0/thROlDOWfNP9qHhYg0tIxmQ5RRsdh7QNnZgVYMFMi
paqpAsVuI7VQPgPVNuYveo0KFDbOF8eoMzDM7en0WaeCX7Ka1M5rMti3eVF6
qb0KvCuOdF3RZvA0zVuTOa6C39/lSp3RZ5Bkpmzm26SCCNdDIy1gUMgqY59/
qYJUecs9NxgG9YPW83dfq4B1vTXnpCWDP88dbZwdU0F815NINRsG214//yFZ
SRUK07cirBwYsCPO7K3yVcWNjI/3R90ZGDlyrHuPqCIoNVrssieDHzQqtIR/
UoWLSJCI6R4Gka1vv265qApKaODfI3sZDLLXh/Y/UMXwb92/PPZlUFT3V8LC
pWyIXxGbrj/GoOHCucCVCmxwFIOt9EMYvNrHd3ag2NgeLauRFcpgKctBMc2Q
jdwdfucDwhkc9izO1fFgY2Gg0+fBUwyM5/fc31rKxrIrjt7L4xnY2ddHW1Wz
ITqE4e0JDPam8xxMGtigLkuLxyUySDbp/6jSxUaVxiJ2bxKDT4G7lAf/ZUPu
1ZjLrhQGGW9cIw7bc6B2+l+RygwGd3UrbbzdOKgZ9ikryyT1jpCTd/HiwF2T
874wi8GkUvttk2McXE/nDJ3PIfVwchyYy+BAOeaUrH4+A+GGLUziCAfDT/ft
bStmoCRVzIr8zsGFGH3lCyUMdD2XvD4sxIVFVuQmp1sMdv7ddMRFjotUXRPx
ptsMKgysClQtuOB3zknFlTFoPpUftMyaCyv27SNryhm8eSayYd6Bi2HLAJt2
4mX+DV2De7lYd8/YSuoeg/159OLieC6c/N1Cd1cyiBjP6ki/zAVHZ9DtM/El
ei4nMZtc7ydWftB90h+va9cF3eNiLv1N5LEqBl3abLG9dVz4zexk/Uk8EhL+
u0sTF96S1CL/agbKcmb+pq+5eBOxx8j5ZwZ63mkmK99z0cJ76VtPbF02LcIe
40JOPkRs1QMGwXZVGfMLePjQeOL4JHHcNQXf8aU8bK0YtXGtYZA9fMxoSIGH
FO/GqHLi1hjDZ7+u5KG1e1Rjdy0DM8mWBReMeFhim+RQRVyY5mWyCzzEh7uZ
S9QxUNCY9te05eEfzc6PO4lPl57PGXPlkf5Ld7lB/M1Us/PnPTzolFhGfSX2
fFyzJMafh83thwL0HpLr/zEcrBTFw4Twm+gi4kLvyJuD8TwsE4kuGSBW+Crf
eyuVBxNm10XpRwxiQm5JheTyIFm1woQmHhfeaCW4xYO/ZlHaQWLPhJ4wiSoe
LLg3f04kblU4XNr5Cw/mQmOppcRmuWJD2a08FE1v1W8hLlyVqejXzcOAyJ24
IWKF+2vtDAd5aPvanzH133qkA+ZGeDjh/DRgUT2Z3+Y9lU+neHDKcv1Hhris
+J+jm4UphLJCrFSIP45ZJ5WKUZgrU7PjEHONLhbJLqUgss9Fkk3scqLvcag0
hZpXy5IUiOMfafX3KVAIu7StZSlxg+jRaYZN4fRb88Y5sv705kcyhXwKEx9f
hI0Qr0kSX71sBYXD13RHOon3d7huCtah0FN7RLWGOFM516tbn0LnYOOiDOIO
z5FwCxMKhwLtykOJJfJNUnMtKHilmCk5ETOfosvEGApnnZ5YaBKH6T5r9t9E
wfSoFm+S1L/siPL7F3YUNqYWPKon/ljtM2/kTMGaE8ONI+bO3VFOd6NQsE7a
wpbYdeM/a4U8KMS8z1YSJ06Is/5hnzc5PhRX0Uie/4xMX/SaAAqvnnxatZpY
b7tWZkowqYek3uLXpL/2Zx6pmgmhUHE0oCCGuGOF+MjjaHL/NUUaLaQ/JQJc
xbTjKOyRKVh0kJi5m0OdT6Tg7p98W4i4zMLEdftVCvTyQEtN0u8fo6ID6zIp
yHYnGJeT+eA2tZ1Vy6PwTn3sqylxgpPPw5HbFPr+lLtjTubr4P4LK6IeUzDf
uuo8i8xndkmv4MNTCkHd8XWhZH67vq1wt31GQcHkS1V/BQPL8IfJ8j2kHuOj
Ullk/nnJX2aKRinMjG/48TPJj4dekUV3/6IQ5+oeTBN7rpXdUTNNwWHlt47k
OyT/usyqWxfwkZVecVerlOQV59zxMQU+ribrDOuQvKoa5SyfVuXDaqH7Jx+S
Z9vqyzuF+Hx4yL61TyticHlvj6HMKj7+0C62nLrJQKZY6y9Dmg+3WkfROJKH
5eG119db8tGZqmWel8fA0d7R2XozH1GRFn0PrpP961tIudtWPvyKtx8YIHm6
1KQp8MQBPt4/Ern7L8njhY37Rh4l8SE2paueTPI6//JM+tMUPmr+F3s5+BL5
/QcSbV+m8WGwcyjW6SKDaPHK4sE8Pmx8x96LJjOYcxT1XVjNh8StqqcCsl9M
911/v+UNHzO9jxzloxh8mRro79RTQ0b98Y+r/RjcP5DUsMVYDScP3bsSdZDB
qe4NNx6Zq8HrFyfvl/vJfFZlBhRZq2HLbI7DPrLfMcd3zUa4q6GkWaTZk+yX
1ya6lDXi1CB3RsLmmj0Dm/E2l+ABNYSxeVcsVzOQ9Tpp+vGdGq6P55hQqxj0
v9Bhu39WwxPRScG0FoOjZfFDVpNk/YGF2Zka5PkHbg5WllDHV1Gdp3WqDL5/
bUyqN1aHlli13bYlpB6fa5pZ59Xxxv9iyOxbAQ5dcVD3u6SO/nmvL8cHBDCx
HAp/clUdExtOWo72CtCcKb46Ik8ddK3H3fZuAcYddyR9qlZHqPD952Ft5P2l
6vvWxiF16B5yvmNULUDPaf2+sHUaiO195xEVLwCLc3Ps3TsNxEffOqu0UgBs
O9039EkDnYttp1RXCBCctLtlcFQD8tWZezgaAnQJK918M60Bvuu8ngpXgKwP
cZ69SzVh9IWSnZUWQLfMr63dUBN9P0/q7Z0B7DfqljTEaCJqmVvoS/K+meBb
uT9HYznCdxR+a3AHvqPk3cHIFcCUh75hywYcNWisUHishZoToWEW7y0wUNoY
/5K/EtqNWtpaL8zwj19HuvaJVfhb9rC58jNTrBIsmttfo4Mnt5JDRIVNsOk6
/0C5oi6aPsxsOKRlhBDObrW37muQO2B/My1hLXRGXCW67fVQH/jjtj/lDSAr
+W1x49966PKtuaqdowfRR+l31DP0wQxWhOk36MLfsKZnia0B2kvZDdO2OijZ
7J3z8LsBlt6oWyOjuhKTX1SkPqSuRWpBt5wPrYXKrZtEUiwNsdtBJbLJbzki
bWKzKz4YIlFb/XN2H6lb35Y/8mKNsOFUhdHRE+owM4lJUTYwRt0FreErqmpw
5z6fEW43xkeJhVPB4xQmmxMHD0eZ4MXZZYUll3m4Kup51FnDFKG5inP12RzI
9ldeX9Boisrs33f59Kpi4ckol3VB65B9NfVyh6oKhIo87wzKmEEzpcb3fboS
gq/dSZRpMEPWi3SXXo4i6lbFLZY+ZI7X16xmf3siD+ktwTrRLAvc0qhvbc2U
Q+/qF+1htRa4+aB2LOSYLMqyaI13nutxSSpcpfGYDDzuGEtz5taDT/WEjiRI
41RsblRv8QZE5axhQq9L4fYwJ51lR2OsY/+x0FJJxGXG7un/gQZ2fgvPvSkJ
H+evmqVONBrzhfNacyTBrq0ts3ej0Snu4aB9SRLnknb9muBNg3sjZMlsiCQO
GqeNi4fRsEo8ayPGSEItRs5m0Q0a91p69Aq7WZgzjVjWXUj+FwWM3ZZ9yULP
16Hfb5TQKLjhqh/VzEKy2z0P63Ia+ds+bPKuY2F+pfOR2FoaqTdHMy3yWOh9
mZQl0k7jyNLI9U6BLFSfmdrb3knjrLDEL70HWUgx362d9weN4PFdG/y8WbAt
0K1g+mkknDVWj3dl4UFo229Rn2hEqG469c6chdTVRklOIzTS3h6ujTRiIWgw
w4U/RuNbqMUIew0LWnY/DtRP0KjaWKruocaCqHBHfvIUjdKR59pCbBbeVJr7
7fmbxu9O56gCeRZq/fLW6P1L4xCLvchOkoUrPInJ+XkaiQqNvROLWfg/bFBw
nA==
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0., 37.50089408582606}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0., 37.50089408582606}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.932567003254272*^9}, {3.932567157578121*^9, 3.932567177205875*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.9325692386376*^9},
 CellLabel->
  "Out[196]=",ExpressionUUID->"fb1299bf-8811-064b-b3f7-e1a1e87663e6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"8.02`", ",", 
    RowBox[{"{", "37.50088378639551`", "}"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.9325670032542725`*^9}, {3.932567157578121*^9, 3.9325671772058754`*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.932569238732811*^9},
 CellLabel->
  "Out[197]=",ExpressionUUID->"fb0bbd7f-9437-7146-a5cf-df3beb1b51d3"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
             0.12423911109296526`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0.012438103447146824`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
            0.12423911109296526`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0.012438103447146824`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
         0.12423911109296526`}}, "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 0.012438103447146824`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.012438103447146824`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0.012438103447146796`, 0.12423911109296526`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.932567003254272*^9}, {3.932567157578121*^9, 3.932567177205875*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.932569238765194*^9},
 CellLabel->
  "Out[198]=",ExpressionUUID->"2bcfb418-6baa-ef46-8d9c-1674ca0ce645"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
             0.12423911109296526`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0.012438103447146824`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
            0.12423911109296526`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0.012438103447146824`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV13k81N33APChlJQSmizDjF32p4Qk54SQKGspJSUULUKW6DHWfGYxKhXZ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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0.012438103447146796`, 
         0.12423911109296526`}}, "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 0.012438103447146824`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.012438103447146824`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0.012438103447146796`, 0.12423911109296526`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.932567003254272*^9}, {3.932567157578121*^9, 3.932567177205875*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.932569238849575*^9},
 CellLabel->
  "Out[199]=",ExpressionUUID->"1856eca9-24cd-4944-851a-d9e6ba03051d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"8.02`", ",", "0.012438106863209824`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.9325670032542725`*^9}, {3.932567157578121*^9, 3.9325671772058754`*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.9325692389241085`*^9},
 CellLabel->
  "Out[200]=",ExpressionUUID->"dd815c78-503d-0745-b041-2a0ceb906b19"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     TagBox[
      TagBox[
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], Opacity[
        1.], LineBox[CompressedData["
1:eJwV1nc8lV8cB/CMolLmvdeMwrXuvc9jRAnPN1EyyswqWRHKDlGhkGQV2VJm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         "]]},
       Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
      Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
   GeometricTransformationBox[{{{}, {}, 
      TagBox[
       TagBox[
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
         LineBox[CompressedData["
1:eJwV13k4VfkfB3AiFXXt+13OtRQlIVuo874npDCWSAuKtGAkWhCNiH4KUUnJ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          "]]},
        Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
       Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
     0., 0.2837180998155117}}, {0., 5.329899217513939}}], {GraphicsGroupBox[{
      {EdgeForm[{RGBColor[
       0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
       AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
        NCache[
         Rational[2, 3], 0.6666666666666666]]}], 
       PolygonBox[{
        Offset[{-1.760731259544893, 2.4289556257086}, {4.907801067477912, 
          5.9753938773026}], 
         Offset[{1.1019826744438286`, 6.477215001889603}, {4.206611602631136, 
          6.550212126363585}], 
         Offset[{22.14947023701985, 6.477215001889608}, {4.206611602631136, 
          6.550212126363585}], 
         Offset[{22.14947023701985, 20.477215001889608`}, {4.206611602631136, 
          6.550212126363585}], 
         Offset[{-39.850529762980145`, 20.477215001889594`}, {
          4.206611602631136, 6.550212126363585}], 
         Offset[{-39.850529762980145`, 6.4772150018895935`}, {
          4.206611602631136, 6.550212126363585}], 
         Offset[{-5.6231227844849245`, 6.4772150018896015`}, {
          4.206611602631136, 6.550212126363585}]}]}, {}, InsetBox[
       StyleBox[
        RotationBox["\<\"Image Plane\"\>",
         BoxRotation->0.],
        StripOnInput->False,
        LineOpacity->1,
        FrontFaceOpacity->1,
        BackFaceOpacity->1,
        Opacity->1,
        FontOpacity->1], 
       Offset[{-8.850529762980148, 13.4772150018896}, \
{4.206611602631136, 6.550212126363585}], NCache[
       ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
        ImageScaled[{0.5, 0.5}]]]}], 
    GeometricTransformationBox[GraphicsGroupBox[{
       {EdgeForm[{RGBColor[
        0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{1.3496786486579206`, 2.6792475707476022`}, {
           25.373594340449714`, 6.572924880775047}], 
          Offset[{5.355878691489553, 7.144660188660272}, {25.793388397368872`,
            8.318346578185574}], 
          Offset[{39.43434574274454, 7.14466018866028}, {25.793388397368872`, 
           8.318346578185574}], 
          Offset[{39.43434574274454, 21.144660188660282`}, {
           25.793388397368872`, 8.318346578185574}], 
          Offset[{-24.56565425725546, 21.144660188660268`}, {
           25.793388397368872`, 8.318346578185574}], 
          Offset[{-24.56565425725546, 7.144660188660266}, {
           25.793388397368872`, 8.318346578185574}], 
          Offset[{-1.7121776407429294`, 7.144660188660271}, {
           25.793388397368872`, 8.318346578185574}]}]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Magnification\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{7.434345742744538, 14.144660188660273}, \
{25.793388397368872, 8.318346578185574}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 0.2837180998155117}}, {
      0., 5.329899217513939}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 5.329899217513951},
  CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
      FreeQ[#, Rule], 
      Apply[{{{Bottom, 1}, {Right, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, -18.785897766056223` + 3.5246253258084415` #2}], {{
          Bottom, 1}, {Left, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
    "DisplayFunction" -> Apply[Grid[{{
         Subscript[
          Style["\[RightArrow]", 20], 
          Style[1, 
           RGBColor[1, 0, 0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, -18.785897766056223` + 3.5246253258084415` #2}]}, {
         Subscript[
          Style["\[LeftArrow]", 20], 
          Style[1, 
           GrayLevel[0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
       Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
       Spacings -> {0, 0.5}]& ]},
  DisplayFunction->Identity,
  Epilog->{{}, {}},
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->{{None, 
     RGBColor[1, 0, 0]}, {None, None}},
  FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "TransformedTicks"[{-2.15745986740248, 40.99173748064712}, {
        4.717788803506282, 16.95999708365943}, 
        "CustomTicks"[True]]][
       SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "CustomTicks"[False]][
       SlotSequence[1]]& }}, {{{{5., 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"5.0\
\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 5.`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {7.5, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"7.5\
\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 7.5`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {10., 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"10.\
0\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 10.`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {12.5, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"12.\
5\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 12.5`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {15., 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"15.\
0\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 15.`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {5.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {7., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {9., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {9.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       10.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {11., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       11.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {13., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       13.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       14.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       15.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       16.5, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
       5.329899217513939, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {8.167080215669056, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {11.004261213824174`, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {13.841442211979292`, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {16.67862321013441, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {4.762463017882915, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       5.897335417144962, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       6.464771616775986, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       7.032207816407009, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       7.599644016038033, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       8.73451641530008, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       9.301952614931103, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       9.869388814562127, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       10.43682501419315, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       11.571697413455198`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       12.139133613086221`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       12.706569812717245`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       13.274006012348268`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       14.408878411610315`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       14.976314611241339`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       15.543750810872362`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       16.111187010503386`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}, {{{
       0., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
       0., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
  FrameTicksStyle->{{None, None}, {None, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->{{28.246092796325684`, 28.246092796325684`}, {28.34375, 
   1.3598258445774718`}},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-0.6666666666666667, 32.666666666666664`}, {4.717788803506282, 
   16.95999708365943}},
  PlotRangeClipping->False,
  PlotRangePadding->None,
  Prolog->{{}, {}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.932141273746629*^9, {3.932141519220983*^9, 3.932141572490829*^9}, 
   3.932227812213167*^9, 3.9324819587661514`*^9, {3.9325669582266083`*^9, 
   3.9325670032542725`*^9}, {3.932567157578121*^9, 3.9325671772058754`*^9}, 
   3.9325672188251305`*^9, 3.932567256516943*^9, 3.932569239096716*^9},
 CellLabel->
  "Out[201]=",ExpressionUUID->"6af84522-0f7e-884a-9a85-678c2dd1717b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Callout", "[", 
     RowBox[{
      RowBox[{"Sin", "[", "x", "]"}], ",", "\"\<Sin[x]\>\""}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.932140889873035*^9, 3.9321409336681376`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"0d90d5cb-fc12-924e-9ce8-90fc7f731480"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     TagBox[
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], Opacity[
       1.], LineBox[CompressedData["
1:eJwlmXk4lN/7x61ZUmaeISRF+0pKaaH7VEKRUqJFSFpIEhGSSiUk2SvZUpb4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        "]]},
      Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
     Annotation[#, "Charting`Private`Tag#1"]& ]}, {{{}, GraphicsGroupBox[{
       {GrayLevel[1], AbsoluteThickness[4], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]], CapForm["Butt"], JoinForm[
        "Round"], 
        BSplineCurveBox[{
         Offset[{3, 0}, {6.283185307179586, -1.28228271801381*^-7}], 
          Offset[{2.999999999968278, 0.000013796164706140446`}, {
           6.539748707222753, -1.28228271801381*^-7}], 
          Offset[{0, 0}, {6.665412725050297, 1.694079395603679*^-7}], 
          Offset[{5., 1.1102230246251565`*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{10., 2.220446049250313*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{10., 2.220446049250313*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}]}]}, 
       {RGBColor[0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25], 
        BSplineCurveBox[{
         Offset[{3, 0}, {6.283185307179586, -1.28228271801381*^-7}], 
          Offset[{2.999999999968278, 0.000013796164706140446`}, {
           6.539748707222753, -1.28228271801381*^-7}], 
          Offset[{0, 0}, {6.665412725050297, 1.694079395603679*^-7}], 
          Offset[{5., 1.1102230246251565`*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{10., 2.220446049250313*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{10., 2.220446049250313*^-15}, {6.665412725050297, 
           1.694079395603679*^-7}]}]}, 
       {EdgeForm[None], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{41., 7.000000000000009}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{41., -6.999999999999991}, {6.665412725050297, 
           1.694079395603679*^-7}], 
          Offset[{10.000000000000002`, -6.999999999999998}, {
           6.665412725050297, 1.694079395603679*^-7}], 
          Offset[{9.999999999999998, 7.000000000000002}, {6.665412725050297, 
           1.694079395603679*^-7}]}]}, 
       {RGBColor[0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25], EdgeForm[None]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Sin[x]\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{25.5, 5.662137425588298*^-15}, \
{6.665412725050297, 1.694079395603679*^-7}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}]}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->{{All, 59.400017858175026`}, {All, All}},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->
   NCache[{{0, 2 Pi}, {-0.9999998592131705, 0.9999998782112116}}, {{
     0, 6.283185307179586}, {-0.9999998592131705, 0.9999998782112116}}],
  PlotRangeClipping->False,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.08090169943749476]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.932140936605221*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"4da63560-5513-8449-8bb0-3b6503046d67"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Pickoff", "[", "x", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.9324820475076103`*^9, 3.93248205569832*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"90a3dc1e-df9b-5c42-87c2-65c58bbbb455"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV13k4lGsUAPDPcksRQlmiIpUQcyXKdj5RISqhb8bYoiRtzFUkNLJky5ai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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV13k4lGsUAPDPcksRQlmiIpUQcyXKdj5RISqhb8bYoiRtzFUkNLJky5ai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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0.0014379091802535493`, 
             0.01290109903987502}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0.0014379091802535526`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0.0014379091802535493`, 
            0.01290109903987502}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0.0014379091802535526`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV13k4lGsUAPDPcksRQlmiIpUQcyXKdj5RISqhb8bYoiRtzFUkNLJky5ai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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0.0014379091802535493`, 
         0.01290109903987502}}, "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 0.0014379091802535526`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.0014379091802535526`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0.0014379091802535493`, 0.01290109903987502}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.93248205887315*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"721308d6-adcf-d14d-a49c-ae897a17fac5"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Full Mask         ", "Chapter",
 CellChangeTimes->{{3.932569243588211*^9, 3.9325692653362613`*^9}, {
  3.932572256545058*^9, 
  3.932572258684763*^9}},ExpressionUUID->"2c2f2d4e-1d29-564a-bd35-\
fa02febacca7"],

Cell[CellGroupData[{

Cell["Maths", "Section",
 CellChangeTimes->{{3.932569309289682*^9, 3.932569318486841*^9}, {
  3.9325718797361183`*^9, 
  3.932571880619219*^9}},ExpressionUUID->"df5b616a-f935-934c-a61a-\
4b9143dad348"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "L2", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"59.8", ",", "500", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
  RowBox[{"MaskFH", "[", 
   RowBox[{"20", ",", "L1", ",", "50", ",", "780"}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.932569267259767*^9, 3.932569292741247*^9}, 
   3.9325708851993217`*^9, 3.9325713272746124`*^9, {3.9325717772001896`*^9, 
   3.932571777762219*^9}, 3.9325735762657185`*^9, {3.932729474694359*^9, 
   3.9327294746953692`*^9}},ExpressionUUID->"33faf687-c04a-554a-ac5d-\
91ed1ab1defd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"35.44944`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[35.44944, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{3.932571782296772*^9, 3.9325735769383583`*^9},
 CellLabel->
  "During evaluation of \
In[349]:=",ExpressionUUID->"1db2c193-44f4-d94d-b175-5faa74de1943"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747045`"}],
  SequenceForm["Angle: ", 0.015598734712747045`],
  Editable->False]], "Print",
 CellChangeTimes->{3.932571782296772*^9, 3.932573576943371*^9},
 CellLabel->
  "During evaluation of \
In[349]:=",ExpressionUUID->"36350a3f-d4ea-b840-890e-ebfcba5ab2bd"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.93288`", ",", "0.015598734712747045`"}], "}"}]], "Output",
 CellChangeTimes->{3.9325735769503803`*^9},
 CellLabel->
  "Out[350]=",ExpressionUUID->"c68b0f8b-14b4-6247-aa35-7dca4ec438b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"MaskFirstLensMax\[ScriptF]", "[", 
  RowBox[{"20", ",", "50", ",", "780", ",", "1"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"MaskFirstLensMax\[ScriptF]", "[", 
  RowBox[{"20", ",", "50", ",", "780", ",", "2"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"MaskFirstLensMax\[ScriptF]", "[", 
  RowBox[{"20", ",", "50", ",", "780", ",", "3"}], "]"}]}], "Input",
 CellChangeTimes->{{3.932571778421673*^9, 3.932571823160804*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"6bbc4f6e-03f0-1b45-9488-124b87dda1dc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"L", "\[Rule]", "3131.4102564102564`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.932571823560419*^9, 3.9325718444872055`*^9}, 
   3.933246693683037*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"34a75c6b-c7a6-c249-8948-d0e181279675"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"L", "\[Rule]", "6387.820512820513`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.932571823560419*^9, 3.9325718444872055`*^9}, 
   3.9332466936937494`*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"2bdd6b7d-567f-3b48-92e6-3cb2d077c645"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"L", "\[Rule]", "9644.23076923077`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.932571823560419*^9, 3.9325718444872055`*^9}, 
   3.933246693702892*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"11e6048a-c078-124e-97ca-c3d70cf5301b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MaskFH", "[", 
   RowBox[{"20", ",", "85", ",", "50", ",", "780"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.9325733538660293`*^9, 3.932573384782108*^9}, 
   3.932729474697996*^9},ExpressionUUID->"1e950e44-6144-8441-9911-\
ae54242a2ba6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{
    "50.388000000000005`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[50.388000000000005`, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.932573379824539*^9, 3.932573385269237*^9}},
 CellLabel->
  "During evaluation of \
In[334]:=",ExpressionUUID->"fe4f41d5-5a6a-4340-94d3-a451b2989a14"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.015598734712747047`"}],
  SequenceForm["Angle: ", 0.015598734712747047`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.932573379824539*^9, 3.9325733852737026`*^9}},
 CellLabel->
  "During evaluation of \
In[334]:=",ExpressionUUID->"b3331f0e-ec11-a04a-988c-0f4bf6f1bda7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    RowBox[{"Q", "[", 
     RowBox[{"50", ",", "\"\<\[Mu]m\>\""}], "]"}], "2"], 
   RowBox[{"(", 
    RowBox[{"40", "-", "1"}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"Q", "[", 
     RowBox[{"100", ",", "\"\<mm\>\""}], "]"}], " ", "*", 
    RowBox[{"Q", "[", 
     RowBox[{"780", ",", "\"\<nm\>\""}], "]"}]}], 
   RowBox[{"2", 
    RowBox[{"Q", "[", 
     RowBox[{"50", ",", "\"\<\[Mu]m\>\""}], "]"}]}]]}]], "Input",
 CellChangeTimes->{{3.933246727011444*^9, 3.933246750981434*^9}, {
  3.933246826369087*^9, 3.933246831580551*^9}, {3.933246864442026*^9, 
  3.933246864696115*^9}},
 CellLabel->"",ExpressionUUID->"e1505723-2ea1-bf4a-a768-1c7d8bdae6e9"],

Cell[BoxData[
 TemplateBox[{"25399.998`", "\"\[Mu]m\"", "micrometers", "\"Micrometers\""},
  "Quantity"]], "Output",
 CellChangeTimes->{3.9332467519747944`*^9, 3.933246833154506*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"c9b4dda3-11c5-bd4f-8750-a9508bb53c6a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{{3.933246774886791*^9, 
  3.933246802589716*^9}},ExpressionUUID->"0afcb17b-7475-c44c-b9ef-\
8abe91374141"],

Cell[BoxData[
 RowBox[{"5", " ", 
  RowBox[{"(", 
   RowBox[{"975", "+", 
    FractionBox[
     RowBox[{"39", " ", "L"}], "5"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.933246780788292*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"fdbe2ef1-7f1b-c447-b7a0-4851f197dba8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"60", ",", "500"}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Lens", "[", 
     RowBox[{"500", ",", "8"}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.933247980243828*^9, 3.933248007288831*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"06ed59e6-5481-1e48-91dc-bfe112a15ee0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", "0.12`"}],
  SequenceForm["Magnification: ", 0.12],
  Editable->False]], "Print",
 CellChangeTimes->{{3.93324799016502*^9, 3.933248007930805*^9}},
 CellLabel->
  "During evaluation of \
In[118]:=",ExpressionUUID->"8dbb7e2c-1b7b-d249-aa6b-08ef0e900124"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "26.785714285714285`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 26.785714285714285`, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.93324799016502*^9, 3.933248007945833*^9}},
 CellLabel->
  "During evaluation of \
In[118]:=",ExpressionUUID->"6233c07a-cd73-ce4d-825b-c3b8df5f2465"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", "62.5`"}],
  SequenceForm["Magnification: ", 62.5],
  Editable->False]], "Print",
 CellChangeTimes->{{3.93324799016502*^9, 3.933248007960773*^9}},
 CellLabel->
  "During evaluation of \
In[118]:=",ExpressionUUID->"088a7b82-1e9a-8240-899c-0b065f5fae30"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[ScriptF]: \"\>", "\[InvisibleSpace]", "3.937007874015748`", 
   "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm["\[ScriptF]: ", 3.937007874015748, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.93324799016502*^9, 3.933248007967316*^9}},
 CellLabel->
  "During evaluation of \
In[118]:=",ExpressionUUID->"9ddffccc-9c16-4046-911a-b4c5874ea99c"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphs", "Section",
 CellChangeTimes->{{3.9325718852087708`*^9, 
  3.932571890961296*^9}},ExpressionUUID->"19e8b363-5247-ba44-9dd6-\
fcdcee8a4eb3"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.9325735618877106`*^9, 
  3.9325735717687397`*^9}},ExpressionUUID->"de671ca7-1322-ce4d-a320-\
e5f105e4c026"],

Cell[CellGroupData[{

Cell["Main  track", "Subsection",
 CellChangeTimes->{{3.932572018048601*^9, 
  3.932572030027092*^9}},ExpressionUUID->"9cc79d4b-8aea-5e4d-95bd-\
5cb4abd7ac1c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"L1", ",", "AL", ",", "MO"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"30", ",", "8", ",", "43"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
  RowBox[{"MaskFH", "[", 
   RowBox[{"20", ",", "L1", ",", "50", ",", "780"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MT", "[", "spacing_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"LM", "[", "MO", "]"}], ".", 
     RowBox[{"TM", "[", "20", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", "spacing", "]"}], ".", 
     RowBox[{"LM", "[", "AL", "]"}], ".", 
     RowBox[{"TM", "[", 
      RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
     RowBox[{"LM", "[", "L1", "]"}], ".", 
     RowBox[{"TM", "[", "L1", "]"}], ".", 
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BFAL", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AFAL", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "503.2", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BSAL", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"TM", "[", "spacing", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ASAL", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", "spacing", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BMO", "[", "spacing_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"TM", "[", "20", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", "spacing", "]"}], ".", 
    RowBox[{"LM", "[", "AL", "]"}], ".", 
    RowBox[{"TM", "[", 
     RowBox[{"L1", "+", "16", "-", "spacing"}], "]"}], ".", 
    RowBox[{"LM", "[", "503.2", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}]}], "Input",
 CellChangeTimes->{{3.932572339011378*^9, 3.932572339503927*^9}, {
   3.9325731085822887`*^9, 3.932573119568741*^9}, {3.932573221403124*^9, 
   3.9325732265489388`*^9}, {3.932573288553341*^9, 3.932573314651727*^9}, {
   3.932573397158104*^9, 3.9325733974699707`*^9}, {3.932573464343107*^9, 
   3.932573471371738*^9}, {3.932573537577772*^9, 3.932573546576252*^9}, {
   3.932573586801974*^9, 3.932573595147852*^9}, {3.932573721763994*^9, 
   3.9325737218135223`*^9}, {3.9325742670287266`*^9, 3.932574267116791*^9}, {
   3.932574626429104*^9, 3.9325746424850883`*^9}, {3.93257514306374*^9, 
   3.9325751432325153`*^9}, {3.9325768900963135`*^9, 3.932576890115677*^9}, {
   3.932576963971564*^9, 3.932576963988249*^9}, 3.932728634767759*^9, {
   3.932729474701996*^9, 3.932729474708779*^9}, {3.932729622067909*^9, 
   3.9327296261067677`*^9}, {3.932729715333423*^9, 3.932729715478918*^9}, {
   3.932729858653359*^9, 3.93272990612471*^9}, {3.9327299419551105`*^9, 
   3.9327299420339775`*^9}, {3.932730014919084*^9, 3.932730202068617*^9}, {
   3.933246901690094*^9, 3.933247038378404*^9}, {3.9332473139746723`*^9, 
   3.933247337599882*^9}, {3.9332476828715305`*^9, 3.933247707427031*^9}, {
   3.933247738690098*^9, 3.933247777242157*^9}, {3.933247850977724*^9, 
   3.9332478828627644`*^9}, {3.93324802216164*^9, 3.933248093237341*^9}, {
   3.933248130786621*^9, 3.933248158347748*^9}, {3.9332481891506634`*^9, 
   3.933248206776346*^9}, {3.9332482987003098`*^9, 3.933248323565029*^9}, {
   3.933249365939953*^9, 3.933249370389051*^9}, {3.933249417166897*^9, 
   3.9332494214319725`*^9}, {3.933249627806738*^9, 3.93324965936512*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"8a1f3525-d625-6043-8dab-fbf5aa5afc0e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Width: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"1.184`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Width: ", 
   Quantity[1.184, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9325735957215576`*^9, {3.932573722956135*^9, 3.932573737396918*^9}, 
   3.9325742676942844`*^9, 3.932574643436285*^9, 3.932575144128271*^9, 
   3.9327286262145977`*^9, 3.9327286624075794`*^9, 3.932728696624857*^9, 
   3.932728785147705*^9, 3.932729397173647*^9, 3.932729493599321*^9, 
   3.932729678541706*^9, 3.932729716065119*^9, {3.93272985940069*^9, 
   3.932729906643219*^9}, 3.9327299427381477`*^9, {3.932730015658903*^9, 
   3.932730039024801*^9}, {3.9327300754339848`*^9, 3.932730127634796*^9}, {
   3.9327301708852997`*^9, 3.932730202534788*^9}, 3.932730484048549*^9, {
   3.9332469430525208`*^9, 3.9332469819742928`*^9}, 3.93324704808638*^9, {
   3.933247316117098*^9, 3.933247338531451*^9}, {3.933247685315336*^9, 
   3.933247708459423*^9}, 3.933247741779108*^9, 3.933247777877066*^9, 
   3.9332478849222374`*^9, 3.933248097971037*^9, 3.933248159056509*^9, {
   3.933248190439421*^9, 3.933248207351658*^9}, {3.933248300275449*^9, 
   3.9332483246047726`*^9}, 3.933249037795023*^9, 3.933249371560261*^9, 
   3.933249435995554*^9, 3.933249661053817*^9, 3.933341093233612*^9},
 CellLabel->
  "During evaluation of \
In[14]:=",ExpressionUUID->"cde0b363-56c5-924e-b2e3-19c5b2d6151f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.006133256427612348`"}],
  SequenceForm["Angle: ", 0.006133256427612348],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.9325735957215576`*^9, {3.932573722956135*^9, 3.932573737396918*^9}, 
   3.9325742676942844`*^9, 3.932574643436285*^9, 3.932575144128271*^9, 
   3.9327286262145977`*^9, 3.9327286624075794`*^9, 3.932728696624857*^9, 
   3.932728785147705*^9, 3.932729397173647*^9, 3.932729493599321*^9, 
   3.932729678541706*^9, 3.932729716065119*^9, {3.93272985940069*^9, 
   3.932729906643219*^9}, 3.9327299427381477`*^9, {3.932730015658903*^9, 
   3.932730039024801*^9}, {3.9327300754339848`*^9, 3.932730127634796*^9}, {
   3.9327301708852997`*^9, 3.932730202534788*^9}, 3.932730484048549*^9, {
   3.9332469430525208`*^9, 3.9332469819742928`*^9}, 3.93324704808638*^9, {
   3.933247316117098*^9, 3.933247338531451*^9}, {3.933247685315336*^9, 
   3.933247708459423*^9}, 3.933247741779108*^9, 3.933247777877066*^9, 
   3.9332478849222374`*^9, 3.933248097971037*^9, 3.933248159056509*^9, {
   3.933248190439421*^9, 3.933248207351658*^9}, {3.933248300275449*^9, 
   3.9332483246047726`*^9}, 3.933249037795023*^9, 3.933249371560261*^9, 
   3.933249435995554*^9, 3.933249661053817*^9, 3.9333410932387333`*^9},
 CellLabel->
  "During evaluation of \
In[14]:=",ExpressionUUID->"6a4dc297-e79b-a54a-95f3-6ed0e68dc86b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.184`", ",", "0.006133256427612348`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.932729678555252*^9, 3.9327297160751877`*^9, {3.932729859410881*^9, 
   3.932729906652876*^9}, 3.9327299427476635`*^9, {3.932730015668938*^9, 
   3.9327300390363426`*^9}, {3.932730075444204*^9, 3.932730127645748*^9}, {
   3.932730170893957*^9, 3.932730202544077*^9}, 3.932730484059547*^9, {
   3.933246943084225*^9, 3.933246982005308*^9}, 3.933247048117638*^9, {
   3.93324731614512*^9, 3.933247338563499*^9}, {3.933247685348634*^9, 
   3.9332477084937954`*^9}, 3.933247741807764*^9, 3.933247777904387*^9, 
   3.933247884953251*^9, 3.933248097998152*^9, 3.933248159084272*^9, {
   3.933248190471758*^9, 3.9332482073835564`*^9}, {3.9332483003067436`*^9, 
   3.9332483246311*^9}, 3.933249037825535*^9, 3.933249371587635*^9, 
   3.933249436026851*^9, 3.933249661085436*^9, 3.9333410932462*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"29cdd064-89b1-a049-abbf-c92b153adada"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"BFAL", "[", "spacing", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"BSAL", "[", "spacing", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.933247794556364*^9, 3.9332477948464622`*^9}, {
  3.9332479033527184`*^9, 3.9332479383170185`*^9}, {3.9332481023563366`*^9, 
  3.9332481153356047`*^9}, {3.933248341003525*^9, 3.9332483666744537`*^9}, {
  3.9332490479826355`*^9, 3.933249066864298*^9}, {3.9332499287227707`*^9, 
  3.933249948066067*^9}},
 CellLabel->
  "In[367]:=",ExpressionUUID->"a90d7474-8035-b246-8a80-13fb764bde8f"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVzXs01AkUB/CpRZGkskl5xQ7VaaX6zczP896icMrWWGqIDUXjsaIpldiO
xy4rVtgcs3rZlJIkkiWlrWix22PtvAzj9/PKIyevLE5m9rd/3HPP55zv9951
ocd8whayWCxvZv7fhm4PF7BYBKobYPlaWgKp9kHJRxgnW6uGVvdIYNpMa0EL
Y63MxGereiXQOcNn5S0gUO9AnWhFvwRuVYyqrT8j0Gh8q1R3SAKwhv3JQ4fA
9WybopkxCcSM50/n6BPIz9ZnS1lSaLsaN2JhQmBxkILMtZRC8MpaRSBBoJ+P
YDgoTAoa96NVbd4Epv+pfbzohhQKS7Pa68MJfPLIPKSgTwpL1jnPNicTuEhj
2vFuvQwyBPt1tYsIfPXSa0OZUAbdN+fMgh8SWNp3cOHzuzKwtzE66/SWwLR4
xQ7xuAwyDxc+8xwmUJX9vT9lL4fG2psGIm0O7p5dNZd0Ug7qFoudr805yBuW
xmbVyIG71ODFHR4Hv9i3cK9gSg5eR3/wuOHDQRu9lbUJpALCzkXUvIniYImX
z8elpxUQWCG1NUln+l3xj/9tUIC3QV0PXczBV/06o1dYHeCxSSejs56DtKhp
4iF0gGlI15YpCQcX749IYad1wNzXFs0uHzhY9thpUOtFB1QHjXxTosfF0DOT
MkddJYQXbsLzbC6ala3abOetBKtc+ZISVy76BgsD87KUUHfNoFPhz8VrkVdX
er9Vgn/MvYLtIi4K57SKTy/vhMnoJvGGLC5u1UguhuzrBGFKWLFdKReNBFlG
xT93woBfbH7YUy7GcuMi+P90AqB2Zp2Si5TQyVNg0gW5B5e1ZE9z0ccw7ifT
oC4YJdIm8pfx0N1FUsa/1AXW7FTL2o083PXEnN9FdcHh9vekvjsPm18U/KWw
VMHlqjYxHcjDPZhwP/+QCu7fIjTtp3jYt8zNouS6Cl4HLt47c4GHM0ccD7N7
VfDSNvy6QzkPLQ2Mt8zbdkNLpV1PeRNzz9lKslPYDU2R0RHXVDyMpQqp3aXd
UOREfKyc5eEm+dTJWyPdcLY1PGpyBYnVZY1j9Z9TwIm1HvCxI9E//9TIHpKC
oV1+t7d6kZjM7Re7BFBQqhzf7x5KotA0snrgDAWQvlpXlMTky+nlTpcooMdu
32gvIHHxuVilRwMFiecrMx/cI9FBv0ZQraRgwnn7iapWEkVu79e0zlNwvNzZ
s6eXxG8fO3qKzWh4QBk1+vSRSOew+bbmNEwbjXKeM/YNNQyoYZyQdNm6pJ9E
x0UDUW8taEj5Sq0Oe8f84+fm6FrRkDfWWDM0TOKvfe+kZ2xouE+4WY+Pkyhd
cjEsYDMNE8K1v4RMkOipOhczyJi4PGn4N+NHlZGn4u1p+E27RF01yfT98Me8
LTQ8lWp1nPhI4rGrI+Wt22h4c7r5wswMiXrbdkw5kjSsuHtlUcQsiUnaX87/
wdiXjv9OwXhMZqxzwIEGuZdtdP0cibLEUWORIw3UmgyPxE8kljQXOt1xpsFq
b/CT94yNxanuDi40HEklOUHzJJ6PivF+yXhwZNDKVU1inKH7oV5XGjZa/i6u
YNzXYyeMAxqifcWGFhoSBTUmcRrGFRlx6TmM29K1ErKRhrEGL7WGsWvAh5S1
22n4D1KURi8=
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVzXs01AkUB/CpRZGkskl5xQ7VaaX6zczP896icMrWWGqIDUXjsaIpldiO
xy4rVtgcs3rZlJIkkiWlrWix22PtvAzj9/PKIyevLE5m9rd/3HPP55zv9951
ocd8whayWCxvZv7fhm4PF7BYBKobYPlaWgKp9kHJRxgnW6uGVvdIYNpMa0EL
Y63MxGereiXQOcNn5S0gUO9AnWhFvwRuVYyqrT8j0Gh8q1R3SAKwhv3JQ4fA
9WybopkxCcSM50/n6BPIz9ZnS1lSaLsaN2JhQmBxkILMtZRC8MpaRSBBoJ+P
YDgoTAoa96NVbd4Epv+pfbzohhQKS7Pa68MJfPLIPKSgTwpL1jnPNicTuEhj
2vFuvQwyBPt1tYsIfPXSa0OZUAbdN+fMgh8SWNp3cOHzuzKwtzE66/SWwLR4
xQ7xuAwyDxc+8xwmUJX9vT9lL4fG2psGIm0O7p5dNZd0Ug7qFoudr805yBuW
xmbVyIG71ODFHR4Hv9i3cK9gSg5eR3/wuOHDQRu9lbUJpALCzkXUvIniYImX
z8elpxUQWCG1NUln+l3xj/9tUIC3QV0PXczBV/06o1dYHeCxSSejs56DtKhp
4iF0gGlI15YpCQcX749IYad1wNzXFs0uHzhY9thpUOtFB1QHjXxTosfF0DOT
MkddJYQXbsLzbC6ala3abOetBKtc+ZISVy76BgsD87KUUHfNoFPhz8VrkVdX
er9Vgn/MvYLtIi4K57SKTy/vhMnoJvGGLC5u1UguhuzrBGFKWLFdKReNBFlG
xT93woBfbH7YUy7GcuMi+P90AqB2Zp2Si5TQyVNg0gW5B5e1ZE9z0ccw7ifT
oC4YJdIm8pfx0N1FUsa/1AXW7FTL2o083PXEnN9FdcHh9vekvjsPm18U/KWw
VMHlqjYxHcjDPZhwP/+QCu7fIjTtp3jYt8zNouS6Cl4HLt47c4GHM0ccD7N7
VfDSNvy6QzkPLQ2Mt8zbdkNLpV1PeRNzz9lKslPYDU2R0RHXVDyMpQqp3aXd
UOREfKyc5eEm+dTJWyPdcLY1PGpyBYnVZY1j9Z9TwIm1HvCxI9E//9TIHpKC
oV1+t7d6kZjM7Re7BFBQqhzf7x5KotA0snrgDAWQvlpXlMTky+nlTpcooMdu
32gvIHHxuVilRwMFiecrMx/cI9FBv0ZQraRgwnn7iapWEkVu79e0zlNwvNzZ
s6eXxG8fO3qKzWh4QBk1+vSRSOew+bbmNEwbjXKeM/YNNQyoYZyQdNm6pJ9E
x0UDUW8taEj5Sq0Oe8f84+fm6FrRkDfWWDM0TOKvfe+kZ2xouE+4WY+Pkyhd
cjEsYDMNE8K1v4RMkOipOhczyJi4PGn4N+NHlZGn4u1p+E27RF01yfT98Me8
LTQ8lWp1nPhI4rGrI+Wt22h4c7r5wswMiXrbdkw5kjSsuHtlUcQsiUnaX87/
wdiXjv9OwXhMZqxzwIEGuZdtdP0cibLEUWORIw3UmgyPxE8kljQXOt1xpsFq
b/CT94yNxanuDi40HEklOUHzJJ6PivF+yXhwZNDKVU1inKH7oV5XGjZa/i6u
YNzXYyeMAxqifcWGFhoSBTUmcRrGFRlx6TmM29K1ErKRhrEGL7WGsWvAh5S1
22n4D1KURi8=
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 25}, {0.3418643635222479, 
             0.5391976888011596}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, 0.3418643635222487}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 25}, {0.3418643635222479, 0.5391976888011596}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {20.000000000000043`, 0.3418643635222487}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVzXs01AkUB/CpRZGkskl5xQ7VaaX6zczP896icMrWWGqIDUXjsaIpldiO
xy4rVtgcs3rZlJIkkiWlrWix22PtvAzj9/PKIyevLE5m9rd/3HPP55zv9951
ocd8whayWCxvZv7fhm4PF7BYBKobYPlaWgKp9kHJRxgnW6uGVvdIYNpMa0EL
Y63MxGereiXQOcNn5S0gUO9AnWhFvwRuVYyqrT8j0Gh8q1R3SAKwhv3JQ4fA
9WybopkxCcSM50/n6BPIz9ZnS1lSaLsaN2JhQmBxkILMtZRC8MpaRSBBoJ+P
YDgoTAoa96NVbd4Epv+pfbzohhQKS7Pa68MJfPLIPKSgTwpL1jnPNicTuEhj
2vFuvQwyBPt1tYsIfPXSa0OZUAbdN+fMgh8SWNp3cOHzuzKwtzE66/SWwLR4
xQ7xuAwyDxc+8xwmUJX9vT9lL4fG2psGIm0O7p5dNZd0Ug7qFoudr805yBuW
xmbVyIG71ODFHR4Hv9i3cK9gSg5eR3/wuOHDQRu9lbUJpALCzkXUvIniYImX
z8elpxUQWCG1NUln+l3xj/9tUIC3QV0PXczBV/06o1dYHeCxSSejs56DtKhp
4iF0gGlI15YpCQcX749IYad1wNzXFs0uHzhY9thpUOtFB1QHjXxTosfF0DOT
MkddJYQXbsLzbC6ala3abOetBKtc+ZISVy76BgsD87KUUHfNoFPhz8VrkVdX
er9Vgn/MvYLtIi4K57SKTy/vhMnoJvGGLC5u1UguhuzrBGFKWLFdKReNBFlG
xT93woBfbH7YUy7GcuMi+P90AqB2Zp2Si5TQyVNg0gW5B5e1ZE9z0ccw7ifT
oC4YJdIm8pfx0N1FUsa/1AXW7FTL2o083PXEnN9FdcHh9vekvjsPm18U/KWw
VMHlqjYxHcjDPZhwP/+QCu7fIjTtp3jYt8zNouS6Cl4HLt47c4GHM0ccD7N7
VfDSNvy6QzkPLQ2Mt8zbdkNLpV1PeRNzz9lKslPYDU2R0RHXVDyMpQqp3aXd
UOREfKyc5eEm+dTJWyPdcLY1PGpyBYnVZY1j9Z9TwIm1HvCxI9E//9TIHpKC
oV1+t7d6kZjM7Re7BFBQqhzf7x5KotA0snrgDAWQvlpXlMTky+nlTpcooMdu
32gvIHHxuVilRwMFiecrMx/cI9FBv0ZQraRgwnn7iapWEkVu79e0zlNwvNzZ
s6eXxG8fO3qKzWh4QBk1+vSRSOew+bbmNEwbjXKeM/YNNQyoYZyQdNm6pJ9E
x0UDUW8taEj5Sq0Oe8f84+fm6FrRkDfWWDM0TOKvfe+kZ2xouE+4WY+Pkyhd
cjEsYDMNE8K1v4RMkOipOhczyJi4PGn4N+NHlZGn4u1p+E27RF01yfT98Me8
LTQ8lWp1nPhI4rGrI+Wt22h4c7r5wswMiXrbdkw5kjSsuHtlUcQsiUnaX87/
wdiXjv9OwXhMZqxzwIEGuZdtdP0cibLEUWORIw3UmgyPxE8kljQXOt1xpsFq
b/CT94yNxanuDi40HEklOUHzJJ6PivF+yXhwZNDKVU1inKH7oV5XGjZa/i6u
YNzXYyeMAxqifcWGFhoSBTUmcRrGFRlx6TmM29K1ErKRhrEGL7WGsWvAh5S1
22n4D1KURi8=
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 25}, {0.3418643635222479, 0.5391976888011596}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, 0.3418643635222487}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, 0.3418643635222487},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {0.3418643635222479, 0.5391976888011596}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.933247795282091*^9, 3.933247939331917*^9, 3.933248121598881*^9, 
   3.933248162686964*^9, {3.933248199362638*^9, 3.93324820970396*^9}, {
   3.933248329519495*^9, 3.9332483672625713`*^9}, {3.933249040588093*^9, 
   3.9332490680419693`*^9}, 3.9332493744576263`*^9, 3.933249669383594*^9, {
   3.933249929714297*^9, 3.933249948963846*^9}},
 CellLabel->
  "Out[367]=",ExpressionUUID->"fc481bc7-a340-e442-8c31-eaa16584507c"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV0HtUjHkcBvB3rCHSFHVQLmna1kltx+V9Z95M9MV0s6XdlM2RdnQjQi6n
XEpGbaULyUqTzdZKyiZpE1n8fiHUoHY7ExHbuFWm6DIzzX323T+e85zPX885
j1PU7pDYCQRBBDH5v23WNLIIgoRQMLpkypQoffFmcQzjsd89s+K7lEg9byKr
lXHdgbrPgc+VqEfzA1HIIiEjNajDtluJqmqHTM5fkXBiUPimvEeJvB1cDH6T
SPAUubqgd0q0a+S0+uQ0Ej6WPo40jSiR9Lc9Ckd7Ekr2isQnOSoksr3RHUGS
YL1OUSYLVCGzcGu9NIgEOdfdIjZLhYov5XXeiiOh4IjdkSXNKmTp5KV9KCZB
mp82dT2hRtnhG6awz5Egs/IWVArU6N9K3TxRIwmFZ2YfjUpRo8Xf2B0W/E1C
5pnwpOjbapQTXXzP/xMJSa5lr1I1aoRuVHL2sSlYfshvmcPycWRqdfRpn0/B
BNufL9xPHkc8K86DP/gUzMrznS1pGEcBWzP9LoZQ0CUSYIvxcRSbFn+9YwcF
Be17Pu+kNCiitmuhfRYFLWeXeYsPalAQp+mtvJwCpcWjJY9va5Cf+6TsnlsU
PJsekTmo16C5W14vUcoowHeWtz0HLdKtd3y44gsFM94lc38Ra9GfmxWRFVN5
EPRtTKLbYy2KK3aHXBce7G7vYA9Z6RD31AvLipU8iN7ZsntrsA41lXF6ujfy
wNU346asSIc27rpatGofDxwr+w8Od+vQWEKLxDWPB437LaRz5+rRtmOx5R6X
eNCces43LEaPPoYlno7FPOAhVSm3So+8gZ3T9IoHkriBWTajenRqk3VrvpoH
gWvX3JspMKAhMmP0tDUfRPdL7EvSDMjZJX3BjUV8eBDouGNDmwFFdw7S04R8
KPo6f2a6jRGV1ksl8gg+PLtMB9aFGdG1KtLcmcyHvbKljR7lRtQeYRGsKeDD
6pfCz+x+I3q0MO6CZw0fysPzhKspE2qt83hb08KHN7bFk6WpJtSyPSG+7A0f
vt9UzvmuxYTOCUhVnZYPf6VE5vjbmtHhtrgdYzNoyFAkSw9FmBGV6PwxxIOG
hHzPYytrzGjAN6x6aQANnicIJ5bejC69GtkgjKIhOLDfJZFLYO+s2VP2pdJQ
PRze17CWwPLh6oudRTQYt+TeEycSOCW3LqfhKg1OtoKm5jMEHvVatb++jYbe
17tMUXcJvLfGy//tOxrmKHiFR98TuKHXDoW8p6F9fhrl9oHAarsh6j7jL1ev
9MgYH0otda74QEPSpzs8tz4CH1tnMsX20XAeX7bvGiBw4TC6PvCJhtCR6yXu
Xwh8jVzjPDJCw8aYwuM9WmZ/25ySLaM0XPSprM7SEZgsHbP5h3FkRtnTpXoC
32RXmOrHaLB38Hc6biAw7pr4cr+KhqrK6HHKTOCOAw8LNBoa3IRPIgsmsvCM
K+cnx2tpEBp87gjYLBwqTzrSzVg6vdKxj/GLgIUJt3Q0LAizH14xmYV7HbL9
Ugw0yL2eIMUUFuYGi+4OMo7qPbDi7FQWjkmnqc1G5l+5JVptycL9in7uShMN
ifr3TyXTWHjRgmZJLeMKO7dNPlYsnBAqsXE00+CT++PgMOPa7D1ZJxmH/LRd
/CuHhYdvB5jMjJ8URDv4W7Pwf6F8YwA=
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV0HtUjHkcBvB3rCHSFHVQLmna1kltx+V9Z95M9MV0s6XdlM2RdnQjQi6n
XEpGbaULyUqTzdZKyiZpE1n8fiHUoHY7ExHbuFWm6DIzzX323T+e85zPX885
j1PU7pDYCQRBBDH5v23WNLIIgoRQMLpkypQoffFmcQzjsd89s+K7lEg9byKr
lXHdgbrPgc+VqEfzA1HIIiEjNajDtluJqmqHTM5fkXBiUPimvEeJvB1cDH6T
SPAUubqgd0q0a+S0+uQ0Ej6WPo40jSiR9Lc9Ckd7Ekr2isQnOSoksr3RHUGS
YL1OUSYLVCGzcGu9NIgEOdfdIjZLhYov5XXeiiOh4IjdkSXNKmTp5KV9KCZB
mp82dT2hRtnhG6awz5Egs/IWVArU6N9K3TxRIwmFZ2YfjUpRo8Xf2B0W/E1C
5pnwpOjbapQTXXzP/xMJSa5lr1I1aoRuVHL2sSlYfshvmcPycWRqdfRpn0/B
BNufL9xPHkc8K86DP/gUzMrznS1pGEcBWzP9LoZQ0CUSYIvxcRSbFn+9YwcF
Be17Pu+kNCiitmuhfRYFLWeXeYsPalAQp+mtvJwCpcWjJY9va5Cf+6TsnlsU
PJsekTmo16C5W14vUcoowHeWtz0HLdKtd3y44gsFM94lc38Ra9GfmxWRFVN5
EPRtTKLbYy2KK3aHXBce7G7vYA9Z6RD31AvLipU8iN7ZsntrsA41lXF6ujfy
wNU346asSIc27rpatGofDxwr+w8Od+vQWEKLxDWPB437LaRz5+rRtmOx5R6X
eNCces43LEaPPoYlno7FPOAhVSm3So+8gZ3T9IoHkriBWTajenRqk3VrvpoH
gWvX3JspMKAhMmP0tDUfRPdL7EvSDMjZJX3BjUV8eBDouGNDmwFFdw7S04R8
KPo6f2a6jRGV1ksl8gg+PLtMB9aFGdG1KtLcmcyHvbKljR7lRtQeYRGsKeDD
6pfCz+x+I3q0MO6CZw0fysPzhKspE2qt83hb08KHN7bFk6WpJtSyPSG+7A0f
vt9UzvmuxYTOCUhVnZYPf6VE5vjbmtHhtrgdYzNoyFAkSw9FmBGV6PwxxIOG
hHzPYytrzGjAN6x6aQANnicIJ5bejC69GtkgjKIhOLDfJZFLYO+s2VP2pdJQ
PRze17CWwPLh6oudRTQYt+TeEycSOCW3LqfhKg1OtoKm5jMEHvVatb++jYbe
17tMUXcJvLfGy//tOxrmKHiFR98TuKHXDoW8p6F9fhrl9oHAarsh6j7jL1ev
9MgYH0otda74QEPSpzs8tz4CH1tnMsX20XAeX7bvGiBw4TC6PvCJhtCR6yXu
Xwh8jVzjPDJCw8aYwuM9WmZ/25ySLaM0XPSprM7SEZgsHbP5h3FkRtnTpXoC
32RXmOrHaLB38Hc6biAw7pr4cr+KhqrK6HHKTOCOAw8LNBoa3IRPIgsmsvCM
K+cnx2tpEBp87gjYLBwqTzrSzVg6vdKxj/GLgIUJt3Q0LAizH14xmYV7HbL9
Ugw0yL2eIMUUFuYGi+4OMo7qPbDi7FQWjkmnqc1G5l+5JVptycL9in7uShMN
ifr3TyXTWHjRgmZJLeMKO7dNPlYsnBAqsXE00+CT++PgMOPa7D1ZJxmH/LRd
/CuHhYdvB5jMjJ8URDv4W7Pwf6F8YwA=
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 
             25}, {-2.1324617444643987`, -1.3021298870044307`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, -1.2560003393677688`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 
            25}, {-2.1324617444643987`, -1.3021298870044307`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {20.000000000000043`, -1.2560003393677688`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV0HtUjHkcBvB3rCHSFHVQLmna1kltx+V9Z95M9MV0s6XdlM2RdnQjQi6n
XEpGbaULyUqTzdZKyiZpE1n8fiHUoHY7ExHbuFWm6DIzzX323T+e85zPX885
j1PU7pDYCQRBBDH5v23WNLIIgoRQMLpkypQoffFmcQzjsd89s+K7lEg9byKr
lXHdgbrPgc+VqEfzA1HIIiEjNajDtluJqmqHTM5fkXBiUPimvEeJvB1cDH6T
SPAUubqgd0q0a+S0+uQ0Ej6WPo40jSiR9Lc9Ckd7Ekr2isQnOSoksr3RHUGS
YL1OUSYLVCGzcGu9NIgEOdfdIjZLhYov5XXeiiOh4IjdkSXNKmTp5KV9KCZB
mp82dT2hRtnhG6awz5Egs/IWVArU6N9K3TxRIwmFZ2YfjUpRo8Xf2B0W/E1C
5pnwpOjbapQTXXzP/xMJSa5lr1I1aoRuVHL2sSlYfshvmcPycWRqdfRpn0/B
BNufL9xPHkc8K86DP/gUzMrznS1pGEcBWzP9LoZQ0CUSYIvxcRSbFn+9YwcF
Be17Pu+kNCiitmuhfRYFLWeXeYsPalAQp+mtvJwCpcWjJY9va5Cf+6TsnlsU
PJsekTmo16C5W14vUcoowHeWtz0HLdKtd3y44gsFM94lc38Ra9GfmxWRFVN5
EPRtTKLbYy2KK3aHXBce7G7vYA9Z6RD31AvLipU8iN7ZsntrsA41lXF6ujfy
wNU346asSIc27rpatGofDxwr+w8Od+vQWEKLxDWPB437LaRz5+rRtmOx5R6X
eNCces43LEaPPoYlno7FPOAhVSm3So+8gZ3T9IoHkriBWTajenRqk3VrvpoH
gWvX3JspMKAhMmP0tDUfRPdL7EvSDMjZJX3BjUV8eBDouGNDmwFFdw7S04R8
KPo6f2a6jRGV1ksl8gg+PLtMB9aFGdG1KtLcmcyHvbKljR7lRtQeYRGsKeDD
6pfCz+x+I3q0MO6CZw0fysPzhKspE2qt83hb08KHN7bFk6WpJtSyPSG+7A0f
vt9UzvmuxYTOCUhVnZYPf6VE5vjbmtHhtrgdYzNoyFAkSw9FmBGV6PwxxIOG
hHzPYytrzGjAN6x6aQANnicIJ5bejC69GtkgjKIhOLDfJZFLYO+s2VP2pdJQ
PRze17CWwPLh6oudRTQYt+TeEycSOCW3LqfhKg1OtoKm5jMEHvVatb++jYbe
17tMUXcJvLfGy//tOxrmKHiFR98TuKHXDoW8p6F9fhrl9oHAarsh6j7jL1ev
9MgYH0otda74QEPSpzs8tz4CH1tnMsX20XAeX7bvGiBw4TC6PvCJhtCR6yXu
Xwh8jVzjPDJCw8aYwuM9WmZ/25ySLaM0XPSprM7SEZgsHbP5h3FkRtnTpXoC
32RXmOrHaLB38Hc6biAw7pr4cr+KhqrK6HHKTOCOAw8LNBoa3IRPIgsmsvCM
K+cnx2tpEBp87gjYLBwqTzrSzVg6vdKxj/GLgIUJt3Q0LAizH14xmYV7HbL9
Ugw0yL2eIMUUFuYGi+4OMo7qPbDi7FQWjkmnqc1G5l+5JVptycL9in7uShMN
ifr3TyXTWHjRgmZJLeMKO7dNPlYsnBAqsXE00+CT++PgMOPa7D1ZJxmH/LRd
/CuHhYdvB5jMjJ8URDv4W7Pwf6F8YwA=
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 
         25}, {-2.1324617444643987`, -1.3021298870044307`}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, -1.2560003393677688`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, -1.2560003393677688`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {-2.1324617444643987`, -1.3021298870044307`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.933247795282091*^9, 3.933247939331917*^9, 3.933248121598881*^9, 
   3.933248162686964*^9, {3.933248199362638*^9, 3.93324820970396*^9}, {
   3.933248329519495*^9, 3.9332483672625713`*^9}, {3.933249040588093*^9, 
   3.9332490680419693`*^9}, 3.9332493744576263`*^9, 3.933249669383594*^9, {
   3.933249929714297*^9, 3.9332499491053314`*^9}},
 CellLabel->
  "Out[368]=",ExpressionUUID->"0670a595-e677-6d4e-ace6-25ca0e8bb0e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"BMO", "[", "spacing", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"FH", "/", 
    RowBox[{
     RowBox[{"BMO", "[", "spacing", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.9332495792783375`*^9, 3.933249583906265*^9}, {
  3.9332497315259857`*^9, 3.933249737286804*^9}, {3.93324996942988*^9, 
  3.9332499715981193`*^9}},
 CellLabel->
  "In[369]:=",ExpressionUUID->"1f4826c7-65ab-ad46-aac0-29cb6a948a43"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVy3841AccB3Aa/dI4N9lqK9zNbIZ+7Hvf+zb0+bQUnu20IVNUpKOkpui3
bCGOq0k2ncqqxyHhkpJIvijXdEgu5WR+K8d952d+PXV2++P9vJ/X837eVjt/
8RTO0dPTE+jyf7PW39XX0yNw56a6iLBoFR27ctupXTr3msSZ5B1R0RPLDPRr
dRbFH5Gpw1V029RPeuf1CTycZjoRHKSir8sYLfcDArORnR/opqJhqfU717m6
vWLD7Z/ZKnr/SOpE8iICfXccctiY3UIrrhwYtFhCYD05+dKu4SUd8FGJyp8g
sLP6vUYx3UzPuoQUKQQE7h/3UuS5PKclOWeUZcEEhl9+6uQpaaKNrJym5acI
vCwLnO153EiLfH0WGF4isPnefbG3fQPdkT2zLOAugeWEXVRdzBN65RdmJxyf
EWhsFPKbSi2nk4Ik1W4DBJ6x/zqUTH5I0yXZxhGGPBQpvmOvUtG0ttZiw9Pl
PAw82hB1glVKkx8aP8rj81DOnd9UHlpEu4fEu2Z58tB+nk/bodBsWvjrnuLG
vTw0Z82w1wyn0P6yFzZLEnhIxS+XVwnjQWBc2t11jYfxPnWTQ72Z4Go3V9RW
xsPRlfIss8uF8FngP6vGm3kYZy+TftxcAjNeFnLnIR7O7Is2Nz1fAbe3DW6X
LiSxQeoo5Q5VQ7DEDsXWJKavUC+uiZUDJ6XFSLqWxHspG/893loLpVeN21Rb
SNzSVuFefLQetuy/mbYugkTJ2aBwUVgjjIXVpH91hsRjvpbOc82aYHeM8JpD
DomVGbmyNR1KeL05PFVYSSJLrZ1NFDcDoGFS6SsSD6GH5LTfS0jxM6k9O0Gi
jcLWqZ6jAoaIG0014WOP1wXBWkUrcK1jLUts+bi89GKl4EIbBCk11CIXPsKM
0byzLu2QUaRI7/Ln4/e28s+t1R1w6zoxqzzCx6kOviinpROe+s/fNHWOj/4F
vnFbC7rgsU1w5pp8Pt648a3Ts9RuqC106M6v4WO+YOEqdWgP1ISG7bnarvtv
qJq+6dwLlxyJt4XTfMTFC+wJTh+ceBK8d4xN4d3qd5U7JvuAF8597elAYd6k
x+/r21+DeuPm3NXuFLq5K795XvkGcl6N+LjspDAy51os+49+gIRPFkScpFC8
RHBhzjE1dA3nZinTKBznXErM9BiAKHFh0p2bFO7bXlc+aTEIo07rIoueUJho
zg+ZnKOBg/lObt09FBoX/Gkie6GBO51mtGcvhcGrd9vtaNXAhBnDe6jzlwcJ
V1a7Bo6fzOBK+yjUtyo7fLBPAzEeWq3wDYXJjscfkOMaOD9MF6sHKIzeVa+u
MGXgFrGeOzJCoeQ0/aD+BwZGd396MXCUQhvf2vToHxkgMsZYTTpb9tVFrPBm
4J6hVFs0RuFWhyqrFD8GKl8YtEa+pfDRye1C71AGGo/Kz01NURjKChO3JjDA
Lvhr3p5pCq8mmrqKxQx4dx2OVunMe1Co55TMQIu7TVjZDIVZXm37MtIY6Fwq
co16R2GUc/+KgCwGOJsCKjQ66yf5vWLlMrArluJte09hz7m/46ryGegf7Oes
1VI4VJ/8jHOHAVvLqnSZzksNBiKVJQyEeaezLGYpzBx3No+7z4BMdCAhWee0
K+JigmZguNxdO6vzewOlZ181A/8B+r1dtQ==
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVy3841AccB3Aa/dI4N9lqK9zNbIZ+7Hvf+zb0+bQUnu20IVNUpKOkpui3
bCGOq0k2ncqqxyHhkpJIvijXdEgu5WR+K8d952d+PXV2++P9vJ/X837eVjt/
8RTO0dPTE+jyf7PW39XX0yNw56a6iLBoFR27ctupXTr3msSZ5B1R0RPLDPRr
dRbFH5Gpw1V029RPeuf1CTycZjoRHKSir8sYLfcDArORnR/opqJhqfU717m6
vWLD7Z/ZKnr/SOpE8iICfXccctiY3UIrrhwYtFhCYD05+dKu4SUd8FGJyp8g
sLP6vUYx3UzPuoQUKQQE7h/3UuS5PKclOWeUZcEEhl9+6uQpaaKNrJym5acI
vCwLnO153EiLfH0WGF4isPnefbG3fQPdkT2zLOAugeWEXVRdzBN65RdmJxyf
EWhsFPKbSi2nk4Ik1W4DBJ6x/zqUTH5I0yXZxhGGPBQpvmOvUtG0ttZiw9Pl
PAw82hB1glVKkx8aP8rj81DOnd9UHlpEu4fEu2Z58tB+nk/bodBsWvjrnuLG
vTw0Z82w1wyn0P6yFzZLEnhIxS+XVwnjQWBc2t11jYfxPnWTQ72Z4Go3V9RW
xsPRlfIss8uF8FngP6vGm3kYZy+TftxcAjNeFnLnIR7O7Is2Nz1fAbe3DW6X
LiSxQeoo5Q5VQ7DEDsXWJKavUC+uiZUDJ6XFSLqWxHspG/893loLpVeN21Rb
SNzSVuFefLQetuy/mbYugkTJ2aBwUVgjjIXVpH91hsRjvpbOc82aYHeM8JpD
DomVGbmyNR1KeL05PFVYSSJLrZ1NFDcDoGFS6SsSD6GH5LTfS0jxM6k9O0Gi
jcLWqZ6jAoaIG0014WOP1wXBWkUrcK1jLUts+bi89GKl4EIbBCk11CIXPsKM
0byzLu2QUaRI7/Ln4/e28s+t1R1w6zoxqzzCx6kOviinpROe+s/fNHWOj/4F
vnFbC7rgsU1w5pp8Pt648a3Ts9RuqC106M6v4WO+YOEqdWgP1ISG7bnarvtv
qJq+6dwLlxyJt4XTfMTFC+wJTh+ceBK8d4xN4d3qd5U7JvuAF8597elAYd6k
x+/r21+DeuPm3NXuFLq5K795XvkGcl6N+LjspDAy51os+49+gIRPFkScpFC8
RHBhzjE1dA3nZinTKBznXErM9BiAKHFh0p2bFO7bXlc+aTEIo07rIoueUJho
zg+ZnKOBg/lObt09FBoX/Gkie6GBO51mtGcvhcGrd9vtaNXAhBnDe6jzlwcJ
V1a7Bo6fzOBK+yjUtyo7fLBPAzEeWq3wDYXJjscfkOMaOD9MF6sHKIzeVa+u
MGXgFrGeOzJCoeQ0/aD+BwZGd396MXCUQhvf2vToHxkgMsZYTTpb9tVFrPBm
4J6hVFs0RuFWhyqrFD8GKl8YtEa+pfDRye1C71AGGo/Kz01NURjKChO3JjDA
Lvhr3p5pCq8mmrqKxQx4dx2OVunMe1Co55TMQIu7TVjZDIVZXm37MtIY6Fwq
co16R2GUc/+KgCwGOJsCKjQ66yf5vWLlMrArluJte09hz7m/46ryGegf7Oes
1VI4VJ/8jHOHAVvLqnSZzksNBiKVJQyEeaezLGYpzBx3No+7z4BMdCAhWee0
K+JigmZguNxdO6vzewOlZ181A/8B+r1dtQ==
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 25}, {-0.3983412867394148, 
             0.9300409906064996}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, 0}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 25}, {-0.3983412867394148, 
            0.9300409906064996}}, "Frame" -> {{False, False}, {False, False}},
           "AxesOrigin" -> {20.000000000000043`, 0}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVy3841AccB3Aa/dI4N9lqK9zNbIZ+7Hvf+zb0+bQUnu20IVNUpKOkpui3
bCGOq0k2ncqqxyHhkpJIvijXdEgu5WR+K8d952d+PXV2++P9vJ/X837eVjt/
8RTO0dPTE+jyf7PW39XX0yNw56a6iLBoFR27ctupXTr3msSZ5B1R0RPLDPRr
dRbFH5Gpw1V029RPeuf1CTycZjoRHKSir8sYLfcDArORnR/opqJhqfU717m6
vWLD7Z/ZKnr/SOpE8iICfXccctiY3UIrrhwYtFhCYD05+dKu4SUd8FGJyp8g
sLP6vUYx3UzPuoQUKQQE7h/3UuS5PKclOWeUZcEEhl9+6uQpaaKNrJym5acI
vCwLnO153EiLfH0WGF4isPnefbG3fQPdkT2zLOAugeWEXVRdzBN65RdmJxyf
EWhsFPKbSi2nk4Ik1W4DBJ6x/zqUTH5I0yXZxhGGPBQpvmOvUtG0ttZiw9Pl
PAw82hB1glVKkx8aP8rj81DOnd9UHlpEu4fEu2Z58tB+nk/bodBsWvjrnuLG
vTw0Z82w1wyn0P6yFzZLEnhIxS+XVwnjQWBc2t11jYfxPnWTQ72Z4Go3V9RW
xsPRlfIss8uF8FngP6vGm3kYZy+TftxcAjNeFnLnIR7O7Is2Nz1fAbe3DW6X
LiSxQeoo5Q5VQ7DEDsXWJKavUC+uiZUDJ6XFSLqWxHspG/893loLpVeN21Rb
SNzSVuFefLQetuy/mbYugkTJ2aBwUVgjjIXVpH91hsRjvpbOc82aYHeM8JpD
DomVGbmyNR1KeL05PFVYSSJLrZ1NFDcDoGFS6SsSD6GH5LTfS0jxM6k9O0Gi
jcLWqZ6jAoaIG0014WOP1wXBWkUrcK1jLUts+bi89GKl4EIbBCk11CIXPsKM
0byzLu2QUaRI7/Ln4/e28s+t1R1w6zoxqzzCx6kOviinpROe+s/fNHWOj/4F
vnFbC7rgsU1w5pp8Pt648a3Ts9RuqC106M6v4WO+YOEqdWgP1ISG7bnarvtv
qJq+6dwLlxyJt4XTfMTFC+wJTh+ceBK8d4xN4d3qd5U7JvuAF8597elAYd6k
x+/r21+DeuPm3NXuFLq5K795XvkGcl6N+LjspDAy51os+49+gIRPFkScpFC8
RHBhzjE1dA3nZinTKBznXErM9BiAKHFh0p2bFO7bXlc+aTEIo07rIoueUJho
zg+ZnKOBg/lObt09FBoX/Gkie6GBO51mtGcvhcGrd9vtaNXAhBnDe6jzlwcJ
V1a7Bo6fzOBK+yjUtyo7fLBPAzEeWq3wDYXJjscfkOMaOD9MF6sHKIzeVa+u
MGXgFrGeOzJCoeQ0/aD+BwZGd396MXCUQhvf2vToHxkgMsZYTTpb9tVFrPBm
4J6hVFs0RuFWhyqrFD8GKl8YtEa+pfDRye1C71AGGo/Kz01NURjKChO3JjDA
Lvhr3p5pCq8mmrqKxQx4dx2OVunMe1Co55TMQIu7TVjZDIVZXm37MtIY6Fwq
co16R2GUc/+KgCwGOJsCKjQ66yf5vWLlMrArluJte09hz7m/46ryGegf7Oes
1VI4VJ/8jHOHAVvLqnSZzksNBiKVJQyEeaezLGYpzBx3No+7z4BMdCAhWee0
K+JigmZguNxdO6vzewOlZ181A/8B+r1dtQ==
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 25}, {-0.3983412867394148, 0.9300409906064996}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {-0.3983412867394148, 0.9300409906064996}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.933249584483509*^9, 3.9332497036728077`*^9, 
  3.9332497382789745`*^9, 3.933249972458948*^9},
 CellLabel->
  "Out[369]=",ExpressionUUID->"53528173-ddf4-9d47-8b7d-c38591891cc4"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV0Xk81ekXB3D7fo3cxXVxdV377nq+xUQO6ZeM8JPKVtkpkjG0L/ZdlKIf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          "]], LineBox[CompressedData["
1:eJwV0nk4lWkfB3C02eJ0ouOILKdIcazP47Q+X00K70SDlIqQNWRJZSzxKhIV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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV0Xk81ekXB3D7fo3cxXVxdV377nq+xUQO6ZeM8JPKVtkpkjG0L/ZdlKIf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              "]], 
             Line[CompressedData["
1:eJwV0nk4lWkfB3C02eJ0ouOILKdIcazP47Q+X00K70SDlIqQNWRJZSzxKhIV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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 25}, {-20.240865723398876`, 
             20.161015602691286`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, 0}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 25}, {-20.240865723398876`, 
            20.161015602691286`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {20.000000000000043`, 0}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV0Xk81ekXB3D7fo3cxXVxdV377nq+xUQO6ZeM8JPKVtkpkjG0L/ZdlKIf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          "]], 
         Line[CompressedData["
1:eJwV0nk4lWkfB3C02eJ0ouOILKdIcazP47Q+X00K70SDlIqQNWRJZSzxKhIV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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 25}, {-20.240865723398876`, 20.161015602691286`}},
        "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {-20.240865723398876`, 20.161015602691286`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.933249584483509*^9, 3.9332497036728077`*^9, 
  3.9332497382789745`*^9, 3.933249972678177*^9},
 CellLabel->
  "Out[370]=",ExpressionUUID->"bf8eee12-1002-d04d-a2b8-d055c27255c1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "FH"}]], "Input",
 CellChangeTimes->{{3.933249842992607*^9, 3.933249843510992*^9}},
 CellLabel->
  "In[362]:=",ExpressionUUID->"6fdeaf84-61c1-5245-b9c3-f23079657581"],

Cell[BoxData["1.184`"], "Output",
 CellChangeTimes->{3.933249844388899*^9},
 CellLabel->
  "Out[362]=",ExpressionUUID->"e3d0cc7e-ac02-7046-8341-2e7139c081f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"MT", "[", "spacing", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"FH", "/", 
    RowBox[{
     RowBox[{"MT", "[", "spacing", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "20", ",", "25"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.933249785090082*^9, 3.933249799342235*^9}, {
  3.9332498383592377`*^9, 3.933249840983631*^9}, {3.933249995938837*^9, 
  3.933249997897768*^9}},
 CellLabel->
  "In[371]:=",ExpressionUUID->"4d1aa3e8-04ca-204c-adcd-c9fe257987f3"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV0Xs0lHkYB/BREeUaOl22xmWt1nGs6n1n3qKex1ExWts2i80xWiqj1mUr
Wt3oYBVSit3WkOLs1JhWU6yyaTYtIdQpvS65lEthZlA/lNvasbN/POd7Pud8
z/n+8dju+UEYNo/D4fjq7v8097yrx+FQGBqs9BytZyHZNThxn87NxbkjDU9Y
mFi1QK9e51lFm1L6jIWuqZ2cLD0K9zRGNe5qYaFIMaK1n09h2r5F8qoeFmCF
w6yXAYUBy/TF+ZMsRI9mT2QaU6h3mjMY7dAMjVcPDXGXUxh+zEw/KbEZQizL
20UUhREbsw0ct7fA3Jbw0kZfCltSBq6ojVohR5bBVogp1PjnGnvUtcJiW/fp
2kQKzY0Kizb/2gapuwKM9PMo3G3psvBJ0Evovj6zKuQuhbJpSUrc+nZw/czq
hFsThX8Z98j7jTogfW9OlbeGwilB99fC5g6oLL9uGqNP42Thd76HSztBW8/d
+mw1jftFozXbfuoCnonpo9/5NFqUmbQJ/F6BIPy01zUhjandBVUXmdcQdurA
necRNDoHCpQc824QKVodl5+h8bDkqLPzbDf4mt7r6y2kMfOXpLHAmB7wcjZI
7aqgMSXBUq3q7YFPQl+t/dBCo1xml2gT1Asz33BrN72ncenSbJ+Ep73wR/DQ
bukiHtr4lD5+6NMH4hxnPOvAw5z1xiLruj6wu/hysXQzD0vVnqFe7m/gXoFp
V3sgDz+VnWgtUr6BwOhblzxieOjLquVV9FsYj6yRfJ7BwyXTnhHSm29hf1JY
oYuMhyscJKe0rv0w4H8wO+whD1PYtJUNxf0AqJ9+r5OH0kWqMQE1ABeDzOrP
TfAwWrout6hiAEaon8ayzfgY33bf3XXDINg7JNuUO/FRnBVVeLd6EPayw4zx
Fj7et7A19NimgvzSRkmviI9zAq8vQ+pUUFJEzbFxfIyqneHU+anhmchwx9QF
PibccLMaaldDnaP4tw3FfHQSPvDPitBA/W2XvuIaPv6cxjY1fdBAzfeRBwpe
8zHQMm9X+skhyHOjPt6e5qMmkWthZjEMJxrEEeNLGFSWaE36Lw8DfdB+QOjC
YFtTHFTTI6De5i9fJ2BQpKwIX/t0BGSdowFb9jBYc3n3mqKgdwBnlhnFxDNo
kNn26NDkO+gl8mvsJQZ91tiS1env4eTZ2+lltxi0nkybSzUhMObuEVvawKBA
GCJ6LiJwuNjdu+8Ng8mhS7liGYGyHqtK4VsGM47Ux5cVEZiwGqGrde4s/EI1
7waB4/H59tJ+Bv08rXuuFhNI+kqrDRtkMF2+VdRRQiCLVN5Raxh0nu92eqeS
QAnlaT86yuCGobgC7ybd/v6VuaFjDJoanj+S84IAlT9u/kJnp03fBqhYAn/q
S7Wl47o+meeW2krgYeuCjtiPDF47VnnhcSeB50drL0xNMahY/jRq+wCBJTev
LDwwzeBIhZU2b5CAX++PCe06H4w1yx1WEXgpcIysmGFwu+vqj+eGCPSsSPU6
OcvgzsYCfhMhYLcj5MGwztUuiQ52YwT2JTN08L8MHrthxY0ZJ6AaUtlt1ur+
o/GjrScIONn8LVHo7H1LTyieJBDpJzHnzjG4LCP0ePkUAUXqoTOZOrskxioM
ZwgQpUA7p/O58xvfBf5D4D9+R1eZ
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV0Xs0lHkYB/BREeUaOl22xmWt1nGs6n1n3qKex1ExWts2i80xWiqj1mUr
Wt3oYBVSit3WkOLs1JhWU6yyaTYtIdQpvS65lEthZlA/lNvasbN/POd7Pud8
z/n+8dju+UEYNo/D4fjq7v8097yrx+FQGBqs9BytZyHZNThxn87NxbkjDU9Y
mFi1QK9e51lFm1L6jIWuqZ2cLD0K9zRGNe5qYaFIMaK1n09h2r5F8qoeFmCF
w6yXAYUBy/TF+ZMsRI9mT2QaU6h3mjMY7dAMjVcPDXGXUxh+zEw/KbEZQizL
20UUhREbsw0ct7fA3Jbw0kZfCltSBq6ojVohR5bBVogp1PjnGnvUtcJiW/fp
2kQKzY0Kizb/2gapuwKM9PMo3G3psvBJ0Evovj6zKuQuhbJpSUrc+nZw/czq
hFsThX8Z98j7jTogfW9OlbeGwilB99fC5g6oLL9uGqNP42Thd76HSztBW8/d
+mw1jftFozXbfuoCnonpo9/5NFqUmbQJ/F6BIPy01zUhjandBVUXmdcQdurA
necRNDoHCpQc824QKVodl5+h8bDkqLPzbDf4mt7r6y2kMfOXpLHAmB7wcjZI
7aqgMSXBUq3q7YFPQl+t/dBCo1xml2gT1Asz33BrN72ncenSbJ+Ep73wR/DQ
bukiHtr4lD5+6NMH4hxnPOvAw5z1xiLruj6wu/hysXQzD0vVnqFe7m/gXoFp
V3sgDz+VnWgtUr6BwOhblzxieOjLquVV9FsYj6yRfJ7BwyXTnhHSm29hf1JY
oYuMhyscJKe0rv0w4H8wO+whD1PYtJUNxf0AqJ9+r5OH0kWqMQE1ABeDzOrP
TfAwWrout6hiAEaon8ayzfgY33bf3XXDINg7JNuUO/FRnBVVeLd6EPayw4zx
Fj7et7A19NimgvzSRkmviI9zAq8vQ+pUUFJEzbFxfIyqneHU+anhmchwx9QF
PibccLMaaldDnaP4tw3FfHQSPvDPitBA/W2XvuIaPv6cxjY1fdBAzfeRBwpe
8zHQMm9X+skhyHOjPt6e5qMmkWthZjEMJxrEEeNLGFSWaE36Lw8DfdB+QOjC
YFtTHFTTI6De5i9fJ2BQpKwIX/t0BGSdowFb9jBYc3n3mqKgdwBnlhnFxDNo
kNn26NDkO+gl8mvsJQZ91tiS1env4eTZ2+lltxi0nkybSzUhMObuEVvawKBA
GCJ6LiJwuNjdu+8Ng8mhS7liGYGyHqtK4VsGM47Ux5cVEZiwGqGrde4s/EI1
7waB4/H59tJ+Bv08rXuuFhNI+kqrDRtkMF2+VdRRQiCLVN5Raxh0nu92eqeS
QAnlaT86yuCGobgC7ybd/v6VuaFjDJoanj+S84IAlT9u/kJnp03fBqhYAn/q
S7Wl47o+meeW2krgYeuCjtiPDF47VnnhcSeB50drL0xNMahY/jRq+wCBJTev
LDwwzeBIhZU2b5CAX++PCe06H4w1yx1WEXgpcIysmGFwu+vqj+eGCPSsSPU6
OcvgzsYCfhMhYLcj5MGwztUuiQ52YwT2JTN08L8MHrthxY0ZJ6AaUtlt1ur+
o/GjrScIONn8LVHo7H1LTyieJBDpJzHnzjG4LCP0ePkUAUXqoTOZOrskxioM
ZwgQpUA7p/O58xvfBf5D4D9+R1eZ
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 25}, {0.309200588367693, 
             1.0613650613603653`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, 0.30920058836769365`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 25}, {0.309200588367693, 1.0613650613603653`}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {20.000000000000043`, 0.30920058836769365`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV0Xs0lHkYB/BREeUaOl22xmWt1nGs6n1n3qKex1ExWts2i80xWiqj1mUr
Wt3oYBVSit3WkOLs1JhWU6yyaTYtIdQpvS65lEthZlA/lNvasbN/POd7Pud8
z/n+8dju+UEYNo/D4fjq7v8097yrx+FQGBqs9BytZyHZNThxn87NxbkjDU9Y
mFi1QK9e51lFm1L6jIWuqZ2cLD0K9zRGNe5qYaFIMaK1n09h2r5F8qoeFmCF
w6yXAYUBy/TF+ZMsRI9mT2QaU6h3mjMY7dAMjVcPDXGXUxh+zEw/KbEZQizL
20UUhREbsw0ct7fA3Jbw0kZfCltSBq6ojVohR5bBVogp1PjnGnvUtcJiW/fp
2kQKzY0Kizb/2gapuwKM9PMo3G3psvBJ0Evovj6zKuQuhbJpSUrc+nZw/czq
hFsThX8Z98j7jTogfW9OlbeGwilB99fC5g6oLL9uGqNP42Thd76HSztBW8/d
+mw1jftFozXbfuoCnonpo9/5NFqUmbQJ/F6BIPy01zUhjandBVUXmdcQdurA
necRNDoHCpQc824QKVodl5+h8bDkqLPzbDf4mt7r6y2kMfOXpLHAmB7wcjZI
7aqgMSXBUq3q7YFPQl+t/dBCo1xml2gT1Asz33BrN72ncenSbJ+Ep73wR/DQ
bukiHtr4lD5+6NMH4hxnPOvAw5z1xiLruj6wu/hysXQzD0vVnqFe7m/gXoFp
V3sgDz+VnWgtUr6BwOhblzxieOjLquVV9FsYj6yRfJ7BwyXTnhHSm29hf1JY
oYuMhyscJKe0rv0w4H8wO+whD1PYtJUNxf0AqJ9+r5OH0kWqMQE1ABeDzOrP
TfAwWrout6hiAEaon8ayzfgY33bf3XXDINg7JNuUO/FRnBVVeLd6EPayw4zx
Fj7et7A19NimgvzSRkmviI9zAq8vQ+pUUFJEzbFxfIyqneHU+anhmchwx9QF
PibccLMaaldDnaP4tw3FfHQSPvDPitBA/W2XvuIaPv6cxjY1fdBAzfeRBwpe
8zHQMm9X+skhyHOjPt6e5qMmkWthZjEMJxrEEeNLGFSWaE36Lw8DfdB+QOjC
YFtTHFTTI6De5i9fJ2BQpKwIX/t0BGSdowFb9jBYc3n3mqKgdwBnlhnFxDNo
kNn26NDkO+gl8mvsJQZ91tiS1env4eTZ2+lltxi0nkybSzUhMObuEVvawKBA
GCJ6LiJwuNjdu+8Ng8mhS7liGYGyHqtK4VsGM47Ux5cVEZiwGqGrde4s/EI1
7waB4/H59tJ+Bv08rXuuFhNI+kqrDRtkMF2+VdRRQiCLVN5Raxh0nu92eqeS
QAnlaT86yuCGobgC7ybd/v6VuaFjDJoanj+S84IAlT9u/kJnp03fBqhYAn/q
S7Wl47o+meeW2krgYeuCjtiPDF47VnnhcSeB50drL0xNMahY/jRq+wCBJTev
LDwwzeBIhZU2b5CAX++PCe06H4w1yx1WEXgpcIysmGFwu+vqj+eGCPSsSPU6
OcvgzsYCfhMhYLcj5MGwztUuiQ52YwT2JTN08L8MHrthxY0ZJ6AaUtlt1ur+
o/GjrScIONn8LVHo7H1LTyieJBDpJzHnzjG4LCP0ePkUAUXqoTOZOrskxioM
ZwgQpUA7p/O58xvfBf5D4D9+R1eZ
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 25}, {0.309200588367693, 1.0613650613603653`}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, 0.30920058836769365`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, 0.30920058836769365`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {0.309200588367693, 1.0613650613603653`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.933249800025114*^9, 3.933249998739736*^9},
 CellLabel->
  "Out[371]=",ExpressionUUID->"8d16ee83-8ef9-5840-a76a-1ac29d5f7679"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVzntUjHkcx/GZzDRTaqa1WUSioVAo+zwzv06t3zchs4zIZbetCBWptWUc
HImtKTrFqYxLo5NrpC3JKF2wScrG2RWt1iRqYkvR5XmmmWamTPvsH9/zPa+/
Pu/Z238JjrJisVgy5v7/DgF32SwWAcuife0DrghA4RWeHMn4qtlzTlu+AAzO
HHYT4+0z/VbuVQmg3biedYpNgLBX+tu1bAHcKO23iCYQ8I3rmo9TjwoAO80d
C7QmoCpB3e8VJoA9lNKQZUeA/sHa8jlTBPDsYsInl2kEVJ5Oi+Bn20PE15Wa
MIKAIs4j4eSDdjC+fKf6mYyAKQt9aouSJ0Ju4YmWmmgCvFIVJk6+LUyc7Wdq
TCbgKSdDtk1tA+k/brbh5hEQMupzjveeDx3Xzc4Rdwng3bc9ZCfgg5ebY6Lv
CwI0NvW/DgfyIGNH7qNVfQTU6RXhslxrqK28LpBzSWCvJaKnvueCpcllxfOZ
JOjXS3h2y7ggthc8LpaQgDq6twYWc0C681jgtWASvjo5luwm5EDU0ZiK5lgS
Qu6truelToCw0lb3acdJKOmhgwZ0ViATVHdpL5NgkzBzyd9xVhDoaZ3eXkOC
YbGR4zHMhhnb3noPvyJh72q3rMb9bDBvcGn8bpCE4RFz2xlrNtwJ/7SlwFYM
PN8L3uM5LIjO9YTMuWJoDng1b9UcFrjmvJ5YsFQM5bNG+R2KcVx9SdCuCRHD
SofCjs67Fhyy59ZZf7kYav5Yp3hl+YJ1cQ2q+SfEkF0XVTy47gvelRJ1eVGh
GM4LLT/55I3h7k3xyqiHYtgp7p/3z8goxsDNqH4jBjpJ1LNANopzQoVNJw1i
cJ1skD8uNuN+IpVWCiUQyr/lvc/JjEVzFbMqF0jg3ebv76xOMeEdLZ+R3XIJ
ZPbcqXI2GXG++plKGyYBOuLFstH9Rnz7BjHeckACqRvPFOweGMHPw/hBxmwJ
vGZtGJwvH8FP3KOv+pRI4MGgqqGLMuCmskVdJQ0SWK/07hMmGXDD7riYS+8k
oAx94sQVGHCeL6EvMzE9erfYdSo9TnwaHaubhGCFZ9+9usV6TMaLuoMXIahu
zbN0PhzGvSs3FS2RIugeulIe98MwLnxDbV6+HcEB7BE6MqLD+PhUG3kSgiaR
aiBZqcPaoaJrLWcRhK7RXDyAdPhwZllG+S0EzqnEUJmWxrSf/z71UwRiHw8h
eYzGe0v8VnW9RyCz6hla+i2Nyzsda4M/INhhTV594U1jg2M/Wc/4npqdEulF
40NJ+aKCfxEEeJseZyykccpaiyWqB8Gu0OytGncanxqqrejtQxAbpO08MoPG
t4kAEUUhSEuM7+zjMvu7pp/fRjN9idhRwaExka9zeMm4SXlZPn0Cjau4BRa1
DkE916piDYvGD1s5bfv0CK7wY/xvmyncfLAx22hE0BifdChlkMKTbl7gxZgQ
SD2cIp0HKLxRu/+IhvH8rNaDVZ8p/FrqHldjRmAsyREN9lK40yk98PAY02cn
TdrygcKuQRG/f2ac99Kp1txF4UgFIsO/IGhxbvE4p6Xwx08fXZdaENj/1ZbW
/I7CC2bVqUoZo7Hp8p/fUjhuo8rBZRxBjb97pm07hUvTE45nMe4/pv+zsI3C
Q/ellnHGNyuO+q7QUPg/cKM/3Q==
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVzntUjHkcx/GZzDRTaqa1WUSioVAo+zwzv06t3zchs4zIZbetCBWptWUc
HImtKTrFqYxLo5NrpC3JKF2wScrG2RWt1iRqYkvR5XmmmWamTPvsH9/zPa+/
Pu/Z238JjrJisVgy5v7/DgF32SwWAcuife0DrghA4RWeHMn4qtlzTlu+AAzO
HHYT4+0z/VbuVQmg3biedYpNgLBX+tu1bAHcKO23iCYQ8I3rmo9TjwoAO80d
C7QmoCpB3e8VJoA9lNKQZUeA/sHa8jlTBPDsYsInl2kEVJ5Oi+Bn20PE15Wa
MIKAIs4j4eSDdjC+fKf6mYyAKQt9aouSJ0Ju4YmWmmgCvFIVJk6+LUyc7Wdq
TCbgKSdDtk1tA+k/brbh5hEQMupzjveeDx3Xzc4Rdwng3bc9ZCfgg5ebY6Lv
CwI0NvW/DgfyIGNH7qNVfQTU6RXhslxrqK28LpBzSWCvJaKnvueCpcllxfOZ
JOjXS3h2y7ggthc8LpaQgDq6twYWc0C681jgtWASvjo5luwm5EDU0ZiK5lgS
Qu6truelToCw0lb3acdJKOmhgwZ0ViATVHdpL5NgkzBzyd9xVhDoaZ3eXkOC
YbGR4zHMhhnb3noPvyJh72q3rMb9bDBvcGn8bpCE4RFz2xlrNtwJ/7SlwFYM
PN8L3uM5LIjO9YTMuWJoDng1b9UcFrjmvJ5YsFQM5bNG+R2KcVx9SdCuCRHD
SofCjs67Fhyy59ZZf7kYav5Yp3hl+YJ1cQ2q+SfEkF0XVTy47gvelRJ1eVGh
GM4LLT/55I3h7k3xyqiHYtgp7p/3z8goxsDNqH4jBjpJ1LNANopzQoVNJw1i
cJ1skD8uNuN+IpVWCiUQyr/lvc/JjEVzFbMqF0jg3ebv76xOMeEdLZ+R3XIJ
ZPbcqXI2GXG++plKGyYBOuLFstH9Rnz7BjHeckACqRvPFOweGMHPw/hBxmwJ
vGZtGJwvH8FP3KOv+pRI4MGgqqGLMuCmskVdJQ0SWK/07hMmGXDD7riYS+8k
oAx94sQVGHCeL6EvMzE9erfYdSo9TnwaHaubhGCFZ9+9usV6TMaLuoMXIahu
zbN0PhzGvSs3FS2RIugeulIe98MwLnxDbV6+HcEB7BE6MqLD+PhUG3kSgiaR
aiBZqcPaoaJrLWcRhK7RXDyAdPhwZllG+S0EzqnEUJmWxrSf/z71UwRiHw8h
eYzGe0v8VnW9RyCz6hla+i2Nyzsda4M/INhhTV594U1jg2M/Wc/4npqdEulF
40NJ+aKCfxEEeJseZyykccpaiyWqB8Gu0OytGncanxqqrejtQxAbpO08MoPG
t4kAEUUhSEuM7+zjMvu7pp/fRjN9idhRwaExka9zeMm4SXlZPn0Cjau4BRa1
DkE916piDYvGD1s5bfv0CK7wY/xvmyncfLAx22hE0BifdChlkMKTbl7gxZgQ
SD2cIp0HKLxRu/+IhvH8rNaDVZ8p/FrqHldjRmAsyREN9lK40yk98PAY02cn
TdrygcKuQRG/f2ac99Kp1txF4UgFIsO/IGhxbvE4p6Xwx08fXZdaENj/1ZbW
/I7CC2bVqUoZo7Hp8p/fUjhuo8rBZRxBjb97pm07hUvTE45nMe4/pv+zsI3C
Q/ellnHGNyuO+q7QUPg/cKM/3Q==
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{20, 25}, {1.11554454080338, 3.8292294534446976`}},
            "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {20.000000000000043`, 1.1155445408033824`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{20, 25}, {1.11554454080338, 3.8292294534446976`}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {20.000000000000043`, 1.1155445408033824`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVzntUjHkcx/GZzDRTaqa1WUSioVAo+zwzv06t3zchs4zIZbetCBWptWUc
HImtKTrFqYxLo5NrpC3JKF2wScrG2RWt1iRqYkvR5XmmmWamTPvsH9/zPa+/
Pu/Z238JjrJisVgy5v7/DgF32SwWAcuife0DrghA4RWeHMn4qtlzTlu+AAzO
HHYT4+0z/VbuVQmg3biedYpNgLBX+tu1bAHcKO23iCYQ8I3rmo9TjwoAO80d
C7QmoCpB3e8VJoA9lNKQZUeA/sHa8jlTBPDsYsInl2kEVJ5Oi+Bn20PE15Wa
MIKAIs4j4eSDdjC+fKf6mYyAKQt9aouSJ0Ju4YmWmmgCvFIVJk6+LUyc7Wdq
TCbgKSdDtk1tA+k/brbh5hEQMupzjveeDx3Xzc4Rdwng3bc9ZCfgg5ebY6Lv
CwI0NvW/DgfyIGNH7qNVfQTU6RXhslxrqK28LpBzSWCvJaKnvueCpcllxfOZ
JOjXS3h2y7ggthc8LpaQgDq6twYWc0C681jgtWASvjo5luwm5EDU0ZiK5lgS
Qu6truelToCw0lb3acdJKOmhgwZ0ViATVHdpL5NgkzBzyd9xVhDoaZ3eXkOC
YbGR4zHMhhnb3noPvyJh72q3rMb9bDBvcGn8bpCE4RFz2xlrNtwJ/7SlwFYM
PN8L3uM5LIjO9YTMuWJoDng1b9UcFrjmvJ5YsFQM5bNG+R2KcVx9SdCuCRHD
SofCjs67Fhyy59ZZf7kYav5Yp3hl+YJ1cQ2q+SfEkF0XVTy47gvelRJ1eVGh
GM4LLT/55I3h7k3xyqiHYtgp7p/3z8goxsDNqH4jBjpJ1LNANopzQoVNJw1i
cJ1skD8uNuN+IpVWCiUQyr/lvc/JjEVzFbMqF0jg3ebv76xOMeEdLZ+R3XIJ
ZPbcqXI2GXG++plKGyYBOuLFstH9Rnz7BjHeckACqRvPFOweGMHPw/hBxmwJ
vGZtGJwvH8FP3KOv+pRI4MGgqqGLMuCmskVdJQ0SWK/07hMmGXDD7riYS+8k
oAx94sQVGHCeL6EvMzE9erfYdSo9TnwaHaubhGCFZ9+9usV6TMaLuoMXIahu
zbN0PhzGvSs3FS2RIugeulIe98MwLnxDbV6+HcEB7BE6MqLD+PhUG3kSgiaR
aiBZqcPaoaJrLWcRhK7RXDyAdPhwZllG+S0EzqnEUJmWxrSf/z71UwRiHw8h
eYzGe0v8VnW9RyCz6hla+i2Nyzsda4M/INhhTV594U1jg2M/Wc/4npqdEulF
40NJ+aKCfxEEeJseZyykccpaiyWqB8Gu0OytGncanxqqrejtQxAbpO08MoPG
t4kAEUUhSEuM7+zjMvu7pp/fRjN9idhRwaExka9zeMm4SXlZPn0Cjau4BRa1
DkE916piDYvGD1s5bfv0CK7wY/xvmyncfLAx22hE0BifdChlkMKTbl7gxZgQ
SD2cIp0HKLxRu/+IhvH8rNaDVZ8p/FrqHldjRmAsyREN9lK40yk98PAY02cn
TdrygcKuQRG/f2ac99Kp1txF4UgFIsO/IGhxbvE4p6Xwx08fXZdaENj/1ZbW
/I7CC2bVqUoZo7Hp8p/fUjhuo8rBZRxBjb97pm07hUvTE45nMe4/pv+zsI3C
Q/ellnHGNyuO+q7QUPg/cKM/3Q==
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{20, 25}, {1.11554454080338, 3.8292294534446976`}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {20.000000000000043`, 1.1155445408033824`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{20.000000000000043`, 1.1155445408033824`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{20, 25}, {1.11554454080338, 3.8292294534446976`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.933249800025114*^9, 3.933249998936159*^9},
 CellLabel->
  "Out[372]=",ExpressionUUID->"9db9ecf5-f0a6-0e49-844d-cf8fef90dea3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"GraphIPPosition", "[", 
      RowBox[{"F", "[", "x", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MinimalBy", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"GraphIPPosition", "[", 
          RowBox[{"F", "[", "x", "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
     "Last"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"GraphIPMag", "[", 
      RowBox[{"FH", ",", 
       RowBox[{"F", "[", "x", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MaximalBy", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"GraphIPMag", "[", 
          RowBox[{"FH", ",", 
           RowBox[{"F", "[", "x", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "32", ",", ".01"}], "}"}]}], "]"}], ",", 
     "Last"}], "]"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.932575169987573*^9, 3.932575170354736*^9}, {
  3.9327294622710075`*^9, 
  3.932729462274084*^9}},ExpressionUUID->"c5fb642c-764e-0543-ab1a-\
68e7b2517593"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Plane Finding", "Section",
 CellChangeTimes->{{3.933250602393644*^9, 
  3.933250617683927*^9}},ExpressionUUID->"9610ee42-6fda-7e48-a848-\
8784fc4cc3bd"],

Cell[CellGroupData[{

Cell["\<\

\[ScriptF]=299 LA1484-B\
\>", "Subsection",
 CellChangeTimes->{{3.93342495029467*^9, 3.9334249741416893`*^9}, {
  3.9334250249559174`*^9, 
  3.933425028471394*^9}},ExpressionUUID->"2d42191e-3c04-8c4e-ab03-\
0df70c96b660"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"L1", ",", "L1V", ",", "V\[Theta]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L1", "=", "299"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L1V", "=", 
   RowBox[{"TLVM", "[", 
    RowBox[{"\[Infinity]", ",", 
     RowBox[{"-", "154.52"}], ",", "2.52", ",", "nair", ",", "nnbk7"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"V\[Theta]", "=", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"L1", ",", "50", ",", "780"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"POIM", "[", "spacing_", "]"}], ":=", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{
      RowBox[{"kSolver", "[", 
       RowBox[{"AL2V", ".", 
        RowBox[{"TVM", "[", "spacing", "]"}], ".", "AL1V", ".", 
        RowBox[{"TVM", "[", 
         RowBox[{"26", "-", "spacing"}], "]"}], ".", "L1V", ".", 
        RowBox[{"{", 
         RowBox[{"V\[Theta]", ",", "1"}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "//", "N"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"POIM", "[", "16", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"POIM", "[", "spacing", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.93325061847431*^9, 3.9332509756465664`*^9}, {
   3.933251924635486*^9, 3.933251950198118*^9}, {3.933252520337353*^9, 
   3.933252586349373*^9}, {3.933252711371441*^9, 3.933252957398201*^9}, {
   3.933253012649261*^9, 3.933253034642021*^9}, {3.933253126229708*^9, 
   3.933253256942467*^9}, {3.933256046006436*^9, 3.9332560977857*^9}, {
   3.93325613792489*^9, 3.9332561416679115`*^9}, 3.9333411216486263`*^9, {
   3.9333427554236565`*^9, 3.933342756288737*^9}, {3.933342787325463*^9, 
   3.933342863012617*^9}, {3.933418539331135*^9, 3.933418585699009*^9}, {
   3.933418794902672*^9, 3.9334189497867374`*^9}, {3.933419001265238*^9, 
   3.933419050686817*^9}, {3.9334205396149635`*^9, 3.93342054406625*^9}, {
   3.9334210298693275`*^9, 3.933421103455084*^9}, {3.933421133550852*^9, 
   3.933421176306904*^9}, {3.933421245356535*^9, 3.933421252004025*^9}, {
   3.9334212985536213`*^9, 3.9334213005307617`*^9}, {3.933421386444422*^9, 
   3.9334213885660286`*^9}, 3.933421663209772*^9, {3.933421708669148*^9, 
   3.933421742330605*^9}, {3.933421791518833*^9, 3.9334218062477016`*^9}, {
   3.933424346441019*^9, 3.933424386905495*^9}, {3.933424571849171*^9, 
   3.9334245882168655`*^9}, {3.9334246890643845`*^9, 3.933424774320446*^9}, {
   3.933424859488377*^9, 3.933424920026762*^9}, {3.9334250328162174`*^9, 
   3.933425048143799*^9}, {3.933425085471525*^9, 3.933425119468567*^9}, {
   3.933425242327927*^9, 3.933425266588457*^9}, 3.93342529997682*^9, {
   3.93342542440163*^9, 3.933425425065836*^9}, {3.933425503005558*^9, 
   3.933425505455635*^9}, {3.9334257255967865`*^9, 3.933425728326336*^9}, {
   3.93342584924798*^9, 3.933425864315748*^9}, {3.933426412453787*^9, 
   3.9334264413530464`*^9}, {3.933426488825613*^9, 3.933426491475727*^9}, {
   3.933426546538824*^9, 3.933426594767561*^9}, {3.933426639555824*^9, 
   3.9334266401154804`*^9}, {3.933426681239567*^9, 3.933426683924782*^9}, {
   3.933426835324051*^9, 3.933426888302016*^9}, {3.933426923476864*^9, 
   3.933427370204891*^9}, {3.933427404959942*^9, 3.93342745122134*^9}, {
   3.933427586323635*^9, 3.933427611514879*^9}, {3.933427700301304*^9, 
   3.933427761871973*^9}, {3.9334280734241877`*^9, 3.933428116189203*^9}, 
   3.9334296035850964`*^9, {3.9334296357647085`*^9, 3.933429712073021*^9}, {
   3.9334300016405506`*^9, 3.9334300017566814`*^9}, {3.9334343716338024`*^9, 
   3.9334344214996033`*^9}, {3.933434467311608*^9, 3.9334344703109894`*^9}, {
   3.9334369932358017`*^9, 3.9334370124451656`*^9}, {3.9334370746458263`*^9, 
   3.9334370884387016`*^9}, {3.933437214363661*^9, 3.933437222863905*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"c115544c-8533-6246-a076-f950f334afa7"],

Cell[BoxData["12.363074430086328`"], "Output",
 CellChangeTimes->{
  3.9334250486271076`*^9, {3.933425116330334*^9, 3.933425120058351*^9}, 
   3.933425267778082*^9, 3.9334253005032606`*^9, 3.933425331838505*^9, 
   3.9334254256063385`*^9, 3.933425506057093*^9, 3.933426492570196*^9, {
   3.933426537708126*^9, 3.933426548144768*^9}, 3.933426595579262*^9, {
   3.933426837359894*^9, 3.93342684708515*^9}, {3.933427001016229*^9, 
   3.933427020396002*^9}, {3.93342706920706*^9, 3.9334271226648865`*^9}, 
   3.933427167401907*^9, {3.933427351183628*^9, 3.933427371117432*^9}, {
   3.9334274306143703`*^9, 3.933427451901619*^9}, 3.9334276157400684`*^9, {
   3.93342770322022*^9, 3.933427748330817*^9}, {3.933428076549879*^9, 
   3.93342812211964*^9}, {3.933429578330511*^9, 3.9334296041696987`*^9}, {
   3.933429648156302*^9, 3.933429684264015*^9}, 3.933429858142456*^9, 
   3.933431687470154*^9, {3.933434369923181*^9, 3.933434422091328*^9}, 
   3.933434481629153*^9, {3.933436981485281*^9, 3.9334369966317863`*^9}, 
   3.9334370786608887`*^9, {3.9334372149772205`*^9, 3.9334372242628307`*^9}},
 CellLabel->
  "Out[135]=",ExpressionUUID->"84e67cf1-09af-e547-befb-39934de2eb64"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV1H0w1AsXB3ChhIhdrbV2W9YSIetld63F70vKS6SUSspr5CUlbuHGI7SN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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV1H0w1AsXB3ChhIhdrbV2W9YSIetld63F70vKS6SUSspr5CUlbuHGI7SN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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-3.2194335392296978`, 
             32.76119631508618}}, "Frame" -> {{False, False}, {False, False}},
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-3.2194335392296978`, 32.76119631508618}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
          "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
          GoldenRatio^(-1), "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV1H0w1AsXB3ChhIhdrbV2W9YSIetld63F70vKS6SUSspr5CUlbuHGI7SN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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-3.2194335392296978`, 32.76119631508618}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {-3.2194335392296978`, 32.76119631508618}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.9334250486271076`*^9, {3.933425116330334*^9, 3.933425120058351*^9}, 
   3.933425267778082*^9, 3.9334253005032597`*^9, 3.933425331838505*^9, 
   3.9334254256063385`*^9, 3.933425506057093*^9, 3.933426492570196*^9, {
   3.933426537708126*^9, 3.933426548144768*^9}, 3.933426595579262*^9, {
   3.933426837359894*^9, 3.93342684708515*^9}, {3.933427001016229*^9, 
   3.933427020396002*^9}, {3.93342706920706*^9, 3.9334271226648865`*^9}, 
   3.933427167401907*^9, {3.933427351183628*^9, 3.933427371117432*^9}, {
   3.9334274306143703`*^9, 3.933427451901619*^9}, 3.9334276157400684`*^9, {
   3.93342770322022*^9, 3.933427748330817*^9}, {3.933428076549879*^9, 
   3.93342812211964*^9}, {3.933429578330511*^9, 3.9334296041696987`*^9}, {
   3.933429648156302*^9, 3.933429684264015*^9}, 3.933429858142456*^9, 
   3.933431687470154*^9, {3.933434369923181*^9, 3.933434422091328*^9}, 
   3.933434481629153*^9, {3.933436981485281*^9, 3.9334369966317863`*^9}, 
   3.933437078660889*^9, {3.9334372149772205`*^9, 3.9334372242985935`*^9}},
 CellLabel->
  "Out[136]=",ExpressionUUID->"c6f395bd-f6e9-d046-8144-94a3437e7345"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\[ScriptF]=498.3 LA1908-B", "Subsection",
 CellChangeTimes->{{3.933253269198171*^9, 3.933253412679747*^9}, {
   3.933253559855203*^9, 3.933253563720991*^9}, {3.933253716601354*^9, 
   3.933253717012998*^9}, {3.933253750924324*^9, 3.9332537701157207`*^9}, {
   3.9332540572391586`*^9, 3.933254061392395*^9}, {3.9332540943952637`*^9, 
   3.933254105222435*^9}, {3.933254137188026*^9, 3.933254230348307*^9}, {
   3.933255568651058*^9, 3.933255609862846*^9}, {3.9332556738041077`*^9, 
   3.9332557328232365`*^9}, {3.933255800365106*^9, 3.93325581197958*^9}, {
   3.93325595622665*^9, 3.933255963616708*^9}, {3.933256111322544*^9, 
   3.933256164963697*^9}, {3.933342898854477*^9, 3.933342928194729*^9}, {
   3.933343194529011*^9, 3.933343226197071*^9}, 3.933418535748947*^9, {
   3.933419055392021*^9, 3.933419061226452*^9}, {3.933419098026436*^9, 
   3.93341913178018*^9}, {3.933419186069315*^9, 3.9334191887242527`*^9}, {
   3.933421270345564*^9, 3.9334212727817783`*^9}, {3.933421329648693*^9, 
   3.933421415011532*^9}, {3.9334217270971527`*^9, 3.9334217512617188`*^9}, {
   3.9334218110920563`*^9, 3.9334218149144077`*^9}, {3.9334226374493732`*^9, 
   3.933422639228443*^9}, {3.933424791821583*^9, 3.933424814443447*^9}, {
   3.9334250461750126`*^9, 3.9334250802075768`*^9}, {3.9334251482346363`*^9, 
   3.933425148579939*^9}},ExpressionUUID->"4a905e24-23f6-6643-b8e9-\
5a6e55c74437"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"L1", ",", "V\[Theta]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L1", "=", "498.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L2V", "=", 
   RowBox[{"TLVM", "[", 
    RowBox[{"\[Infinity]", ",", 
     RowBox[{"-", "257.54"}], ",", "2.31", ",", "nair", ",", "nnbk7"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"V\[Theta]", "=", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"L1", ",", "50", ",", "780"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"POIM", "[", "spacing_", "]"}], ":=", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{
      RowBox[{"kSolver", "[", 
       RowBox[{"AL2V", ".", 
        RowBox[{"TVM", "[", "spacing", "]"}], ".", "AL1V", ".", 
        RowBox[{"TVM", "[", 
         RowBox[{"26", "-", "spacing"}], "]"}], ".", "L2V", ".", 
        RowBox[{"{", 
         RowBox[{"V\[Theta]", ",", "1"}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "//", "N"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"POIM", "[", "16", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"POIM", "[", "spacing", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.933425131806246*^9, 3.933425139828937*^9}, {
   3.933425290895487*^9, 3.9334252932624054`*^9}, {3.9334253647733173`*^9, 
   3.933425430211572*^9}, {3.933425510440464*^9, 3.933425512781025*^9}, {
   3.933428066794657*^9, 3.933428067111983*^9}, {3.933433840507183*^9, 
   3.933433870658997*^9}, {3.933433902894413*^9, 3.933434026318697*^9}, 
   3.933434117900479*^9, {3.9334343433318233`*^9, 3.933434357310009*^9}, {
   3.933434430054874*^9, 3.933434478559944*^9}, {3.933437200472185*^9, 
   3.9334372290809784`*^9}, {3.9334373161352673`*^9, 
   3.933437340895853*^9}},ExpressionUUID->"b6380b88-b2db-ae48-a53b-\
891d502e0ac3"],

Cell[BoxData["12.391300413913317`"], "Output",
 CellChangeTimes->{{3.9334344558872986`*^9, 3.933434479025326*^9}, {
   3.9334372016902294`*^9, 3.9334372298399467`*^9}, 3.9334373229874477`*^9},
 CellLabel->
  "Out[156]=",ExpressionUUID->"1f4fdc97-3ca3-d042-bd00-c1ab3d77eb34"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwV1Xk01QkbB3ChEilbFxddrp99u1zu5Vp+X4aytogjhSJbLrINzUQoVJaY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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwV1Xk01QkbB3ChEilbFxddrp99u1zu5Vp+X4aytogjhSJbLrINzUQoVJaY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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-3.041119282495872, 
             32.508191096445785`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-3.041119282495872, 32.508191096445785`}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
          "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
          GoldenRatio^(-1), "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwV1Xk01QkbB3ChEilbFxddrp99u1zu5Vp+X4aytogjhSJbLrINzUQoVJaY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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-3.041119282495872, 32.508191096445785`}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {-3.041119282495872, 32.508191096445785`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.9334344558872986`*^9, 3.933434479025326*^9}, {
   3.9334372016902294`*^9, 3.933437229839947*^9}, 3.9334373230239735`*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"9fde0170-39d6-e34b-89b6-6b8d21117ab1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Microscope Objective", "Subsection",
 CellChangeTimes->{{3.9334402053339443`*^9, 
  3.9334402169312706`*^9}},ExpressionUUID->"8131f867-070c-a041-97a3-\
1f5f27be866b"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"npyrex", "=", "1.470"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PVM", "=", 
    RowBox[{"TLVM", "[", 
     RowBox[{"\[Infinity]", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", ".25", ",", "nair", ",", "npyrex"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PVM", ".", 
   RowBox[{"TVM", "[", "1", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TrackLength", "=", 
    RowBox[{
     RowBox[{"L1", "*", "2"}], "+", "20", "+", "MO", "+", "10", "+", 
     RowBox[{"AL", "*", "2"}], "+", "16"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MOAV", "=", 
    RowBox[{"TLVM", "[", 
     RowBox[{"40.1", ",", 
      RowBox[{"-", "40.1"}], ",", "6.1", ",", "nair", ",", "nnbk7"}], "]"}]}],
    ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"kSolver", "[", 
      RowBox[{"AL1V", ".", 
       RowBox[{"TVM", "[", "spacing", "]"}], ".", "AL2V", ".", 
       RowBox[{"TVM", "[", "19", "]"}], ".", "MOAV", ".", 
       RowBox[{"TVM", "[", "26", "]"}], ".", "L1V", ".", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "1"}], "}"}]}], "]"}], ")"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.933440228772131*^9, 3.933440322493299*^9}, {
  3.933440352644556*^9, 3.9334403536592035`*^9}, {3.934560420151779*^9, 
  3.9345604250960217`*^9}, {3.9345606925509434`*^9, 3.9345607098871727`*^9}, {
  3.934560743828081*^9, 3.9345607750592976`*^9}, {3.9345608051826897`*^9, 
  3.934560882551628*^9}, {3.9345609289227695`*^9, 3.934561017954813*^9}, {
  3.9345610832548504`*^9, 3.934561098829777*^9}, {3.9345611694173565`*^9, 
  3.9345611722600136`*^9}, {3.9345612056133976`*^9, 3.934561240686842*^9}, {
  3.9345612708271847`*^9, 3.9345612712592907`*^9}, {3.9345614940812035`*^9, 
  3.934561629589243*^9}, {3.934562044990156*^9, 3.9345620880267754`*^9}},
 CellLabel->
  "In[307]:=",ExpressionUUID->"f1757b15-40aa-d84e-b044-c399d197aea0"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVyXk41AkYwHEyW45dZ63GTa7QjNzH8L5FKUeeaEMYklqRUEqX1ZTRVKKH
2aF1U1bkyNnTjBKTSsSYYX6elSnJuiqeDdtltv3j+3z/+BhGJQQcXCUjI+P3
vf/vfXBK0DF9y/29z4XQmdkcIHloJUrI6UA9cWN/s3ou2JbkFzaR2WDHYQWd
c84Fnz5xYxH5Jgg98zRWX8qFoOjl9hxyM0zNqwpkjNjwknrJ4xqZDynPXDNy
g36H0nX+GVfIIuiobluhPMoDhnyT2WXyBBQNyHp6ZRVCcEhZ/fzCR9A5Q1C6
4ytAScoI89KTwglP0Y/2VlVgsvv9VNdVEp4s6GoP77oDKS+cIf+jAm5zImty
hhtAs1ltTFZWBbvVq5LbyE3QOu7R209TR+43bqo0vQU6Y4u0Q+bWop2cnum9
0TZYNHVTqY3XREa5pOYt6T6s+lSjqm2ihfFKpuUzgTxwkEa2Btbp4PaiBcvL
yQ+gN93uRbeFPurv3e67sKUD9K/Pfrr93gBpvm098WGPYHZZMjZkbYQNWlHc
u5GdcHOG26OctQE5SY0JHildoKz754eJCWP8WslZ7cjkQ+bhlkOlxqbITq6V
fZP6GJawZiImzQxZa+QKvFndkGzDb/65yxxJiZ8dJ1OfgKSOf1VgaIHUAybT
j9OfwpdYUcHGM5bYWMr2L7n4DCy3rFk5xLVCp3p3CutoD3iVG/56V5OC7mbr
D1Nin0OKboTR6zAq/rU5s3NPQC9Yzf2iJPazxpyk+Ji9tn2goTIvz/9sjbO0
J615xi+A9LCgfkPhZlSi9jK15fohzo47ouBjg+WKfcdOLvRDzc6o0gdLNhj6
jme+98gALM5qqU5ybDHqfIDL/PAAtAR6ybE97dD3w2/FLjsFkLaDWdI8aYfV
nAvBzY0CMHzpTVQw7VFP4ajq1/WD4OKYzibbOGDol6V2XsYghOn1f5IVOqDB
Zg1/mblBWOy5Np7IcEQVCeVlVrAQ8kn05ABjJ6w0iKjo5QlBY6ylfBXfCXts
6KcU9ETwQypjj3OSM46ocUbCM0Qgc5teP67ugmZ0i8S6SREc+6P+mnqnC3pM
mr2a9RuCdkuWvNpRV+wYOve3aeMQqHkfs7qgTMPo1ihBlfIwjG4aEJ7m0ZCR
pjk6mTQMDcVgPEF3w8cJgSY5fcMQXu+gprvihqEPGMJLpmI4zyxjjFa7YzW3
7KtShhhqp3QLlH0B3aiXvXBMDKwiZuTYLsDbDcf1n0rEEB3wzqRuN2DIgZG3
/q/FoMPjNfgFAZ5U0XaPmBDDlezQ7swowKbIfJ3UGTHEONxYUDwNGJ3GyGlZ
EoNR+todayoB+f/QYskqBKw4nftJXPXdtw1qlKgSMPLuzWBlDaCelfwdY3UC
rgc1hW+/C2hA31dFXUeA1CLgOJMHeGTo3oCnNgGjguxiOSHg+Yf7X8eZEXAv
Y/mAcAhwJfvqiXlzAtiuERsriO+eFvNvsgUBPrcozVvHAHP3YU/qJgLun+p7
xpgGdAlkFWfZEsDZZJ+9ew4QE+Kq1O0JSBov3GP4ATDurWIZx4EAc98jko6P
gANnL9KLnQkgyYpuXl8GZE/TNxi5EvCqxTU28jNgge+X4Vs0AnixFVTrb4DB
z0NOb3QnIE9faVEqBdyVeVaxFgj4D0P4PIE=
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVyXk41AkYwHEyW45dZ63GTa7QjNzH8L5FKUeeaEMYklqRUEqX1ZTRVKKH
2aF1U1bkyNnTjBKTSsSYYX6elSnJuiqeDdtltv3j+3z/+BhGJQQcXCUjI+P3
vf/vfXBK0DF9y/29z4XQmdkcIHloJUrI6UA9cWN/s3ou2JbkFzaR2WDHYQWd
c84Fnz5xYxH5Jgg98zRWX8qFoOjl9hxyM0zNqwpkjNjwknrJ4xqZDynPXDNy
g36H0nX+GVfIIuiobluhPMoDhnyT2WXyBBQNyHp6ZRVCcEhZ/fzCR9A5Q1C6
4ytAScoI89KTwglP0Y/2VlVgsvv9VNdVEp4s6GoP77oDKS+cIf+jAm5zImty
hhtAs1ltTFZWBbvVq5LbyE3QOu7R209TR+43bqo0vQU6Y4u0Q+bWop2cnum9
0TZYNHVTqY3XREa5pOYt6T6s+lSjqm2ihfFKpuUzgTxwkEa2Btbp4PaiBcvL
yQ+gN93uRbeFPurv3e67sKUD9K/Pfrr93gBpvm098WGPYHZZMjZkbYQNWlHc
u5GdcHOG26OctQE5SY0JHildoKz754eJCWP8WslZ7cjkQ+bhlkOlxqbITq6V
fZP6GJawZiImzQxZa+QKvFndkGzDb/65yxxJiZ8dJ1OfgKSOf1VgaIHUAybT
j9OfwpdYUcHGM5bYWMr2L7n4DCy3rFk5xLVCp3p3CutoD3iVG/56V5OC7mbr
D1Nin0OKboTR6zAq/rU5s3NPQC9Yzf2iJPazxpyk+Ji9tn2goTIvz/9sjbO0
J615xi+A9LCgfkPhZlSi9jK15fohzo47ouBjg+WKfcdOLvRDzc6o0gdLNhj6
jme+98gALM5qqU5ybDHqfIDL/PAAtAR6ybE97dD3w2/FLjsFkLaDWdI8aYfV
nAvBzY0CMHzpTVQw7VFP4ajq1/WD4OKYzibbOGDol6V2XsYghOn1f5IVOqDB
Zg1/mblBWOy5Np7IcEQVCeVlVrAQ8kn05ABjJ6w0iKjo5QlBY6ylfBXfCXts
6KcU9ETwQypjj3OSM46ocUbCM0Qgc5teP67ugmZ0i8S6SREc+6P+mnqnC3pM
mr2a9RuCdkuWvNpRV+wYOve3aeMQqHkfs7qgTMPo1ihBlfIwjG4aEJ7m0ZCR
pjk6mTQMDcVgPEF3w8cJgSY5fcMQXu+gprvihqEPGMJLpmI4zyxjjFa7YzW3
7KtShhhqp3QLlH0B3aiXvXBMDKwiZuTYLsDbDcf1n0rEEB3wzqRuN2DIgZG3
/q/FoMPjNfgFAZ5U0XaPmBDDlezQ7swowKbIfJ3UGTHEONxYUDwNGJ3GyGlZ
EoNR+todayoB+f/QYskqBKw4nftJXPXdtw1qlKgSMPLuzWBlDaCelfwdY3UC
rgc1hW+/C2hA31dFXUeA1CLgOJMHeGTo3oCnNgGjguxiOSHg+Yf7X8eZEXAv
Y/mAcAhwJfvqiXlzAtiuERsriO+eFvNvsgUBPrcozVvHAHP3YU/qJgLun+p7
xpgGdAlkFWfZEsDZZJ+9ew4QE+Kq1O0JSBov3GP4ATDurWIZx4EAc98jko6P
gANnL9KLnQkgyYpuXl8GZE/TNxi5EvCqxTU28jNgge+X4Vs0AnixFVTrb4DB
z0NOb3QnIE9faVEqBdyVeVaxFgj4D0P4PIE=
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0., 0.37888647102062556`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0., 0.37888647102062556`}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVyXk41AkYwHEyW45dZ63GTa7QjNzH8L5FKUeeaEMYklqRUEqX1ZTRVKKH
2aF1U1bkyNnTjBKTSsSYYX6elSnJuiqeDdtltv3j+3z/+BhGJQQcXCUjI+P3
vf/vfXBK0DF9y/29z4XQmdkcIHloJUrI6UA9cWN/s3ou2JbkFzaR2WDHYQWd
c84Fnz5xYxH5Jgg98zRWX8qFoOjl9hxyM0zNqwpkjNjwknrJ4xqZDynPXDNy
g36H0nX+GVfIIuiobluhPMoDhnyT2WXyBBQNyHp6ZRVCcEhZ/fzCR9A5Q1C6
4ytAScoI89KTwglP0Y/2VlVgsvv9VNdVEp4s6GoP77oDKS+cIf+jAm5zImty
hhtAs1ltTFZWBbvVq5LbyE3QOu7R209TR+43bqo0vQU6Y4u0Q+bWop2cnum9
0TZYNHVTqY3XREa5pOYt6T6s+lSjqm2ihfFKpuUzgTxwkEa2Btbp4PaiBcvL
yQ+gN93uRbeFPurv3e67sKUD9K/Pfrr93gBpvm098WGPYHZZMjZkbYQNWlHc
u5GdcHOG26OctQE5SY0JHildoKz754eJCWP8WslZ7cjkQ+bhlkOlxqbITq6V
fZP6GJawZiImzQxZa+QKvFndkGzDb/65yxxJiZ8dJ1OfgKSOf1VgaIHUAybT
j9OfwpdYUcHGM5bYWMr2L7n4DCy3rFk5xLVCp3p3CutoD3iVG/56V5OC7mbr
D1Nin0OKboTR6zAq/rU5s3NPQC9Yzf2iJPazxpyk+Ji9tn2goTIvz/9sjbO0
J615xi+A9LCgfkPhZlSi9jK15fohzo47ouBjg+WKfcdOLvRDzc6o0gdLNhj6
jme+98gALM5qqU5ybDHqfIDL/PAAtAR6ybE97dD3w2/FLjsFkLaDWdI8aYfV
nAvBzY0CMHzpTVQw7VFP4ajq1/WD4OKYzibbOGDol6V2XsYghOn1f5IVOqDB
Zg1/mblBWOy5Np7IcEQVCeVlVrAQ8kn05ABjJ6w0iKjo5QlBY6ylfBXfCXts
6KcU9ETwQypjj3OSM46ocUbCM0Qgc5teP67ugmZ0i8S6SREc+6P+mnqnC3pM
mr2a9RuCdkuWvNpRV+wYOve3aeMQqHkfs7qgTMPo1ihBlfIwjG4aEJ7m0ZCR
pjk6mTQMDcVgPEF3w8cJgSY5fcMQXu+gprvihqEPGMJLpmI4zyxjjFa7YzW3
7KtShhhqp3QLlH0B3aiXvXBMDKwiZuTYLsDbDcf1n0rEEB3wzqRuN2DIgZG3
/q/FoMPjNfgFAZ5U0XaPmBDDlezQ7swowKbIfJ3UGTHEONxYUDwNGJ3GyGlZ
EoNR+todayoB+f/QYskqBKw4nftJXPXdtw1qlKgSMPLuzWBlDaCelfwdY3UC
rgc1hW+/C2hA31dFXUeA1CLgOJMHeGTo3oCnNgGjguxiOSHg+Yf7X8eZEXAv
Y/mAcAhwJfvqiXlzAtiuERsriO+eFvNvsgUBPrcozVvHAHP3YU/qJgLun+p7
xpgGdAlkFWfZEsDZZJ+9ew4QE+Kq1O0JSBov3GP4ATDurWIZx4EAc98jko6P
gANnL9KLnQkgyYpuXl8GZE/TNxi5EvCqxTU28jNgge+X4Vs0AnixFVTrb4DB
z0NOb3QnIE9faVEqBdyVeVaxFgj4D0P4PIE=
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0., 0.37888647102062556`}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0., 0.37888647102062556`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.934561589983721*^9, 3.934561631704246*^9}, {
  3.934562047638891*^9, 3.9345620885812473`*^9}},
 CellLabel->
  "Out[312]=",ExpressionUUID->"5f72af37-deca-c749-85a5-2d5a6d03d891"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.934560430247427*^9, 3.934560459616167*^9}, {
  3.9345605100298367`*^9, 
  3.934560518939644*^9}},ExpressionUUID->"be86a78d-2244-594b-af25-\
7724a094c291"],

Cell[BoxData[
 TemplateBox[{
  "Power", "infy", 
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", \\\"0.`\\\"]\\) \
encountered.\"", 2, 48, 2, 26788392604780596168, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.934560514287398*^9},
 CellLabel->
  "During evaluation of \
In[48]:=",ExpressionUUID->"4c00383a-dd8f-0c4b-8c24-07530deb13de"],

Cell[BoxData["ComplexInfinity"], "Output",
 CellChangeTimes->{{3.9345604454243736`*^9, 3.9345604601021347`*^9}, 
   3.934560514298916*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"5c20073b-6147-1145-8422-d00e73067969"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"kSolver", "[", 
   RowBox[{"L1V", ".", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "L1"}], ",", "1"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.9345611217080803`*^9, 3.9345611661627655`*^9}, 
   3.9345611987599773`*^9, {3.934561296722286*^9, 3.934561314020241*^9}, {
   3.9345613545605297`*^9, 3.934561355907526*^9}},
 CellLabel->
  "In[193]:=",ExpressionUUID->"d5d647cf-b447-6844-9100-fbabef2e7460"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.006707115567681107`", ",", "0.9999999999999999`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.934561122818289*^9, 3.9345611578723736`*^9}, {
   3.9345612974823036`*^9, 3.9345613146342354`*^9}, 3.934561358085207*^9},
 CellLabel->
  "Out[193]=",ExpressionUUID->"06bf874b-49ae-7840-96c4-5a09591a310e"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Final Graphs", "Chapter",
 CellChangeTimes->{{3.933434887498019*^9, 
  3.933434895320345*^9}},ExpressionUUID->"4adc9176-ccff-6e4c-ad9a-\
b29b45135ba4"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Clear", "[", "FH", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"L1", ",", "AL", ",", "MO"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{"299", ",", "8", ",", "43"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
     RowBox[{"FHG", "[", 
      RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"L1V", "=", 
     RowBox[{"TLVM", "[", 
      RowBox[{"\[Infinity]", ",", 
       RowBox[{"-", "154.52"}], ",", "2.52", ",", "nair", ",", "nnbk7"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"L2V", "=", 
     RowBox[{"TLVM", "[", 
      RowBox[{"\[Infinity]", ",", 
       RowBox[{"-", "257.54"}], ",", "2.31", ",", "nair", ",", "nnbk7"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"V\[Theta]", "=", 
     RowBox[{"V", "[", 
      RowBox[{"L1", ",", "50", ",", "780"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MT", "[", "spacing_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"LM", "[", "AL", "]"}], ".", 
      RowBox[{"TM", "[", 
       RowBox[{"26", "-", "spacing"}], "]"}], ".", 
      RowBox[{"LM", "[", "AL", "]"}], ".", 
      RowBox[{"TM", "[", "10", "]"}], ".", 
      RowBox[{"LM", "[", "MO", "]"}], ".", 
      RowBox[{"TM", "[", "20", "]"}], ".", 
      RowBox[{"LM", "[", "L1", "]"}], ".", 
      RowBox[{"TM", "[", "L1", "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"POIM", "[", 
     RowBox[{"spacing_", ",", "L1V_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{
       RowBox[{"kSolver", "[", 
        RowBox[{"AL2V", ".", 
         RowBox[{"TVM", "[", "spacing", "]"}], ".", "AL1V", ".", "MOV", ".", 
         RowBox[{"TVM", "[", "26", "]"}], ".", "L1V", ".", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "1"}], "}"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "//", "N"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.933435312384945*^9, 3.933435312653129*^9}, {
   3.933435443442978*^9, 3.9334354704010677`*^9}, {3.933435554236964*^9, 
   3.933435559627655*^9}, {3.933435712472985*^9, 3.933435712916451*^9}, {
   3.933435838943569*^9, 3.933435860538208*^9}, 3.93343615187448*^9, {
   3.9334361932726917`*^9, 3.933436229191958*^9}, {3.933436267124945*^9, 
   3.9334363163546734`*^9}, {3.933436377273537*^9, 3.933436379608734*^9}, {
   3.933436420067789*^9, 3.933436509858171*^9}, {3.933436546225947*^9, 
   3.9334365607791634`*^9}, {3.933436623828754*^9, 3.933436626346025*^9}, {
   3.933436828628252*^9, 3.933436843871197*^9}, {3.933436906803341*^9, 
   3.9334369131664047`*^9}, {3.933436960650228*^9, 3.933436965624417*^9}, {
   3.9334371021554413`*^9, 3.9334371193034573`*^9}, {3.9334371705255833`*^9, 
   3.9334371871497993`*^9}, {3.933437235808653*^9, 3.933437251670126*^9}, {
   3.93343732856272*^9, 3.933437328850367*^9}, {3.933439757394093*^9, 
   3.933439768891264*^9}, {3.9334398275166016`*^9, 3.9334399148157063`*^9}},
 CellLabel->
  "In[342]:=",ExpressionUUID->"f89b27bd-2368-4d40-adcc-ddc178a0bff2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
    RowBox[{
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"Callout", "[", 
        RowBox[{
         RowBox[{"POIM", "[", 
          RowBox[{"spacing", ",", "L1V"}], "]"}], ",", "\"\<Image Plane\>\"", 
         ",", "5", ",", 
         RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
         RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"spacing", ",", "0", ",", "32"}], "}"}], ",", 
       RowBox[{"Frame", "->", "True"}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"Callout", "[", 
        RowBox[{
         RowBox[{"GraphIPMag", "[", 
          RowBox[{"FH", ",", 
           RowBox[{"MT", "[", "spacing", "]"}]}], "]"}], ",", 
         "\"\<Magnification\>\"", ",", "25", ",", 
         RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
         RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"spacing", ",", "0", ",", "32"}], "}"}], ",", 
       RowBox[{"Frame", "->", "True"}], ",", 
       RowBox[{"FrameStyle", "->", "Red"}], ",", 
       RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
     RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"POIM", "[", 
      RowBox[{"spacing", ",", "L1V"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"GraphIPMag", "[", 
      RowBox[{"FH", ",", 
       RowBox[{"MT", "[", "spacing", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Pickoff", "[", "spacing", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"spacing", ",", "0", ",", "32"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.9334351599315147`*^9, 3.933435160497759*^9}, {
   3.933435190760277*^9, 3.9334351926950417`*^9}, {3.93343527999185*^9, 
   3.933435311571932*^9}, 3.933435441070799*^9, {3.933435479411941*^9, 
   3.933435481078123*^9}, {3.9334355810053196`*^9, 3.933435640960928*^9}, {
   3.933437434394781*^9, 3.933437459614788*^9}, {3.9334375014248276`*^9, 
   3.9334375241597233`*^9}, {3.933439921833992*^9, 
   3.9334399281440907`*^9}},ExpressionUUID->"37905c51-4148-3942-a3cc-\
63b0ab6da134"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     TagBox[
      TagBox[
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], Opacity[
        1.], LineBox[CompressedData["
1:eJwVz2k01A0bBnDkqck21rFnmUFlaGbMYgb9rzyKQiStIo1SSHuSFlHkkUFR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         "]]},
       Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
      Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
   GeometricTransformationBox[{{{}, {}, 
      TagBox[
       TagBox[
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
         LineBox[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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          "]], LineBox[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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          "]]},
        Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
       Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
     0., 11.360537244024938`}}, {0., -3.5953335743237225`}}], {
    GraphicsGroupBox[{
      {EdgeForm[{RGBColor[
       0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
       AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
        NCache[
         Rational[2, 3], 0.6666666666666666]]}], 
       PolygonBox[{
        Offset[{-1.9681467837300664`, -2.2641550825182}, {5.149384406028062, 
          21.89749280463701}], 
         Offset[{-8.188152588841582, -6.0377468867151975`}, {
          4.281952448910188, 19.82907537204576}], 
         Offset[{-47.87237289291207, -6.037746886715206}, {4.281952448910188, 
          19.82907537204576}], 
         Offset[{-47.87237289291207, -20.037746886715205`}, {
          4.281952448910188, 19.82907537204576}], 
         Offset[{14.127627107087932`, -20.03774688671519}, {4.281952448910188,
           19.82907537204576}], 
         Offset[{14.127627107087932`, -6.037746886715192}, {4.281952448910188,
           19.82907537204576}], 
         Offset[{-1.708028834219051, -6.037746886715196}, {4.281952448910188, 
          19.82907537204576}]}]}, {}, InsetBox[
       StyleBox[
        RotationBox["\<\"Image Plane\"\>",
         BoxRotation->0.],
        StripOnInput->False,
        LineOpacity->1,
        FrontFaceOpacity->1,
        BackFaceOpacity->1,
        Opacity->1,
        FontOpacity->1], 
       Offset[{-16.872372892912068, -13.0377468867152}, \
{4.281952448910188, 19.82907537204576}], NCache[
       ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
        ImageScaled[{0.5, 0.5}]]]}], 
    GeometricTransformationBox[GraphicsGroupBox[{
       {EdgeForm[{RGBColor[
        0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{0.27900675422203775`, 2.9869976951947055`}, {
           25.71554915802416, 0.22283694530509215`}], 
          Offset[{4.123638419951242, 7.965327187185881}, {25.793388397368872`,
            0.3748825849409765}], 
          Offset[{36.24831008682562, 7.965327187185888}, {25.793388397368872`,
            0.3748825849409765}], 
          Offset[{36.24831008682562, 21.96532718718589}, {25.793388397368872`,
            0.3748825849409765}], 
          Offset[{-27.75168991317438, 21.965327187185874`}, {
           25.793388397368872`, 0.3748825849409765}], 
          Offset[{-27.75168991317438, 7.965327187185874}, {
           25.793388397368872`, 0.3748825849409765}], 
          Offset[{-3.324167418229289, 7.9653271871858795`}, {
           25.793388397368872`, 0.3748825849409765}]}]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Magnification\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{4.248310086825619, 14.965327187185881}, \
{25.793388397368872, 0.3748825849409765}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
      11.360537244024938`}}, {0., -3.5953335743237225`}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
      FreeQ[#, Rule], 
      Apply[{{{Bottom, 1}, {Right, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, 0.3164756645830887 + 0.08802400612928309 #2}], {{
          Bottom, 1}, {Left, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
    "DisplayFunction" -> Apply[Grid[{{
         Subscript[
          Style["\[RightArrow]", 20], 
          Style[1, 
           RGBColor[1, 0, 0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, 0.3164756645830887 + 0.08802400612928309 #2}]}, {
         Subscript[
          Style["\[LeftArrow]", 20], 
          Style[1, 
           GrayLevel[0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
       Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
       Spacings -> {0, 0.5}]& ]},
  DisplayFunction->Identity,
  Epilog->{{}, {}},
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->{{None, 
     RGBColor[1, 0, 0]}, {None, None}},
  FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "TransformedTicks"[{-0.18793874627238932`, 
        3.570836179175397}, {-5.730418700946554, 36.971283831510085`}, 
        "CustomTicks"[True]]][
       SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "CustomTicks"[False]][
       SlotSequence[1]]& }}, {{{{0., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {-4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {-2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {34., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {36., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
        0.}}}, {{-3.595333574323723, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {7.765203669701215, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"1\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {19.125740913726155`, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"2\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30.486278157751087`, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"3\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {-1.3232261255187354`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       0.9488813232862521, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       3.22098877209124, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       5.493096220896227, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       10.037311118506203`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       12.309418567311189`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       14.581526016116177`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       16.853633464921167`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       21.397848362531143`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       23.66995581133613, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       25.94206326014112, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       28.2141707089461, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       32.758385606556075`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       35.03049305536106, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}, {{{
       0., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
       0., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
  FrameTicksStyle->{{None, None}, {None, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->{{28.246092796325684`, 33.802733302116394`}, {28.34375, 
   3.1912521306861663`}},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-0.6666666666666667, 32.666666666666664`}, {-5.730418700946554,
    36.971283831510085`}},
  PlotRangeClipping->False,
  PlotRangePadding->None,
  Prolog->{{}, {}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.933435636745851*^9, 3.933435641803667*^9}, 
   3.93343632010861*^9, 3.9334374118816566`*^9, 3.93343746085235*^9, 
   3.933437525270588*^9},
 CellLabel->
  "Out[172]=",ExpressionUUID->"da18500d-f059-9e48-b626-b39560e4d911"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVz2k01A0bBnDkqck21rFnmUFlaGbMYgb9rzyKQiStIo1SSHuSFlHkkUFR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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVz2k01A0bBnDkqck21rFnmUFlaGbMYgb9rzyKQiStIo1SSHuSFlHkkUFR
EUpIi0JlihIlJ0qKJFFmSiJRsrepd94P97nO75zr+nCbCbf6bFCQk5NLkN3/
UyX0JN3Pi4RC8bRAsxrAfLBwVtAZEoZJjczyE8CeZ3wiY3Q6UqslFdYZBNRs
xR8fk5SgOBS1MjqWQIGIkfTLSAmpD+uFPzcTaPawag+Yr4QOfW/yBmcC1g3a
Oy1OKUHKNwuXH5wLad1g4Q2eMuyndcvJec2F64MLao1RKlhUKzK7YOUEiamZ
+E+yCo6mbU9gUJyw61C2HyNfBQYL9mx/reiE80TapbQGFZxVWVq2v8sRv+4d
cl5tpIpqd8kp8jlHlNzxi+i9pwrXke9LLI0doVumIZGXJyM+o8Nmn7UD1iT9
8u2mkEHWG4wdMHRA3vqPDY/oZCSspjVHqDiArlNRcWwlGc2r+kNavwjgHBF4
UqeUDA/nEXrZdQG42SsK0+eoY9HXpfPrnARYF1Dof0mijt3x/PPSDXwcWWSY
mdmnjsjvJ8dJq/go5Ka+TBxVR5X186nzPfgYUItyD1fSwOR4S9koi4+Iak8+
i6uBJ51n+23k+UgyHdOuFGkg3fnB8p5ce9zq+vfpc0dNsD4dfBQ5wMMrt5gh
kasmNOqOne5+z8N4cRXFw0cTkmCxe0AbD7x9/HX1GzUxdb7oW1QND+Vac8bv
n9BEmOrEvOWZPFS4GJje+KSJvn2ZyQcX8lBZ+G1neroWQs2Zv77e4OKtim2m
zzktOJQ2Lui9zMXvHWFV6le0sKX/Z/znXC6ciB6SqFoLBtsvn9RI4aKq7U1O
3GctiPSsGqRhXFST6uoioI3MVUzqZisuakJzDFcNaKP0TOfFxxc4uNkXFhYw
rg051xzB4bMcFGwS3A2S08HectXdLqc5iAtuW71FWwe/uqSlnQkcuAk1zhx2
1EHjo47vIZs5eL4qTq84SQfDBTOrpGwO3rqF60yxoeCM/vCm0SdsNNY5bCDx
KFD25/iLatmoWqAkVp1HQaqNOJ9excY5l4u+esso6MgwVjh4nQ0h3qfZHKDg
aseOKWEZbHziLdNc2UhBrK/VwuCNbIxZOpGvhesiuX3yReF0NuZ2OdclRuoi
7LPXu4NT2IjPcYvedFgX6poe5v6TdqBo+w5SM3Wxd0g6gz5kB6582PMztbrI
etf6XbPdDpFvMlISDPVQHMwJ+H3ZDr9TRsnrH+vhp9/NTgVvOyj8KFI3tDDA
i93o4RWxYNjoPELMMcDvqOOzSgtZYJ9vb13PN8DF9o1ceh4LGxZOyyr2NIDN
Q3HmnEwW6jOFFs4RBsieVFQMOspCikBfEFJngH3+YyGR61kw2h8fdDvEEGvK
m1UIMxa4fwNvLS02wvvj8t3+BUx4eN6PnV9uhFGfFN87uUwEZZl48WqMwKkU
RurnMJHKk/QavDKCRNrZKD3JRN9WP/2uSSMcq7TzTzrKRPa7Zfu3eRqj9b+R
w8IwJuRrFjmLBoxh1dx7cJDNxNMj7GePZpsg5kr+5O9nDAjIDQrHOSbQuuo1
XtzAwKXMdTw/mICzhx0QVM/A4eLk3MFlJqiX/7qt5YGs//rTDr0YE3wM/bCi
qUzWt87RDW0zwZqOfT2CLAac+2JLpzqbQqI/lPUghAGT1P4fl7+agnF5fIaO
KgP9E1JJK8McOub3VWf02qLg890naslU3C6y+M/1sQ3UjC8OdnfTUKnl+6Dm
FR1JIeLgXJolWCsqVAl1OsZR1L0p2gpBd75pti6xxi5WbRnl4UzETZ+SfO3m
bEiLa481m82Gl0vZ43kGs/Er9GXWrChrbPf5/EI9bRas5037E3yXjl6lKNuH
prPgmme28bquLZK29il/L5mJPcZrzd+vmYOJxXPpdV4zQR9YptzmyYDaWNTa
n9+toEX+Rqr9ycBASYWXIM8KitVZJdRsJuzVKEo7V1ghjH23fbo7CyECJApV
rFC0UJhbNc4C0bP8s269Jcb6DdR7TtkhKWIouzzJEuKlrlPSXdjAhc6OdG9L
RLvFnSvrYcM+nExRNbKEWeei1/lxHNRnjRzP7beAgHckXZ/FBeuYdxHvjgXW
zHj+Q76FC8/qazufJVtg7Imoa1sMD4EmV7TChRbIUAzY5UOzR1yexxZ3Bwto
ScR5CrX2qM/3Zg5QLPDPgRhf/nY+5rrofIsfokHuckBJl6YA73tsnUKaaNhx
pkSkWSNA4JOrZT7FNNyzTiBpbHFAxM1rtYnJNGgs2kGPVXOE6UTeP+47aHhr
09Syt9IRKnp60drLaCg9S9C6A5wQTanZpuJAg38JV8P4jxPS2j405JjTcCju
fMzbK3MhIQILiOk0XPtknKXmQeD2cP6x9GEqEnLiAiWLCdAZt7YwZV7v88Wi
eAmB8B5p0LMhKowqK0s9VxBwG9lwhCRzYorfoyQhAVL4jZwDg1Rs4mYOKe0l
8EksbxM2QIX5EW23aYWy/b8Hspf2UPHHfr9q2yUCpuuUKoY/UtH+5cOLwiIC
ZiTt3uMyp6646b/gOoFEUuKepm4q/s722RlXScC7aX/I4g9UvG1OOTulhYDL
iFDk+Y6K8viJoJZWAueeHqn+IqUi3WHtrPzXBHI8Xysky+x+wbbMWULger38
vWcSKu5ENj6O6SPgntL5x7uTilM2nJQlAwRM4pXvDL2lYntXtq/ZIIG+pQvi
T8g802Oz9P6o7F/rpiUv31ChKP+yIHWCgFCbsmS3zO/EDqGBPwlEpy1fR5G5
MjR/DmOSwF4jUeztDipOmyiP/f1L4D5NXLZS5v8BW+6qmg==
              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-3.595333574323723, 33.51664352775997}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-3.595333574323723, 33.51664352775997}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVz2k01A0bBnDkqck21rFnmUFlaGbMYgb9rzyKQiStIo1SSHuSFlHkkUFR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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-3.595333574323723, 33.51664352775997}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {-3.595333574323723, 33.51664352775997}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.933435636745851*^9, 3.933435641803667*^9}, 
   3.93343632010861*^9, 3.9334374118816566`*^9, 3.93343746085235*^9, 
   3.933437525436743*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"96b7264a-b21c-2f46-9e5f-2592954002eb"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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          "]], LineBox[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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              "]], 
             Line[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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          "]], 
         Line[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0., 3.2667448999036286`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.933435636745851*^9, 3.933435641803667*^9}, 
   3.93343632010861*^9, 3.9334374118816566`*^9, 3.93343746085235*^9, 
   3.933437525506079*^9},
 CellLabel->
  "Out[174]=",ExpressionUUID->"61b7448f-7165-1e4c-8795-c5b5b5e101b3"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVxX081HccAHCna+T5EB1xnsX9PKSj8vT9FEvzsF6kzJIkrKyWxCvatbqG
PGQMmXnuUonysEMJ3WfCmpCGl4fEXGYek0oXw2374/166wef9gmVlpKS8vrP
/7uHTj7HqZvOA63NH2WEDKC7aEWMMuMI9+0ddnQ9A7YV5eQLmFlkyPODt0jA
AI/O/l8KmCUEkx/FNJYywC9E3JTBrCGObEWriAwGvLS64pLKbCFza3znvlAG
FG/cl5DM7CXbF6qmrikwgCcrME1ijpOTtIOnF/xV4Av/65VvFt6T6VW7xBfl
iiAv4QW46UpIHE/B81qfHBh7v558nEIHE66qeEVeFs517SQ57zfAPv74rCl9
PWjWMEZoNGXwng4qO2spDXUil45njqogSxp+PMZZI83hBdr+s+qQTTPtXDX6
SBZNnJTvndIEfpkoreD8WyK9VK6ibawF02qZSdUlk8ROElS3v2IzWG7aGLfo
NEQ64jhdbeYs+Hao9Jy4+y5hpc8s3XmtB7S62zaH6H3CGfHoSJ+1AVz2+sRe
a/2EsGS6oV3pB0PIOdpU5eWyIFTSuT0/Pm4EUbrDZmHhYuHVE7VhxUYm0OEt
XskwXxV+gPLx4xdNoTayOvxELQ2jbFpqNB5vAd25hPtj1+k4WtGS8lzfHL7b
E5VV0yWD/4T35pmdZ4OFx3Ri6ms5ZO+SWQtroMDny0P3A4YU0Y2v/1W1piXM
u/aWRH+vgud0jhiMBVhBZtU7mSIJA6nZA/L9XtZgoNwVwYxWQzXlN7Ity9YQ
0d1XZyS/EenCvErD/K1QKvD1EiVo4NechsENHjawGvLK3N9wE5Z/Flz86IMN
BArfXbCuZ+LijJbKRPY2qDxVZp3E0cba/W7rslw5EBM7GNHZvRkv7o0vqpng
gLoel3XeRxf1X7oP3Ii3Be6q/dEDnSy03x6XxbSxgycr2vm3avQwQPfZEq3H
Dp5u9Z1xjtbHxfZUUQRvO3QsVpfH7jHAHHpglI/RDuAEtu51lTNEtZFavnTL
DnjYPN2R326I6y/wfHee2QlHG54GV+UZodSdwEqRqj1Au/gvhyPGGJlbmara
bA8KRfUPsreZYBM7UZbxjQO4Kg5YXKGbIsM9krqs5AiJ0VaK/b+Z4rBFd09s
oyPscnMLV87fglWFxGg80AkyVriC3GAzPFxpx9BZc4Jg3UE+39gcL8Vf5w2X
OYPmRFdh+ZI53pvUyVPyJNDW+qB0XsjGxIL4oJHPCWwa6xgKfczGEJ854wpv
AuLoVvXhNjZubmys8vIjsF8hpPhJJxuT0w61XQ0mkD5zUIP/go3H7X5ekIsl
oBelduGgmI0Gcep7ZW4RyLr3t22rJYVrO7iK/aUE3JeTQxxtKByce/XHrXIC
KaiaJ7ClMN1PcHhPNYG79c9YfEcKJeY+Z+MbCcQESq5cdKdw+Hla4boeAgaR
tj0OYRQ+SBAf6+kjkOynd0lwgsIshyNmNwYIcOvmOexTFHrctKzZPUKANuZQ
pxVF4cOYzt95UwQyJ5M0l3kUZlvYpnnPEvDNzVkXGU/hGVG+r/48gcLWFPFU
IoVbPE+O4nsCfYks8WAahXRab0m6mECzHkr7ZFL4Z61DeNAyAXubTzXasyls
DL9hZb1KwLmpYuvuXAp/YskvSiQEnv664vuwgMJ/AWuvRXw=
          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVxX081HccAHCna+T5EB1xnsX9PKSj8vT9FEvzsF6kzJIkrKyWxCvatbqG
PGQMmXnuUonysEMJ3WfCmpCGl4fEXGYek0oXw2374/166wef9gmVlpKS8vrP
/7uHTj7HqZvOA63NH2WEDKC7aEWMMuMI9+0ddnQ9A7YV5eQLmFlkyPODt0jA
AI/O/l8KmCUEkx/FNJYywC9E3JTBrCGObEWriAwGvLS64pLKbCFza3znvlAG
FG/cl5DM7CXbF6qmrikwgCcrME1ijpOTtIOnF/xV4Av/65VvFt6T6VW7xBfl
iiAv4QW46UpIHE/B81qfHBh7v558nEIHE66qeEVeFs517SQ57zfAPv74rCl9
PWjWMEZoNGXwng4qO2spDXUil45njqogSxp+PMZZI83hBdr+s+qQTTPtXDX6
SBZNnJTvndIEfpkoreD8WyK9VK6ibawF02qZSdUlk8ROElS3v2IzWG7aGLfo
NEQ64jhdbeYs+Hao9Jy4+y5hpc8s3XmtB7S62zaH6H3CGfHoSJ+1AVz2+sRe
a/2EsGS6oV3pB0PIOdpU5eWyIFTSuT0/Pm4EUbrDZmHhYuHVE7VhxUYm0OEt
XskwXxV+gPLx4xdNoTayOvxELQ2jbFpqNB5vAd25hPtj1+k4WtGS8lzfHL7b
E5VV0yWD/4T35pmdZ4OFx3Ri6ms5ZO+SWQtroMDny0P3A4YU0Y2v/1W1piXM
u/aWRH+vgud0jhiMBVhBZtU7mSIJA6nZA/L9XtZgoNwVwYxWQzXlN7Ity9YQ
0d1XZyS/EenCvErD/K1QKvD1EiVo4NechsENHjawGvLK3N9wE5Z/Flz86IMN
BArfXbCuZ+LijJbKRPY2qDxVZp3E0cba/W7rslw5EBM7GNHZvRkv7o0vqpng
gLoel3XeRxf1X7oP3Ii3Be6q/dEDnSy03x6XxbSxgycr2vm3avQwQPfZEq3H
Dp5u9Z1xjtbHxfZUUQRvO3QsVpfH7jHAHHpglI/RDuAEtu51lTNEtZFavnTL
DnjYPN2R326I6y/wfHee2QlHG54GV+UZodSdwEqRqj1Au/gvhyPGGJlbmara
bA8KRfUPsreZYBM7UZbxjQO4Kg5YXKGbIsM9krqs5AiJ0VaK/b+Z4rBFd09s
oyPscnMLV87fglWFxGg80AkyVriC3GAzPFxpx9BZc4Jg3UE+39gcL8Vf5w2X
OYPmRFdh+ZI53pvUyVPyJNDW+qB0XsjGxIL4oJHPCWwa6xgKfczGEJ854wpv
AuLoVvXhNjZubmys8vIjsF8hpPhJJxuT0w61XQ0mkD5zUIP/go3H7X5ekIsl
oBelduGgmI0Gcep7ZW4RyLr3t22rJYVrO7iK/aUE3JeTQxxtKByce/XHrXIC
KaiaJ7ClMN1PcHhPNYG79c9YfEcKJeY+Z+MbCcQESq5cdKdw+Hla4boeAgaR
tj0OYRQ+SBAf6+kjkOynd0lwgsIshyNmNwYIcOvmOexTFHrctKzZPUKANuZQ
pxVF4cOYzt95UwQyJ5M0l3kUZlvYpnnPEvDNzVkXGU/hGVG+r/48gcLWFPFU
IoVbPE+O4nsCfYks8WAahXRab0m6mECzHkr7ZFL4Z61DeNAyAXubTzXasyls
DL9hZb1KwLmpYuvuXAp/YskvSiQEnv664vuwgMJ/AWuvRXw=
              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-14.308062225202681`, 
             4.436553847206106}}, "Frame" -> {{False, False}, {False, False}},
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-14.308062225202681`, 4.436553847206106}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
          "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
          GoldenRatio^(-1), "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVxX081HccAHCna+T5EB1xnsX9PKSj8vT9FEvzsF6kzJIkrKyWxCvatbqG
PGQMmXnuUonysEMJ3WfCmpCGl4fEXGYek0oXw2374/166wef9gmVlpKS8vrP
/7uHTj7HqZvOA63NH2WEDKC7aEWMMuMI9+0ddnQ9A7YV5eQLmFlkyPODt0jA
AI/O/l8KmCUEkx/FNJYywC9E3JTBrCGObEWriAwGvLS64pLKbCFza3znvlAG
FG/cl5DM7CXbF6qmrikwgCcrME1ijpOTtIOnF/xV4Av/65VvFt6T6VW7xBfl
iiAv4QW46UpIHE/B81qfHBh7v558nEIHE66qeEVeFs517SQ57zfAPv74rCl9
PWjWMEZoNGXwng4qO2spDXUil45njqogSxp+PMZZI83hBdr+s+qQTTPtXDX6
SBZNnJTvndIEfpkoreD8WyK9VK6ibawF02qZSdUlk8ROElS3v2IzWG7aGLfo
NEQ64jhdbeYs+Hao9Jy4+y5hpc8s3XmtB7S62zaH6H3CGfHoSJ+1AVz2+sRe
a/2EsGS6oV3pB0PIOdpU5eWyIFTSuT0/Pm4EUbrDZmHhYuHVE7VhxUYm0OEt
XskwXxV+gPLx4xdNoTayOvxELQ2jbFpqNB5vAd25hPtj1+k4WtGS8lzfHL7b
E5VV0yWD/4T35pmdZ4OFx3Ri6ms5ZO+SWQtroMDny0P3A4YU0Y2v/1W1piXM
u/aWRH+vgud0jhiMBVhBZtU7mSIJA6nZA/L9XtZgoNwVwYxWQzXlN7Ity9YQ
0d1XZyS/EenCvErD/K1QKvD1EiVo4NechsENHjawGvLK3N9wE5Z/Flz86IMN
BArfXbCuZ+LijJbKRPY2qDxVZp3E0cba/W7rslw5EBM7GNHZvRkv7o0vqpng
gLoel3XeRxf1X7oP3Ii3Be6q/dEDnSy03x6XxbSxgycr2vm3avQwQPfZEq3H
Dp5u9Z1xjtbHxfZUUQRvO3QsVpfH7jHAHHpglI/RDuAEtu51lTNEtZFavnTL
DnjYPN2R326I6y/wfHee2QlHG54GV+UZodSdwEqRqj1Au/gvhyPGGJlbmara
bA8KRfUPsreZYBM7UZbxjQO4Kg5YXKGbIsM9krqs5AiJ0VaK/b+Z4rBFd09s
oyPscnMLV87fglWFxGg80AkyVriC3GAzPFxpx9BZc4Jg3UE+39gcL8Vf5w2X
OYPmRFdh+ZI53pvUyVPyJNDW+qB0XsjGxIL4oJHPCWwa6xgKfczGEJ854wpv
AuLoVvXhNjZubmys8vIjsF8hpPhJJxuT0w61XQ0mkD5zUIP/go3H7X5ekIsl
oBelduGgmI0Gcep7ZW4RyLr3t22rJYVrO7iK/aUE3JeTQxxtKByce/XHrXIC
KaiaJ7ClMN1PcHhPNYG79c9YfEcKJeY+Z+MbCcQESq5cdKdw+Hla4boeAgaR
tj0OYRQ+SBAf6+kjkOynd0lwgsIshyNmNwYIcOvmOexTFHrctKzZPUKANuZQ
pxVF4cOYzt95UwQyJ5M0l3kUZlvYpnnPEvDNzVkXGU/hGVG+r/48gcLWFPFU
IoVbPE+O4nsCfYks8WAahXRab0m6mECzHkr7ZFL4Z61DeNAyAXubTzXasyls
DL9hZb1KwLmpYuvuXAp/YskvSiQEnv664vuwgMJ/AWuvRXw=
          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-14.308062225202681`, 4.436553847206106}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {-14.308062225202681`, 4.436553847206106}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.933435636745851*^9, 3.933435641803667*^9}, 
   3.93343632010861*^9, 3.9334374118816566`*^9, 3.93343746085235*^9, 
   3.933437525555269*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"97f66a00-fcf4-e44a-9d48-ffd49abb5957"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.933437369912367*^9, 
  3.93343740726956*^9}},ExpressionUUID->"48d8123e-cedc-384a-8910-\
b2b87e693d27"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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          "]], LineBox[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0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              "]], 
             Line[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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              "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVkmk8FAgfgOdwjAnjGmZGB0XHu0y1idjl/2+coVok5aqMa5tEseNar6N0
iOwrK2fOJB16K5IIW4vSENmmkjN3bmPceXs/PL/n0/Pt0fTwt/ciEQiE37/z
f1t7DbXUDN80YVRpcVxau0HClBXQxTwPHIlm7k1hN+zKTs18xEyGD22bBqY/
d4ONQPgwi1kAKUF/M1MHu8HJc64qifkYWuYyU9esdEPH9oumCcyXMBip3522
tQdy6AcvxDHboPWG9WdeTA9EUx5tuczsA6vhBf8ne3vhX5b/ufQwoA+wurj1
d6teaI31H26v7wOiSdZ+y4O9oEXWucPm98MZgVP+V9deqFspYLe1DkB6bPSZ
syG9IDuTsntD/DBkyJBbIh70QmpHmGnpt3Gw1ku3faL1BY4czS2ZnBLBT/bh
GXob+mCi/RA1jzULWqcCzg1u7oML7hQvB9NZmB8K4uaw++AR159VljwLoavn
t2iZ9IH8aePYcAMx9FsrxQa59cHfMR+dpSLmQEZeut8kqw9+vKsotZayCCIZ
N0aJZj+sWY12tVy/CkR/t9ImGIDUX53cdSxW4eT9r/fk9w2AVpvOccXTq+BO
svM/bD8AJreF3PaqVdBuowWteA7A09sppU/YBCSKFLKK4wZgzGG00qaJgDFG
bG6ccAAci643BsqR8GSt/NY7wYOQ6RZj661JwpCGpPz56EHoVfITHNlNwq4D
k+YH4wfBP4LTbOxGwvH+rTsYuYNw2X6sVfoeCYsuz84yGwehapnzKcOWjBe8
zU8NaQyBtt340IsrEljcslOZ1jYErEhLI59cCay1ftz+Z/cQKNzLuUJ9IoEH
ZZpObRsbgkWKA9uuVwL197saBEsNw9uaJ4GdeySxjSXMLDEchrAd0d/m+yVR
popbfDNvGJpoKipslEaXN0VEjByBF8Z+Xi2O0niv4rXG5YQRKOfVlQXxpHFX
ok1rT8YI5NeHHH2WIo2GhBL7v8pHICSy44bV2PeeZZTLmRmBjROF27jpFHTl
y8w58b5CcJMhpIpksHqfvM8N31GQZ5f2v6JQMayTZycOHoWChB3xS2upmLvL
edH94ii02G756G5Oxdg9ZLFH4Sj80KgSqJ1CxXeKCQV7+kehq36i8KHBGqw7
w9XV8x4Dy9qb8oIwWYyXvGVoxh+HTg3N0m9XZdFutmLd+MVxCIrKdNmRL4vE
oMr/3k0bh1y4VnStURavCBLDfavGYakqiuO8Vg5dPhXc6pScgJIKF/5glRwO
1/6gNJg+AWqPFTuJRBrOLSc3mPEmwTV+6VCfKg1DdQy5vvxJyPPsb6zToeGt
iGzMiJ4EHfrTp1eO0ND5dfPe7amTwOEf/5P+gIbngmu+KNdNgn6mU2HydgXM
c2ohjWlNwQn3QreiTgXst02hd05MwXlr9bS0YQWkRtgZsFemoFD/j7Y4kQL6
uZ+1SaJOw6h8mI0fVRF3SpiupmhPA796v+GP+oooY1yXe911GuI1ZlUqExTx
7Lp/FHKapqGs1/RN889K2HZeWhFfzsB7q+ipBEslTORGfX98BsT3n6va2iuh
ZuxuQ62+GTAINzzR4KOE14oVrgRIiKBcebu4JkkJX3f5Vu+zEMFTM5bGwyEl
DLb4NGPYLILKwsnA5GRlFFfkdW+Yn4XPsuw0+2xl7FrvR3+9RgzLZ3nPFYqV
8U6ll+D6BjEYwwAloVoZi455WmdbiuG5sD0rdkQZbV+5HPs1TQzVlPp6Pqqg
cX6HpIXZHPx1Mkv96KgKTo82TB2pmIdHwzyeu1gFydaVG2+0zEOBr9EzLoGO
4YYGEbTheYj1FjqfVqEjXeL47RDGAlh5KKaf+5mOcu8PaAWGLkDz0VjG/Xg6
blmxiY02W4SaDw6+j1LoGFbTL2xwX4QHThvLy3PoSNY9zTYPXYQkx2qnF4/p
2FGpfrrr/iIctltI+fCZjg6mb0Lvrl2Cz1Z+dLKuKuYkXhWZkpdBUP+TF8VA
Fcfi1hN1NZfhuQW1VG6vKjrdzg86DMuQbXbrEMNRFblbM4V+vy+DB/Zc041Q
xairnvvqFpZhyMBR6YhAFaPtXIKHiN9gdrMx7Z6fGhbn1vJStxDQpJdTHxei
hrUHzHr0jQl4Icsq0vecGrL19MtoDgRUVTk0sSlNDWP3bjIKiiSgPpHXnP5S
DUcnKiY2tRMwpD018ZI6Ax2PTXRTs4lYk3LD0nszA8H11PvX5USk2Besmu5k
4JhpS8X7ViKmNZT4r1ow0P1UaLZQmoQVpXUH+WcZyDtwvKHgNxIuJ4ponq8Y
WFVKOFZ7goxmNov1e9sY+HZEmDMVRcZ4KULUhi4GOs/q7LyYQ8Z1EWsmP4kY
2NEiLzfSTUaTkxvf2mkwMYnyG6fBWwIjzX75A4KZ6H3On/PlkiQ2rDparYth
4qVwvn9AiSQqPHMhLMUz8XYXa+nSe0nM2ekTUJbHxHcxSVt9N0thzfp//6Lb
xERR8oNCA4EUkhbuKKhrs/Dd/NFVPSMKqgs4M7CdhSvXGgMFPhTUy/34j6ch
C/fv9tBTTqGg1z7pjPv7WWhwINK8TETBhjQPbQ6fhSe8Hbc1V8hgj9+CtE8U
C9sfYo35uAwGPL1jERnHwp4S3mabjVT8H8mwjdo=
          "]], 
         Line[CompressedData["
1:eJwVlGk8FIgfh9GIJLk6WJSZMcbMOJKjkn6/pDKhcnWsnCuEXEmESsk6YjrU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          "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {0., 3.2667448999036286`}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 32}, {0., 3.2667448999036286`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.933437378501335*^9, 3.933437401093876*^9}},
 CellLabel->
  "Out[167]=",ExpressionUUID->"65e80ec7-bca1-5645-b2db-cd33dbc58352"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Zemax", "Chapter",
 CellChangeTimes->{{3.935146568206515*^9, 3.9351465724392376`*^9}, 
   3.9380013610014114`*^9},ExpressionUUID->"ea61edb6-faaa-b741-9ca7-\
86fe5da5e473"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FH", ",", "\[Theta]"}], "}"}], "=", 
     RowBox[{"FringeHeight", "[", 
      RowBox[{"500", ",", "50", ",", "780"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"L1", ",", "AL", ",", "MO"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{"500", ",", "8", ",", "43"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MT", "[", "spacing_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"LM", "[", "AL", "]"}], ".", 
      RowBox[{"TM", "[", 
       RowBox[{"26", "-", "spacing"}], "]"}], ".", 
      RowBox[{"LM", "[", "AL", "]"}], ".", 
      RowBox[{"TM", "[", "10", "]"}], ".", 
      RowBox[{"LM", "[", "MO", "]"}], ".", 
      RowBox[{"TM", "[", "20", "]"}], ".", 
      RowBox[{"LM", "[", "L1", "]"}], ".", 
      RowBox[{"TM", "[", "L1", "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"FH", ",", "\[Theta]"}], "}"}]}], "//", "N"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LM", "[", "L1", "]"}], ".", 
    RowBox[{"TM", "[", "L1", "]"}], ".", 
    RowBox[{"{", 
     RowBox[{"FH", ",", "\[Theta]"}], "}"}]}]}]}]], "Input",
 CellChangeTimes->{{3.9351465733789787`*^9, 3.935146610855444*^9}, {
  3.9351470077563877`*^9, 3.9351470724539413`*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"abc7998e-40b4-4043-b854-274c9c8f7c2a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Fringe Height: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{"3.9`", "\"mm\"", "millimeters", "\"Millimeters\""},
    "Quantity"]}],
  SequenceForm["Fringe Height: ", 
   Quantity[3.9, "Millimeters"]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.9351466061635113`*^9, 3.935146611352413*^9}, 
   3.935147019928091*^9, {3.935147057438959*^9, 3.9351470730864162`*^9}},
 CellLabel->
  "During evaluation of \
In[58]:=",ExpressionUUID->"ac3ec62a-3fe8-354e-8b41-ed3e99d9eaa7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Angle: \"\>", "\[InvisibleSpace]", "0.007749844844133057`"}],
  SequenceForm["Angle: ", 0.007749844844133057],
  Editable->False]], "Print",
 CellChangeTimes->{{3.9351466061635113`*^9, 3.935146611352413*^9}, 
   3.935147019928091*^9, {3.935147057438959*^9, 3.9351470730894165`*^9}},
 CellLabel->
  "During evaluation of \
In[58]:=",ExpressionUUID->"aca803de-5de4-ac4f-bf5e-fe95653cba4b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.7749224220665285`", ",", 
   RowBox[{"-", "0.0078`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.935147063415388*^9, 3.935147073093975*^9}},
 CellLabel->"Out[61]=",ExpressionUUID->"2e0f8e7a-ee3f-8b4b-b919-f9544d167e29"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["1st order", "Chapter",
 CellChangeTimes->{{3.937492075285799*^9, 
  3.9374920971248035`*^9}},ExpressionUUID->"44f37645-283a-6641-bebb-\
57c12be10d20"],

Cell[CellGroupData[{

Cell["Initialization", "Subsection",
 CellChangeTimes->{{3.937556824509027*^9, 
  3.937556849683008*^9}},ExpressionUUID->"7f8a02a3-1df1-d446-99ec-\
c8f3dc5557c3"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Mu]m", "=", ".001"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nm", "=", ".000001"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cm", "=", "10"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LM", "[", "f_", "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", "0"},
       {
        FractionBox[
         RowBox[{"-", "1"}], "f"], "1"}
      }], ")"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TM", "[", "L_", "]"}], ":=", 
    RowBox[{"(", GridBox[{
       {"1", "L"},
       {"0", "1"}
      }], ")"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FringeHeight", "[", 
     RowBox[{"L_", ",", "d_", ",", "\[Lambda]_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{"FH", ",", "\[Phi]"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"FH", "=", 
        RowBox[{
         FractionBox[
          RowBox[{"L", "*", "\[Lambda]", " ", "nm"}], 
          RowBox[{"2", "d", " ", "\[Mu]m"}]], "//", "N"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\[Phi]", "=", 
        RowBox[{
         RowBox[{"ArcTan", "[", 
          FractionBox[
           RowBox[{"FH", "-", 
            FractionBox[
             RowBox[{"d", " ", "\[Mu]m"}], "2"]}], "L"], "]"}], "//", "N"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"RR", "=", 
        FractionBox[
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"d", " ", 
             RowBox[{"\[Mu]m", "/", "2"}]}], ")"}], "2"]}], 
         RowBox[{"\[Lambda]", " ", "nm"}]]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{"RR", "//", "N"}], " ", ",", "\"\< mm\>\""}], "]"}], ";", 
       "\[IndentingNewLine]", "FH"}], ",", "\[Phi]"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FullTrack", "[", 
     RowBox[{
     "h0_", ",", "\[Theta]0_", ",", "f1_", ",", "LPf1_", ",", "L_", ",", 
      "LPf2_", ",", "MOL_", ",", "MO_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{"M", ",", "si"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"si", "=", 
        FractionBox[
         RowBox[{"MO", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"L", " ", 
             RowBox[{"(", 
              RowBox[{"LPf2", "-", "MOL"}], ")"}]}], "+", 
            RowBox[{"LPf1", " ", "MOL"}], "+", 
            RowBox[{"LPf2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "LPf1"}], "+", "MOL"}], ")"}]}]}], ")"}]}], 
         RowBox[{
          RowBox[{"L", " ", 
           RowBox[{"(", 
            RowBox[{"LPf2", "+", "MO", "-", "MOL"}], ")"}]}], "-", 
          RowBox[{"LPf2", " ", 
           RowBox[{"(", 
            RowBox[{"LPf1", "+", "MO", "-", "MOL"}], ")"}]}], "+", 
          RowBox[{"LPf1", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "MO"}], "+", "MOL"}], ")"}]}]}]]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"h", ",", "\[Theta]"}], "}"}], "=", 
        RowBox[{
         RowBox[{"TM", "[", "si", "]"}], ".", 
         RowBox[{"LM", "[", "MO", "]"}], ".", 
         RowBox[{"TM", "[", "MOL", "]"}], ".", 
         RowBox[{"LM", "[", "LPf2", "]"}], ".", 
         RowBox[{"TM", "[", "L", "]"}], ".", 
         RowBox[{"LM", "[", "LPf1", "]"}], ".", 
         RowBox[{"TM", "[", 
          RowBox[{"f1", "+", "LPf1", "+", "LPf2", "-", "L"}], "]"}], ".", 
         RowBox[{"LM", "[", "f1", "]"}], ".", 
         RowBox[{"TM", "[", "f1", "]"}], ".", 
         RowBox[{"{", 
          RowBox[{"h0", ",", "\[Theta]0"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"M", "=", 
        RowBox[{"h", "/", "h0"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "si"}], ",", "M", ",", 
      RowBox[{"2", " ", "h"}]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FTG", "[", 
     RowBox[{"Data_", ",", "L_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{
        "V", ",", "M", ",", "si", ",", "LPf1", ",", "LPf2", ",", "MOL", ",", 
         "MO"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "f1", ",", "f1s", ",", "LPf1", ",", "LPf2", ",", "MOL", ",", "MO"}], 
         "}"}], "=", 
        RowBox[{"Data", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"Data", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"si", "=", 
        FractionBox[
         RowBox[{"MO", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"L", " ", 
             RowBox[{"(", 
              RowBox[{"LPf2", "-", "MOL"}], ")"}]}], "+", 
            RowBox[{"LPf1", " ", "MOL"}], "+", 
            RowBox[{"LPf2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "LPf1"}], "+", "MOL"}], ")"}]}]}], ")"}]}], 
         RowBox[{
          RowBox[{"L", " ", 
           RowBox[{"(", 
            RowBox[{"LPf2", "+", "MO", "-", "MOL"}], ")"}]}], "-", 
          RowBox[{"LPf2", " ", 
           RowBox[{"(", 
            RowBox[{"LPf1", "+", "MO", "-", "MOL"}], ")"}]}], "+", 
          RowBox[{"LPf1", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "MO"}], "+", "MOL"}], ")"}]}]}]]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"h", ",", "\[Theta]"}], "}"}], "=", 
        RowBox[{
         RowBox[{"TM", "[", "si", "]"}], ".", 
         RowBox[{"LM", "[", "MO", "]"}], ".", 
         RowBox[{"TM", "[", "MOL", "]"}], ".", 
         RowBox[{"LM", "[", "LPf2", "]"}], ".", 
         RowBox[{"TM", "[", "L", "]"}], ".", 
         RowBox[{"LM", "[", "LPf1", "]"}], ".", 
         RowBox[{"TM", "[", 
          RowBox[{"f1s", "+", "LPf1", "+", "LPf2", "-", "L"}], "]"}], ".", 
         RowBox[{"LM", "[", "f1", "]"}], ".", 
         RowBox[{"TM", "[", "f1", "]"}], ".", "V"}]}], ";", 
       RowBox[{"M", "=", 
        RowBox[{"h", "/", 
         RowBox[{"V", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"si", "-", "8.3"}]}], ",", "M", ",", 
      RowBox[{"2", " ", "h"}]}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SizeLP2", "[", 
     RowBox[{"Data_", ",", "int_", ",", "fin_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Clear", "[", 
        RowBox[{
        "V", ",", "M", ",", "si", ",", "LPf1", ",", "LPf2", ",", "MOL", ",", 
         "MO"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "f1", ",", "f1s", ",", "LPf1", ",", "LPf2", ",", "MOL", ",", "MO"}], 
         "}"}], "=", 
        RowBox[{"Data", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"V", "=", 
        RowBox[{"Data", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"v1", "=", 
        RowBox[{
         RowBox[{"TM", "[", 
          RowBox[{"f1s", "+", "LPf1", "+", "LPf2", "-", "L"}], "]"}], ".", 
         RowBox[{"LM", "[", "f1", "]"}], ".", 
         RowBox[{"TM", "[", "f1", "]"}], ".", "V"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"v2", "=", 
        RowBox[{
         RowBox[{"TM", "[", "L", "]"}], ".", 
         RowBox[{"LM", "[", "LPf1", "]"}], ".", 
         RowBox[{"TM", "[", 
          RowBox[{"f1s", "+", "LPf1", "+", "LPf2", "-", "L"}], "]"}], ".", 
         RowBox[{"LM", "[", "f1", "]"}], ".", 
         RowBox[{"TM", "[", "f1", "]"}], ".", "V"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Plot", "[", 
        RowBox[{"v1", ",", 
         RowBox[{"{", 
          RowBox[{"L", ",", "int", ",", " ", "fin"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{"v2", ",", 
        RowBox[{"{", 
         RowBox[{"L", ",", "int", ",", " ", "fin"}], "}"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PlotTrackAll", "[", 
     RowBox[{"Data_", ",", "int_", ",", "fin_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
       RowBox[{
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"Callout", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"FTG", "[", 
              RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<Image Plane\>\"", ",", 
            "5", ",", 
            RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
            RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
          RowBox[{"Frame", "->", "True"}]}], "]"}], ",", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"Callout", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"FTG", "[", 
              RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
             RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<Image Size\>\"", ",", 
            "25", ",", 
            RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
            RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
          RowBox[{"Frame", "->", "True"}], ",", 
          RowBox[{"FrameStyle", "->", "Red"}], ",", 
          RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
        RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}], ",", 
        RowBox[{"ImageSize", "->", "\"\<Medium\>\""}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FTG", "[", 
          RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
        RowBox[{"PlotLabel", "->", "\"\<Image Plane\>\""}], ",", 
        RowBox[{"ImageSize", "->", "\"\<Medium\>\""}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FTG", "[", 
          RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
        RowBox[{"PlotLabel", "->", "\"\<Image Size\>\""}], ",", 
        RowBox[{"ImageSize", "->", "\"\<Medium\>\""}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FTG", "[", 
          RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
        RowBox[{"PlotLabel", "->", "\"\<Magnification\>\""}], ",", 
        RowBox[{"ImageSize", "->", "\"\<Medium\>\""}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PlotTrack", "[", 
     RowBox[{"Data_", ",", "int_", ",", "fin_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
      RowBox[{
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"Callout", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FTG", "[", 
             RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<Image Plane\>\"", ",", 
           "5", ",", 
           RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
           RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
         RowBox[{"Frame", "->", "True"}]}], "]"}], ",", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"Callout", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"FTG", "[", 
             RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
            RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<Image Size\>\"", ",", 
           "25", ",", 
           RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
           RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
         RowBox[{"Frame", "->", "True"}], ",", 
         RowBox[{"FrameStyle", "->", "Red"}], ",", 
         RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
       RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}], ",", 
       RowBox[{"ImageSize", "->", "\"\<Medium\>\""}]}], "]"}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RangeAnyl", "[", 
     RowBox[{"Data_", ",", "L1_", ",", "L2_"}], "]"}], ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Clear", "[", 
       RowBox[{"si1", ",", "si2", ",", "M1", ",", "M2"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"si1", ",", "M1", ",", "x"}], "}"}], "=", 
       RowBox[{
        RowBox[{"FTG", "[", 
         RowBox[{"Data", ",", "L1"}], "]"}], "//", "N"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"si2", ",", "M2", ",", "y"}], "}"}], "=", 
       RowBox[{"FTG", "[", 
        RowBox[{"Data", ",", "L2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Image plane travel: \>\"", ",", 
        RowBox[{"N", "[", 
         RowBox[{"si1", "-", "si2"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Magnification: \>\"", ",", " ", 
        RowBox[{"M2", "/", "M1"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}]}], "\[IndentingNewLine]", 
     "}"}]}]}]}]], "Input",
 CellChangeTimes->{{3.937492132166977*^9, 3.937492182055704*^9}, {
   3.9374922311561394`*^9, 3.937492287223858*^9}, {3.937492559529909*^9, 
   3.937492743071955*^9}, {3.9374927905835915`*^9, 3.93749280045195*^9}, {
   3.937492836582102*^9, 3.937492867043091*^9}, {3.93749296557983*^9, 
   3.9374930305625*^9}, {3.937493126521984*^9, 3.9374931530429997`*^9}, {
   3.9374933048719425`*^9, 3.937493330046602*^9}, {3.937493401036129*^9, 
   3.937493401652891*^9}, {3.937556603443508*^9, 3.937556674427269*^9}, 
   3.937556715747523*^9, {3.937556749787564*^9, 3.937556751270975*^9}, 
   3.937556795245655*^9, {3.937557064146166*^9, 3.9375570804637165`*^9}, {
   3.937557137978237*^9, 3.93755714007488*^9}, {3.937557245309326*^9, 
   3.937557278456497*^9}, {3.937557330281252*^9, 3.937557343788278*^9}, {
   3.937557471941204*^9, 3.937557472381174*^9}, {3.937557710490694*^9, 
   3.9375577279260216`*^9}, {3.9375593658977985`*^9, 3.937559414917675*^9}, 
   3.937559842710373*^9, 3.9375601670268517`*^9, {3.937560296767481*^9, 
   3.937560307301459*^9}, {3.937563377605315*^9, 3.937563386218033*^9}, {
   3.937563417442833*^9, 3.9375634473406982`*^9}, {3.93756349661738*^9, 
   3.937563574132456*^9}, {3.9375636227756233`*^9, 3.937563720509424*^9}, {
   3.937563853702603*^9, 3.937563860240233*^9}, {3.937563922069319*^9, 
   3.937563923617399*^9}, 3.937564038884012*^9, {3.937564088242579*^9, 
   3.9375640990458145`*^9}, {3.937564133181467*^9, 3.937564169275835*^9}, {
   3.9375650028902607`*^9, 3.937565007006265*^9}, {3.937565042608361*^9, 
   3.9375650848404427`*^9}, {3.937565120174755*^9, 3.937565143908018*^9}, {
   3.937565836844225*^9, 3.9375658505763702`*^9}, {3.9375660018769054`*^9, 
   3.9375660353703213`*^9}, {3.937566346440218*^9, 3.937566350832171*^9}, {
   3.9375666463439865`*^9, 3.937566656726076*^9}, {3.937566787604233*^9, 
   3.937566889587225*^9}, {3.9375669928126087`*^9, 3.937567003240661*^9}, {
   3.937567268088276*^9, 3.937567285469183*^9}, {3.937567361436924*^9, 
   3.937567381705267*^9}, 3.9375674634983463`*^9, {3.937567591543518*^9, 
   3.937567591934141*^9}, {3.937567628830187*^9, 3.937567653683794*^9}, {
   3.937567685769614*^9, 3.9375676954154186`*^9}, 3.937567752339538*^9, {
   3.93790880850544*^9, 3.9379088494855995`*^9}, {3.937909831329647*^9, 
   3.937909856871239*^9}, {3.937918328440218*^9, 3.9379183627309895`*^9}, {
   3.9379959500112534`*^9, 3.937996026514709*^9}, {3.937996064581152*^9, 
   3.937996067193259*^9}, {3.937996103189089*^9, 3.9379961640006332`*^9}, {
   3.9379970660499*^9, 3.937997066605595*^9}, {3.937997132405411*^9, 
   3.937997151200001*^9}, {3.937997207539513*^9, 3.937997213866184*^9}, {
   3.9379973699332657`*^9, 3.93799740404455*^9}, {3.937997441789326*^9, 
   3.937997469944891*^9}, {3.937997942898707*^9, 3.937997945722861*^9}, {
   3.937997980413709*^9, 3.937997980912586*^9}, {3.937998033004537*^9, 
   3.937998097565657*^9}, {3.937999229740372*^9, 3.9379992680192413`*^9}, {
   3.937999364336577*^9, 3.937999393578953*^9}, {3.937999457134999*^9, 
   3.9379995013334236`*^9}, {3.937999701995783*^9, 3.937999747654001*^9}, {
   3.9380000070205994`*^9, 3.938000062283983*^9}, {3.938000092335228*^9, 
   3.9380000927293453`*^9}, {3.9380001486290073`*^9, 3.938000179703075*^9}, {
   3.938000403059732*^9, 3.938000490444086*^9}, {3.938000548330492*^9, 
   3.938000550050127*^9}, {3.938001242886643*^9, 3.938001266909275*^9}, {
   3.938001299150961*^9, 3.9380013309712753`*^9}, {3.9380013935078273`*^9, 
   3.938001441453684*^9}, {3.938001486542448*^9, 3.938001523322323*^9}, {
   3.938001570754989*^9, 3.9380015764155846`*^9}, {3.938001655341778*^9, 
   3.9380016853589687`*^9}, {3.938001778832611*^9, 3.9380017791730175`*^9}, {
   3.9380021577599735`*^9, 3.938002187404253*^9}, {3.938002465558468*^9, 
   3.938002560881283*^9}, 3.938002695967924*^9, {3.9380029787284374`*^9, 
   3.9380030095671864`*^9}, {3.938003763046589*^9, 3.938003763422571*^9}, {
   3.9380037947315598`*^9, 3.9380037971949043`*^9}, {3.938088895432405*^9, 
   3.9380889000209064`*^9}, {3.938088932048515*^9, 3.9380890223436737`*^9}, {
   3.938090084719825*^9, 3.938090134723658*^9}, {3.938090317883285*^9, 
   3.938090346087315*^9}, {3.938090379581156*^9, 3.938090445701084*^9}, {
   3.938090561652857*^9, 3.938090590078802*^9}, {3.938090639127777*^9, 
   3.93809072538579*^9}, {3.9380907971058807`*^9, 3.938090822016016*^9}, {
   3.938090883182146*^9, 3.938090914753824*^9}, {3.938091014819618*^9, 
   3.938091044357514*^9}, {3.938181720578501*^9, 3.938181720997525*^9}, {
   3.9381891920415688`*^9, 3.938189203939562*^9}, 3.938190014732132*^9, {
   3.938262912858495*^9, 3.938262913547161*^9}, {3.9405989712271595`*^9, 
   3.940598987214941*^9}, {3.9406005491325436`*^9, 3.9406006091166553`*^9}, {
   3.9406007046410084`*^9, 3.940600771667385*^9}, {3.9406816132472477`*^9, 
   3.9406817308208694`*^9}, {3.9406817659162216`*^9, 3.940681812816294*^9}, {
   3.940681842856892*^9, 3.940681858114992*^9}, {3.9409471060022526`*^9, 
   3.94094711970866*^9}, {3.940947155230416*^9, 3.940947190635624*^9}, 
   3.940947224898348*^9, {3.940947270847489*^9, 3.9409474293714848`*^9}, {
   3.940947462711872*^9, 3.940947501739907*^9}, {3.9409476197774296`*^9, 
   3.940947626119993*^9}, {3.940947660482371*^9, 3.940947661561552*^9}, {
   3.940947722425743*^9, 3.940947775749449*^9}, {3.9409478187673273`*^9, 
   3.940947831166441*^9}, {3.940947886107807*^9, 3.940947960084051*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"0446db09-358a-ae4c-a901-e339d8f65751"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.938182606479219*^9, 3.938182689553859*^9}, {
  3.938182743020611*^9, 3.938182747494179*^9}, {3.93818281879241*^9, 
  3.938182833615724*^9}, {3.938182895812107*^9, 3.93818290594594*^9}, {
  3.938182939028116*^9, 3.938183093893917*^9}, {3.9382625567734795`*^9, 
  3.9382626460960484`*^9}, {3.938262863788757*^9, 3.938262880379089*^9}, {
  3.938262941397507*^9, 3.938263025192068*^9}, {3.938263063873079*^9, 
  3.938263065138731*^9}, {3.938263155840643*^9, 3.9382633233848734`*^9}, {
  3.9382634850092688`*^9, 3.938263583669794*^9}, {3.940598982436651*^9, 
  3.9405989837937126`*^9}},ExpressionUUID->"1f101efc-1e84-0d48-86d2-\
16d2baa19aa0"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.9381826023061867`*^9, 
  3.938182666562624*^9}},ExpressionUUID->"0d20bbcc-b72d-3940-bdfe-\
000e7436ab15"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Not in use", "Subsection",
 CellChangeTimes->{{3.93800247385161*^9, 
  3.938002482170431*^9}},ExpressionUUID->"f799a4df-7641-c04d-9a24-\
2544fd331708"],

Cell[BoxData[
 RowBox[{
  RowBox[{"si", "=", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"32", " ", "f2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "18"}], "+", "L"}], ")"}]}], 
     RowBox[{
      RowBox[{
       RowBox[{"-", "32"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "18"}], "+", "L"}], ")"}]}], "+", 
      RowBox[{"f2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "16"}], "+", "L"}], ")"}]}]}]]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.9380029858676414`*^9, 
  3.9380029934201317`*^9}},ExpressionUUID->"cb6e08d8-4796-664e-938f-\
24d95e5f67c4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlane", "[", 
    RowBox[{"y0_", ",", "so_", ",", "\[ScriptF]_"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "=", 
       RowBox[{
        FractionBox["\[ScriptF]", 
         RowBox[{"\[ScriptF]", "-", "so"}]], "//", "Simplify"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"h", "=", 
       RowBox[{
        RowBox[{"y0", "*", "M"}], "//", "FullSimplify"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"si", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ScriptF]", " ", "so"}], 
          RowBox[{"\[ScriptF]", "-", "so"}]]}], "//", "Simplify"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Magnification: \>\"", ",", " ", 
        RowBox[{"M", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Image Height: \>\"", ",", " ", 
        RowBox[{
         RowBox[{"y0", "*", "M"}], "//", "N"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Image location: \>\"", ",", 
        RowBox[{"si", "//", "N"}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "M"}], ",", "h", ",", "si"}], 
    "\[IndentingNewLine]", "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mag", "[", 
   RowBox[{"so_", ",", "\[ScriptF]_"}], "]"}], ":=", 
  FractionBox["\[ScriptF]", 
   RowBox[{"\[ScriptF]", "-", "so"}]]}]}], "Input",
 CellChangeTimes->{{3.938002483950989*^9, 
  3.938002500706255*^9}},ExpressionUUID->"8d2b93c7-c1db-5e4e-9bae-\
a77c755f3181"]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Subsection",
 CellChangeTimes->{{3.9375568639330025`*^9, 
  3.937556867909411*^9}},ExpressionUUID->"b2f74721-8aa7-0a4a-a9f4-\
14fdfce3adc6"],

Cell[CellGroupData[{

Cell["f = 100, 8, 8", "Subsubsection",
 CellChangeTimes->{{3.938181625867285*^9, 
  3.9381816539861183`*^9}},ExpressionUUID->"b537f931-ec2a-b54f-8105-\
42b68aae6ca5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"h0", ",", "\[Theta]0"}], "}"}], "=", 
    RowBox[{"FringeHeight", "[", 
     RowBox[{"100", ",", "300", ",", "780"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f1", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f1s", "=", "20"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPf1", "=", "8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPf2", "=", "8"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MOL", "=", "80"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MO", "=", "22"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"h0", ",", "\[Theta]0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "f1", ",", "f1s", ",", "LPf1", ",", "LPf2", ",", "MOL", ",", "MO"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FullTrack", "[", 
  RowBox[{
  "h0", ",", "\[Theta]0", ",", "f1", ",", "LPf1", ",", "16", ",", "LPf2", ",",
    "MOL", ",", "MO"}], "]"}]}], "Input",
 CellChangeTimes->{{3.937563889538597*^9, 3.937563889960785*^9}, 
   3.937564127306965*^9, 3.9375669869621944`*^9, {3.937567799679605*^9, 
   3.937567801285736*^9}, {3.937568577200423*^9, 3.93756861163694*^9}, {
   3.937909980524193*^9, 3.937909988831604*^9}, {3.937996177677321*^9, 
   3.937996177812035*^9}, {3.9379974210680904`*^9, 3.9379974246626186`*^9}, {
   3.937999322457518*^9, 3.937999341467701*^9}, {3.937999433599207*^9, 
   3.9379994522782345`*^9}, {3.937999496604931*^9, 3.937999497015665*^9}, {
   3.937999634702368*^9, 3.937999692445116*^9}, 3.9379997293199425`*^9, {
   3.937999768868122*^9, 3.937999789397949*^9}, {3.937999823304821*^9, 
   3.937999826707051*^9}, {3.9380003178456726`*^9, 3.9380003181218777`*^9}, {
   3.9380005643862453`*^9, 3.938000577812718*^9}, {3.938001219563579*^9, 
   3.938001222027657*^9}, {3.938001279598684*^9, 3.938001280054478*^9}, {
   3.9380014548765316`*^9, 3.938001455879257*^9}, {3.938001510789711*^9, 
   3.938001512286536*^9}, 3.938001582082384*^9, {3.9380016894271545`*^9, 
   3.938001694929884*^9}, {3.938003014772217*^9, 3.938003023809051*^9}, {
   3.9380032906007977`*^9, 3.938003291098064*^9}, {3.938004210087841*^9, 
   3.938004210218769*^9}, {3.9380042942312374`*^9, 3.938004294293289*^9}, {
   3.93808922627528*^9, 3.9380892330329113`*^9}, {3.938089279683377*^9, 
   3.938089282111779*^9}, {3.938090052605944*^9, 3.9380900757344112`*^9}, {
   3.938090108058693*^9, 3.938090112581787*^9}, {3.9380901593835773`*^9, 
   3.938090291827664*^9}, {3.93809078136431*^9, 3.938090781722227*^9}, {
   3.938090837559669*^9, 3.9380908738830547`*^9}, {3.9380909442541943`*^9, 
   3.9380909848871784`*^9}, {3.938181739128992*^9, 3.938181767957089*^9}, {
   3.9381822074881687`*^9, 3.9381822077837143`*^9}, {3.938190037452309*^9, 
   3.93819003816613*^9}},
 CellLabel->
  "In[125]:=",ExpressionUUID->"7f7052de-99a9-e644-b212-e0ae8289d009"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"90.62286500739786`", "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm[90.62286500739786, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.940681850353836*^9, 3.940681870450033*^9}},
 CellLabel->
  "During evaluation of \
In[125]:=",ExpressionUUID->"f9a07cd7-ff3a-1544-b95b-2be8fd7ce616"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"22", ",", "0.21999999999999997`", ",", "0.0572`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.9381900387465496`*^9, {3.9406818503638744`*^9, 3.940681870462635*^9}},
 CellLabel->
  "Out[133]=",ExpressionUUID->"a62671ad-11d2-3948-9b35-d955b261f563"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"int", ",", "fin"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "32"}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"ResourceFunction", "[", "\"\<CombinePlots\>\"", "]"}], "[", 
   RowBox[{
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"Callout", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FTG", "[", 
          RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<Image Plane\>\"", ",", "5",
         ",", 
        RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
        RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
      RowBox[{"Frame", "->", "True"}]}], "]"}], ",", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"Callout", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FTG", "[", 
          RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<Image Size\>\"", ",", "25",
         ",", 
        RowBox[{"Appearance", "->", "\"\<Balloon\>\""}], ",", 
        RowBox[{"Background", "->", "White"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
      RowBox[{"Frame", "->", "True"}], ",", 
      RowBox[{"FrameStyle", "->", "Red"}], ",", 
      RowBox[{"PlotStyle", "->", "Red"}]}], "]"}], ",", 
    RowBox[{"\"\<AxesSides\>\"", "->", "\"\<TwoY\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"FTG", "[", 
     RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
   RowBox[{"PlotLabel", "->", "\"\<Image Plane\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"FTG", "[", 
     RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
    RowBox[{"[", "3", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
   RowBox[{"PlotLabel", "->", "\"\<Image Size\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"FTG", "[", 
     RowBox[{"Data", ",", "spacing"}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"spacing", ",", "int", ",", "fin"}], "}"}], ",", 
   RowBox[{"PlotLabel", "->", "\"\<Magnification\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.9381817035269966`*^9, 3.938181703952215*^9}, {
  3.9381817492935066`*^9, 3.9381818534555073`*^9}, {3.9381819808744335`*^9, 
  3.9381820003642616`*^9}},
 CellLabel->
  "In[564]:=",ExpressionUUID->"35b00336-4de0-2846-8274-62792a3bc77e"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, {}, 
     TagBox[
      TagBox[
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], Opacity[
        1.], LineBox[CompressedData["
1:eJwVkXk41YkXxpEpMzWUJdnKct173dWUcV33+/3eNzQphFKouO2iLElkKRlr
ZclEmRaj0AgpIqlIhWRLZS1LRdbQIsZM5Xd/f5znPJ/nnOc573lfvR2+63fL
ycjInJbW//va3UPPKoezqY56TnnUFAV5S02/Xo0ocYr7MwUvKa/4K+3CTY0U
8aXi67b2UrZpbC+6qJElFiovKNeQsvOu6fI/NIrFbjN94oIvFLr5sZYJGlXi
BJWf61snKWSo2cec0GgRJ6CiZ+lnChEKNxnHNfrF+ZkhxmkTFFxcL13/8HFS
nLj9T4XgQQrzZyO2rl46K+abDH8heikYOo4PPTopD5ff9rgGt1EIahKK0yZ/
RGzPD8TiBgrqxYt6ZGWV0Hb0QaL/Awq33lo2PCWU0RUcVVZWTOGh10Ut1/eq
MBIYXG65QuELnVS65q2OKaI2Z3caBbmZvIVahppYxCow7IihYDq77daGAm3U
RhZvcgqg0BBl0lTDWobAHcnDNRIKy06Nzlwd1wW/+W3f8t8ojE739rQa62NW
cvRNLEt63yPp4VpTfWzOl8TMlfKxdurKfZE+0p8/aYkyorC49KL31d/0ceFb
1/5jTAoWgVu+hm3Vh8WunccO0imcm2zToMXpA4XxA9b6FKw/Njr59+pDSS9T
v0CDQtbI3TrFRAM82+chsJ1HweesvYHXaQMc/X5UuWQuBYFVX2h1mgFWn3CP
0JFy3cWfuGGZBiCcM5eMyVP46OCaNHzbAE2hEt1YOQpU6dSGqj4DjBSvZV/5
RqIz8pfuYCENg29t7sd/JqGo8/dEfz8Nu/f6dXV3k8CmyO6+YRrONWaPrJCy
f5Kk/u04Dba7xGHHu0i0yS75+/U/NHhJghkrXpFIH4hz71pgiMCsF4nHOkjw
bng1vjAxhE7wU9qcFyTsLHl5D6MMEa163T3zMYl4z5I9GTQ6PJK8j3GukxjB
tbj5LDoWxalz7ApIrF6SnRvIpyPSmKvqfY2E3OOUcVtzOm5KUlJz80gE0wIC
Z+zp8FW5B+0cEnt6l8esD6Xjx9p7dp0ZJFZuvJEt/5yOXkun2KJkqT5OzmPf
djrunXS6evsUia9zMoZfdtGBXe195UkkbhclcQsH6djp6HqxOkGqf6Fvids3
OsrOBH9/cpyEdj23+haTATonfn12BIkp5PXvDWdA9KQw+oIfiXtZo+eDohio
jy7uTfUl8bsCZ0PMcQaUx4qsE32k/jbnP8g8zYD2Fx+LsP0k6JKC9J6/Gdjv
/um67V4Sm44Uujg1M8B+fNCyQkKipKy0QazHhEL7XauXdiRCdP6JXEdnYonH
3doiW2k+EWYiNzYTzllq3BM2JBqsy66G/MrExmzLU7+uIdHffiemZA0T9meK
ko9akVCdKgfbnwmB5prZdnMSAcurihc/YmJhjVHFebrUPxPdjORaJjxmGpuM
DUm4mIadXNDExCpu/uoqAxIic5Mdcp1MjCfZeQzoSvOwyFIaH2ciU2y3SF2L
RJJjlFe1phHWquWkMJRI5PpZ6Qb4G4GoKFb78IXABf+M+RNBRri9wiXIdpJA
QsDXKc8jRrCOHum+8omA3+HiRkmcERS7vfM2ThAQHKOF2qQbYXje7OtzQwSq
kuTb9OuM0KV4eVvlSwK9BVUnn+mxYFJOfN1cTqB5TP79cgYLc9eGUMF3CVRy
VtmmcFhYohi/OLWMQEZu9QJnAQvbWsIOVZcQ2HGlJqHLlgXWqI6nQgGBgYu1
SYNBLKi803iunE5gLL7h9LdGFnRL3fiqYQR66hdMur9gIYXbSXsVTKDpJzun
yg4W8j8EyfwVRKAgrlE1so+F2KEfHHQOSv+JakpVmGFB8D0r9bMngcnQ5rMq
NDayVodnyzgT+M+r5bxRCBvO+/5t8+ARcDJ1S+aFs6EyoeA8yiaQLzsQsyKK
DeOscZt9RgTc06YPkIlsDN6tObSNRuBBtaa142U2itJjJpZqEojV3T55uI6N
D1Ob3d/JE1BpG7Ot1eTgvGmO8uZ2EfZfCrRoXMbBdmP7jC0tIlTtnxU8p3Ew
JHh81OWZCIFzFhl08Thovj8qa1UvQqexycyEBQcabn/2va4Q4a+TIdnq+6Tz
wIjrjGwR2Cvnfd9zl4PQ0aquBG8RbuTmMToqOfhdrFuU7CmCiaqD45oaDpTi
Vyok7haBGEzLYj/jgD2T+sbXTYR1CSybDwMc3M9tfdNqK4J/p11asDIX9rsP
VC9miTBl8enBiDoX3+Iap88aihCaf2Z0iw4XwlsfuAv1RIgK76UoJheWcz+a
vVMX4YzhgXdyFBcMF5uypT+IUHYgZXm8JxdKnezNJd3moF6Zbf3mw8XB9TPa
f3aY46FVd7RPABczWjn/Hnhhjjp1eqdDOBexLN0QuSfm6CovDVdL5SKoSOvU
uZvmkPnpVUN6JReu6w//Eh1jjtWX9TwK1XnQTTDeqqhvDpM0RXqNNg8zkmH1
21rm0E38r/+lHg/j5C7rDWrm+De4dYc8hwfvDcdJNwVzXHM87u4MHuY/elpe
NiaEiuzHjd/28pD4IGBqZ4kQMtPdqso+PCyQ0Vo1v0CI9+/rXtAP8mBWNuSZ
cUWImo4sR4cjPMh/HjQ8fVaI4BsudpnJPEz9w83747AQvZJKqzV3eJjH6xeW
mgrRsPHaHPf7PAwO1f+swRPits25h/5VPKRPe9btNBTiD0EALjRJ92MuxxSp
CLFKiUlMvOWhte+QM2vCDHkVSStS5/OhYHvnCP2SGdKKwz5dXcjHo0E9z4Ez
ZojK9SysUONDVDG9OS7eDO5nLPlDy/jYMjlK+gWZYZHPNEtkwofl0+KqShsz
BOlI9N9s5ePQKepc75gAOxyMN3Vt58N3Q+DKsjcCrIuUPdG+hw9mgXPq/lYB
6MOZHxv9+HBVzd/ldk+AluKhyjtRfBgkJkevjxPA2NZfkpLPR1Fl4qtmdQG0
wy1PJxXyMVKtWNSvIMC8ItXHJ27xUfF6p0PVjCl61Et5EZV8XLX+FP/2pSkM
5HM4d2r5SGiQP7Su0hT/AwIGAnA=
         "]], LineBox[CompressedData["
1:eJwV1XlUjdsbB/AGKlxRIoWSQpPqnvec06j3+76nNJxEgzSXhERStCilgXKU
SnSRBspQGtHAj4RIJY2nkeoqdAsh6VKi+/7+2Guvz1p7P/t5nvWstVV8Au13
iImIiAiY9f/9mK3Ey1WFLNzjrr6oYG2G0uw3Ha4VLAwEz322SdMMbsfv7mtt
YKEBxiNyozzcXCmkoppYiL/Xmj70jofZD0bldFtZ2BqV6tXaz0PJxKr7pzpZ
MF2cJ/elhQfxXYmSlgMsmEuY15tV8FBg5XO56l8WPIMdZr0/zgNbW8WUnGQh
bcrENSyShyrp168e/mQhJXX+DcUwHlqEHvKPRQjIbBFfFh/IwzcPl6Qncwnk
F8jPXeHGg2nw5vA6JQIZBSlxfWweah0XKFqpEMg8KvV8kx4Pm/Wb7tSrEsi+
m2TbpMWDzzR//Lk6AWmbaafPq3g4EWfh38gi0CPMoitlmPcumjq3bWDuF4Uf
cBuj4RLxa8LeisDK3Rm14aM0Br0qzwr5BI4MDlTkjtD4pmbU3L6ZgF2JVo/C
IA2FEs6GLlcC3ymT4D1CGj5PtNm9+wjsEPho5t2hMfFBceHQOQIioQPJNbE0
UjP/qc1II5CrvdYmJ4YGsaks0iGDgGj17K1xkTSCbm/8/CibgImT9/j2UBqj
h6Oa0gsJlB3yTQ8OoPFu9tApu2oCtyZ/FdU70Th+57aZVA0B1xtVLgsdaaju
jpyuqiXQPWPy2d2OxrYXS/dqNxLoiJFLkLSh0XeGz5fsJjCSYx19maLRoXxr
zoNRAkn2Xwza1tE42Brx+MAXAl6vmrUDtWgsOmYdqjlOIOLf3qmFGjTsht4M
n//BnFeve++jRqOxcEldsDgb7u0ZCabLaNQYhsepK7BxTaJTtn4OjXIHC/FU
MzZkQteYdY1QEPDvxi63YENL7/edJcMU3HkaUtes2Gj5d4+yyxAFMWLe/Apb
Nl627ywYGqRgK9u8pNuZDbmTj0ZVeykMtzhpLg9g40/fKHmVZgqKtjvtrv7F
Rqumkc5UBYVR8y6h9gU2dJfkuCeUU3i03tKp/CIb/S/l7ymVUdi5TtPt2SU2
QmbsP/FvUSj945Pv8A02Vvvalz0soGDTEHJYu4qNCtoxVyqbQqRl7KWyITZS
U3tcxBIptHn6ueuNsJE3Zd7YmUBBLYSvUPiBya/KracwnsLzbJmzV76w4fzz
WLGHgILcz8y4M1NslDqUjbceo5BXVBGwX5oDXlqQidgRCi2yw8baXA7UVX6N
B/hTWKXR8CPXgIP9Yj11gbsphJDF5arGHKj1cvuC/Zh69x7UXQYOEn0U74fv
pOBbI6I615qDzAXEvEs+FH4cUpg77MGBYFfSH8vdKKj0WXdfieVg0eHNqiM2
FOKrjUu2CDg44TdiNM2n8DVXO04ygQO/F6JHFzKuDpZm7znNQa9Lb4SJFRNf
qi2Zlc5B39GMtTnmTP6Ei8XjmxzkmD/dlGNKQSd+V0X/Kw6yyQhnvz8pnAt0
Tjzdz0HRee/JDD0KM45WvvQAB8WW8YI2XaZeZS3Z60Mc3HZctwc6FILKPwUE
jHFwnD0qt1aLQtnrkNXTEly8i11yWWk1BSP946kKLC5eBC8KKVSg0OmjwM1k
c+HlV1IjyfhAUnHXSn0uXu9YXLV9KYXCd92K6iZcPBRSOSvkKSilrsvmbuBi
TWjm8jQ5Zr7GOoscXLkY0moQL15AoSFfozYxhous7+mbrCSYeVRqnhQVcqFi
PNy+dAKQVgguv9/BRYZQN+zUN+DxosVBId1cfH//KU+E8Zo5bsPDfVzkdhRf
ev8V+Dw+1Nk8zIV6ysnep1+AmPrfpZm/uegvXPUh5SOQd1Bnn6GmPnYcavE+
+RaYeJ44uD9aH2PJGh/rO4DeeR1+08f08a719tdtjKttln8+EaePGzKTG6fa
gdNN+T+zEvRRE6Esqs1Ys61WrvEvfaxfU2R7tg3w7BG10MjXx+Gl+bpBzcCz
f0IKBtr0EXNkMHBXPXBhludBezUDaL0qHdWsAn5vl+e0rjHABxOuaNcDwPdJ
y8QmDQPIN6XaHWOsF8M7tFHHAF6B/bm9lUDdjHqYpYEBtkhEqZ65D3yfGo80
tTGA9tsFylL/A5zGTiZoHjTA83TDMKUyYFF/eY7YUwNceHJt+3A+MDsi2tEw
yBAmC935zmmAyA3PkkFZI/w9n+b5JgDBF0sSZauNcHdOYLXnUeCBlkBKZp8x
+OnyNvwDgIx1sHaMtAlKrYtEOP5Mv9a1CEMrTRA9ncsN2wbczCLV3nquh5fh
mRSuK+BRwpVZ8Xs9xLNq8hocgKjY7OjefFOE/6jrjt4IFA2vSJe2IbHU1faI
riUgyIz17rclEdn9pnEpY1/70dXFdiQyryZpiDFeXll5c+NWEgGu0tPtFkB8
stuzUz4k3mYpzT/C2I+bNjY3lERWqfBl3QZg1XE5S8nrJMJMJmb8zZl+G4TP
78ojkfh+wn8L457RN23XC0jUCXb0k4xPby312HCLxMOuiH45xjOa9gdiK0kc
9J3De2jG1NuanCUuJMFv25i2mPHduO/bhR0kHihNCEQYpxp7aVzpJgHFqqgP
PIB/TaeM7iexcHOO4DHje4cb66NHSDS90psMYHxuHSfZ7iMJt0IfDRfGQYMZ
jiqfSaR/PL3NjLG6zd6/H30joeLdMqLIeJZo+9XT30mw9nUbSjB+XW7s7z1F
4nD28xTm+0Sl/xVdvV8kFu/PGetlfF553sTMDBPPwc2ljvF//2+0DA==
         "]]},
       Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
      Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
   GeometricTransformationBox[{{{}, {}, 
      TagBox[
       TagBox[
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
         LineBox[CompressedData["
1:eJwVkXk8FAgfh127tbKdrrEUY8yMMUc0sW/F77c6JMfmSgqz2U2h3MuGnNM4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          "]], LineBox[CompressedData["
1:eJwVkGk4lA0bhoVoVZREVFK9SNs888yMlOf+KISkSCVbSEUUnmnxKvvQYIwl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          "]]},
        Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
       Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, {{{1., 
     0.}, {0., 169.39993628836478`}}, {0., 31.662922118303335`}}], {
    GraphicsGroupBox[{
      {EdgeForm[{RGBColor[
       0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
       AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
        NCache[
         Rational[2, 3], 0.6666666666666666]]}], 
       PolygonBox[{
        Offset[{0.3291752571400405, 2.9818859217090763`}, {5.701395369638902, 
          30.609278850397803`}], 
         Offset[{4.191280553896035, 7.9516957912242034`}, {5.793388397368865, 
          31.439042276900558`}], 
         Offset[{35.191200055407094`, 7.9516957912242106`}, {
          5.793388397368865, 31.439042276900558`}], 
         Offset[{35.191200055407094`, 21.95169579122421}, {5.793388397368865, 
          31.439042276900558`}], 
         Offset[{-26.80879994459291, 21.951695791224196`}, {5.793388397368865,
           31.439042276900558`}], 
         Offset[{-26.80879994459291, 7.951695791224196}, {5.793388397368865, 
          31.439042276900558`}], 
         Offset[{-3.2505580560718785`, 7.951695791224202}, {5.793388397368865,
           31.439042276900558`}]}]}, {}, InsetBox[
       StyleBox[
        RotationBox["\<\"Image Plane\"\>",
         BoxRotation->0.],
        StripOnInput->False,
        LineOpacity->1,
        FrontFaceOpacity->1,
        BackFaceOpacity->1,
        Opacity->1,
        FontOpacity->1], 
       Offset[{4.191200055407092, 14.951695791224203}, \
{5.793388397368865, 31.439042276900558}], NCache[
       ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
        ImageScaled[{0.5, 0.5}]]]}], 
    GeometricTransformationBox[GraphicsGroupBox[{
       {EdgeForm[{RGBColor[
        0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{-0.8668349810666749, 2.872037102058248}, {
           24.458127324243698`, -0.01020535604188192}], 
          Offset[{2.444669675206689, 7.658765605488663}, {
           24.20661160263114, -0.005307104928668557}], 
          Offset[{22.74858203544643, 7.658765605488667}, {
           24.20661160263114, -0.005307104928668557}], 
          Offset[{22.74858203544643, 21.658765605488668`}, {
           24.20661160263114, -0.005307104928668557}], 
          Offset[{-33.25141796455357, 21.658765605488654`}, {
           24.20661160263114, -0.005307104928668557}], 
          Offset[{-33.25141796455357, 7.658765605488655}, {
           24.20661160263114, -0.005307104928668557}], 
          Offset[{-4.866255186690219, 7.658765605488661}, {
           24.20661160263114, -0.005307104928668557}]}]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Image Size\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{-5.251417964553571, 14.65876560548866}, \
{24.20661160263114, -0.005307104928668557}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
      169.39993628836478`}}, {0., 31.662922118303335`}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 22.751197160407724`},
  CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
      FreeQ[#, Rule], 
      Apply[{{{Bottom, 1}, {Right, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, -0.18691224336946874` + 0.005903189941569565 #2}], {{
          Bottom, 1}, {Left, 1}} -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
    "DisplayFunction" -> Apply[Grid[{{
         Subscript[
          Style["\[RightArrow]", 20], 
          Style[1, 
           RGBColor[1, 0, 0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{
          0. + 1. #, -0.18691224336946874` + 0.005903189941569565 #2}]}, {
         Subscript[
          Style["\[LeftArrow]", 20], 
          Style[1, 
           GrayLevel[0]]], ": ", 
         ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
       Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
       Spacings -> {0, 0.5}]& ]},
  DisplayFunction->Identity,
  Epilog->{{}, {}},
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->{{None, 
     RGBColor[1, 0, 0]}, {None, None}},
  FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "TransformedTicks"[{-0.05866217648027985, 0.06242925045563484}, {
        21.725553160007117`, 42.23843316801824}, 
        "CustomTicks"[True]]][
       SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
       "CustomTicks"[True]][
       SlotSequence[1]]& , ResourceFunction["CombinePlots"][
       "CustomTicks"[False]][
       SlotSequence[1]]& }}, {{{{25., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {35., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"35\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {40., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {23., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {27., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {29., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {31., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {33., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {34., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {36., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {37., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {38., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {39., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {41., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {42., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
       23.192925303885094`, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-0.\
050\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
-0.05`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 3]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {27.427923711094213`, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-0.\
025\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
-0.025`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 3]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {31.66292211830333, 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {35.89792052551245, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
025\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.025`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 3]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {40.132918932721566`, 
        FormBox[
        "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
050\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.05`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 3]]]], TraditionalForm]\\)\"", TraditionalForm], {
        0.01, 0.}}, {22.345925622443268`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       24.03992498532692, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       24.886924666768742`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       25.733924348210564`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       26.58092402965239, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       28.274923392536035`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       29.12192307397786, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       29.968922755419683`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       30.81592243686151, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       32.50992179974516, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       33.35692148118698, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       34.2039211626288, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       35.050920844070625`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       36.744920206954276`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       37.5919198883961, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       38.43891956983792, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       39.28591925127974, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       40.979918614163395`, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
       41.82691829560522, 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}, {{{
       0., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
        "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
         TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
       0., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
        FormBox[
         TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {4., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {6., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {8., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {12., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {14., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {16., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {18., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {22., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {24., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {26., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {28., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {32., 
        FormBox[
         TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
  FrameTicksStyle->{{None, None}, {None, None}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->{{28.246092796325684`, 57.60546672344208}, {28.34375, 
   2.971535051205251}},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None},
  PlotRange->{{-0.6666666666666667, 32.666666666666664`}, {
   21.725553160007117`, 42.23843316801824}},
  PlotRangeClipping->False,
  PlotRangePadding->None,
  Prolog->{{}, {}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.938181873293707*^9, {3.938181981862961*^9, 3.938182003026455*^9}, 
   3.938182213299698*^9, 3.9381899549255295`*^9, 3.938190043347498*^9},
 CellLabel->
  "Out[564]=",ExpressionUUID->"4a4d2b68-8495-814b-a66d-c21a5ecf1ac2"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVkXk41YkXxpEpMzWUJdnKct173dWUcV33+/3eNzQphFKouO2iLElkKRlr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          "]], LineBox[CompressedData["
1:eJwV1XlUjdsbB/AGKlxRIoWSQpPqnvec06j3+76nNJxEgzSXhERStCilgXKU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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVkXk41YkXxpEpMzWUJdnKct173dWUcV33+/3eNzQphFKouO2iLElkKRlr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              "]], 
             Line[CompressedData["
1:eJwV1XlUjdsbB/AGKlxRIoWSQpPqnvec06j3+76nNJxEgzSXhERStCilgXKU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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {22.751197160407674`, 40.57890631501273}},
            "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 22.751197160407724`}, 
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
           "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
           "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {22.751197160407674`, 40.57890631501273}}, 
          "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 22.751197160407724`}, 
          "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVkXk41YkXxpEpMzWUJdnKct173dWUcV33+/3eNzQphFKouO2iLElkKRlr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          "]], 
         Line[CompressedData["
1:eJwV1XlUjdsbB/AGKlxRIoWSQpPqnvec06j3+76nNJxEgzSXhERStCilgXKU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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {22.751197160407674`, 40.57890631501273}}, 
       "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 22.751197160407724`}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 22.751197160407724`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
  PlotRange->{{0, 32}, {22.751197160407674`, 40.57890631501273}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.938181873293707*^9, {3.938181981862961*^9, 3.938182003026455*^9}, 
   3.938182213299698*^9, 3.9381899549255295`*^9, 3.938190043834364*^9},
 CellLabel->
  "Out[565]=",ExpressionUUID->"3cd2953f-2eb3-194a-882b-8dece1df196b"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVkXk8FAgfh127tbKdrrEUY8yMMUc0sW/F77c6JMfmSgqz2U2h3MuGnNM4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          "]], LineBox[CompressedData["
1:eJwVkGk4lA0bhoVoVZREVFK9SNs888yMlOf+KISkSCVbSEUUnmnxKvvQYIwl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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVkXk8FAgfh127tbKdrrEUY8yMMUc0sW/F77c6JMfmSgqz2U2h3MuGnNM4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              "]], 
             Line[CompressedData["
1:eJwVkGk4lA0bhoVoVZREVFK9SNs888yMlOf+KISkSCVbSEUUnmnxKvvQYIwl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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-0.052607605133484114`, 
             0.05263274822920812}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-0.052607605133484114`, 
            0.05263274822920812}}, 
          "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0},
           "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
          "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
          "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVkXk8FAgfh127tbKdrrEUY8yMMUc0sW/F77c6JMfmSgqz2U2h3MuGnNM4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          "]], 
         Line[CompressedData["
1:eJwVkGk4lA0bhoVoVZREVFK9SNs888yMlOf+KISkSCVbSEUUnmnxKvvQYIwl
S5bsyZZs9TG5S6HNnqVCUkmLSlKo+Pp+XMd5nP/O41J1PLn3iLiYmFjY3/2f
QbzE6IkCBuS5q+12/JKPZRmvO6wrGTA4fHp8el0+Hgq+5dH6mAHNji6N/v/N
w5KV7f/xb2JAP9XhMl+QhzNvDy/e2MqATRrTRZud8vD62KrqiE4GxATZSJML
8lDiaKS00SsGyLXWlXS4X8WCnY7pNT8YYFqS/Gyzfi4ytVR1qQkGnF8xKLFr
VS7WyPS/wF8M6ODdb38wIxdb2m0V7ooR8E2/sfnF3Rz8bntQcG8OAU/0dpL6
Bjmo62Xu+2A5AefsJXPb7bKxwXKB0k5VAqqTFg3s0M9Gc3bTzYdqBIjdILaL
q2ej42+T0UfqBLSt6n9m+S0LQ3mGro0MAui6CLYePwtbLuseaDMgAP+MOe6v
z8SD5/+M7d1JQO945KdPxZk4YC+KbTch4McT7XhRQiZ+X72l+ak5ARzZY1+l
XDNR8Tpp0GVNwKo64abNspnoeE+L2eNBgK0Bq5g4noFjH5UWDsYTsOGT88eD
OukYl/quISWJAK9601O26ulI7C73s0gh4PagpFakfDp6lu76cieDAMmv9g29
/Vdw+Kx/U3IhAUd/BtlYmV/BtzMHI/bUEnCYeJegrJuGwTdLt8+qI6Bqlyh7
jUoaqh33+13TQEBa9CU4/TsVDz9ZekKrkYCNyasvfqhOxd4YExPpbgLa6xw+
S+mmYseKG7NvDxNA7PtkvN8sBenW83e9vxLwOkgrkN6cgouCjM9pjhKQfn62
15PFKbhn8PVQwvjf/yLEKzR6krGxcMkDLwkm3JNf+Z3nnox12r48dUUm1Pwz
xda9fBkrLAwl4rYz4bW936urCkkYZnIrRNmQCY1dEtne4kloo68xK2cnE35U
+y13Gk5EcWLu/EozJlS+r3xacC8RzeSal3QfYML9CPtbzz0TcajFSlPZnQnP
EuIvHnmagEpmLnuyLzHB6to7WZWSeBze0dWulciEuDKft3Vp8Xhnm5FVxWUm
1H+6svZiZDy6rNc8VH+FCXks5xl2bvFYNu+z89C1v/2zg4q3qMej6WPuWa0a
JpgrixoEuZfQzyjkSvkgE/aZxDK0y+Owze6Yzab3TIiorlu2MDcOV3NNFAs/
MsHVL9hqMiEOH2XIxmZ9ZYJY9iG1Wb5xuPhXKi9mkgkjzT5vJHfEYV5Rpfsp
GRL8yxUyHJ/HYovckI4WiwRzvzNLUDYWV2k8Hr/KIaHU8+7G6pmxyKWKK9R0
SOhWL3Cqn4hBpRP0xmVAAj9LLH/2QAw614mpzTEmIbY0KBfKYnD8jOKcIVsS
nEoXfjxwIAZVe427s0JIOGIcORBUGI38Wp3r+8JIYBxO6TPPiMZvV7V40uEk
GHqoSWjFR2OtlwzTTUiCw3aR9Tz/aHSe1RbFSCYhJSDFxcsyGvOIg4Z3S0iY
rbCj6/a0EDfwj1b2vSBhWIXwK7IXYvzJA5HCPhJuRQ9YLrQS4rTlTme9VyQ0
Da/0uGAqxJYV6+RyB0nwljur7KstRM+Kz+7uIyQ4Jtcb/1okxPJ+7prfUizg
GwWuGLkUhVvYwXGKDBYEfH/rMuQvwE5HRVYqkwWzUvadsPIUoLeguGslmwUq
M16ZPT0swMK33UrqW1kQEVFmPK0nwOVx6zNYBiygJuuCFkgJUHyks8jCmgVn
dTY9koyKxMf5Gg2RgSzoE9iy8gsi0GZ588SMdhYstQhNSZsbjjKKXhXVHSzo
9j/FOzjFx7uL5D253Swgu8JPqo7wce3sQ0NDvSxgLNYf7erk45fRwc7mIRaY
y2iU92byMfDhVFnqFAusfWq1tm7jYx69wUNbkw3q/iK3Jz4XcexR5MCpADYk
y/+T3y0fhj1zO479DmJDepFISXJeGNaaKn8J5bEhm28iYIuHobAp/1daOBtG
mw33V34ORc22hsWNl9iQ1dLsKPcgFO2ezTDUyGdDYi5HbatvKNa/4xa8amND
rDLhpPCBh4mSdvTe1RyYGGtzU30eglNOCmTrWg70K0ppMNpC0Pley9huDQ50
2ehdNXoUgpsC9c/s2sCBL0ovG3lVIfhgWt3HiMOBY8LeJYbJIfhzctRP15QD
W6oOmbXZhqDVyMVwTZoDUfvX3vkwGIyL+ioyxe9zQEVW3HNcOhhnng+w1PbU
BouBS4kDdoEods3u+oDcFjjQ8/qU5vwA9Lp8PVKudgv45S6Tn87yw9vrwmbJ
euhAlYH+ks7w8yhr7KUVKLMV3kilB35v/xd71re0nxNthePe3qcd1vtgSRq1
+o3dNrCmXVeKGs+i7XWWrMrUNhDj7rNdlHAG/UMyAnrydSHH+U91octpLBpS
SZYxpaCwxtJ64REuhqWGOPSZUTBv80RSvQMXnfcOryneQ8GzHbujL9hwUVkk
Ktm1nwKaMZI5asFFftSh+ghHCsLaHMhvelw8xkoamXOOggdRukxQ5eKq4MVG
0rkUdOVJFi99SeMUx3d+Vx4FBnN/jkq8oPHZ8Ou23AIKKm+safvaSaNwf5mt
wY2/buFr0dxE47TmXu8QEQXRwfLmV2po7GmNSpNop8BmI9+Jn0bjLd5Pp/YO
Cr4W3akRXKYxTsdeI6ubgth7CVlx8TSa5Gwo1+ujoD82SSpHQGPV2caHAe8p
UJu/XrH7Ao3x68moPZ8ouOmZkzfkQ6PnQIql6hcKxs+VVU2eplHd9MTLO98p
qPFTcFI7SaPkjKfZwp8UVHWW/tR2o7G/QsfVYZKCWguPuXuP0ihyzdq46Q8F
fbs9Ut2caExYMXdsepqCf0u7Cnn2NP4PuYAlcQ==
          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-0.052607605133484114`, 
         0.05263274822920812}}, "Frame" -> {{False, False}, {False, False}}, 
       "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
       "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
       GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
  PlotRange->{{0, 32}, {-0.052607605133484114`, 0.05263274822920812}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.938181873293707*^9, {3.938181981862961*^9, 3.938182003026455*^9}, 
   3.938182213299698*^9, 3.9381899549255295`*^9, 3.9381900439881096`*^9},
 CellLabel->
  "Out[566]=",ExpressionUUID->"d55d94b9-bc7c-1e44-b64d-7203510c6d6d"],

Cell[BoxData[
 GraphicsBox[
  InterpretationBox[{
    TagBox[{{{}, {}, 
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVi3k4FIgbgF1thyLlSLEyxph7So7a8H0lkWgjbVpi8yvFrjHJYkgqQhRy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          "]], LineBox[CompressedData["
1:eJwVj3c8lYsfgK0KpTIaSkbrZ1fnfc8Ieb8NEZJVKeGSChdllYYrQqVEnRMS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          "]]},
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
     {"WolframDynamicHighlight", <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
    StyleBox[
     DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
       Slot["HighlightElements"], 
       Slot["LayoutOptions"], 
       Slot["Meta"], 
       Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
           Annotation[{
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]], 
             Line[CompressedData["
1:eJwVi3k4FIgbgF1thyLlSLEyxph7So7a8H0lkWgjbVpi8yvFrjHJYkgqQhRy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              "]], 
             Line[CompressedData["
1:eJwVj3c8lYsfgK0KpTIaSkbrZ1fnfc8Ieb8NEZJVKeGSChdllYYrQqVEnRMS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              "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
        "HighlightElements" -> <|
          "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
         "LayoutOptions" -> <|
          "PanelPlotLayout" -> <||>, 
           "PlotRange" -> {{0, 32}, {-0.2023369428210927, 
             0.2024336470354158}}, 
           "Frame" -> {{False, False}, {False, False}}, 
           "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
           "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
           GoldenRatio^(-1), "DefaultStyle" -> {
             Directive[
              Opacity[1.], 
              RGBColor[0.368417, 0.506779, 0.709798], 
              AbsoluteThickness[2]]}, 
           "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
               Identity[
                Part[#, 1]], 
               Identity[
                Part[#, 2]]}& ), 
             "ScalingFunctions" -> {{Identity, Identity}, {
               Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
           False|>, 
         "Meta" -> <|
          "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
           Plot, "GroupHighlight" -> False|>|>]]& )[<|
       "HighlightElements" -> <|
         "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
        "LayoutOptions" -> <|
         "PanelPlotLayout" -> <||>, 
          "PlotRange" -> {{0, 32}, {-0.2023369428210927, 0.2024336470354158}},
           "Frame" -> {{False, False}, {False, False}}, 
          "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
          "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
          GoldenRatio^(-1), "DefaultStyle" -> {
            Directive[
             Opacity[1.], 
             RGBColor[0.368417, 0.506779, 0.709798], 
             AbsoluteThickness[2]]}, 
          "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
              Identity[
               Part[#, 1]], 
              Identity[
               Part[#, 2]]}& ), 
            "ScalingFunctions" -> {{Identity, Identity}, {
              Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>,
         "Meta" -> <|
         "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
          Plot, "GroupHighlight" -> False|>|>],
      ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
       4.503599627370496*^15, -4.503599627370496*^15}}],
     Selectable->False]},
   Annotation[{{{{}, {}, 
       Annotation[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]], 
         Line[CompressedData["
1:eJwVi3k4FIgbgF1thyLlSLEyxph7So7a8H0lkWgjbVpi8yvFrjHJYkgqQhRy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          "]], 
         Line[CompressedData["
1:eJwVj3c8lYsfgK0KpTIaSkbrZ1fnfc8Ieb8NEZJVKeGSChdllYYrQqVEnRMS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          "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
    "HighlightElements" -> <|
      "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
     "LayoutOptions" -> <|
      "PanelPlotLayout" -> <||>, 
       "PlotRange" -> {{0, 32}, {-0.2023369428210927, 0.2024336470354158}}, 
       "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
       "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
       "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), "DefaultStyle" -> {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[2]]}, 
       "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
           Identity[
            Part[#, 1]], 
           Identity[
            Part[#, 2]]}& ), 
         "ScalingFunctions" -> {{Identity, Identity}, {Identity, Identity}}|>,
        "Primitives" -> {}, "GCFlag" -> False|>, 
     "Meta" -> <|
      "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
       Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
  PlotRange->{{0, 32}, {-0.2023369428210927, 0.2024336470354158}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.938181873293707*^9, {3.938181981862961*^9, 3.938182003026455*^9}, 
   3.938182213299698*^9, 3.9381899549255295`*^9, 3.938190044142252*^9},
 CellLabel->
  "Out[567]=",ExpressionUUID->"edce925a-10bf-0c47-838e-c316fb5511f0"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 20, 20", "Subsubsection",
 CellChangeTimes->{{3.938089060286934*^9, 3.938089315683029*^9}, {
  3.9380901457520275`*^9, 3.938090157619892*^9}, {3.9381821351021233`*^9, 
  3.9381821438745384`*^9}, {3.9381822916210613`*^9, 3.9381822988799477`*^9}, {
  3.9381823801595783`*^9, 
  3.9381823802251225`*^9}},ExpressionUUID->"393e8d62-45b7-6b49-852a-\
142bed70f9e7"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Data", "=", 
    RowBox[{"{", 
     RowBox[{"V", ",", 
      RowBox[{"{", 
       RowBox[{"100", ",", "20", ",", "20", ",", "20", ",", "80", ",", "22"}],
        "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "80"}], "]"}]}], "Input",
 CellChangeTimes->{{3.9381820307599545`*^9, 3.9381821493392467`*^9}, {
  3.93818219964616*^9, 3.9381822250989*^9}, {3.93818226631205*^9, 
  3.9381822737577343`*^9}, {3.9381824234598103`*^9, 3.938182423562069*^9}, {
  3.9381831231342583`*^9, 3.9381831285653877`*^9}, {3.938184717541132*^9, 
  3.9381847234904423`*^9}},
 CellLabel->
  "In[576]:=",ExpressionUUID->"35326e73-b428-e345-bc6a-4ee05e02c38c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwV0Hk4lAsDBfDRopJKcSUtxhbZGsyMMRPvme2d1GSpLJVrm0qXYRBXRbTd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           "]], LineBox[CompressedData["
1:eJwVknlUzYsWx3vGS0WmLC+aVUJpuK5U7jenM/7O+f1+p5/jIlMR0UBRaUDD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           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVjHk01IsbhykRCiWSwtCOpE2leN/ZvqMuVxJtfoREWYZEi8melFCUJTGm
yQzZd9NIDNMk2SMlorpKUSpK1HX7/fGcz3nO+ZxH14W5122WlJRU3B/+v+nB
LrIbjgrNhUVaU/Xu0dDQSbLcT0qFcl1DxeYT0TDzsCaCRMoBe0ZGX7d3NKTX
xurMIQlguKZFMuIfDV5mAd4/dBqBzrMW6IZGQ+e0x/UxnecQ2ifaU5QSDXK9
r1eP6gwDeW7sAZfH0cB5zPb7qPMTHqhEhOkbX4KCwku9XkYKyFqwiTijcRnc
oT115KQq+iveMpCRjgGff9a+KStYgt2+Vm/pEzGgoBu5+tU2Esapkr9HLYyF
OJUmfc6R5eiWElMwb2McuPTuezD7ySpceDo+vyMiHvzEkS7M1fo4LpEnqgKv
QrHvPFuNXevwwO/XX9lG14AT5PnBeL8x/p0c0L9IPgHC2b9sxkc2oEzrUf34
4QSQ6hzA6nOb8FyDd1R/byKsOnXszD79LVgheu3WOHMd3k4k2yveN0GltLM1
WsZJsPufE+cT/LbhWeGznwHcZPj77VUDbW1TTDFeosuipMKHepfQR/k7cKGs
UuOBXzfBaEG3FtXJDFf0dnnvXZkOCjDh/PKbOVYfn0mXhLDhDHnN3Iopc4zz
aL/SfpkNQ9TDBfHSgLpH5Xe8ucEGkUXdFEUZcM0dl+9aeWw4tzc2MUcfcLid
3valhw0f3VaKA50Bd+6TMp2vmQlPrtitWdAKGJjZG2d/JhMYo4d+6NkhniuX
LjpD4UDGoojOkAOIfR5lr6YsODC+I7fw5WHEBVsHf4ZZcyDz8rR7kgtiqom0
DNuBA1Orb/XI+yJempM5X+00B/Jc+gRjlxFfNWvP+Z7HAZUeJ1ZNLWIkafxF
+bLb0CM6Kn3IkIwWVa6tmfO5MEZ+oXl+PRmpr2+T5NS4IFdnvTlzIxkf2oRt
8l/GBZMHpu5D28hou1RZ4GDAhetCleaTdDLOCzw6K3AXF6zLqlNiHMnYoGya
I4niwsOsRcb3r5Ix1vxboKbsHSiPbnAkTZDRiPOoHpdkQfbuJo2Lk2RM2Jog
pbE8C27O6+gYnSaj4o985qRhFoRefUUIZ1GwKzxdowuzwDJlyshehYIaS6Tn
zHhkwWu+8UyMAQVjctiLdYVZoCS5xf7hTEHhUPXSWe48kL7EPejoRsEi1wts
zZM8GN99V1XsQcEV4kurzM/z4HlL5cUEJgWdTJeF8hJ5cKe7g7nuPAXvGp3f
8m8tD0yH5qJrCgW3+IsFPVp8ODYnYKClhYKr/FZq3xvgg6ZO47Ppdgo22I7N
CRnhQ8s2rdY1XRRcmBsVaz3JBxMv8f3wXgqO9O2sU1XJBtlOtTST9xTM3+DL
08dsyMqssMuQpmJJ5Nj227ez4e2Oycfem6lYqxDea+6XAyl2lqKbW6nYWj/2
LS04ByyZmQKJKRXHftzWkruSA2W3LbJ1yVRcTpb/V46fA5HyqRe6rKg48ELi
XdGXAyuebUczdyqeHb8b9sLqLrieDCqfd5OKF+x7Z3/angsmG/vL16ZTUbu/
VfezRS4ofMUKIpOKxruudUgdyIUiP9nKUB4VtRKbDtkH5sIv32tV4yVUNFF7
uri5NBeSmHzhyyYq3lt6hztrYx40enXW5f2mIls7Rd59Zz7cMjQRNUrRkDuo
111mlQ++Iymiodk0nNa+pr/YKR/UvRzrSQo0rPD99HtJeD64eA43XFen4Q18
6basMR9+HZ+RsNbTsGZqimRyuADWuxu0WDrT8ONcEA5cLYT+4zrM/KM0fHgx
Rk/MK4QrXqoqSh40XH+j7JekuhCG/aZtWn1oWOuuIa8/XAhcVlOXDYuGcc2y
tqW6RbA4wbPPPpmGJ2T49/8NLoKZ6tyRI800XNtVofaUKIaCB+zYujYasirj
eV9ti8FBlGik95SGVlZHNq10LgaBJMj3zQsaflvOm3wYVAz+HX+Nu72n4XOu
9v5ZJcXw7t3H6ROz6ailbXc2Qq8EWhcaKgZsp+O3R5kP16qVgrm393DaTjo2
qJp3LVlRCgWSAokI6OhlrX5Qd1MpxLE2RKoQdEzo7804bVMKlkMmv3P30vG3
lasjI74UHgvIn1970tFqgjHGVy4D8ZH9nXsy6KizW7pr+8py2CxMKT7NoePi
XLPnCVvL4Y7ai/iMO3RcqGjXpri7HCIfO1iO3KVj8fE17xyZ5UDZ7CK+WEnH
DSspaxOF5VAr511Z00ZH1qDTzYhDFSAsCE8znE2gcstmt13llSBraaeZLEtg
zXODc1YtlWAzvDpVWoHAtlbRtah3lfBueXNStwqBhTY+vjc1q0A1dXFCqDaB
DhcT9RwiqsAzIi/66XYCbUeVNn50EkAFKUQOzAgM8NV0vsESgHSNTVQOEngw
4eut0FQBJE9+jwhmECh0zq/SeiqAem9yyBq7P56d1xljeQ+WHugOYPkSSGVb
xKv8JYRjE9njQ/4ExvUPGpl5CaE4Icjf5jSBPWT97nuxQmA0k/xWBRP43KLm
Q367EPwpnl5tMQTaLfU0v/G/amgylHJdwSfw/RM7hbio+xAkrb/nSR+BpB4l
9U+qtTBEU+xZNUjgCaXpoSv6tbAnesQp7O0fX3emypNcCyuUC5kmHwlkbmnn
jzJr4cmyzfGZkwTybR309NpqQXubecspVQY2+2z1ccqog+ggHftWdQZa15TM
XBHUwdcaqf61mgz8XOQyotRVBxJ6/Wg/iYHf6Jz56vNF4GtrMX+XEQPDmLeW
OoWJQOSz11JrFwMb8yZVfVj1YFiy6elpyz/9I/3aJen1kDSxyKHD+s/f2C/M
40E9eLKeeV60ZyD/VA93i0wDLLrsEPPFlYGlbUnOSYkNENxspmrpzkBFlp64
uKoB3qvopPFOMHCUE/LFtr8B7icP3j3sx0APGT+LbQZiOJZ17LE4mIEXboyb
PWsSg9vlND0ilIEDE8ky5/vF8B/smhUO
            "]], LineBox[CompressedData["
1:eJwVzGk8lAsbgHHRKhXl6HWU1ESiZCl7vTeS8szMMzyJ0KJsbSoRoUgk2WWG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            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, {{{1., 
       0.}, {0., 219.92023573369246`}}, {0., 34.964620882260206`}}], {
      GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{0.14268784186396458`, 2.996604775372322}, {
            6.884269944401724, 31.663824208367785`}], 
           Offset[{3.9323222255004, 7.990946067659526}, {6.983470993422164, 
            35.18450917332422}], 
           Offset[{31.380500911637238`, 7.990946067659532}, {
            6.983470993422164, 35.18450917332422}], 
           Offset[{31.380500911637238`, 21.990946067659532`}, {
            6.983470993422164, 35.18450917332422}], 
           Offset[{-30.619499088362762`, 21.990946067659518`}, {
            6.983470993422164, 35.18450917332422}], 
           Offset[{-30.619499088362762`, 7.990946067659518}, {
            6.983470993422164, 35.18450917332422}], 
           Offset[{-3.526669073275675, 7.990946067659524}, {6.983470993422164,
             35.18450917332422}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{0.38050091163723887, 14.990946067659525}, \
{6.983470993422164, 35.18450917332422}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-0.41316530470788815`, 2.9714128678097964`}, {
             23.306209737518877`, 0.022139851856061935`}], 
            Offset[{3.126906854814801, 7.923767647492792}, {23.01652900657783,
              0.038148769603948196`}], 
            Offset[{24.170955278289533`, 7.923767647492796}, {
             23.01652900657783, 0.038148769603948196`}], 
            Offset[{24.170955278289533`, 21.923767647492795`}, {
             23.01652900657783, 0.038148769603948196`}], 
            Offset[{-31.829044721710467`, 21.923767647492785`}, {
             23.01652900657783, 0.038148769603948196`}], 
            Offset[{-31.829044721710467`, 7.923767647492784}, {
             23.01652900657783, 0.038148769603948196`}], 
            Offset[{-4.302671990800718, 7.92376764749279}, {23.01652900657783,
              0.038148769603948196`}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{-3.829044721710468, 14.92376764749279}, \
{23.01652900657783, 0.038148769603948196}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
        219.92023573369246`}}, {0., 34.964620882260206`}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.15898773828434704` + 0.004547103165217265 #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.15898773828434704` + 0.004547103165217265 #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{-0.19289207051202922`, 
          0.20287014113977597`}, {-7.456248735905293, 79.5798701450472}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {60., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"60\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {-5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         50., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         75., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         12.972597308890958`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.1\\\\\\\"\\\", Rule[ShowStringCharacters, False]], -0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {34.964620882260206`, 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {56.95664445562946, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
1\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {78.9486680289987, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
2\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.2`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {-4.621021549804439, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}, {-0.22261683513058728`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4.1757878795432575`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8.574192594217113, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         17.37100202356481, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.769406738238658`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.16781145291251, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.566216167586358`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         39.36302559693406, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         43.7614303116079, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48.159835026281755`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         52.5582397409556, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         61.3550491703033, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65.75345388497715, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70.151858599651, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         74.55026331432485, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {60., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"60\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {80., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"80\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         50., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         75., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {60., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {80., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         50., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         75., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 57.60546672344208}, {28.34375, 
     8.207440286993574}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-1.666666666666667, 81.66666666666667}, {-7.456248735905293, 
     79.5798701450472}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV0Hk4lAsDBfDRopJKcSUtxhbZGsyMMRPvme2d1GSpLJVrm0qXYRBXRbTd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            "]], LineBox[CompressedData["
1:eJwVknlUzYsWx3vGS0WmLC+aVUJpuK5U7jenM/7O+f1+p5/jIlMR0UBRaUDD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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwV0Hk4lAsDBfDRopJKcSUtxhbZGsyMMRPvme2d1GSpLJVrm0qXYRBXRbTd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                "]], 
               Line[CompressedData["
1:eJwVknlUzYsWx3vGS0WmLC+aVUJpuK5U7jenM/7O+f1+p5/jIlMR0UBRaUDD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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 80}, {-3.104442791857668, 
               72.53850021513432}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 80}, {-3.104442791857668, 72.53850021513432}},
             "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwV0Hk4lAsDBfDRopJKcSUtxhbZGsyMMRPvme2d1GSpLJVrm0qXYRBXRbTd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            "]], 
           Line[CompressedData["
1:eJwVknlUzYsWx3vGS0WmLC+aVUJpuK5U7jenM/7O+f1+p5/jIlMR0UBRaUDD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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 80}, {-3.104442791857668, 72.53850021513432}}, 
         "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 80}, {-3.104442791857668, 72.53850021513432}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVjHk01IsbhykRCiWSwtCOpE2leN/ZvqMuVxJtfoREWYZEi8melFCUJTGm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            "]], LineBox[CompressedData["
1:eJwVzGk8lAsbgHHRKhXl6HWU1ESiZCl7vTeS8szMMzyJ0KJsbSoRoUgk2WWG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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVjHk01IsbhykRCiWSwtCOpE2leN/ZvqMuVxJtfoREWYZEi8melFCUJTGm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                "]], 
               Line[CompressedData["
1:eJwVzGk8lAsbgHHRKhXl6HWU1ESiZCl7vTeS8szMMzyJ0KJsbSoRoUgk2WWG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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 80}, {-0.17310395992943897`, 
               0.17085230564400344`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 80}, {-0.17310395992943897`, 
              0.17085230564400344`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVjHk01IsbhykRCiWSwtCOpE2leN/ZvqMuVxJtfoREWYZEi8melFCUJTGm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            "]], 
           Line[CompressedData["
1:eJwVzGk8lAsbgHHRKhXl6HWU1ESiZCl7vTeS8szMMzyJ0KJsbSoRoUgk2WWG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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 80}, {-0.17310395992943897`, 
           0.17085230564400344`}}, 
         "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 80}, {-0.17310395992943897`, 0.17085230564400344`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVjXlczAkfx2tbRTxrdkvooZlIl0phk5Tvd67fqGdCmIS2Y3TRMR3IoySV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            "]], LineBox[CompressedData["
1:eJwVj3s4lIkfxUWlRCm2X1IikhKKahH1Tai8M+/MeNclSlE0RdqtdGHa0AWR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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVjXlczAkfx2tbRTxrdkvooZlIl0phk5Tvd67fqGdCmIS2Y3TRMR3IoySV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                "]], 
               Line[CompressedData["
1:eJwVj3s4lIkfxUWlRCm2X1IikhKKahH1Tai8M+/MeNclSlE0RdqtdGHa0AWR
XMKUri6RIjQk5DsumRmz5FJybck1rGLyy6Cs/eM85znP53nOc46Wx0l7T1kZ
GZmwGf3nDGF6wkMZAuDcwFZ1sgd9r1eaTM8i4OxqvueARQ8GBxrdHllBwE8v
1fYI+W60ftDWw9AkwPypwjHHri6ULwkzztImoHuMMfkIuzBiskt8fD0BIhcn
Nu9CF8af5f7s+pWAqgLHoT8ln/CJz6wjjfYEPJ1wfZg62Yk+4VnZmx0JqP4I
Xic/dqJhhuuPmH0EvAz08U8o7cTcvrx4xiECZt1OCpoM7cRij+Mi4QkCog7F
r+xW78Ra5wbDotCZvr7+4g5mB8acCwxQiyCAZI9o1Jl2oEO8gfDcTQLSfOcq
z9PqwJaGEPfN8QQEG79PC+v+G7tJi1uZyQQkOkfcf2H0N45bp0oflBCw0Pdl
hUJ7O3KKHlyuKCWgVFS1hv2yHWWM7yh9riDAdkXboHZMO8qvuqllLJ7Zn2qm
l7OnHZdKz++t+EDAlFe4+49XbWiSSbvd/5WA1nyB4d5nrZivvVtb6RsB/YZW
GmPhrWh+Z2fmpu8ExImjtg95t6JVyNZS/x8EuByvn1WwoRWZ7pqfFRVocCsp
cE1GTgv6/vLNdJM2DTryv1/RFzbjaPhwmYMuDbZJOFlqz5rRT/YzzX8dDbbo
5vKso5qR86X9ULkRDR4NzLcl9zVjuEgQ6mBBgztBSwqXDzdh+sXEpgsONMhd
plc1pdWEXT1W58tCaKDjo8yOzmpEqwc1SevDadA3mDVfLqERHzq7VMdE0sBV
sMcr9VIjuon/WH04jgbyjr7jF1iN2JL98C+5ZBqUvFC4Z//9PdYH/NS0KaHB
ApbbUjviPZYtLhQJvtHA7rVjx4TyO9QS23wzGqfBiOyJ3tCfDRh4pU6DO0kD
wy+n802HGnD79/7TbFk61Erjd00JGrCw7X8a85XpMG6732Z+UAPmpvmdstOn
Q8m8iaCv4/WYZLlJvdqdDkLLYHbLjzosIxUuTx6hQ7GzNH/6Sx1+Otg1sI5N
hxwJEOaf6lA7OK7wmi8drhT9ETxcWYcpldJ9EECHfTeqv9Oj6zCVUcZ9cYsO
DtFfDErX1WG6O7X0joAOfY+8In9j16Lw1IY/hVV0eFSvr1mzvxb7L8/p/X/1
zL7BkA9OrFrUe/wyj3pHh7z8uRsTzWvxyYC6g1InHcSlVwfblWox43R3bOAE
Heia9tyTvm8x86rf4qMGJEQMOS7u0KvBIYsDwVc3ktDY8LtE8EsNbvhmLUk2
mckbUyUC2RrM8FB932FGgvwNDndRezWm73jBdbElIW755diCmGpMkX5dRR4k
Yfsh1RxCthrvnPAx3BJNwg8rNWe3ETG26Pz2gLpFQkbRsmRphxjV2rYpn0og
ga+ouCq9VoxcuwWjWfdICH1+X3t7thjj1mbk6WX8x5e/sftdjFGdfRYryklQ
DawPr5JUYYjDYUJujASbuvbrsfJVmMRo2+85TsLogYigNeMiLN7r4CuYJKFT
x7tA1C/CUcvd0eGyDKDlij33VIlwv67+BxVlBoyFKu5VjxSh8fdRDx19Bliz
1E9OLRPhR26wv407AxSK+uZ0mwtRGjMZnnZkhvMrC68YCFH1xpl789kMUGUv
Wr9ZU4h7g7z41b4MaJ2UNJbMESLvmN1cRw4Dwt0M3gbWCfC6+ZIYrwQG+PbH
z0/2FuCWtkdPQqoZoOVgOSp8UonKhuzx57UMWKu+TKH9fiUOXTLc3dQw02+a
mDwZW4kp2kXdei0M+KfbaJXzn5Wo6v1uVVUvAzgeowkRVCVOcOSIuTJMKJBx
622cfoPNC7aW7lFjwqbg+CXRB98gd11iZjXBhPvWhlOfTSvwm8Q29TKdCaky
KUEXjSqQUTJ614zBBOMCf7GabgXOpewiUu2Z4Hg5NMBHpQL9ONLjF/cx4VZz
0dT54XK0f+ukZ3CUCfLc4t06j8tR0U81OSKYCXKMwwfOqpfjJf4NLvGKCSYT
brQm9TIcaOffkhYyoeNUQIKPahk6Tkqi0oqZwE5XGpurVIYbtrqEyfGZ4NzW
KqL/LMWmp7r+RZVMoMSvFbU7S9E4AV313zEhNHTxi560Uuw9MaKx4AsTIncq
PUk0K0W6ukNqlQ4LxkjbJh8fPnK7DfmuuixwluW1FnrxsTtzXuvQWhYUC0dr
Fd35yIFi5UX6LLjufT2w2IGPzzy1OdQmFljGDQXb7eCjQvaIfZslC45NN99d
qcJHgXWkzLAjC3LLfCYUAhB3+gpcF4exIE5lBWlgVoIPVnjo/DXGgi0xcv3n
aotQpzwtnnS1h7v2VgfoXa8wyqBsfX2JPZxp8Tr2j2UBeklm14nWU+Bmsijx
dGY+euSMaobdpMCbk/Xl1eE89AmmpuyiKTBSUEsh3fLQj+J9UIyloCv8zdJe
5zwMHfOLjIqnICQv1nAlmYdZZtLJhHsUNAith5+a5qG0dLrx8VMKXpKve/cu
zMOoesUbFQIKumkLBi8U8fBO8gn2NREFZvKD1zzyeZh8pmbXHjEFK8qdkug5
PMxfGjUhrqEg6msgUz+Nh20uKuyG9xQkuqg4zY7l4doutV2fuihwSF0QoO/N
w408f42UHgoE5et/3ebFQ/OrrVLPPgpOvrBxpLvzkLb2XvbnAQoyS67ln3fi
4SlvTY2REQpOHDV9O7iLhxyLIGmuhILXJganF+7g4VWlT+/OjFHQtO68j4k5
D7nPk8PHxynIz9nvfGUjD5MCZx8tnKDAYt/D3dn6PHzK8rTiTFGgQou8+lGX
h7zVlSu3/6Rg581LyotW87BEoiudnp75W1DTu3MlD/8FAnJnwg==
                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 80}, {-0.6657844612670729, 
               0.6571242524769363}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 80}, {-0.6657844612670729, 
              0.6571242524769363}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVjXlczAkfx2tbRTxrdkvooZlIl0phk5Tvd67fqGdCmIS2Y3TRMR3IoySV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            "]], 
           Line[CompressedData["
1:eJwVj3s4lIkfxUWlRCm2X1IikhKKahH1Tai8M+/MeNclSlE0RdqtdGHa0AWR
XMKUri6RIjQk5DsumRmz5FJybck1rGLyy6Cs/eM85znP53nOc46Wx0l7T1kZ
GZmwGf3nDGF6wkMZAuDcwFZ1sgd9r1eaTM8i4OxqvueARQ8GBxrdHllBwE8v
1fYI+W60ftDWw9AkwPypwjHHri6ULwkzztImoHuMMfkIuzBiskt8fD0BIhcn
Nu9CF8af5f7s+pWAqgLHoT8ln/CJz6wjjfYEPJ1wfZg62Yk+4VnZmx0JqP4I
Xic/dqJhhuuPmH0EvAz08U8o7cTcvrx4xiECZt1OCpoM7cRij+Mi4QkCog7F
r+xW78Ra5wbDotCZvr7+4g5mB8acCwxQiyCAZI9o1Jl2oEO8gfDcTQLSfOcq
z9PqwJaGEPfN8QQEG79PC+v+G7tJi1uZyQQkOkfcf2H0N45bp0oflBCw0Pdl
hUJ7O3KKHlyuKCWgVFS1hv2yHWWM7yh9riDAdkXboHZMO8qvuqllLJ7Zn2qm
l7OnHZdKz++t+EDAlFe4+49XbWiSSbvd/5WA1nyB4d5nrZivvVtb6RsB/YZW
GmPhrWh+Z2fmpu8ExImjtg95t6JVyNZS/x8EuByvn1WwoRWZ7pqfFRVocCsp
cE1GTgv6/vLNdJM2DTryv1/RFzbjaPhwmYMuDbZJOFlqz5rRT/YzzX8dDbbo
5vKso5qR86X9ULkRDR4NzLcl9zVjuEgQ6mBBgztBSwqXDzdh+sXEpgsONMhd
plc1pdWEXT1W58tCaKDjo8yOzmpEqwc1SevDadA3mDVfLqERHzq7VMdE0sBV
sMcr9VIjuon/WH04jgbyjr7jF1iN2JL98C+5ZBqUvFC4Z//9PdYH/NS0KaHB
ApbbUjviPZYtLhQJvtHA7rVjx4TyO9QS23wzGqfBiOyJ3tCfDRh4pU6DO0kD
wy+n802HGnD79/7TbFk61Erjd00JGrCw7X8a85XpMG6732Z+UAPmpvmdstOn
Q8m8iaCv4/WYZLlJvdqdDkLLYHbLjzosIxUuTx6hQ7GzNH/6Sx1+Otg1sI5N
hxwJEOaf6lA7OK7wmi8drhT9ETxcWYcpldJ9EECHfTeqv9Oj6zCVUcZ9cYsO
DtFfDErX1WG6O7X0joAOfY+8In9j16Lw1IY/hVV0eFSvr1mzvxb7L8/p/X/1
zL7BkA9OrFrUe/wyj3pHh7z8uRsTzWvxyYC6g1InHcSlVwfblWox43R3bOAE
Heia9tyTvm8x86rf4qMGJEQMOS7u0KvBIYsDwVc3ktDY8LtE8EsNbvhmLUk2
mckbUyUC2RrM8FB932FGgvwNDndRezWm73jBdbElIW755diCmGpMkX5dRR4k
Yfsh1RxCthrvnPAx3BJNwg8rNWe3ETG26Pz2gLpFQkbRsmRphxjV2rYpn0og
ga+ouCq9VoxcuwWjWfdICH1+X3t7thjj1mbk6WX8x5e/sftdjFGdfRYryklQ
DawPr5JUYYjDYUJujASbuvbrsfJVmMRo2+85TsLogYigNeMiLN7r4CuYJKFT
x7tA1C/CUcvd0eGyDKDlij33VIlwv67+BxVlBoyFKu5VjxSh8fdRDx19Bliz
1E9OLRPhR26wv407AxSK+uZ0mwtRGjMZnnZkhvMrC68YCFH1xpl789kMUGUv
Wr9ZU4h7g7z41b4MaJ2UNJbMESLvmN1cRw4Dwt0M3gbWCfC6+ZIYrwQG+PbH
z0/2FuCWtkdPQqoZoOVgOSp8UonKhuzx57UMWKu+TKH9fiUOXTLc3dQw02+a
mDwZW4kp2kXdei0M+KfbaJXzn5Wo6v1uVVUvAzgeowkRVCVOcOSIuTJMKJBx
622cfoPNC7aW7lFjwqbg+CXRB98gd11iZjXBhPvWhlOfTSvwm8Q29TKdCaky
KUEXjSqQUTJ614zBBOMCf7GabgXOpewiUu2Z4Hg5NMBHpQL9ONLjF/cx4VZz
0dT54XK0f+ukZ3CUCfLc4t06j8tR0U81OSKYCXKMwwfOqpfjJf4NLvGKCSYT
brQm9TIcaOffkhYyoeNUQIKPahk6Tkqi0oqZwE5XGpurVIYbtrqEyfGZ4NzW
KqL/LMWmp7r+RZVMoMSvFbU7S9E4AV313zEhNHTxi560Uuw9MaKx4AsTIncq
PUk0K0W6ukNqlQ4LxkjbJh8fPnK7DfmuuixwluW1FnrxsTtzXuvQWhYUC0dr
Fd35yIFi5UX6LLjufT2w2IGPzzy1OdQmFljGDQXb7eCjQvaIfZslC45NN99d
qcJHgXWkzLAjC3LLfCYUAhB3+gpcF4exIE5lBWlgVoIPVnjo/DXGgi0xcv3n
aotQpzwtnnS1h7v2VgfoXa8wyqBsfX2JPZxp8Tr2j2UBeklm14nWU+Bmsijx
dGY+euSMaobdpMCbk/Xl1eE89AmmpuyiKTBSUEsh3fLQj+J9UIyloCv8zdJe
5zwMHfOLjIqnICQv1nAlmYdZZtLJhHsUNAith5+a5qG0dLrx8VMKXpKve/cu
zMOoesUbFQIKumkLBi8U8fBO8gn2NREFZvKD1zzyeZh8pmbXHjEFK8qdkug5
PMxfGjUhrqEg6msgUz+Nh20uKuyG9xQkuqg4zY7l4doutV2fuihwSF0QoO/N
w408f42UHgoE5et/3ebFQ/OrrVLPPgpOvrBxpLvzkLb2XvbnAQoyS67ln3fi
4SlvTY2REQpOHDV9O7iLhxyLIGmuhILXJganF+7g4VWlT+/OjFHQtO68j4k5
D7nPk8PHxynIz9nvfGUjD5MCZx8tnKDAYt/D3dn6PHzK8rTiTFGgQou8+lGX
h7zVlSu3/6Rg581LyotW87BEoiudnp75W1DTu3MlD/8FAnJnwg==
            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 80}, {-0.6657844612670729, 0.6571242524769363}}, 
         "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 80}, {-0.6657844612670729, 0.6571242524769363}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.938182150765629*^9, 3.938182226206747*^9, {3.9381822677152348`*^9, 
   3.938182274588009*^9}, 3.938182321222664*^9, 3.938182425309828*^9, 
   3.9381831296004486`*^9, {3.938184718480194*^9, 3.938184724459114*^9}, 
   3.938189968047949*^9, 3.9381900699999313`*^9},
 CellLabel->
  "Out[579]=",ExpressionUUID->"22691d1b-de08-f447-889e-9f6dc1793257"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 40, 40 ", "Subsubsection",
 CellChangeTimes->{{3.938182345854248*^9, 3.938182389967308*^9}, {
  3.9381825415497932`*^9, 
  3.938182567923853*^9}},ExpressionUUID->"48da975d-1325-f644-a5b7-\
bbd5e55810fc"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "20", ",", "40", ",", "40", ",", "80", ",", "22"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "50"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.9381823479765244`*^9, 3.9381823543808823`*^9}, {
  3.9381824016034584`*^9, 3.9381824032886143`*^9}, {3.938182470138239*^9, 
  3.9381824704203415`*^9}, {3.9381825012994175`*^9, 3.9381825597797813`*^9}, {
  3.938182701261015*^9, 3.938182715603897*^9}},
 CellLabel->
  "In[572]:=",ExpressionUUID->"872ccae9-476c-fe4a-b3e6-95917e3298dd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwVz3s0lAkABXC1hbaUV4nmUFYWpy0jTPHNfPebwqeiSFsKWzRmJHkvdpUx
tSqPxqPVwyMqj6X1mDaWkjgeUZKhzslomS01Tm0txWgkO/vHPff8/rnn3DWB
4d68+RoaGh7q/N/m4tlrhaa1nMncoae7AijUa1ubhQnEpMDzWqOl2i3xVdet
BFfI8PaY/M/+FDpsI/magmryUDBrf7na99Ol9CS/mVxUxLo750ehy+lkw1t+
LylyX2hVdYBCd5YsUsEfJrmi4eRFvhS2NWl5vuK/J5ete+LauJtCj47jogX+
GgjNlNesoilwxS73ynZqQ3spo92MTYG3QaXD1NEFNzyR4WRHwcOaN77CzRDO
fp+TuJYUJAPHY7s2rcT5lMCEDyYUnPVtqhckMfBSr2lT6lIK/JnsgpJ9qyEp
7e5lzqcQ3vF6Y7WHOQh306AzU0Dqfs21s0ctsOyOh7BhDAjq/DmYKbCExe6E
svznQIuWsVeorxUi3RxbcvsApp4wdyzGBuLr2R0/tAEHP7DXeR5dh6Bi5SV5
PVBc2M5QZqyHryqnzKoCuHnOSSb1tsXwGwd7YT4Q08jeVbCDifeCzBcXxEBz
d8nE2QN2eEEszuUnAyFum5tC9m1E9ba4UVU0kF/OvBV6xB5P9ygCnHlA1oem
5Ig4B0jahUj7HnhVEfujIMoRRG1zWykNtLlmXxSJWFhukJJ3cDMwb+fg32Lh
JvA0DZ+P2QAaVN28ooTNSNIPW5HKAM4YKT2kp53QtN7CrmEJELE/qFV50hmM
l+nJwhkS8mT7w+SvBKQG41nZgyQMcy4Nni1m47C/3aN7DSRKdW0SOvM4yIqL
ENVeJtESZebybSWJce2aClE8icLVRQy2D9C111hluo9EU6JKQ/AY4PmFShUs
Emu2a33+Zi8FB+3mpccMSfzRa532bIBCtc0qF+kEB+kdX2xX+3NxcbSzX9rD
QU702JGDQ1xMyW70367gIHG56TJz3y3Q9ZPf6T3NwW/WC7tjRrbAJF38bM8h
DjQ/zjNuCdiKwBcsapDgoMy29kTh662o1/3l1O+GHFgHVnjOhrlgx1BGTPZb
NmTuDZI9b1zg/W5DbkYHG9JrP31HRrsiNfFGUmk+G9M3vQjzCVc4Fp4Qj8Sw
Mfdn1K2UY27wZ/rYcz3Y2G7r6pI46Qb5o3hVxho2Ov03hIRG09ieo7hgOE1A
P0hwuyCWxuWH52W+SgIBgmKdx3E0Tsbl6F2ZIjAVZSCxT6QhMxX5WE8SsDij
VM2eojEtVjmwJwgIJc3pmbk0XNdqBge+JeCktavmVgON8y3/hF8dIZCy5Ox8
xW0anCCVanSYQJ9eq4/JXRol763irdUWMOw/nWil0Vs+Stc8J3CBuZJLP6Bh
USvZ0jRI4OOBkf7BIRpv5rgFAwMEcMjYUmeYxnGTOncjtdOCveNJOQ37FDuF
bz8B88g2xvVRGq3m1MxffQS8Usp5Ye9omJmlJigeEchPk9df+ZeGVzSjzkZt
RabJ19IJGovrKl8e7VH/yUuvclTSiOhrNBp/QOBhUbtGyCcatedYjI1qG5V+
8c6boVH1VaV+bDeBwEpWSc+sev+qwUxdF4Gqmgjl3BwNoSz8yfR9Av8BL/Mn
cw==
           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVj3s0lHkcxocjk22l1C5qEiqMY8stFabv13V+Ckls99bS8KKLW9FmC0kJ
SdRmY2bemXlR9ihjJVtonHIr69puLuvSlkiXpSTamdb+8ZznfP75nOcxDjrs
J1BnsVjes/m/TbKUUqFh2cZvI17PedkphMq53OUHqSxwC5Eep7uEoIgvlZlT
Ihg0H5re8VgI9VZRoZrUDSgM+aDT+IcQGjM6yGRoLTRFXpEUdguhyeFU1avQ
Vkj1wyDBgBCas3ujRkIHwKPVZ8voSyFsqmb7DIe+hbuKherz1EXQom2vpbGX
hcuKzfC6nQhcstzvFW2Zi6SKaU/ZLwLBmhlta+0FaHNrTKDKEYE3VzD+NX8x
7mvOPGHcKAJ5149HmtbrY/9zo+Uh0yJw1LW4oXGSg32Z+uZ39cQQ+uliAbPD
CM90BlwQ24jhcP0L2xveJvgXn37I9hLDuV2aq5QHViLfD8ibUDEENxwPsaZM
cbxHf9w3WQwKtsHWiJ3mqG+5riApXwzWCxMvj8ZaoNb8lO5NVWIIfMez9Dlg
icyuxaeTusRACx9wpjJX4y/jK/oFE2IoP+/Q2+FnhTn9i4jpAhpif+P5FnhZ
I9eZx3WzpKG2mZlI222D77UDkyw30xDG31AdtsMWXerOVYdTNOQXW1dEhNvh
YIyxbvpZGrLfVSdFxq1FdoXOn2nFNAxfP3KUirbHW2PfabbU03Df4+KV5OR1
OFQqk+iO0KC2pedpVuJ6bKL2H8hlS4DlfEtNfGwDmg1rrn5mKoGzelPeHWcc
sHiyUrndUwKRu4Lrpk45YuyMoWAyTAJDSXb74ZITunqdme7IlMDinLyeNJqH
p721BrLLJFC4wOJYw9WNmKK11iSkUwKK6OXuZiWAGV3VjvRHCQiNxByeP2JA
XBpvZKkUqhNmWFQbomq+dpFyoxSMN7P/XbHdGfvPj7pJBFL4tZWb3t3ljMdr
S2x556SQUa+yMtrrgrnzlpmlyaWQEzMaHtjngs/67TiKJ1JI+MpQx2SnK0qL
Tvo3q6RwjTunOXbQFTu3ecbLzWWg+V7NQLHPDV8vXdt+yFcGRVZlJ4Qv3LAo
yjrXKkEG3KDrPsqD7qg0UNMbKJJBr2eVPGDMHVWK+/X8dhl0SH/4BmI80IIt
8h9TyeBj+VYnkwkPzKXyjXgWDHy+HV2ReoiPrp56bcEBDGy28nBPmORj/yVL
kTKFgYa9a8IiYgi2HFUv48oZ0A2m7hQcIbgzr2bR5Czvo2jttjiCgYmBp++V
M/AhepHcLoGg3HzPpe0VDKw8OzWjTCGY3BBIpd5mIFFem3HhMsFcW52+4RoG
HNi+NyuqCDqaZs4pf8hA6pdp6iN3CNInbUjiIwbaF9b5L6khaBA/kefdwgDF
sZs+UUfw8Xhj+MjvDPxkre9CHhJ826BSGHYw8H73YGdPH0FhvQY5/4QB/N7A
VHuAYPZNzo97uhlID/GLh6FZv0a4wqKHAZOo+xzZc4LNhSVxDb0MbE0tFhx8
Q7CONfOz2gAD+elDlaJ/CDpRrzzbZnnkwpIvOiYI2lcazxUNzv65mlFqPzW7
r3W33OkpA4/ED1hh0wTJTLBw3t8M6BWq/K5+IljQXpHXM8tBJeuYFiXBl5rb
ZNeeMVB6M3Lq82eCq7x4NfHPGfgPX4hDcw==
            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
       0., 470.0854700854692}}, {0., 14.633000032389855`}}], {
      GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{-1.389751625396775, -2.6586820832335376`}, {
            4.494496618101298, 34.34978006523477}], 
           Offset[{-5.389325534817676, -7.089818888622765}, {
            3.7603306291111482`, 34.05097261556497}], 
           Offset[{-38.64058515865392, -7.089818888622773}, {
            3.7603306291111482`, 34.05097261556497}], 
           Offset[{-38.64058515865392, -21.089818888622773`}, {
            3.7603306291111482`, 34.05097261556497}], 
           Offset[{23.35941484134608, -21.08981888862276}, {
            3.7603306291111482`, 34.05097261556497}], 
           Offset[{23.35941484134608, -7.089818888622759}, {
            3.7603306291111482`, 34.05097261556497}], 
           Offset[{1.6517770722975769`, -7.089818888622764}, {
            3.7603306291111482`, 34.05097261556497}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{-7.640585158653918, -14.089818888622766}, \
{3.7603306291111482, 34.05097261556497}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-1.5376460891619637`, 2.5759744766757526`}, {
             24.649682068920587`, 0.03525029323327207}], 
            Offset[{1.4308885415224162`, 6.869265271135342}, {
             23.76033062911115, 0.03592458785156058}], 
            Offset[{20.348280839493967`, 6.869265271135347}, {
             23.76033062911115, 0.03592458785156058}], 
            Offset[{20.348280839493967`, 20.869265271135347`}, {
             23.76033062911115, 0.03592458785156058}], 
            Offset[{-35.65171916050603, 20.869265271135333`}, {
             23.76033062911115, 0.03592458785156058}], 
            Offset[{-35.65171916050603, 6.869265271135334}, {
             23.76033062911115, 0.03592458785156058}], 
            Offset[{-5.49966265137012, 6.869265271135341}, {23.76033062911115,
              0.03592458785156058}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{-7.651719160506034, 13.86926527113534}, \
{23.76033062911115, 0.03592458785156058}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
        470.0854700854692}}, {0., 14.633000032389855`}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 28.785046901520737`},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.031128381887083924` + 
             0.0021272727272727316` #2}], {{Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.031128381887083924` + 0.0021272727272727316` #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{0.029376859462737697`, 0.04394493700373244}, {
          28.44263482256567, 35.29087640166575}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{29., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"29\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {31., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"31\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {32., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"32\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {33., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"33\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {34., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"34\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {35., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"35\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {28.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         28.735564134953925`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0300\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.03`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {29.910777810167595`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0325\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.0325`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {31.08599148538127, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0350\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.035`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {32.26120516059494, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0375\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.0375`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {33.43641883580862, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0400\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.04`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {34.611632511022286`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
0425\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.0425`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 4]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {28.500521399911186`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.970606869996658`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.20564960503939, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.44069234008213, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.675735075124862`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.145820545210334`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.380863280253067`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.6159060152958, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.85094875033854, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.321034220424004`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.556076955466736`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.79111969050947, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.02616242555221, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.49624789563767, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.73129063068041, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.966333365723145`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.20137610076588, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.67146157085135, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.90650430589408, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.14154704093682, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.376589775979554`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.84667524606502, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35.08171798110776, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 56.04882609844208}, {
     28.343750000000227`, 1.}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-1.0416666666666667`, 51.041666666666664`}, {
     28.44263482256567, 35.29087640166575}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVz3s0lAkABXC1hbaUV4nmUFYWpy0jTPHNfPebwqeiSFsKWzRmJHkvdpUx
tSqPxqPVwyMqj6X1mDaWkjgeUZKhzslomS01Tm0txWgkO/vHPff8/rnn3DWB
4d68+RoaGh7q/N/m4tlrhaa1nMncoae7AijUa1ubhQnEpMDzWqOl2i3xVdet
BFfI8PaY/M/+FDpsI/magmryUDBrf7na99Ol9CS/mVxUxLo750ehy+lkw1t+
LylyX2hVdYBCd5YsUsEfJrmi4eRFvhS2NWl5vuK/J5ete+LauJtCj47jogX+
GgjNlNesoilwxS73ynZqQ3spo92MTYG3QaXD1NEFNzyR4WRHwcOaN77CzRDO
fp+TuJYUJAPHY7s2rcT5lMCEDyYUnPVtqhckMfBSr2lT6lIK/JnsgpJ9qyEp
7e5lzqcQ3vF6Y7WHOQh306AzU0Dqfs21s0ctsOyOh7BhDAjq/DmYKbCExe6E
svznQIuWsVeorxUi3RxbcvsApp4wdyzGBuLr2R0/tAEHP7DXeR5dh6Bi5SV5
PVBc2M5QZqyHryqnzKoCuHnOSSb1tsXwGwd7YT4Q08jeVbCDifeCzBcXxEBz
d8nE2QN2eEEszuUnAyFum5tC9m1E9ba4UVU0kF/OvBV6xB5P9ygCnHlA1oem
5Ig4B0jahUj7HnhVEfujIMoRRG1zWykNtLlmXxSJWFhukJJ3cDMwb+fg32Lh
JvA0DZ+P2QAaVN28ooTNSNIPW5HKAM4YKT2kp53QtN7CrmEJELE/qFV50hmM
l+nJwhkS8mT7w+SvBKQG41nZgyQMcy4Nni1m47C/3aN7DSRKdW0SOvM4yIqL
ENVeJtESZebybSWJce2aClE8icLVRQy2D9C111hluo9EU6JKQ/AY4PmFShUs
Emu2a33+Zi8FB+3mpccMSfzRa532bIBCtc0qF+kEB+kdX2xX+3NxcbSzX9rD
QU702JGDQ1xMyW70367gIHG56TJz3y3Q9ZPf6T3NwW/WC7tjRrbAJF38bM8h
DjQ/zjNuCdiKwBcsapDgoMy29kTh662o1/3l1O+GHFgHVnjOhrlgx1BGTPZb
NmTuDZI9b1zg/W5DbkYHG9JrP31HRrsiNfFGUmk+G9M3vQjzCVc4Fp4Qj8Sw
Mfdn1K2UY27wZ/rYcz3Y2G7r6pI46Qb5o3hVxho2Ov03hIRG09ieo7hgOE1A
P0hwuyCWxuWH52W+SgIBgmKdx3E0Tsbl6F2ZIjAVZSCxT6QhMxX5WE8SsDij
VM2eojEtVjmwJwgIJc3pmbk0XNdqBge+JeCktavmVgON8y3/hF8dIZCy5Ox8
xW0anCCVanSYQJ9eq4/JXRol763irdUWMOw/nWil0Vs+Stc8J3CBuZJLP6Bh
USvZ0jRI4OOBkf7BIRpv5rgFAwMEcMjYUmeYxnGTOncjtdOCveNJOQ37FDuF
bz8B88g2xvVRGq3m1MxffQS8Usp5Ye9omJmlJigeEchPk9df+ZeGVzSjzkZt
RabJ19IJGovrKl8e7VH/yUuvclTSiOhrNBp/QOBhUbtGyCcatedYjI1qG5V+
8c6boVH1VaV+bDeBwEpWSc+sev+qwUxdF4Gqmgjl3BwNoSz8yfR9Av8BL/Mn
cw==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVz3s0lAkABXC1hbaUV4nmUFYWpy0jTPHNfPebwqeiSFsKWzRmJHkvdpUx
tSqPxqPVwyMqj6X1mDaWkjgeUZKhzslomS01Tm0txWgkO/vHPff8/rnn3DWB
4d68+RoaGh7q/N/m4tlrhaa1nMncoae7AijUa1ubhQnEpMDzWqOl2i3xVdet
BFfI8PaY/M/+FDpsI/magmryUDBrf7na99Ol9CS/mVxUxLo750ehy+lkw1t+
LylyX2hVdYBCd5YsUsEfJrmi4eRFvhS2NWl5vuK/J5ete+LauJtCj47jogX+
GgjNlNesoilwxS73ynZqQ3spo92MTYG3QaXD1NEFNzyR4WRHwcOaN77CzRDO
fp+TuJYUJAPHY7s2rcT5lMCEDyYUnPVtqhckMfBSr2lT6lIK/JnsgpJ9qyEp
7e5lzqcQ3vF6Y7WHOQh306AzU0Dqfs21s0ctsOyOh7BhDAjq/DmYKbCExe6E
svznQIuWsVeorxUi3RxbcvsApp4wdyzGBuLr2R0/tAEHP7DXeR5dh6Bi5SV5
PVBc2M5QZqyHryqnzKoCuHnOSSb1tsXwGwd7YT4Q08jeVbCDifeCzBcXxEBz
d8nE2QN2eEEszuUnAyFum5tC9m1E9ba4UVU0kF/OvBV6xB5P9ygCnHlA1oem
5Ig4B0jahUj7HnhVEfujIMoRRG1zWykNtLlmXxSJWFhukJJ3cDMwb+fg32Lh
JvA0DZ+P2QAaVN28ooTNSNIPW5HKAM4YKT2kp53QtN7CrmEJELE/qFV50hmM
l+nJwhkS8mT7w+SvBKQG41nZgyQMcy4Nni1m47C/3aN7DSRKdW0SOvM4yIqL
ENVeJtESZebybSWJce2aClE8icLVRQy2D9C111hluo9EU6JKQ/AY4PmFShUs
Emu2a33+Zi8FB+3mpccMSfzRa532bIBCtc0qF+kEB+kdX2xX+3NxcbSzX9rD
QU702JGDQ1xMyW70367gIHG56TJz3y3Q9ZPf6T3NwW/WC7tjRrbAJF38bM8h
DjQ/zjNuCdiKwBcsapDgoMy29kTh662o1/3l1O+GHFgHVnjOhrlgx1BGTPZb
NmTuDZI9b1zg/W5DbkYHG9JrP31HRrsiNfFGUmk+G9M3vQjzCVc4Fp4Qj8Sw
Mfdn1K2UY27wZ/rYcz3Y2G7r6pI46Qb5o3hVxho2Ov03hIRG09ieo7hgOE1A
P0hwuyCWxuWH52W+SgIBgmKdx3E0Tsbl6F2ZIjAVZSCxT6QhMxX5WE8SsDij
VM2eojEtVjmwJwgIJc3pmbk0XNdqBge+JeCktavmVgON8y3/hF8dIZCy5Ox8
xW0anCCVanSYQJ9eq4/JXRol763irdUWMOw/nWil0Vs+Stc8J3CBuZJLP6Bh
USvZ0jRI4OOBkf7BIRpv5rgFAwMEcMjYUmeYxnGTOncjtdOCveNJOQ37FDuF
bz8B88g2xvVRGq3m1MxffQS8Usp5Ye9omJmlJigeEchPk9df+ZeGVzSjzkZt
RabJ19IJGovrKl8e7VH/yUuvclTSiOhrNBp/QOBhUbtGyCcatedYjI1qG5V+
8c6boVH1VaV+bDeBwEpWSc+sev+qwUxdF4Gqmgjl3BwNoSz8yfR9Av8BL/Mn
cw==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {28.785046901520673`, 
               34.736842019758036`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 28.785046901520737`}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {28.785046901520673`, 
              34.736842019758036`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 28.785046901520737`}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVz3s0lAkABXC1hbaUV4nmUFYWpy0jTPHNfPebwqeiSFsKWzRmJHkvdpUx
tSqPxqPVwyMqj6X1mDaWkjgeUZKhzslomS01Tm0txWgkO/vHPff8/rnn3DWB
4d68+RoaGh7q/N/m4tlrhaa1nMncoae7AijUa1ubhQnEpMDzWqOl2i3xVdet
BFfI8PaY/M/+FDpsI/magmryUDBrf7na99Ol9CS/mVxUxLo750ehy+lkw1t+
LylyX2hVdYBCd5YsUsEfJrmi4eRFvhS2NWl5vuK/J5ete+LauJtCj47jogX+
GgjNlNesoilwxS73ynZqQ3spo92MTYG3QaXD1NEFNzyR4WRHwcOaN77CzRDO
fp+TuJYUJAPHY7s2rcT5lMCEDyYUnPVtqhckMfBSr2lT6lIK/JnsgpJ9qyEp
7e5lzqcQ3vF6Y7WHOQh306AzU0Dqfs21s0ctsOyOh7BhDAjq/DmYKbCExe6E
svznQIuWsVeorxUi3RxbcvsApp4wdyzGBuLr2R0/tAEHP7DXeR5dh6Bi5SV5
PVBc2M5QZqyHryqnzKoCuHnOSSb1tsXwGwd7YT4Q08jeVbCDifeCzBcXxEBz
d8nE2QN2eEEszuUnAyFum5tC9m1E9ba4UVU0kF/OvBV6xB5P9ygCnHlA1oem
5Ig4B0jahUj7HnhVEfujIMoRRG1zWykNtLlmXxSJWFhukJJ3cDMwb+fg32Lh
JvA0DZ+P2QAaVN28ooTNSNIPW5HKAM4YKT2kp53QtN7CrmEJELE/qFV50hmM
l+nJwhkS8mT7w+SvBKQG41nZgyQMcy4Nni1m47C/3aN7DSRKdW0SOvM4yIqL
ENVeJtESZebybSWJce2aClE8icLVRQy2D9C111hluo9EU6JKQ/AY4PmFShUs
Emu2a33+Zi8FB+3mpccMSfzRa532bIBCtc0qF+kEB+kdX2xX+3NxcbSzX9rD
QU702JGDQ1xMyW70367gIHG56TJz3y3Q9ZPf6T3NwW/WC7tjRrbAJF38bM8h
DjQ/zjNuCdiKwBcsapDgoMy29kTh662o1/3l1O+GHFgHVnjOhrlgx1BGTPZb
NmTuDZI9b1zg/W5DbkYHG9JrP31HRrsiNfFGUmk+G9M3vQjzCVc4Fp4Qj8Sw
Mfdn1K2UY27wZ/rYcz3Y2G7r6pI46Qb5o3hVxho2Ov03hIRG09ieo7hgOE1A
P0hwuyCWxuWH52W+SgIBgmKdx3E0Tsbl6F2ZIjAVZSCxT6QhMxX5WE8SsDij
VM2eojEtVjmwJwgIJc3pmbk0XNdqBge+JeCktavmVgON8y3/hF8dIZCy5Ox8
xW0anCCVanSYQJ9eq4/JXRol763irdUWMOw/nWil0Vs+Stc8J3CBuZJLP6Bh
USvZ0jRI4OOBkf7BIRpv5rgFAwMEcMjYUmeYxnGTOncjtdOCveNJOQ37FDuF
bz8B88g2xvVRGq3m1MxffQS8Usp5Ye9omJmlJigeEchPk9df+ZeGVzSjzkZt
RabJ19IJGovrKl8e7VH/yUuvclTSiOhrNBp/QOBhUbtGyCcatedYjI1qG5V+
8c6boVH1VaV+bDeBwEpWSc+sev+qwUxdF4Gqmgjl3BwNoSz8yfR9Av8BL/Mn
cw==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {28.785046901520673`, 34.736842019758036`}},
          "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 28.785046901520737`}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 28.785046901520737`},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 50}, {28.785046901520673`, 34.736842019758036`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVj3s0lHkcxocjk22l1C5qEiqMY8stFabv13V+Ckls99bS8KKLW9FmC0kJ
SdRmY2bemXlR9ihjJVtonHIr69puLuvSlkiXpSTamdb+8ZznfP75nOcxDjrs
J1BnsVjes/m/TbKUUqFh2cZvI17PedkphMq53OUHqSxwC5Eep7uEoIgvlZlT
Ihg0H5re8VgI9VZRoZrUDSgM+aDT+IcQGjM6yGRoLTRFXpEUdguhyeFU1avQ
Vkj1wyDBgBCas3ujRkIHwKPVZ8voSyFsqmb7DIe+hbuKherz1EXQom2vpbGX
hcuKzfC6nQhcstzvFW2Zi6SKaU/ZLwLBmhlta+0FaHNrTKDKEYE3VzD+NX8x
7mvOPGHcKAJ5149HmtbrY/9zo+Uh0yJw1LW4oXGSg32Z+uZ39cQQ+uliAbPD
CM90BlwQ24jhcP0L2xveJvgXn37I9hLDuV2aq5QHViLfD8ibUDEENxwPsaZM
cbxHf9w3WQwKtsHWiJ3mqG+5riApXwzWCxMvj8ZaoNb8lO5NVWIIfMez9Dlg
icyuxaeTusRACx9wpjJX4y/jK/oFE2IoP+/Q2+FnhTn9i4jpAhpif+P5FnhZ
I9eZx3WzpKG2mZlI222D77UDkyw30xDG31AdtsMWXerOVYdTNOQXW1dEhNvh
YIyxbvpZGrLfVSdFxq1FdoXOn2nFNAxfP3KUirbHW2PfabbU03Df4+KV5OR1
OFQqk+iO0KC2pedpVuJ6bKL2H8hlS4DlfEtNfGwDmg1rrn5mKoGzelPeHWcc
sHiyUrndUwKRu4Lrpk45YuyMoWAyTAJDSXb74ZITunqdme7IlMDinLyeNJqH
p721BrLLJFC4wOJYw9WNmKK11iSkUwKK6OXuZiWAGV3VjvRHCQiNxByeP2JA
XBpvZKkUqhNmWFQbomq+dpFyoxSMN7P/XbHdGfvPj7pJBFL4tZWb3t3ljMdr
S2x556SQUa+yMtrrgrnzlpmlyaWQEzMaHtjngs/67TiKJ1JI+MpQx2SnK0qL
Tvo3q6RwjTunOXbQFTu3ecbLzWWg+V7NQLHPDV8vXdt+yFcGRVZlJ4Qv3LAo
yjrXKkEG3KDrPsqD7qg0UNMbKJJBr2eVPGDMHVWK+/X8dhl0SH/4BmI80IIt
8h9TyeBj+VYnkwkPzKXyjXgWDHy+HV2ReoiPrp56bcEBDGy28nBPmORj/yVL
kTKFgYa9a8IiYgi2HFUv48oZ0A2m7hQcIbgzr2bR5Czvo2jttjiCgYmBp++V
M/AhepHcLoGg3HzPpe0VDKw8OzWjTCGY3BBIpd5mIFFem3HhMsFcW52+4RoG
HNi+NyuqCDqaZs4pf8hA6pdp6iN3CNInbUjiIwbaF9b5L6khaBA/kefdwgDF
sZs+UUfw8Xhj+MjvDPxkre9CHhJ826BSGHYw8H73YGdPH0FhvQY5/4QB/N7A
VHuAYPZNzo97uhlID/GLh6FZv0a4wqKHAZOo+xzZc4LNhSVxDb0MbE0tFhx8
Q7CONfOz2gAD+elDlaJ/CDpRrzzbZnnkwpIvOiYI2lcazxUNzv65mlFqPzW7
r3W33OkpA4/ED1hh0wTJTLBw3t8M6BWq/K5+IljQXpHXM8tBJeuYFiXBl5rb
ZNeeMVB6M3Lq82eCq7x4NfHPGfgPX4hDcw==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVj3s0lHkcxocjk22l1C5qEiqMY8stFabv13V+Ckls99bS8KKLW9FmC0kJ
SdRmY2bemXlR9ihjJVtonHIr69puLuvSlkiXpSTamdb+8ZznfP75nOcxDjrs
J1BnsVjes/m/TbKUUqFh2cZvI17PedkphMq53OUHqSxwC5Eep7uEoIgvlZlT
Ihg0H5re8VgI9VZRoZrUDSgM+aDT+IcQGjM6yGRoLTRFXpEUdguhyeFU1avQ
Vkj1wyDBgBCas3ujRkIHwKPVZ8voSyFsqmb7DIe+hbuKherz1EXQom2vpbGX
hcuKzfC6nQhcstzvFW2Zi6SKaU/ZLwLBmhlta+0FaHNrTKDKEYE3VzD+NX8x
7mvOPGHcKAJ5149HmtbrY/9zo+Uh0yJw1LW4oXGSg32Z+uZ39cQQ+uliAbPD
CM90BlwQ24jhcP0L2xveJvgXn37I9hLDuV2aq5QHViLfD8ibUDEENxwPsaZM
cbxHf9w3WQwKtsHWiJ3mqG+5riApXwzWCxMvj8ZaoNb8lO5NVWIIfMez9Dlg
icyuxaeTusRACx9wpjJX4y/jK/oFE2IoP+/Q2+FnhTn9i4jpAhpif+P5FnhZ
I9eZx3WzpKG2mZlI222D77UDkyw30xDG31AdtsMWXerOVYdTNOQXW1dEhNvh
YIyxbvpZGrLfVSdFxq1FdoXOn2nFNAxfP3KUirbHW2PfabbU03Df4+KV5OR1
OFQqk+iO0KC2pedpVuJ6bKL2H8hlS4DlfEtNfGwDmg1rrn5mKoGzelPeHWcc
sHiyUrndUwKRu4Lrpk45YuyMoWAyTAJDSXb74ZITunqdme7IlMDinLyeNJqH
p721BrLLJFC4wOJYw9WNmKK11iSkUwKK6OXuZiWAGV3VjvRHCQiNxByeP2JA
XBpvZKkUqhNmWFQbomq+dpFyoxSMN7P/XbHdGfvPj7pJBFL4tZWb3t3ljMdr
S2x556SQUa+yMtrrgrnzlpmlyaWQEzMaHtjngs/67TiKJ1JI+MpQx2SnK0qL
Tvo3q6RwjTunOXbQFTu3ecbLzWWg+V7NQLHPDV8vXdt+yFcGRVZlJ4Qv3LAo
yjrXKkEG3KDrPsqD7qg0UNMbKJJBr2eVPGDMHVWK+/X8dhl0SH/4BmI80IIt
8h9TyeBj+VYnkwkPzKXyjXgWDHy+HV2ReoiPrp56bcEBDGy28nBPmORj/yVL
kTKFgYa9a8IiYgi2HFUv48oZ0A2m7hQcIbgzr2bR5Czvo2jttjiCgYmBp++V
M/AhepHcLoGg3HzPpe0VDKw8OzWjTCGY3BBIpd5mIFFem3HhMsFcW52+4RoG
HNi+NyuqCDqaZs4pf8hA6pdp6iN3CNInbUjiIwbaF9b5L6khaBA/kefdwgDF
sZs+UUfw8Xhj+MjvDPxkre9CHhJ826BSGHYw8H73YGdPH0FhvQY5/4QB/N7A
VHuAYPZNzo97uhlID/GLh6FZv0a4wqKHAZOo+xzZc4LNhSVxDb0MbE0tFhx8
Q7CONfOz2gAD+elDlaJ/CDpRrzzbZnnkwpIvOiYI2lcazxUNzv65mlFqPzW7
r3W33OkpA4/ED1hh0wTJTLBw3t8M6BWq/K5+IljQXpHXM8tBJeuYFiXBl5rb
ZNeeMVB6M3Lq82eCq7x4NfHPGfgPX4hDcw==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.030105263339787434`, 
               0.04276635477312877}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.0301052633397875}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.030105263339787434`, 
              0.04276635477312877}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.0301052633397875}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVj3s0lHkcxocjk22l1C5qEiqMY8stFabv13V+Ckls99bS8KKLW9FmC0kJ
SdRmY2bemXlR9ihjJVtonHIr69puLuvSlkiXpSTamdb+8ZznfP75nOcxDjrs
J1BnsVjes/m/TbKUUqFh2cZvI17PedkphMq53OUHqSxwC5Eep7uEoIgvlZlT
Ihg0H5re8VgI9VZRoZrUDSgM+aDT+IcQGjM6yGRoLTRFXpEUdguhyeFU1avQ
Vkj1wyDBgBCas3ujRkIHwKPVZ8voSyFsqmb7DIe+hbuKherz1EXQom2vpbGX
hcuKzfC6nQhcstzvFW2Zi6SKaU/ZLwLBmhlta+0FaHNrTKDKEYE3VzD+NX8x
7mvOPGHcKAJ5149HmtbrY/9zo+Uh0yJw1LW4oXGSg32Z+uZ39cQQ+uliAbPD
CM90BlwQ24jhcP0L2xveJvgXn37I9hLDuV2aq5QHViLfD8ibUDEENxwPsaZM
cbxHf9w3WQwKtsHWiJ3mqG+5riApXwzWCxMvj8ZaoNb8lO5NVWIIfMez9Dlg
icyuxaeTusRACx9wpjJX4y/jK/oFE2IoP+/Q2+FnhTn9i4jpAhpif+P5FnhZ
I9eZx3WzpKG2mZlI222D77UDkyw30xDG31AdtsMWXerOVYdTNOQXW1dEhNvh
YIyxbvpZGrLfVSdFxq1FdoXOn2nFNAxfP3KUirbHW2PfabbU03Df4+KV5OR1
OFQqk+iO0KC2pedpVuJ6bKL2H8hlS4DlfEtNfGwDmg1rrn5mKoGzelPeHWcc
sHiyUrndUwKRu4Lrpk45YuyMoWAyTAJDSXb74ZITunqdme7IlMDinLyeNJqH
p721BrLLJFC4wOJYw9WNmKK11iSkUwKK6OXuZiWAGV3VjvRHCQiNxByeP2JA
XBpvZKkUqhNmWFQbomq+dpFyoxSMN7P/XbHdGfvPj7pJBFL4tZWb3t3ljMdr
S2x556SQUa+yMtrrgrnzlpmlyaWQEzMaHtjngs/67TiKJ1JI+MpQx2SnK0qL
Tvo3q6RwjTunOXbQFTu3ecbLzWWg+V7NQLHPDV8vXdt+yFcGRVZlJ4Qv3LAo
yjrXKkEG3KDrPsqD7qg0UNMbKJJBr2eVPGDMHVWK+/X8dhl0SH/4BmI80IIt
8h9TyeBj+VYnkwkPzKXyjXgWDHy+HV2ReoiPrp56bcEBDGy28nBPmORj/yVL
kTKFgYa9a8IiYgi2HFUv48oZ0A2m7hQcIbgzr2bR5Czvo2jttjiCgYmBp++V
M/AhepHcLoGg3HzPpe0VDKw8OzWjTCGY3BBIpd5mIFFem3HhMsFcW52+4RoG
HNi+NyuqCDqaZs4pf8hA6pdp6iN3CNInbUjiIwbaF9b5L6khaBA/kefdwgDF
sZs+UUfw8Xhj+MjvDPxkre9CHhJ826BSGHYw8H73YGdPH0FhvQY5/4QB/N7A
VHuAYPZNzo97uhlID/GLh6FZv0a4wqKHAZOo+xzZc4LNhSVxDb0MbE0tFhx8
Q7CONfOz2gAD+elDlaJ/CDpRrzzbZnnkwpIvOiYI2lcazxUNzv65mlFqPzW7
r3W33OkpA4/ED1hh0wTJTLBw3t8M6BWq/K5+IljQXpHXM8tBJeuYFiXBl5rb
ZNeeMVB6M3Lq82eCq7x4NfHPGfgPX4hDcw==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.030105263339787434`, 
           0.04276635477312877}}, "Frame" -> {{False, False}, {False, False}},
          "AxesOrigin" -> {0, 0.0301052633397875}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.0301052633397875},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.030105263339787434`, 0.04276635477312877}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVzXk41Akcx/HRTo5KYVmUiqEpcswUCun7JcOvRGV1qNUWaca17u2ilHbK
sY48UY8jnowjz1IjtXjm+M38fom0ZO1mo0SrZKst0eQYrf3j87yf118fi5CY
gLB5DAbDb27/l5Wjvl664tbmwsUN8w9XSOCutvXKaEEO2EXpROuLJEAer6tY
I7gGxfn5/eSc73Hi+JqCejDK4PWwqiRwP6ubmODL4JflHPZwjQTaXNOa3vA7
IWhHWWBkvQTa8/riRvgDoLT+OJDSLIFtEi3/l/x/YdJP0dXSJYGHus46zGAG
iizYZQINKXjm8ORVO7Rx9boaZpSDFMIcpnS5uno4nvKGbRAsBT/rsA/f+Bhi
dcrs8PocKYh7UpLaNpqg3bcNUflSKbgZ2NQzz5jhoG+ES96YFPjTl0pE+8zR
OE3rOMGWQcy9V+vr/Vi40HC6jrVXBhn7NVepo6ywnrF2U3uWDEJbTx3lCtj4
KVxbdUEmA1LLdFdk0BocyOnIHf4gA65+asHrRBvUrjUoKDOUw6GP7rb+UbYo
Hm/2f2Avh/JS2kz1sz2uuntld7qvHBqyXfu6Azho08HutBLIIbHZfWfJdi6m
EkO9dmlykLWLxtIPrEOH7/qfDZfJIdzHRRK+bz2uHeLbMiVyKK7mNkZGOKL2
/c/2I31yyPsoORt7zAnrNAPf1E7J4eWNpB8F8c7owKi1pI1JoLwvXTl3bgO6
vnBjKzeQoLHjyVBO6kacMZq9s3gPCQyPOxplJ1xwtNHD1iaRhIvGKr/uC644
1dys2HaZhNj9oQpVmhvGtJVoV90mYfCs4xG4vAn5zNYTlo9JMMy/+iS93B2p
U+yIc5MkVOrZnGgt2oyPixcW6ixVABm/kre6FlCoeLXsT3cFlJqXmbkHIj6y
Y9Lk9wqQJE8xBF2IW0xspClnFWDhqzVjudcDZwY7BkSVCrjdaZ35V48HtuiN
hvS2KSDr3izHPNgTz4tH8wrfKyA/4XXEoX5PbFBXb9xrpIRkoxVLWEFbsDKt
7d1rFyXUWM9vT3y+BWdU1QlOIUrQHNcwJQ964ZoLRtkRF5VQxbl1uvSVF94w
fHgyRawE65Ab/upoHvr+9OLvlH4l9G1tEu/+h4eJZ2r6/ZkUdF8/aQcJ3vhC
GLeIy6Hgc8OuTawxb8w+UrCzN4iCL7/GNwp/8MGetw3me9Io8OV485InfND+
QQwuu0VBa7BDeGQCgQyyJiujnwKDUEFLSRKBwt96zPyfUnBQUK7bdYzAwg8B
LfrPKPgU/7XYMZnAWsrf8uoABVYXVVPq8wT+IYu9Vj1EQapYlpVbQOBUr2xr
+wgFrlo7bzY2EbjdUxRnMkGBcFH6vJEWAivAq/PpnB/pKwKXSglstAp3u/6J
AoGZ4+RpBYGjS3zB/jMFhVwTT+IBgfeDiye8pikYP/D89yf9BFo4PV2epEED
HjZl6w4QaFRQdMRtHg2ZRwOOwyCB6vLJJo2vaGDFUWYVwwTqORblZjNp2CWs
Dot+R6BXafnbai0aijMH7157T+CsOKMmRpuGkdylC7rHCHSPNE901qEhtSir
zlk19+ezz4laQENHGc0InySwpVa9NnMhDcaVswFF0wT2Oe3hBiyiIaR2g+ih
mkCRMJRnqktD3c1Y1ZcvBB6E1YLnc/4PS3lE4g==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVzXk41Akcx/HRTo5KYVmUiqEpcswUCun7JcOvRGV1qNUWaca17u2ilHbK
sY48UY8jnowjz1IjtXjm+M38fom0ZO1mo0SrZKst0eQYrf3j87yf118fi5CY
gLB5DAbDb27/l5Wjvl664tbmwsUN8w9XSOCutvXKaEEO2EXpROuLJEAer6tY
I7gGxfn5/eSc73Hi+JqCejDK4PWwqiRwP6ubmODL4JflHPZwjQTaXNOa3vA7
IWhHWWBkvQTa8/riRvgDoLT+OJDSLIFtEi3/l/x/YdJP0dXSJYGHus46zGAG
iizYZQINKXjm8ORVO7Rx9boaZpSDFMIcpnS5uno4nvKGbRAsBT/rsA/f+Bhi
dcrs8PocKYh7UpLaNpqg3bcNUflSKbgZ2NQzz5jhoG+ES96YFPjTl0pE+8zR
OE3rOMGWQcy9V+vr/Vi40HC6jrVXBhn7NVepo6ywnrF2U3uWDEJbTx3lCtj4
KVxbdUEmA1LLdFdk0BocyOnIHf4gA65+asHrRBvUrjUoKDOUw6GP7rb+UbYo
Hm/2f2Avh/JS2kz1sz2uuntld7qvHBqyXfu6Azho08HutBLIIbHZfWfJdi6m
EkO9dmlykLWLxtIPrEOH7/qfDZfJIdzHRRK+bz2uHeLbMiVyKK7mNkZGOKL2
/c/2I31yyPsoORt7zAnrNAPf1E7J4eWNpB8F8c7owKi1pI1JoLwvXTl3bgO6
vnBjKzeQoLHjyVBO6kacMZq9s3gPCQyPOxplJ1xwtNHD1iaRhIvGKr/uC644
1dys2HaZhNj9oQpVmhvGtJVoV90mYfCs4xG4vAn5zNYTlo9JMMy/+iS93B2p
U+yIc5MkVOrZnGgt2oyPixcW6ixVABm/kre6FlCoeLXsT3cFlJqXmbkHIj6y
Y9Lk9wqQJE8xBF2IW0xspClnFWDhqzVjudcDZwY7BkSVCrjdaZ35V48HtuiN
hvS2KSDr3izHPNgTz4tH8wrfKyA/4XXEoX5PbFBXb9xrpIRkoxVLWEFbsDKt
7d1rFyXUWM9vT3y+BWdU1QlOIUrQHNcwJQ964ZoLRtkRF5VQxbl1uvSVF94w
fHgyRawE65Ab/upoHvr+9OLvlH4l9G1tEu/+h4eJZ2r6/ZkUdF8/aQcJ3vhC
GLeIy6Hgc8OuTawxb8w+UrCzN4iCL7/GNwp/8MGetw3me9Io8OV485InfND+
QQwuu0VBa7BDeGQCgQyyJiujnwKDUEFLSRKBwt96zPyfUnBQUK7bdYzAwg8B
LfrPKPgU/7XYMZnAWsrf8uoABVYXVVPq8wT+IYu9Vj1EQapYlpVbQOBUr2xr
+wgFrlo7bzY2EbjdUxRnMkGBcFH6vJEWAivAq/PpnB/pKwKXSglstAp3u/6J
AoGZ4+RpBYGjS3zB/jMFhVwTT+IBgfeDiye8pikYP/D89yf9BFo4PV2epEED
HjZl6w4QaFRQdMRtHg2ZRwOOwyCB6vLJJo2vaGDFUWYVwwTqORblZjNp2CWs
Dot+R6BXafnbai0aijMH7157T+CsOKMmRpuGkdylC7rHCHSPNE901qEhtSir
zlk19+ezz4laQENHGc0InySwpVa9NnMhDcaVswFF0wT2Oe3hBiyiIaR2g+ih
mkCRMJRnqktD3c1Y1ZcvBB6E1YLnc/4PS3lE4g==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.11578947438379782`, 
               0.1644859798966491}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.11578947438379808`}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.11578947438379782`, 
              0.1644859798966491}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.11578947438379808`}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVzXk41Akcx/HRTo5KYVmUiqEpcswUCun7JcOvRGV1qNUWaca17u2ilHbK
sY48UY8jnowjz1IjtXjm+M38fom0ZO1mo0SrZKst0eQYrf3j87yf118fi5CY
gLB5DAbDb27/l5Wjvl664tbmwsUN8w9XSOCutvXKaEEO2EXpROuLJEAer6tY
I7gGxfn5/eSc73Hi+JqCejDK4PWwqiRwP6ubmODL4JflHPZwjQTaXNOa3vA7
IWhHWWBkvQTa8/riRvgDoLT+OJDSLIFtEi3/l/x/YdJP0dXSJYGHus46zGAG
iizYZQINKXjm8ORVO7Rx9boaZpSDFMIcpnS5uno4nvKGbRAsBT/rsA/f+Bhi
dcrs8PocKYh7UpLaNpqg3bcNUflSKbgZ2NQzz5jhoG+ES96YFPjTl0pE+8zR
OE3rOMGWQcy9V+vr/Vi40HC6jrVXBhn7NVepo6ywnrF2U3uWDEJbTx3lCtj4
KVxbdUEmA1LLdFdk0BocyOnIHf4gA65+asHrRBvUrjUoKDOUw6GP7rb+UbYo
Hm/2f2Avh/JS2kz1sz2uuntld7qvHBqyXfu6Azho08HutBLIIbHZfWfJdi6m
EkO9dmlykLWLxtIPrEOH7/qfDZfJIdzHRRK+bz2uHeLbMiVyKK7mNkZGOKL2
/c/2I31yyPsoORt7zAnrNAPf1E7J4eWNpB8F8c7owKi1pI1JoLwvXTl3bgO6
vnBjKzeQoLHjyVBO6kacMZq9s3gPCQyPOxplJ1xwtNHD1iaRhIvGKr/uC644
1dys2HaZhNj9oQpVmhvGtJVoV90mYfCs4xG4vAn5zNYTlo9JMMy/+iS93B2p
U+yIc5MkVOrZnGgt2oyPixcW6ixVABm/kre6FlCoeLXsT3cFlJqXmbkHIj6y
Y9Lk9wqQJE8xBF2IW0xspClnFWDhqzVjudcDZwY7BkSVCrjdaZ35V48HtuiN
hvS2KSDr3izHPNgTz4tH8wrfKyA/4XXEoX5PbFBXb9xrpIRkoxVLWEFbsDKt
7d1rFyXUWM9vT3y+BWdU1QlOIUrQHNcwJQ964ZoLRtkRF5VQxbl1uvSVF94w
fHgyRawE65Ab/upoHvr+9OLvlH4l9G1tEu/+h4eJZ2r6/ZkUdF8/aQcJ3vhC
GLeIy6Hgc8OuTawxb8w+UrCzN4iCL7/GNwp/8MGetw3me9Io8OV485InfND+
QQwuu0VBa7BDeGQCgQyyJiujnwKDUEFLSRKBwt96zPyfUnBQUK7bdYzAwg8B
LfrPKPgU/7XYMZnAWsrf8uoABVYXVVPq8wT+IYu9Vj1EQapYlpVbQOBUr2xr
+wgFrlo7bzY2EbjdUxRnMkGBcFH6vJEWAivAq/PpnB/pKwKXSglstAp3u/6J
AoGZ4+RpBYGjS3zB/jMFhVwTT+IBgfeDiye8pikYP/D89yf9BFo4PV2epEED
HjZl6w4QaFRQdMRtHg2ZRwOOwyCB6vLJJo2vaGDFUWYVwwTqORblZjNp2CWs
Dot+R6BXafnbai0aijMH7157T+CsOKMmRpuGkdylC7rHCHSPNE901qEhtSir
zlk19+ezz4laQENHGc0InySwpVa9NnMhDcaVswFF0wT2Oe3hBiyiIaR2g+ih
mkCRMJRnqktD3c1Y1ZcvBB6E1YLnc/4PS3lE4g==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.11578947438379782`, 0.1644859798966491}},
          "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.11578947438379808`}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.11578947438379808`},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.11578947438379782`, 0.1644859798966491}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.938182471618582*^9, {3.9381825026143517`*^9, 3.938182527537937*^9}, 
   3.9381825604806786`*^9, 3.938182716826149*^9, {3.938182751807266*^9, 
   3.9381827603937607`*^9}, 3.938182952028139*^9, 3.938182993981361*^9, 
   3.9381830255511703`*^9, 3.9381830644805756`*^9, 3.9381830983465996`*^9, 
   3.938189975907328*^9, 3.93819006485413*^9},
 CellLabel->
  "Out[575]=",ExpressionUUID->"c32582b2-33a6-0c45-8ad6-5cd2395aec9b"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 40, 20", "Subsubsection",
 CellChangeTimes->{{3.93800348313385*^9, 3.938003488595513*^9}, {
  3.938182332504423*^9, 3.938182344956808*^9}, {3.938183304740076*^9, 
  3.9381833139726048`*^9}, {3.9381842768653316`*^9, 
  3.938184278329859*^9}},ExpressionUUID->"a7062b32-c093-f142-b732-\
77a709070168"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "20", ",", "40", ",", "20", ",", "80", ",", "22"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "50"}], "]"}]}], "Input",
 CellChangeTimes->{{3.938003499419222*^9, 3.9380034998256445`*^9}, {
  3.9381833478833275`*^9, 3.9381833562567997`*^9}},
 CellLabel->
  "In[568]:=",ExpressionUUID->"1ca93689-4b5a-d94a-9cd3-d1326a60e5bd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwV0XtUzHkYBvDh2IalpQspQ5ou1IpGQ8l35vdMmulHNxWrhkhtZqa03eS2
SSqjmpRry8FUFFZOpVRik0Y1xJBxOZSzKpbY3aJiFJmd/eM9z/n8+TyvTURc
UNRYBoPhZ7j/k50/ekY56xJfUa90/hoN1I13tI6V5lMt3KTiPoObtpeXzJUW
UqkxLWbdBre6JEiMpBWU04SewRaDb+Vq6Y+SRqpoYKg43+DbHhn1/0juU65X
6Bq2wW0HOxN6JS+o6pd/1nrLgBUNTP/Xkn6qzsjXYr8E0BgvnjAujIHA0JnH
6iIBz3zhjXMB4xGlXuDKDAeiFowYc4ynILbp5Ae/dYCfY9SHad7mCM5UttuG
AFWPdiXfdp8O+b/lATargKWmThXjdrNQZjzxQUkAIPly6FRpyGxkNes/T/MB
4lrfuFb4sfH+nX1etQjIERvZj262g+rtzh9vCYBI9a+bOFIHNA5TGibP0J9p
GRgTOheTKh4K3dwBjklawdstTuBaHK+9txAIH+TN8988D8ozfaZHnIFiZQtL
t38+nqTvXFI9B6jO8+jUBrlghcZ51WUbYMtV3spTvhw03/JJfT0DaGwrHche
uxC+GsXMdVMBmfeSBlmIKw5iU/vYycDJ85yamGguLHvYoc+YwMHBhj3x2xbB
QYe4DAbw+kLyVmniYrRfbR93c4BCs+jQsfR0N1ybv7+gsIfCmICOnvw0d8xY
tOFTt5YCQ1A7pmjHEgwbBbDVKgpZFjo/7T4PhG2zF6ZVUogXR6p0GUshzj39
5LSSQvce7s/UUYLaNE1WcA4F88PHO7KLebA85GK5NpnC2SlOO9Qn+NBlh93U
hFNoSrQWzimjoOM86A1ZTkE5u4jFM/zlhyK1iddCCg0pIwxpOyCw0+rirCjY
+DC/2q4RQHv0MbHW83H5vqPi2SMBort3sR1e8ZHb+s1ldpgnVIIYf9sWPg4n
vY0Of+6Jd/1y/bqzfKRMnTWZHboMeUbm4cFyPn53/K5tS9cytIpHL3pv5MNo
aIxl03ovjFxkWa0mfJxzuZSqfOMFVXzmT7EmfDhGXPAfjRUiTuj11OwVD53L
66tW/y1E/Yac63m1PGjP7HSmkkQoaLPt8trDw+fqQMIeEKE/PzN2gw8P+iuJ
NfJfvMGtypw8x5QHHxeRMOWjN8ScOxPT7xGowxbIYpJoiItG9HHZBKaR0mun
kmlMLxX7OmcRrJcWG7dvo6HYKpn6Tk7wKdGsiptCoyNYxIrIJLDL0o2MZtII
kHkO+ewmSKtqzD1QQKPMt3SvUTKBB3NlZU09DXlWyUvzcAL5pOyxvddo+HaZ
2TetJ3hgolpldZ2G442Sp5vDCKQs7nCqioadifqISkzwG2e6J32HhixesEay
mmBobdfDjuc0gvIqa46uIMBGSwfjFzSub3zZ576cQLEpaDvVTaOYv/dIpzcB
O6GZVfIXDXaH0tZaSBAoPx8V20fDK+exqJAiOKnorit8T+OLav4zHp+g94DV
99oBGs0xjMedxNDnRG75Yh2Nu38omNM8CO4WtTBkwzQY/Rm8KncCi7Pfgk58
oZFektDp50YQUeZWqhmlwQoe7OpdRFBeGa/T6w17zjznl8El+A9GvhaO
           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVkns0lAkchofc2lZiWZItTTYzU4rYLsLvNzLmoyZxtFFLhmVGuZNklVuJ
WMy45DpojPvnulbWmRUVoVYke5o6hy6i3UIkWxm2/njPc54/n3Pezd7BLr6K
FAqF83lfSM2Qi0Ubm2wmo+kjijECaFOjbwrkZ4Chk6va0mfviqovp/FLoDEE
3RbOC6DHNJSnwm+AInrwwalYAdxJGyYWeJ2wKrMqdjBRAH2Wie2veYOgE1+y
RZwqgH7B49Ap3hjI/c5GnywUgKNU9fBL3gzYvNAOMukQwD313auVPCh4/+T0
SIuCEGwzWDcqndRQaiKWZrCE4Lvzo7qZ+jrs4qZXr70iBA7d9+23bG38rnfs
UfWoEJpHzp/p26uHF/ZWGQUYZsF+LUaDUqwBqt8/GzQXlgW8T8JiiZshckZk
sraeLAjumTRv4FBx2wm6LEQ3G64cV/leHmCESjNq89Oh2eDT+4ufGX8rusy3
3Tjalw1dquudT7vTkJzVeTixOQfMNONyX0Uw8NNGnWjvSzngNW+9/XDAdtyT
Yh8knMiBMtFtg8Vfd6C3cndvi3MutKRbPh52McVjitPD8s5ciPjD+kjxITPM
csg/1cW4Cp39krmUE7uQNTturim+Cv7sfVJ/N3Psi5BYyXTzoKjKrPX0KQs8
dDOBn1eYB4J5aXzI2R9QEuCzM5maDy9rzkTyw3Zjx3SDpEOSD7fshXkJCXvw
H3eLZbplASg4yZ5lxO3FOeqdlZn+AqAwf1coPbcP9YqH9mmcLIRk3UXO8GVL
nDbSSaKpFkHIcZ/uxcT9eI6hsimqtgiexlv8DDlWyJ1X3mDnVwzaWfmylDJr
fJ5uU73FWAQV6xjnegtt0HFH3jbGCxF0hW1iGdcCms8y9Sc7SkBkWGpg7Yq4
xvh5tB5RCtKYjxT+fcTWN0sLda2lsPmg6tKWY0z00B3zcDQvg98G6amPRpio
cXnhrmtDGaT1LJsaetiiY1GP0lvra5AV/uqU1xNbpOnYvI4cuAYxOhs1qO4H
cNT+esWApxiq6cr9EeMH8KcmbSZtdTmovFNY3+VphzzjJifNlnKoNG26IJq0
Q2m3HXhFSYDuXXNYHshCrbSbba+JCnjs0N589F8W1k6UtTP1K2FYHG0C4faY
GJwYeUSjCv5rcbaiztmj8wOtaoZqNaxcD2tNCmKj2zaLD5y1NXDQ1J4Vs8DG
l3pUIZdVC70eO/1PhxPIfvX24arEOtDy4XcUnyEwQcn+78HkOvDkl32+KoFe
wUkWovQ6eB/2TbNFDIFTDIGabUEdGCUvfpRfJHBANRwqmuogrrkzLTOXwA6v
aLNn43VgqXqksbWdQCtuZMMuJglJX6coTnUQ6FBZsI7DJmFIs9tV/08CU3+k
LftzSOAbWHy40E1g/66Ji7XuJFw107MlBggcGn0XyAkj4d2J8QeyJwR6xnI3
rC0nAbnrt6qPEfhXxB1llxoSUv1couApgQ/kA7l5jSRQQ28ZlE8QKD7u12Ii
JcE5qco3cPpLD08lapSEotSnbSWzBGY60I4OPSFhKlP/q+E5AuPYW91MnpMQ
V5hWv3uRwDVlt+PfzJBwt/Q2xf8DgcLK8Vrn9yToViy7FH4iUMbYLri+RIJ3
7R7JPTmBB9r55tRV9VDfGLK4skLgBq5bdvrqevgf4xs1Ig==
            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
       0., 111.33603238866402`}}, {0., 26.304107292588363`}}], {
      GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{-0.7347827218691545, -2.908624133786034}, {
            4.089265648474323, 32.71873122563056}], 
           Offset[{-4.711065152322874, -7.756331023429425}, {
            3.7603306291111482`, 32.50320274082697}], 
           Offset[{-36.372024132541014`, -7.756331023429432}, {
            3.7603306291111482`, 32.50320274082697}], 
           Offset[{-36.372024132541014`, -21.756331023429432`}, {
            3.7603306291111482`, 32.50320274082697}], 
           Offset[{25.627975867458986`, -21.756331023429418`}, {
            3.7603306291111482`, 32.50320274082697}], 
           Offset[{25.627975867458986`, -7.756331023429418}, {
            3.7603306291111482`, 32.50320274082697}], 
           Offset[{2.6440400545279243`, -7.756331023429423}, {
            3.7603306291111482`, 32.50320274082697}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{-5.372024132541015, -14.756331023429425}, \
{3.7603306291111482, 32.50320274082697}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-1.3555900787572248`, 2.6762614854260747`}, {
             24.461483263235365`, 0.026143507381174366`}], 
            Offset[{1.7039800105654235`, 7.136697294469535}, {
             23.76033062911115, 0.02820149561594085}], 
            Offset[{21.248532183888468`, 7.136697294469539}, {
             23.76033062911115, 0.02820149561594085}], 
            Offset[{21.248532183888468`, 21.13669729446954}, {
             23.76033062911115, 0.02820149561594085}], 
            Offset[{-34.75146781611153, 21.136697294469528`}, {
             23.76033062911115, 0.02820149561594085}], 
            Offset[{-34.75146781611153, 7.136697294469527}, {
             23.76033062911115, 0.02820149561594085}], 
            Offset[{-5.360175649507869, 7.136697294469533}, {
             23.76033062911115, 0.02820149561594085}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{-6.751467816111532, 14.136697294469533}, \
{23.76033062911115, 0.02820149561594085}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
        111.33603238866402`}}, {0., 26.304107292588363`}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 28.205128529834077`},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.23625870913706626` + 0.008981818181818178 #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.23625870913706626` + 0.008981818181818178 #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{0.014681800167214428`, 0.0625383390772355}, {
          27.93872067152924, 33.266877837624705`}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{28., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"28\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {29., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"29\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {31., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"31\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {32., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"32\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {33., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"33\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {28.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         28.530827940361643`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
02\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.02`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {29.64418826424828, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
03\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.03`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {30.757548588134924`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
04\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.04`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {31.870908912021562`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
05\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.05`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {32.9842692359082, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
06\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.06`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {28.085483810806988`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.308155875584315`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.75350000513897, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.9761720699163, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.198844134693626`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.421516199470954`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.866860329025613`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.08953239380294, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.31220445858027, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.534876523357596`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.98022065291225, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.20289271768958, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.425564782466907`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.648236847244235`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.09358097679889, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.31625304157622, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.538925106353545`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.76159717113087, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.20694130068553, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 44.925779700279236`}, {
     28.343749999999545`, 1.0000000000006821`}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-1.0416666666666667`, 51.041666666666664`}, {
     27.93872067152924, 33.266877837624705`}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV0XtUzHkYBvDh2IalpQspQ5ou1IpGQ8l35vdMmulHNxWrhkhtZqa03eS2
SSqjmpRry8FUFFZOpVRik0Y1xJBxOZSzKpbY3aJiFJmd/eM9z/n8+TyvTURc
UNRYBoPhZ7j/k50/ekY56xJfUa90/hoN1I13tI6V5lMt3KTiPoObtpeXzJUW
UqkxLWbdBre6JEiMpBWU04SewRaDb+Vq6Y+SRqpoYKg43+DbHhn1/0juU65X
6Bq2wW0HOxN6JS+o6pd/1nrLgBUNTP/Xkn6qzsjXYr8E0BgvnjAujIHA0JnH
6iIBz3zhjXMB4xGlXuDKDAeiFowYc4ynILbp5Ae/dYCfY9SHad7mCM5UttuG
AFWPdiXfdp8O+b/lATargKWmThXjdrNQZjzxQUkAIPly6FRpyGxkNes/T/MB
4lrfuFb4sfH+nX1etQjIERvZj262g+rtzh9vCYBI9a+bOFIHNA5TGibP0J9p
GRgTOheTKh4K3dwBjklawdstTuBaHK+9txAIH+TN8988D8ozfaZHnIFiZQtL
t38+nqTvXFI9B6jO8+jUBrlghcZ51WUbYMtV3spTvhw03/JJfT0DaGwrHche
uxC+GsXMdVMBmfeSBlmIKw5iU/vYycDJ85yamGguLHvYoc+YwMHBhj3x2xbB
QYe4DAbw+kLyVmniYrRfbR93c4BCs+jQsfR0N1ybv7+gsIfCmICOnvw0d8xY
tOFTt5YCQ1A7pmjHEgwbBbDVKgpZFjo/7T4PhG2zF6ZVUogXR6p0GUshzj39
5LSSQvce7s/UUYLaNE1WcA4F88PHO7KLebA85GK5NpnC2SlOO9Qn+NBlh93U
hFNoSrQWzimjoOM86A1ZTkE5u4jFM/zlhyK1iddCCg0pIwxpOyCw0+rirCjY
+DC/2q4RQHv0MbHW83H5vqPi2SMBort3sR1e8ZHb+s1ldpgnVIIYf9sWPg4n
vY0Of+6Jd/1y/bqzfKRMnTWZHboMeUbm4cFyPn53/K5tS9cytIpHL3pv5MNo
aIxl03ovjFxkWa0mfJxzuZSqfOMFVXzmT7EmfDhGXPAfjRUiTuj11OwVD53L
66tW/y1E/Yac63m1PGjP7HSmkkQoaLPt8trDw+fqQMIeEKE/PzN2gw8P+iuJ
NfJfvMGtypw8x5QHHxeRMOWjN8ScOxPT7xGowxbIYpJoiItG9HHZBKaR0mun
kmlMLxX7OmcRrJcWG7dvo6HYKpn6Tk7wKdGsiptCoyNYxIrIJLDL0o2MZtII
kHkO+ewmSKtqzD1QQKPMt3SvUTKBB3NlZU09DXlWyUvzcAL5pOyxvddo+HaZ
2TetJ3hgolpldZ2G442Sp5vDCKQs7nCqioadifqISkzwG2e6J32HhixesEay
mmBobdfDjuc0gvIqa46uIMBGSwfjFzSub3zZ576cQLEpaDvVTaOYv/dIpzcB
O6GZVfIXDXaH0tZaSBAoPx8V20fDK+exqJAiOKnorit8T+OLav4zHp+g94DV
99oBGs0xjMedxNDnRG75Yh2Nu38omNM8CO4WtTBkwzQY/Rm8KncCi7Pfgk58
oZFektDp50YQUeZWqhmlwQoe7OpdRFBeGa/T6w17zjznl8El+A9GvhaO
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwV0XtUzHkYBvDh2IalpQspQ5ou1IpGQ8l35vdMmulHNxWrhkhtZqa03eS2
SSqjmpRry8FUFFZOpVRik0Y1xJBxOZSzKpbY3aJiFJmd/eM9z/n8+TyvTURc
UNRYBoPhZ7j/k50/ekY56xJfUa90/hoN1I13tI6V5lMt3KTiPoObtpeXzJUW
UqkxLWbdBre6JEiMpBWU04SewRaDb+Vq6Y+SRqpoYKg43+DbHhn1/0juU65X
6Bq2wW0HOxN6JS+o6pd/1nrLgBUNTP/Xkn6qzsjXYr8E0BgvnjAujIHA0JnH
6iIBz3zhjXMB4xGlXuDKDAeiFowYc4ynILbp5Ae/dYCfY9SHad7mCM5UttuG
AFWPdiXfdp8O+b/lATargKWmThXjdrNQZjzxQUkAIPly6FRpyGxkNes/T/MB
4lrfuFb4sfH+nX1etQjIERvZj262g+rtzh9vCYBI9a+bOFIHNA5TGibP0J9p
GRgTOheTKh4K3dwBjklawdstTuBaHK+9txAIH+TN8988D8ozfaZHnIFiZQtL
t38+nqTvXFI9B6jO8+jUBrlghcZ51WUbYMtV3spTvhw03/JJfT0DaGwrHche
uxC+GsXMdVMBmfeSBlmIKw5iU/vYycDJ85yamGguLHvYoc+YwMHBhj3x2xbB
QYe4DAbw+kLyVmniYrRfbR93c4BCs+jQsfR0N1ybv7+gsIfCmICOnvw0d8xY
tOFTt5YCQ1A7pmjHEgwbBbDVKgpZFjo/7T4PhG2zF6ZVUogXR6p0GUshzj39
5LSSQvce7s/UUYLaNE1WcA4F88PHO7KLebA85GK5NpnC2SlOO9Qn+NBlh93U
hFNoSrQWzimjoOM86A1ZTkE5u4jFM/zlhyK1iddCCg0pIwxpOyCw0+rirCjY
+DC/2q4RQHv0MbHW83H5vqPi2SMBort3sR1e8ZHb+s1ldpgnVIIYf9sWPg4n
vY0Of+6Jd/1y/bqzfKRMnTWZHboMeUbm4cFyPn53/K5tS9cytIpHL3pv5MNo
aIxl03ovjFxkWa0mfJxzuZSqfOMFVXzmT7EmfDhGXPAfjRUiTuj11OwVD53L
66tW/y1E/Yac63m1PGjP7HSmkkQoaLPt8trDw+fqQMIeEKE/PzN2gw8P+iuJ
NfJfvMGtypw8x5QHHxeRMOWjN8ScOxPT7xGowxbIYpJoiItG9HHZBKaR0mun
kmlMLxX7OmcRrJcWG7dvo6HYKpn6Tk7wKdGsiptCoyNYxIrIJLDL0o2MZtII
kHkO+ewmSKtqzD1QQKPMt3SvUTKBB3NlZU09DXlWyUvzcAL5pOyxvddo+HaZ
2TetJ3hgolpldZ2G442Sp5vDCKQs7nCqioadifqISkzwG2e6J32HhixesEay
mmBobdfDjuc0gvIqa46uIMBGSwfjFzSub3zZ576cQLEpaDvVTaOYv/dIpzcB
O6GZVfIXDXaH0tZaSBAoPx8V20fDK+exqJAiOKnorit8T+OLav4zHp+g94DV
99oBGs0xjMedxNDnRG75Yh2Nu38omNM8CO4WtTBkwzQY/Rm8KncCi7Pfgk58
oZFektDp50YQUeZWqhmlwQoe7OpdRFBeGa/T6w17zjznl8El+A9GvhaO
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {28.205128529834013`, 
               32.835820868017514`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 28.205128529834077`}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {28.205128529834013`, 
              32.835820868017514`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 28.205128529834077`}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwV0XtUzHkYBvDh2IalpQspQ5ou1IpGQ8l35vdMmulHNxWrhkhtZqa03eS2
SSqjmpRry8FUFFZOpVRik0Y1xJBxOZSzKpbY3aJiFJmd/eM9z/n8+TyvTURc
UNRYBoPhZ7j/k50/ekY56xJfUa90/hoN1I13tI6V5lMt3KTiPoObtpeXzJUW
UqkxLWbdBre6JEiMpBWU04SewRaDb+Vq6Y+SRqpoYKg43+DbHhn1/0juU65X
6Bq2wW0HOxN6JS+o6pd/1nrLgBUNTP/Xkn6qzsjXYr8E0BgvnjAujIHA0JnH
6iIBz3zhjXMB4xGlXuDKDAeiFowYc4ynILbp5Ae/dYCfY9SHad7mCM5UttuG
AFWPdiXfdp8O+b/lATargKWmThXjdrNQZjzxQUkAIPly6FRpyGxkNes/T/MB
4lrfuFb4sfH+nX1etQjIERvZj262g+rtzh9vCYBI9a+bOFIHNA5TGibP0J9p
GRgTOheTKh4K3dwBjklawdstTuBaHK+9txAIH+TN8988D8ozfaZHnIFiZQtL
t38+nqTvXFI9B6jO8+jUBrlghcZ51WUbYMtV3spTvhw03/JJfT0DaGwrHche
uxC+GsXMdVMBmfeSBlmIKw5iU/vYycDJ85yamGguLHvYoc+YwMHBhj3x2xbB
QYe4DAbw+kLyVmniYrRfbR93c4BCs+jQsfR0N1ybv7+gsIfCmICOnvw0d8xY
tOFTt5YCQ1A7pmjHEgwbBbDVKgpZFjo/7T4PhG2zF6ZVUogXR6p0GUshzj39
5LSSQvce7s/UUYLaNE1WcA4F88PHO7KLebA85GK5NpnC2SlOO9Qn+NBlh93U
hFNoSrQWzimjoOM86A1ZTkE5u4jFM/zlhyK1iddCCg0pIwxpOyCw0+rirCjY
+DC/2q4RQHv0MbHW83H5vqPi2SMBort3sR1e8ZHb+s1ldpgnVIIYf9sWPg4n
vY0Of+6Jd/1y/bqzfKRMnTWZHboMeUbm4cFyPn53/K5tS9cytIpHL3pv5MNo
aIxl03ovjFxkWa0mfJxzuZSqfOMFVXzmT7EmfDhGXPAfjRUiTuj11OwVD53L
66tW/y1E/Yac63m1PGjP7HSmkkQoaLPt8trDw+fqQMIeEKE/PzN2gw8P+iuJ
NfJfvMGtypw8x5QHHxeRMOWjN8ScOxPT7xGowxbIYpJoiItG9HHZBKaR0mun
kmlMLxX7OmcRrJcWG7dvo6HYKpn6Tk7wKdGsiptCoyNYxIrIJLDL0o2MZtII
kHkO+ewmSKtqzD1QQKPMt3SvUTKBB3NlZU09DXlWyUvzcAL5pOyxvddo+HaZ
2TetJ3hgolpldZ2G442Sp5vDCKQs7nCqioadifqISkzwG2e6J32HhixesEay
mmBobdfDjuc0gvIqa46uIMBGSwfjFzSub3zZ576cQLEpaDvVTaOYv/dIpzcB
O6GZVfIXDXaH0tZaSBAoPx8V20fDK+exqJAiOKnorit8T+OLav4zHp+g94DV
99oBGs0xjMedxNDnRG75Yh2Nu38omNM8CO4WtTBkwzQY/Rm8KncCi7Pfgk58
oZFektDp50YQUeZWqhmlwQoe7OpdRFBeGa/T6w17zjznl8El+A9GvhaO
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {28.205128529834013`, 32.835820868017514`}},
          "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 28.205128529834077`}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 28.205128529834077`},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 50}, {28.205128529834013`, 32.835820868017514`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVkns0lAkchofc2lZiWZItTTYzU4rYLsLvNzLmoyZxtFFLhmVGuZNklVuJ
WMy45DpojPvnulbWmRUVoVYke5o6hy6i3UIkWxm2/njPc54/n3Pezd7BLr6K
FAqF83lfSM2Qi0Ubm2wmo+kjijECaFOjbwrkZ4Chk6va0mfviqovp/FLoDEE
3RbOC6DHNJSnwm+AInrwwalYAdxJGyYWeJ2wKrMqdjBRAH2Wie2veYOgE1+y
RZwqgH7B49Ap3hjI/c5GnywUgKNU9fBL3gzYvNAOMukQwD313auVPCh4/+T0
SIuCEGwzWDcqndRQaiKWZrCE4Lvzo7qZ+jrs4qZXr70iBA7d9+23bG38rnfs
UfWoEJpHzp/p26uHF/ZWGQUYZsF+LUaDUqwBqt8/GzQXlgW8T8JiiZshckZk
sraeLAjumTRv4FBx2wm6LEQ3G64cV/leHmCESjNq89Oh2eDT+4ufGX8rusy3
3Tjalw1dquudT7vTkJzVeTixOQfMNONyX0Uw8NNGnWjvSzngNW+9/XDAdtyT
Yh8knMiBMtFtg8Vfd6C3cndvi3MutKRbPh52McVjitPD8s5ciPjD+kjxITPM
csg/1cW4Cp39krmUE7uQNTturim+Cv7sfVJ/N3Psi5BYyXTzoKjKrPX0KQs8
dDOBn1eYB4J5aXzI2R9QEuCzM5maDy9rzkTyw3Zjx3SDpEOSD7fshXkJCXvw
H3eLZbplASg4yZ5lxO3FOeqdlZn+AqAwf1coPbcP9YqH9mmcLIRk3UXO8GVL
nDbSSaKpFkHIcZ/uxcT9eI6hsimqtgiexlv8DDlWyJ1X3mDnVwzaWfmylDJr
fJ5uU73FWAQV6xjnegtt0HFH3jbGCxF0hW1iGdcCms8y9Sc7SkBkWGpg7Yq4
xvh5tB5RCtKYjxT+fcTWN0sLda2lsPmg6tKWY0z00B3zcDQvg98G6amPRpio
cXnhrmtDGaT1LJsaetiiY1GP0lvra5AV/uqU1xNbpOnYvI4cuAYxOhs1qO4H
cNT+esWApxiq6cr9EeMH8KcmbSZtdTmovFNY3+VphzzjJifNlnKoNG26IJq0
Q2m3HXhFSYDuXXNYHshCrbSbba+JCnjs0N589F8W1k6UtTP1K2FYHG0C4faY
GJwYeUSjCv5rcbaiztmj8wOtaoZqNaxcD2tNCmKj2zaLD5y1NXDQ1J4Vs8DG
l3pUIZdVC70eO/1PhxPIfvX24arEOtDy4XcUnyEwQcn+78HkOvDkl32+KoFe
wUkWovQ6eB/2TbNFDIFTDIGabUEdGCUvfpRfJHBANRwqmuogrrkzLTOXwA6v
aLNn43VgqXqksbWdQCtuZMMuJglJX6coTnUQ6FBZsI7DJmFIs9tV/08CU3+k
LftzSOAbWHy40E1g/66Ji7XuJFw107MlBggcGn0XyAkj4d2J8QeyJwR6xnI3
rC0nAbnrt6qPEfhXxB1llxoSUv1couApgQ/kA7l5jSRQQ28ZlE8QKD7u12Ii
JcE5qco3cPpLD08lapSEotSnbSWzBGY60I4OPSFhKlP/q+E5AuPYW91MnpMQ
V5hWv3uRwDVlt+PfzJBwt/Q2xf8DgcLK8Vrn9yToViy7FH4iUMbYLri+RIJ3
7R7JPTmBB9r55tRV9VDfGLK4skLgBq5bdvrqevgf4xs1Ig==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVkns0lAkchofc2lZiWZItTTYzU4rYLsLvNzLmoyZxtFFLhmVGuZNklVuJ
WMy45DpojPvnulbWmRUVoVYke5o6hy6i3UIkWxm2/njPc54/n3Pezd7BLr6K
FAqF83lfSM2Qi0Ubm2wmo+kjijECaFOjbwrkZ4Chk6va0mfviqovp/FLoDEE
3RbOC6DHNJSnwm+AInrwwalYAdxJGyYWeJ2wKrMqdjBRAH2Wie2veYOgE1+y
RZwqgH7B49Ap3hjI/c5GnywUgKNU9fBL3gzYvNAOMukQwD313auVPCh4/+T0
SIuCEGwzWDcqndRQaiKWZrCE4Lvzo7qZ+jrs4qZXr70iBA7d9+23bG38rnfs
UfWoEJpHzp/p26uHF/ZWGQUYZsF+LUaDUqwBqt8/GzQXlgW8T8JiiZshckZk
sraeLAjumTRv4FBx2wm6LEQ3G64cV/leHmCESjNq89Oh2eDT+4ufGX8rusy3
3Tjalw1dquudT7vTkJzVeTixOQfMNONyX0Uw8NNGnWjvSzngNW+9/XDAdtyT
Yh8knMiBMtFtg8Vfd6C3cndvi3MutKRbPh52McVjitPD8s5ciPjD+kjxITPM
csg/1cW4Cp39krmUE7uQNTturim+Cv7sfVJ/N3Psi5BYyXTzoKjKrPX0KQs8
dDOBn1eYB4J5aXzI2R9QEuCzM5maDy9rzkTyw3Zjx3SDpEOSD7fshXkJCXvw
H3eLZbplASg4yZ5lxO3FOeqdlZn+AqAwf1coPbcP9YqH9mmcLIRk3UXO8GVL
nDbSSaKpFkHIcZ/uxcT9eI6hsimqtgiexlv8DDlWyJ1X3mDnVwzaWfmylDJr
fJ5uU73FWAQV6xjnegtt0HFH3jbGCxF0hW1iGdcCms8y9Sc7SkBkWGpg7Yq4
xvh5tB5RCtKYjxT+fcTWN0sLda2lsPmg6tKWY0z00B3zcDQvg98G6amPRpio
cXnhrmtDGaT1LJsaetiiY1GP0lvra5AV/uqU1xNbpOnYvI4cuAYxOhs1qO4H
cNT+esWApxiq6cr9EeMH8KcmbSZtdTmovFNY3+VphzzjJifNlnKoNG26IJq0
Q2m3HXhFSYDuXXNYHshCrbSbba+JCnjs0N589F8W1k6UtTP1K2FYHG0C4faY
GJwYeUSjCv5rcbaiztmj8wOtaoZqNaxcD2tNCmKj2zaLD5y1NXDQ1J4Vs8DG
l3pUIZdVC70eO/1PhxPIfvX24arEOtDy4XcUnyEwQcn+78HkOvDkl32+KoFe
wUkWovQ6eB/2TbNFDIFTDIGabUEdGCUvfpRfJHBANRwqmuogrrkzLTOXwA6v
aLNn43VgqXqksbWdQCtuZMMuJglJX6coTnUQ6FBZsI7DJmFIs9tV/08CU3+k
LftzSOAbWHy40E1g/66Ji7XuJFw107MlBggcGn0XyAkj4d2J8QeyJwR6xnI3
rC0nAbnrt6qPEfhXxB1llxoSUv1couApgQ/kA7l5jSRQQ28ZlE8QKD7u12Ii
JcE5qco3cPpLD08lapSEotSnbSWzBGY60I4OPSFhKlP/q+E5AuPYW91MnpMQ
V5hWv3uRwDVlt+PfzJBwt/Q2xf8DgcLK8Vrn9yToViy7FH4iUMbYLri+RIJ3
7R7JPTmBB9r55tRV9VDfGLK4skLgBq5bdvrqevgf4xs1Ig==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.01707462711271548, 
               0.058666663750218194`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.01707462711271552}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.01707462711271548, 
              0.058666663750218194`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.01707462711271552}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVkns0lAkchofc2lZiWZItTTYzU4rYLsLvNzLmoyZxtFFLhmVGuZNklVuJ
WMy45DpojPvnulbWmRUVoVYke5o6hy6i3UIkWxm2/njPc54/n3Pezd7BLr6K
FAqF83lfSM2Qi0Ubm2wmo+kjijECaFOjbwrkZ4Chk6va0mfviqovp/FLoDEE
3RbOC6DHNJSnwm+AInrwwalYAdxJGyYWeJ2wKrMqdjBRAH2Wie2veYOgE1+y
RZwqgH7B49Ap3hjI/c5GnywUgKNU9fBL3gzYvNAOMukQwD313auVPCh4/+T0
SIuCEGwzWDcqndRQaiKWZrCE4Lvzo7qZ+jrs4qZXr70iBA7d9+23bG38rnfs
UfWoEJpHzp/p26uHF/ZWGQUYZsF+LUaDUqwBqt8/GzQXlgW8T8JiiZshckZk
sraeLAjumTRv4FBx2wm6LEQ3G64cV/leHmCESjNq89Oh2eDT+4ufGX8rusy3
3Tjalw1dquudT7vTkJzVeTixOQfMNONyX0Uw8NNGnWjvSzngNW+9/XDAdtyT
Yh8knMiBMtFtg8Vfd6C3cndvi3MutKRbPh52McVjitPD8s5ciPjD+kjxITPM
csg/1cW4Cp39krmUE7uQNTturim+Cv7sfVJ/N3Psi5BYyXTzoKjKrPX0KQs8
dDOBn1eYB4J5aXzI2R9QEuCzM5maDy9rzkTyw3Zjx3SDpEOSD7fshXkJCXvw
H3eLZbplASg4yZ5lxO3FOeqdlZn+AqAwf1coPbcP9YqH9mmcLIRk3UXO8GVL
nDbSSaKpFkHIcZ/uxcT9eI6hsimqtgiexlv8DDlWyJ1X3mDnVwzaWfmylDJr
fJ5uU73FWAQV6xjnegtt0HFH3jbGCxF0hW1iGdcCms8y9Sc7SkBkWGpg7Yq4
xvh5tB5RCtKYjxT+fcTWN0sLda2lsPmg6tKWY0z00B3zcDQvg98G6amPRpio
cXnhrmtDGaT1LJsaetiiY1GP0lvra5AV/uqU1xNbpOnYvI4cuAYxOhs1qO4H
cNT+esWApxiq6cr9EeMH8KcmbSZtdTmovFNY3+VphzzjJifNlnKoNG26IJq0
Q2m3HXhFSYDuXXNYHshCrbSbba+JCnjs0N589F8W1k6UtTP1K2FYHG0C4faY
GJwYeUSjCv5rcbaiztmj8wOtaoZqNaxcD2tNCmKj2zaLD5y1NXDQ1J4Vs8DG
l3pUIZdVC70eO/1PhxPIfvX24arEOtDy4XcUnyEwQcn+78HkOvDkl32+KoFe
wUkWovQ6eB/2TbNFDIFTDIGabUEdGCUvfpRfJHBANRwqmuogrrkzLTOXwA6v
aLNn43VgqXqksbWdQCtuZMMuJglJX6coTnUQ6FBZsI7DJmFIs9tV/08CU3+k
LftzSOAbWHy40E1g/66Ji7XuJFw107MlBggcGn0XyAkj4d2J8QeyJwR6xnI3
rC0nAbnrt6qPEfhXxB1llxoSUv1couApgQ/kA7l5jSRQQ28ZlE8QKD7u12Ii
JcE5qco3cPpLD08lapSEotSnbSWzBGY60I4OPSFhKlP/q+E5AuPYW91MnpMQ
V5hWv3uRwDVlt+PfzJBwt/Q2xf8DgcLK8Vrn9yToViy7FH4iUMbYLri+RIJ3
7R7JPTmBB9r55tRV9VDfGLK4skLgBq5bdvrqevgf4xs1Ig==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.01707462711271548, 
           0.058666663750218194`}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.01707462711271552}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.01707462711271552},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.01707462711271548, 0.058666663750218194`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVzX080wkcwPEp0dMuHEVUKDSn2s5CSt+v518PzFxeV3lxHWlD2jyWTjUp
hRXrQV15mBc9yCttHtvyNESzXwn1ukOXpgdK18V0osZ1f3xe7z8/VmG8wIhZ
FArF71v/a52tLS5YLt2cvaw3qL9TArVzaStiuNmgY8ge73gsAcWh8pLV3EJ4
NS/5trxLAm30WI4e9w4sfvmOd6VHAg+E3cQnTiNEsHrWB/8hAaVrmuw9pxMY
zsVK9XMJdIj6Y4c5A3DE+yl99gcJbK3X93/D+Qfeu2VqLy2UwkOq0zzdEApO
vv6s5QRIwSPbu+kGay5uuUxvuiGSQsS6KSqDaoAJTefwRI8U/GgRo4t9jdHI
1MJ+zbIKqHhyJFHpYoqLT350MttbARuN7O/oHrNAxwaD8bjKCuB8OZd/bacl
NpWknZmZXQm8tiHHO37WWG9k3JDProTM3Xo22v2rkN8w/VR8sxLC23/bx+Da
4iPNiGHZ10pQ6Juxo3etxmhOqk0PuwoYhoLctwn2WBPGck2RVsEejZuD/34H
rOr2NJ+kVkNRwX2LiTNr0axjRDmaWA2VZ137uwPpCLOCh7UD1ZAgdwvI385A
Xt8n4rpPDTR2XBvLCP4RB/iPkoLkNRDpu6E+cqcjrjzclie2r4W8m4zq6Cgm
6saICv1Ka0GkqU/lH1yP4beXqhb+cBfe3EpM4sY5oVuyyQFm6V1o9Tl3+fhx
Z5zWzPf721kGOqy+wWyBCz7p5vxp1SIDinuNjjh5A1KXDBWfZcvh9JIJv+5T
rnjxubSTrpEDf3d480TaRrQx+Xp+regeqFOZe+HiJtwnWhSk8qoD4/O/92UU
uWGB60QPTNfBdQP75Parm/HA6DuaTlU9KOJWeNuVAXr9pDscm9YABZZiC7cd
iOHOzzJErEaoT5micB8jahZo/W0Nm8Bqm/7XlT+7ozHP/NWHjCao6qRl9T5x
R6DZUZg6ChC2TdMtQzywy5H/3Y5MBZyPfxu155kHevVKBVyjZkgxWb7Iepcn
yi2Sco3EzVBKm9OR8MIT7dL2P1B7toDeuI6ZItQLL8jYL9yHWuAGXXq0YMgL
lTvjTaZKWoEWdstfG+ONp3J6bVNj7kP/FllF0Ig3XikzX6B0aoPu4sNrIN4H
XUbMh6Os2+FzJXuT9ZgPzg3yrKkzeAAzd+Oq0w/44kphr6WCqoRtdB/vlE++
aHqW1/WXSwe0h6yLjI4nMG97Sh4RpQKjcO69/EQC9UyNMvt5KgjlFlEfHyRw
s3pXHT9RBf/GfV/BTCEw52LWeJFABatOT0xpTxCobyPsW3FJBYKKRmFOLoG0
nmhZZqsKXPUDJNUyAtfFdry0tSIhfWHGrOF7BLJmp66ZY0dCl2HzjqUNBJ6E
jHevHUjgWjAnjzYTeGWmqrXchYRLDFMPQvXtP/hwVWgACePBL3r6nhFYyB8d
YwpIwF/NbKkDBK6eGnXYmE5C1r7AQ6AmMHRPosZTSIJ1bKtFyWsCJePHHEIu
k8BOvxkR84HAqhZWSrmEhLwsdW3hRwLnO84jlDUkDOcsnd89RuCWwV9uv6kj
QXBVWO40QaAxKdxGU5JAiu9TIicJrE+Wn/LvJGHJ9enAq18IzA1g7k16SkJY
mfO1h1oCYwtKB8X9JJRL+BMzMwRutVbpPlKT8B+RdER6
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVzX080wkcwPEp0dMuHEVUKDSn2s5CSt+v518PzFxeV3lxHWlD2jyWTjUp
hRXrQV15mBc9yCttHtvyNESzXwn1ukOXpgdK18V0osZ1f3xe7z8/VmG8wIhZ
FArF71v/a52tLS5YLt2cvaw3qL9TArVzaStiuNmgY8ge73gsAcWh8pLV3EJ4
NS/5trxLAm30WI4e9w4sfvmOd6VHAg+E3cQnTiNEsHrWB/8hAaVrmuw9pxMY
zsVK9XMJdIj6Y4c5A3DE+yl99gcJbK3X93/D+Qfeu2VqLy2UwkOq0zzdEApO
vv6s5QRIwSPbu+kGay5uuUxvuiGSQsS6KSqDaoAJTefwRI8U/GgRo4t9jdHI
1MJ+zbIKqHhyJFHpYoqLT350MttbARuN7O/oHrNAxwaD8bjKCuB8OZd/bacl
NpWknZmZXQm8tiHHO37WWG9k3JDProTM3Xo22v2rkN8w/VR8sxLC23/bx+Da
4iPNiGHZ10pQ6Juxo3etxmhOqk0PuwoYhoLctwn2WBPGck2RVsEejZuD/34H
rOr2NJ+kVkNRwX2LiTNr0axjRDmaWA2VZ137uwPpCLOCh7UD1ZAgdwvI385A
Xt8n4rpPDTR2XBvLCP4RB/iPkoLkNRDpu6E+cqcjrjzclie2r4W8m4zq6Cgm
6saICv1Ka0GkqU/lH1yP4beXqhb+cBfe3EpM4sY5oVuyyQFm6V1o9Tl3+fhx
Z5zWzPf721kGOqy+wWyBCz7p5vxp1SIDinuNjjh5A1KXDBWfZcvh9JIJv+5T
rnjxubSTrpEDf3d480TaRrQx+Xp+regeqFOZe+HiJtwnWhSk8qoD4/O/92UU
uWGB60QPTNfBdQP75Parm/HA6DuaTlU9KOJWeNuVAXr9pDscm9YABZZiC7cd
iOHOzzJErEaoT5micB8jahZo/W0Nm8Bqm/7XlT+7ozHP/NWHjCao6qRl9T5x
R6DZUZg6ChC2TdMtQzywy5H/3Y5MBZyPfxu155kHevVKBVyjZkgxWb7Iepcn
yi2Sco3EzVBKm9OR8MIT7dL2P1B7toDeuI6ZItQLL8jYL9yHWuAGXXq0YMgL
lTvjTaZKWoEWdstfG+ONp3J6bVNj7kP/FllF0Ig3XikzX6B0aoPu4sNrIN4H
XUbMh6Os2+FzJXuT9ZgPzg3yrKkzeAAzd+Oq0w/44kphr6WCqoRtdB/vlE++
aHqW1/WXSwe0h6yLjI4nMG97Sh4RpQKjcO69/EQC9UyNMvt5KgjlFlEfHyRw
s3pXHT9RBf/GfV/BTCEw52LWeJFABatOT0xpTxCobyPsW3FJBYKKRmFOLoG0
nmhZZqsKXPUDJNUyAtfFdry0tSIhfWHGrOF7BLJmp66ZY0dCl2HzjqUNBJ6E
jHevHUjgWjAnjzYTeGWmqrXchYRLDFMPQvXtP/hwVWgACePBL3r6nhFYyB8d
YwpIwF/NbKkDBK6eGnXYmE5C1r7AQ6AmMHRPosZTSIJ1bKtFyWsCJePHHEIu
k8BOvxkR84HAqhZWSrmEhLwsdW3hRwLnO84jlDUkDOcsnd89RuCWwV9uv6kj
QXBVWO40QaAxKdxGU5JAiu9TIicJrE+Wn/LvJGHJ9enAq18IzA1g7k16SkJY
mfO1h1oCYwtKB8X9JJRL+BMzMwRutVbpPlKT8B+RdER6
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.06567164274121338, 
               0.2256410144239161}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.06567164274121354}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.06567164274121338, 
              0.2256410144239161}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.06567164274121354}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVzX080wkcwPEp0dMuHEVUKDSn2s5CSt+v518PzFxeV3lxHWlD2jyWTjUp
hRXrQV15mBc9yCttHtvyNESzXwn1ukOXpgdK18V0osZ1f3xe7z8/VmG8wIhZ
FArF71v/a52tLS5YLt2cvaw3qL9TArVzaStiuNmgY8ge73gsAcWh8pLV3EJ4
NS/5trxLAm30WI4e9w4sfvmOd6VHAg+E3cQnTiNEsHrWB/8hAaVrmuw9pxMY
zsVK9XMJdIj6Y4c5A3DE+yl99gcJbK3X93/D+Qfeu2VqLy2UwkOq0zzdEApO
vv6s5QRIwSPbu+kGay5uuUxvuiGSQsS6KSqDaoAJTefwRI8U/GgRo4t9jdHI
1MJ+zbIKqHhyJFHpYoqLT350MttbARuN7O/oHrNAxwaD8bjKCuB8OZd/bacl
NpWknZmZXQm8tiHHO37WWG9k3JDProTM3Xo22v2rkN8w/VR8sxLC23/bx+Da
4iPNiGHZ10pQ6Juxo3etxmhOqk0PuwoYhoLctwn2WBPGck2RVsEejZuD/34H
rOr2NJ+kVkNRwX2LiTNr0axjRDmaWA2VZ137uwPpCLOCh7UD1ZAgdwvI385A
Xt8n4rpPDTR2XBvLCP4RB/iPkoLkNRDpu6E+cqcjrjzclie2r4W8m4zq6Cgm
6saICv1Ka0GkqU/lH1yP4beXqhb+cBfe3EpM4sY5oVuyyQFm6V1o9Tl3+fhx
Z5zWzPf721kGOqy+wWyBCz7p5vxp1SIDinuNjjh5A1KXDBWfZcvh9JIJv+5T
rnjxubSTrpEDf3d480TaRrQx+Xp+regeqFOZe+HiJtwnWhSk8qoD4/O/92UU
uWGB60QPTNfBdQP75Parm/HA6DuaTlU9KOJWeNuVAXr9pDscm9YABZZiC7cd
iOHOzzJErEaoT5micB8jahZo/W0Nm8Bqm/7XlT+7ozHP/NWHjCao6qRl9T5x
R6DZUZg6ChC2TdMtQzywy5H/3Y5MBZyPfxu155kHevVKBVyjZkgxWb7Iepcn
yi2Sco3EzVBKm9OR8MIT7dL2P1B7toDeuI6ZItQLL8jYL9yHWuAGXXq0YMgL
lTvjTaZKWoEWdstfG+ONp3J6bVNj7kP/FllF0Ig3XikzX6B0aoPu4sNrIN4H
XUbMh6Os2+FzJXuT9ZgPzg3yrKkzeAAzd+Oq0w/44kphr6WCqoRtdB/vlE++
aHqW1/WXSwe0h6yLjI4nMG97Sh4RpQKjcO69/EQC9UyNMvt5KgjlFlEfHyRw
s3pXHT9RBf/GfV/BTCEw52LWeJFABatOT0xpTxCobyPsW3FJBYKKRmFOLoG0
nmhZZqsKXPUDJNUyAtfFdry0tSIhfWHGrOF7BLJmp66ZY0dCl2HzjqUNBJ6E
jHevHUjgWjAnjzYTeGWmqrXchYRLDFMPQvXtP/hwVWgACePBL3r6nhFYyB8d
YwpIwF/NbKkDBK6eGnXYmE5C1r7AQ6AmMHRPosZTSIJ1bKtFyWsCJePHHEIu
k8BOvxkR84HAqhZWSrmEhLwsdW3hRwLnO84jlDUkDOcsnd89RuCWwV9uv6kj
QXBVWO40QaAxKdxGU5JAiu9TIicJrE+Wn/LvJGHJ9enAq18IzA1g7k16SkJY
mfO1h1oCYwtKB8X9JJRL+BMzMwRutVbpPlKT8B+RdER6
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.06567164274121338, 0.2256410144239161}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.06567164274121354}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.06567164274121354},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.06567164274121338, 0.2256410144239161}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.938183357025748*^9, 3.938190054852509*^9},
 CellLabel->
  "Out[571]=",ExpressionUUID->"212169c4-6eda-d64c-be5d-26cd7116512a"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 40, 8", "Subsubsection",
 CellChangeTimes->{
  3.9381833240695553`*^9, {3.938183372097025*^9, 3.938183409709221*^9}, 
   3.9381836322710648`*^9, {3.9381842790778503`*^9, 
   3.938184279587679*^9}},ExpressionUUID->"c1dde6cc-cbd8-1543-9bc1-\
11c748ccb31d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"50", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Data", "=", 
    RowBox[{"{", 
     RowBox[{"V", ",", 
      RowBox[{"{", 
       RowBox[{"50", ",", "20", ",", "40", ",", "8", ",", "80", ",", "22"}], 
       "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "50"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.938183421081602*^9, 3.938183439884941*^9}, {
   3.9381834845517025`*^9, 3.938183485141369*^9}, {3.9381836746637917`*^9, 
   3.938183677062367*^9}, {3.938190425790083*^9, 3.9381904619935646`*^9}, {
   3.9381907369714746`*^9, 3.938190863193897*^9}, 3.938190918222216*^9, {
   3.938191086839756*^9, 3.938191088059515*^9}, {3.9381911250878277`*^9, 
   3.938191126418499*^9}, {3.938191157996647*^9, 3.9381913172520742`*^9}, {
   3.938262539899605*^9, 
   3.9382625409007683`*^9}},ExpressionUUID->"3467e28e-52d1-eb48-a420-\
ebf9f196dee7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"122.43346007604563`", ",", "0.2798479087452471`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.9381834272581863`*^9, 3.938183440730196*^9}, 
   3.938183485941889*^9, 3.938190075643368*^9, {3.938190454122925*^9, 
   3.9381904626329975`*^9}, {3.938190738735672*^9, 3.938190777831972*^9}, {
   3.938190853618643*^9, 3.9381908636181526`*^9}, 3.9381910900438156`*^9, 
   3.938191127678442*^9, {3.9381911587459335`*^9, 3.9381912135220585`*^9}, {
   3.938191249511795*^9, 3.9381912905628395`*^9}},
 CellLabel->
  "Out[740]=",ExpressionUUID->"9b24502d-602d-9540-9eb0-315a6631ef5f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"118.46575342465754`", ",", "0.5041095890410959`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.9381834272581863`*^9, 3.938183440730196*^9}, 
   3.938183485941889*^9, 3.938190075643368*^9, {3.938190454122925*^9, 
   3.9381904626329975`*^9}, {3.938190738735672*^9, 3.938190777831972*^9}, {
   3.938190853618643*^9, 3.9381908636181526`*^9}, 3.9381910900438156`*^9, 
   3.938191127678442*^9, {3.9381911587459335`*^9, 3.9381912135220585`*^9}, {
   3.938191249511795*^9, 3.9381912905749073`*^9}},
 CellLabel->
  "Out[741]=",ExpressionUUID->"f099db0e-19aa-6445-8399-a99f9a6cd202"],

Cell[BoxData["3.9677066513880987`"], "Output",
 CellChangeTimes->{{3.9381834272581863`*^9, 3.938183440730196*^9}, 
   3.938183485941889*^9, 3.938190075643368*^9, {3.938190454122925*^9, 
   3.9381904626329975`*^9}, {3.938190738735672*^9, 3.938190777831972*^9}, {
   3.938190853618643*^9, 3.9381908636181526`*^9}, 3.9381910900438156`*^9, 
   3.938191127678442*^9, {3.9381911587459335`*^9, 3.9381912135220585`*^9}, {
   3.938191249511795*^9, 3.93819129058881*^9}},
 CellLabel->
  "Out[742]=",ExpressionUUID->"aa7acac6-6464-2645-9b6a-09a5a4ab9f7a"],

Cell[BoxData["1.801369863013699`"], "Output",
 CellChangeTimes->{{3.9381834272581863`*^9, 3.938183440730196*^9}, 
   3.938183485941889*^9, 3.938190075643368*^9, {3.938190454122925*^9, 
   3.9381904626329975`*^9}, {3.938190738735672*^9, 3.938190777831972*^9}, {
   3.938190853618643*^9, 3.9381908636181526`*^9}, 3.9381910900438156`*^9, 
   3.938191127678442*^9, {3.9381911587459335`*^9, 3.9381912135220585`*^9}, {
   3.938191249511795*^9, 3.938191290603527*^9}},
 CellLabel->
  "Out[743]=",ExpressionUUID->"3692ec3b-5880-d741-a126-598c70f12606"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwVj3s41AkfxSm5rKwQm5LwikguSxIxh5nfj1zDYC7mFyojZV2KJCPlqfCW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           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVjns41Ikeh4cwnNhS6YIj7KbMurMS8f0y8/ux5NJlHdfWZRnXSChKKZWI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            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
       0., 139.3722323230141}}, {0., 76.22828961879648}}], {GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{-0.18036006069637678`, -2.994573466873972}, {
            3.9327890012382367`, 123.0787426613819}], 
           Offset[{-3.9846100723094158`, -7.98552924499726}, {
            3.8543658696538605`, 121.07175317171124`}], 
           Offset[{-31.480960161857006`, -7.985529244997267}, {
            3.8543658696538605`, 121.07175317171124`}], 
           Offset[{-31.480960161857006`, -21.985529244997267`}, {
            3.8543658696538605`, 121.07175317171124`}], 
           Offset[{30.519039838142994`, -21.985529244997252`}, {
            3.8543658696538605`, 121.07175317171124`}], 
           Offset[{30.519039838142994`, -7.985529244997252}, {
            3.8543658696538605`, 121.07175317171124`}], 
           Offset[{3.4720193755917923`, -7.985529244997259}, {
            3.8543658696538605`, 121.07175317171124`}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{-0.48096016185700474, -14.98552924499726}, \
{3.8543658696538605, 121.07175317171124}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-0.6629711064294391, 2.925827970342707}, {
             24.151738224642536`, 0.05596672357349287}], 
            Offset[{2.7532375245469334`, 7.802207920913888}, {
             23.856695714654425`, 0.07036693411915731}], 
            Offset[{23.63892493606124, 7.802207920913893}, {
             23.856695714654425`, 0.07036693411915731}], 
            Offset[{23.63892493606124, 21.802207920913894`}, {
             23.856695714654425`, 0.07036693411915731}], 
            Offset[{-32.36107506393876, 21.80220792091388}, {
             23.856695714654425`, 0.07036693411915731}], 
            Offset[{-32.36107506393876, 7.80220792091388}, {
             23.856695714654425`, 0.07036693411915731}], 
            Offset[{-4.622440706345541, 7.802207920913887}, {
             23.856695714654425`, 0.07036693411915731}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{-4.3610750639387605, 14.802207920913887}, \
{23.856695714654425, 0.07036693411915731}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
        139.3722323230141}}, {0., 76.22828961879648}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 80.29387969755352},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.5469402932581798 + 0.007175030372494603 #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.5469402932581798 + 0.007175030372494603 #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{0.011371093172442483`, 0.3673638756674545}, {
          77.81310425819278, 127.42861304540381`}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{80., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"80\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {90., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"90\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"100\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {110., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"110\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {120., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"120\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {78., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         82., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         84., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         86., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         88., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         92., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         94., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         96., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         98., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         102., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         104., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         106., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         108., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         112., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         114., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         116., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         118., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         122., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         124., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         126., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         83.1969012349472, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
05\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.05`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {90.1655128510979, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
10\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {97.1341244672486, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
15\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.15`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {104.10273608339931`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
20\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.2`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {111.07134769955002`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
25\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.25`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {118.03995931570071`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
30\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.3`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {125.00857093185141`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
35\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.35`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {79.01573426525678, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80.40945658848692, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         81.80317891171705, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         84.59062355817734, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85.98434588140748, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         87.37806820463761, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         88.77179052786776, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         91.55923517432804, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         92.95295749755817, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         94.34667982078832, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95.74040214401846, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         98.52784679047875, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         99.92156911370888, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         101.31529143693902`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         102.70901376016917`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105.49645840662944`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         106.8901807298596, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         108.28390305308973`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         109.67762537631987`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         112.46507002278015`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         113.85879234601029`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115.25251466924044`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         116.64623699247056`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         119.43368163893086`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         120.82740396216099`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         122.22112628539114`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         123.61484860862129`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         126.40229325508156`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {10., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {40., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {2., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         4., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         6., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         8., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         12., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         14., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         16., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         18., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         36., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         38., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         42., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         44., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         46., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         48., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{39.369139194488554`, 44.925779700279236`}, {28.34375, 
     1.0000000000001137`}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-1.0416666666666667`, 51.041666666666664`}, {
     77.81310425819278, 127.42861304540381`}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVj3s41AkfxSm5rKwQm5LwikguSxIxh5nfj1zDYC7mFyojZV2KJCPlqfCW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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVj3s41AkfxSm5rKwQm5LwikguSxIxh5nfj1zDYC7mFyojZV2KJCPlqfCW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                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {80.29387969755334, 
               123.41463406606248`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 80.29387969755352}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {80.29387969755334, 
              123.41463406606248`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 80.29387969755352}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVj3s41AkfxSm5rKwQm5LwikguSxIxh5nfj1zDYC7mFyojZV2KJCPlqfCW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            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {80.29387969755334, 123.41463406606248`}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 80.29387969755352}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 80.29387969755352},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 50}, {80.29387969755334, 123.41463406606248`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVjns41Ikeh4cwnNhS6YIj7KbMurMS8f0y8/ux5NJlHdfWZRnXSChKKZWI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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVjns41Ikeh4cwnNhS6YIj7KbMurMS8f0y8/ux5NJlHdfWZRnXSChKKZWI
CK3IuF9yCVkllWPGjNsgjGklaiOVOCXlti7Zzh+f5/3jfZ73+ah4hRzyEaVQ
KGe+7f9UTVktylW6a9Yv9rL+40sWNEiq7wz2SwFnqXy++SgLOKeqi/f45UEi
l2p64zUL2nSOMyX8akBhRsnIdIIFHUkCqzlmMwiHuhKuz7Cg0ziu8X/MXvDx
1q+2EcsF/vXh4xPMv4Aib3pDgpYL1k1Uu7fMadhvb8G9FZkLPTKGUmLuFCw6
YfnzqkoeWKQQ7DJ7Sbwi/d/G2Y488NFektGV2YifJ4xc+fvywVbdZ2ar5RaM
oVkZR2XnQ50wJqLTaDu6Rh0aer6YDyabaDVi5xTxwarJoxXvAmAup7FKnJRx
daqz55igAELa3unX2KqiHtlMizMrhEQXiV2rQT/g5qO7Npc2FoJ3+2lfXT81
fOb54USOXhFwqDsOBjrvQfGSRCWipgh0ZWN/fx9OQ9J/KHXUtBg8vphq2AVp
oJhNhmYwvxgKclsVF5K1sKlzz0JxYAn8cc14WHBIB9XGjO/Vby6F8IemDqwD
unimuOTiWmMpNPNLPie46uEjOcmgzqgy8Lfc1+TvpI8PbddyrhvdhpzbuvcC
AwzQROxBVbhcOVz/0nQ+9ORPaEh3rNb+Wg5vKyIi/cIMseyn/q3r31UAj0y7
eeHCXtQKzRAtna8EEfvnYymxRthWFOTkIHkHKOb3RfKj9uFJ+vy2e+rVcGXb
gq0g3hjt16SNGGdrINTFu2UhzgR7BmNe0YJqYfS8wW9wYz/uCC+iHdh3F7ak
Zz1PKDBFBfv0dNVtdVC6kRbVfssM/Q9sitqzXAecsJ3E7kpA55tzVSBTD7nK
+YqmRxB3z/kGptLuQdOZJYpfH6LaG5tNAq/7oGJDXfn+P+Y4ubfQcstoA9T3
ql8dEpojPdxKoTWyEZLavuoou1ugqv9kjHzoI0g/8T7AY8QCE2dQuC+jCc7I
KW1QdabjuIw1m7uODT13pVzAlY4Vr1nH4qXYoGQ3V+zmTse1xRaG/QY2NF/u
Ns70pCPYx0dPybNBdDHaVzqAjrU3Mq466rEh/vlg03w0HaWj8hyXPdmQlnc9
qCuHjr+rOGcW8NhQri7OD39FxwzTBo3EmxwQKJovB4/RkTuSNSqZx4GVDTEa
zHE67jn90DuphAN287PXnCfo2KC96U1BHQdmW8YPm32iY/VfHieoPRxAN94L
KoWBj3Yx0zmiLfDsWtxM9k4Gfu9yyUo+rAUkZkV2cI4y0OWt+8VmTy4s1t68
Nu7BQNqiOWkdwIWpYG0xSW8GMr2X00bCuND3zm3ajsnAsUGJuW0XuZA93NA6
EvKt/1JucbKUC1rc4LDFWAb+65CCwvqPXHBMG+rSLmJguT51KPYCD6zsQ80P
lzAwMsSrXTaJBybS1IbIMgaOS7qXVt7ggfJlg8KmSgZ26MX6Ld3mwWRUyimb
egauJrzyEu/jwVlPYhezlYH0oyGVIztboUzn7tncdwysizZonGlrhWNyM383
vGdgY1bC1Sv9rWCwpBPRP8XA6VBajfpIK7C5tYFinxgonjWsdnWmFZ451joF
LDLQ7YvT5W7FNpCMqdEzlCIQNQteOEa0gV/nnbc9NAKXK6U817TaQav6g+c7
DQLPDSZKUUzaYTZN8wVFm8DWJ1JqMpbtEOt2Z0Bfn0Be76Ck7a/tcHO6ip1l
QuDAWlyeT2o7dMhVZfscIJA1aji5fq4d1L0q7FaDCUz3GFjmdXRAB8u49nMI
gfYqofWpTzvAd4gvO3GcwPO77Sv8xzqg2GFKKIggUL3LOZ++0gHKoOF6O4bA
lvdNlGydTtiqWM08nExgiRbt7OtbnSD6593Y8ioCRYdPX02M4UOBrMVYbjWB
l7OEdupJfEBbAT2jlsA5EV+zZ9l8iOF9ljhXT+DJ30S+Yz7gw2KdfvKRxwTK
nFs4ZjPLh48p97LWugh8dnKzmFVIFwz/3Fj3yxSBQ0vROeNh3WBhX+wU8YHA
f7v7dmhd6oaKIylfM6YJfPW+Nz41sxuif/WxFn4hMDDT89Stx90gHyE7dmiF
wK6JTFMhtQec8v1lHWRIxO1Sw8uFPfDn/I5Qa20Sn3s+xvQPT8BsRWxrgC6J
2QkzDL11vVAq8ulRgj6JBhc1s6a390KkdBu1cy+JPTpKem2MXpBTDcuzRBKT
ZLIcJlm9cMSW/4RxkMTETCuxXT/2gaAoWhNOkOipyTV58KkPNlHuNxpHkOj6
Qyr16UofHHabIQxPkmizc1l3nVQ/CLf4HdU8TeLutTmjDJV+GLz0S4pCHIm5
5CV68uF+GGHqzCykkcheKfD++rAf3vz4tr62jsSAVQnHDVkCULuiYl5VT+Ky
g/jt8jIB+I679ZTd/+a3FS653BfARM7Am9yHJA6ZRJ5ZJxTApAxna3ILiUel
1beEbRyAj9O3TvkLSIwiD3xdTB6AxT8O7lf9TOLTuSNvwlhCkDYyfLJ5lsSy
+Il162uEoPxY3kN8/tu//kAGhy0EK97ruIm/SbRmLXkljAshSxjRVS1iiatL
LwdTNZ9C8xC15dx3lpjEMpeRqHwK/wA36aWm
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.029170732297193084`, 
               0.3385634545761256}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.02917073229719315}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.029170732297193084`, 
              0.3385634545761256}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.02917073229719315}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVjns41Ikeh4cwnNhS6YIj7KbMurMS8f0y8/ux5NJlHdfWZRnXSChKKZWI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            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.029170732297193084`, 
           0.3385634545761256}}, "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.02917073229719315}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.02917073229719315},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.029170732297193084`, 0.3385634545761256}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVkmk81AsbhmfkWE4UijZlaaMkIqd0eB5m/kNkKeqk8CYxY4swEok2STFv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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVkmk81AsbhmfkWE4UijZlaaMkIqd0eB5m/kNkKeqk8CYxY4swEok2STFv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                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 50}, {0.2243902484399468, 
               2.604334265970197}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.2243902484399473}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 50}, {0.2243902484399468, 2.604334265970197}},
             "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.2243902484399473}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVkmk81AsbhmfkWE4UijZlaaMkIqd0eB5m/kNkKeqk8CYxY4swEok2STFv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            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 50}, {0.2243902484399468, 2.604334265970197}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.2243902484399473}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.2243902484399473},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 50}, {0.2243902484399468, 2.604334265970197}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{{3.9381834272581863`*^9, 3.938183440730196*^9}, 
   3.938183485941889*^9, 3.938190075643368*^9, {3.938190454122925*^9, 
   3.938190462632998*^9}, {3.938190738735672*^9, 3.938190777831972*^9}, {
   3.938190853618643*^9, 3.9381908636181526`*^9}, 3.938191090043815*^9, 
   3.938191127678442*^9, {3.9381911587459345`*^9, 3.938191213522059*^9}, {
   3.938191249511795*^9, 3.938191291213175*^9}},
 CellLabel->
  "Out[744]=",ExpressionUUID->"a3515007-87fb-4d41-9468-cc9a49f6494b"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 200, 20", "Subsubsection",
 CellChangeTimes->{{3.938183375058937*^9, 3.9381834165018864`*^9}, {
  3.938183686202059*^9, 3.9381837042143936`*^9}, {3.9381838931169033`*^9, 
  3.9381838966284466`*^9}, {3.938184280196192*^9, 
  3.9381842807976646`*^9}},ExpressionUUID->"eee0b744-3d1d-c040-a856-\
716650512007"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "20", ",", "200", ",", "20", ",", "80", ",", "22"}],
       "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FTG", "[", 
   RowBox[{"Data", ",", "40"}], "]"}], "//", "N"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PlotTrack", "[", 
   RowBox[{"Data", ",", "0", ",", "100"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.938183687789049*^9, 3.9381837071245613`*^9}, {
  3.938183737854021*^9, 3.938183826366516*^9}, {3.938187475630459*^9, 
  3.938187571580759*^9}, {3.9381877969492493`*^9, 3.938187800935873*^9}, {
  3.938188026950384*^9, 3.9381880290519733`*^9}, {3.9381894367918816`*^9, 
  3.93818943761462*^9}},
 CellLabel->"",ExpressionUUID->"bb529ee4-fa45-a24d-8e7c-48425e37405f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "34.033149171270715`", ",", "0.14024649358832694`", ",", 
   "0.03646408833296501`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.938183708137453*^9, {3.9381837393776894`*^9, 3.9381838272260056`*^9}, {
   3.938187526577215*^9, 3.9381875720851574`*^9}},
 CellLabel->
  "Out[346]=",ExpressionUUID->"127aad23-20cd-ff47-984b-9fecbb30e291"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 100, 20, 200", "Subsubsection",
 CellChangeTimes->{{3.9381836888463287`*^9, 3.938183692363661*^9}, {
  3.9381839050823517`*^9, 3.938183914883312*^9}, {3.938184012976198*^9, 
  3.938184013896208*^9}, {3.93818428153841*^9, 
  3.938184281952942*^9}},ExpressionUUID->"f4d9294e-1397-cc4f-b3ad-\
53aa7bd0af4a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "20", ",", "20", ",", "200", ",", "80", ",", "22"}],
       "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "120"}], "]"}]}], "Input",
 CellChangeTimes->{{3.938183917532587*^9, 3.938184027974619*^9}},
 CellLabel->
  "In[256]:=",ExpressionUUID->"4d2879b0-0838-1643-a5a4-068cdd0cf013"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwV0Hs0lAkYBnDpbGK7uGRHmbRyqTBuxffNzTyD0kzGujRk8q1cpuxZ1Yak
9pRbG62obZZaXZY5s13IJce2ssqs2sQWJTEpKYawlREjozp29o/3POf3z/Oc
89rG7g6VGhoYGIj0939OPW+5bZ9328dr9i6vz4KPzvNW+/kqOW9L3j2XKnM+
YNkea6Wq4b3yLExNN+MjNbise66qiRfnfW+F7WI+zN7STuq6O3jWMWtvJ5jw
0dcQtHuyu5+3XhHobjyHjw32o73j3e94Jv6GqflvAV03UajpNoRrTL7xmVbg
lt9FxUO5BTp9+VqjTIDed30o1mU5vE8oxnj6+SWJ0WVGfnaYaSM/ezYPOOmx
4c8g8Wo4f/dm+fZTPDw57a4cN2UgjLtVYeHOQ54ivd1wqQesFhvX05t9QPt5
4Kjs3FoMBczRZGz3Qc5mgU/HlBcUm15Hl5r5IJlZGt2SRWK6Yu1gRz0X/mMz
B3YNsPBphAwW7uIikxMSs4zkYkdD16jDKi5Ylb/UHmrkoToujabr5SBxejzj
7kI+VAZ/32Cc40DnbPqcIfZFwMq8ohQJB5zyKyVFRX7o29Oa7EPnYNxcuC28
yR++vsa6CTUb6mPbwpOMNqCESLukLGdDMLZPMOgdgNpDhdda0th4HTc/uTZ9
IxwiugKM/Nn6f9IMc5oEKF91yuy4ORvm9x0LqseE2Hb0klYyxAI9tyrY2zsQ
gTJ+2Ld1LJx2Zppa7BChxvSRj+A4C63L+F4TPwWhv/gylZXAAovedMKt6yuI
8tskFmBh0Vx5SkxWMLi2sc6t1izYZK7gRDqGoLZesWBCy4SxQ9S10OYQ8LKk
UWQHE67cpVX7qFCoVc+GaTVMJD03vyU0CMOg8JD84AkmxiaOiQWnw+Bsk3yU
mcREgNudYgFjM3ryP1fnipm4OcH+8L5tMxwLZ9ckEUzscvHseSgVQx3SWiWi
M8F9G98ZaRyOPBPfL1SzJNbbW4kWysPR0P/PA9shEqszfkxrIiLgIet9evU+
CScps9GhJwKM7IYyw1oS0psJh2v3bEH0h45bd86SaCzpjB+3jER7gTibOkxi
8tLse7c/IjG/wKPZbieJOIdy42KRBB/PPCCst5AYd5J512gkEOt6s7V8EnWK
Dy+1uVshD26jvWCQkPjbgW0TBfWV0KV1y0hY78y57qqMQlebYjJzHglLk8Sr
oggKRhl119dMElD4HTygiaTQ9GTHiGqCgOfBAj9ZFIWPPxSvzNU7SFP9WBVD
ocwm++rQOwJHurS6uEQKG+M9+YpxAtPydN8DmRQqHGSOtmMEetiyRxfKKXzv
9Ncn21ECCXsVZwWVFJT7SiUdIwSmKn+Xvq6mYEd/oMzS23yl6r3HNQolarPL
A8MENs1fTr+hpDDSrxv+7RWBhs4L8Y8eUyhfr7F3GSQgXFTHSFVRKHWcsOxV
E1AFtExZPaUQleJkWqD3ZP2/uV+/oNA47PalZoAAo9S9YmSUgiDwm8rafn1f
Dz/12BsKoxf7h6V6C5eE8dw0FNb9mu1C03t7zt6HKVoKYbNe7ftf6vuUR4pp
0xQiSH9XZ72zZk7F1c9QkFYkFz17QcB03WUX6hOFzOYmowK9z++s187OUlig
ccvi6f0fngYujg==
           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVkGk41AkcgGXajXqqScnRsDaUjXF0yNnvx7hmaoQcjfxXrt3q0VSosEVq
/mOMcQ6Tq9nyzNo2oaxKIpYOahMyzZhto2Q7N6zB0JZtP7zP++398H4dfSAo
TltLS4v9mf899bTrlkX2rS2eeZ39Lk+k0C81TPFQVgJl2ayGp5AC6j+MNlTW
g00HNaenTwpHAi4oKMp2EFLZ2vFdUlj23qBwRtEHQvqvSxquSmGw2f+AWvEc
RFlUU0GBFHws3vw5rvgHkpzYla5+UphRbC4eU2gj2zhaXnP9DHQwfpb1Vi7H
5Lz7eq+KK4A2eP2vaBsTpMYn/6ApKYcV8ZEXFjDMcdEr+djey2VQ6OBzwz/E
ChuLEmcf3CmFgRL7tnEqHf0kcsroTAlky9Ifahs54Cfmypjub0rAoGg4S3xm
AxotlW+FfachM5i5pW9qExYIXQwnf5NAovO5yK6TTvhiUJ0j15eA1+hsKnfY
BUXdtdUr0oohwy0wytjJHZtqHZPnjxeBS21pQ1orYH3EsbB3kUUQrxk/0bnY
A1emrwpLGBTDjDX1KT3EE43mx22y3CUGt+qLZyUSBpZvL2feGyyEcT3W7tB2
LwwN53hbJRTCC9Hu0IQFPvg7Y9dMs1YhMEePMkccfdF6aeL8uvICeBejk9iQ
7oeBqe2aZRsKPv800M5sZ+LlvYdez/bkg96DNbmXRlk4wgt9G5ySDzRBXYCj
4zY86G14HEzzocTambr8ezYWl/HNdpfmwT1jj00TBf5Y2GIZWTqXCy609ny7
x9uxsNO6CiNzYQmlMinqZACa1T+6G/4wB0wzvnLjrAnEnXds5SznHNC1jLga
dDcQJ6IClpZVi8DW3ajuKBGEz7KHxOttRJDwVK+DpbUDzx4Lvj1WlQ2jE6IQ
ZskOrHDp4LyxzQZfuztlTHownrfwHzZvEcLNCdcP093B+FJKiev1FgLXZr2q
Ny4EnTpH5tmqssD9fWw/RzcUW/sWNgTuzQJvC0P24spQ3HPtdkE4JQusTgiT
2zeHYYbOorRDlQJYF+fcaqkKw6HXw1yJmwDibu7hNRzaidxPJlqJQ5nQerY/
dlyfgx6Wrqdk6ZmgPj83bXeNgwFmJy5mmWdCjGW1bhk7HFtkId5mPXwYXyd2
rB8Lx5SkC/rbkvnQKPvwbFKwC+kBZsNVVnwI9zJHV9MIHBjmYt0TElbtz7xu
2xaBc73TLIGIBP2F8ZfZYQS+UjcVdTJIkDGOp45xCCTvy4wEniSsP57LEEcQ
OBHkd8vXgwT/sUtyZRSBgr5zwrtbSOA/npyJiSfQPO2FqtOZBE1lumdqBoEb
J56c6rMjQeUqflRVTWCodl7XPBoJew7LKpi1BIoGRjS3jUmYqr0S9+4SgVHe
FmyhEQl6q5XTDlcJTJlzj11uQMJWHRNaS9vnnpf9trV6JDT3V8U+khNo73/g
Y4gOCawljfQjSgIlF12SaQtIUPp2TRn+QSBXxTcY/oIEddNbwbdDBN5bI+g4
SCGBfs6+5vUbAjn7jvXkfOJBs8rjiOhvAteaVXBDPvKAtWIH2I0ReKNX18Hk
Xx58l3m4N2mSwP0DV1bXzPBA3cYvM9AQ6CN6GXhYw4OTs6djmmYJdFOzf3Kf
5gF14y82xEcCWR3PaV9O8UC6v2lybo5A45ofG7vVPPgPxgg+oA==
            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ]}, {{}, {}}}, {{{1., 0.}, {
       0., 516.4319258007301}}, {0., 18.591549295774644`}}], {
      GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{-0.7018603072921343, -2.9167434081605106`}, {
            4.323343309966162, 33.14036001143523}], 
           Offset[{-1.0130997068429732`, -7.777982421761364}, {
            2.0247935098667567`, 31.677937227037628`}], 
           Offset[{-19.74076370407093, -7.777982421761369}, {
            2.0247935098667567`, 31.677937227037628`}], 
           Offset[{-19.74076370407093, -21.77798242176137}, {
            2.0247935098667567`, 31.677937227037628`}], 
           Offset[{42.25923629592907, -21.777982421761354`}, {
            2.0247935098667567`, 31.677937227037628`}], 
           Offset[{42.25923629592907, -7.7779824217613545`}, {
            2.0247935098667567`, 31.677937227037628`}], 
           Offset[{6.351730763977714, -7.7779824217613625`}, {
            2.0247935098667567`, 31.677937227037628`}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{11.259236295929073, -14.777982421761362}, \
{2.0247935098667567, 31.677937227037628}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{1.573086086056712, 2.554486282181757}, {
             25.441615794097423`, 0.021341045670680053`}], 
            Offset[{4.194896229484563, -0.03331709067937787}, {
             27.97520649013324, 0.02256072578304822}], 
            Offset[{4.194896229484563, -0.18803658084865482`}, {
             27.97520649013324, 0.02256072578304822}], 
            Offset[{60.19489622948456, -0.1880365808486424}, {
             27.97520649013324, 0.02256072578304822}], 
            Offset[{60.19489622948456, 13.811963419151358`}, {
             27.97520649013324, 0.02256072578304822}], 
            Offset[{4.194896229484563, 13.811963419151345`}, {
             27.97520649013324, 0.02256072578304822}], 
            Offset[{4.194896229484563, 2.4930207519441216`}, {
             27.97520649013324, 0.02256072578304822}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{32.19489622948456, 6.811963419151351}, \
{27.97520649013324, 0.02256072578304822}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
        516.4319258007301}}, {0., 18.591549295774644`}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 23.875969063476173`},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.035999999936 + 0.0019363636329212126` #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.035999999936 + 0.0019363636329212126` #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{0.009087438841862704, 0.03198982718995062}, {
          23.284592837474158`, 35.112117357513405`}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{24., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"24\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {26., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"26\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {28., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"28\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {30., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"30\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {32., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"32\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {34., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"34\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {23.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         27., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         27.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         31.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.5, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         23.755868553781944`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
010\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.01`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 3]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {26.338028182785592`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
015\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.015`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 3]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {28.920187811789244`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
020\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.02`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 3]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {31.502347440792896`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
025\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
0.025`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 3]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {34.084507069796544`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
030\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.03`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 3]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {24.272300479582672`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.788732405383403`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.30516433118413, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.82159625698486, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.854460108586323`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         27.370892034387055`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         27.887323960187782`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         28.403755885988513`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.436619737589975`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         29.953051663390703`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.469483589191434`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30.985915514992165`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.01877936659362, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         32.53521129239435, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.05164321819508, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         33.56807514399581, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         34.600938995597275`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"75\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"100\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         120., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         120., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 56.04882609844208}, {28.34375, 1.}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-2.5, 122.5}, {23.284592837474158`, 35.112117357513405`}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV0Hs0lAkYBnDpbGK7uGRHmbRyqTBuxffNzTyD0kzGujRk8q1cpuxZ1Yak
9pRbG62obZZaXZY5s13IJce2ssqs2sQWJTEpKYawlREjozp29o/3POf3z/Oc
89rG7g6VGhoYGIj0939OPW+5bZ9328dr9i6vz4KPzvNW+/kqOW9L3j2XKnM+
YNkea6Wq4b3yLExNN+MjNbise66qiRfnfW+F7WI+zN7STuq6O3jWMWtvJ5jw
0dcQtHuyu5+3XhHobjyHjw32o73j3e94Jv6GqflvAV03UajpNoRrTL7xmVbg
lt9FxUO5BTp9+VqjTIDed30o1mU5vE8oxnj6+SWJ0WVGfnaYaSM/ezYPOOmx
4c8g8Wo4f/dm+fZTPDw57a4cN2UgjLtVYeHOQ54ivd1wqQesFhvX05t9QPt5
4Kjs3FoMBczRZGz3Qc5mgU/HlBcUm15Hl5r5IJlZGt2SRWK6Yu1gRz0X/mMz
B3YNsPBphAwW7uIikxMSs4zkYkdD16jDKi5Ylb/UHmrkoToujabr5SBxejzj
7kI+VAZ/32Cc40DnbPqcIfZFwMq8ohQJB5zyKyVFRX7o29Oa7EPnYNxcuC28
yR++vsa6CTUb6mPbwpOMNqCESLukLGdDMLZPMOgdgNpDhdda0th4HTc/uTZ9
IxwiugKM/Nn6f9IMc5oEKF91yuy4ORvm9x0LqseE2Hb0klYyxAI9tyrY2zsQ
gTJ+2Ld1LJx2Zppa7BChxvSRj+A4C63L+F4TPwWhv/gylZXAAovedMKt6yuI
8tskFmBh0Vx5SkxWMLi2sc6t1izYZK7gRDqGoLZesWBCy4SxQ9S10OYQ8LKk
UWQHE67cpVX7qFCoVc+GaTVMJD03vyU0CMOg8JD84AkmxiaOiQWnw+Bsk3yU
mcREgNudYgFjM3ryP1fnipm4OcH+8L5tMxwLZ9ckEUzscvHseSgVQx3SWiWi
M8F9G98ZaRyOPBPfL1SzJNbbW4kWysPR0P/PA9shEqszfkxrIiLgIet9evU+
CScps9GhJwKM7IYyw1oS0psJh2v3bEH0h45bd86SaCzpjB+3jER7gTibOkxi
8tLse7c/IjG/wKPZbieJOIdy42KRBB/PPCCst5AYd5J512gkEOt6s7V8EnWK
Dy+1uVshD26jvWCQkPjbgW0TBfWV0KV1y0hY78y57qqMQlebYjJzHglLk8Sr
oggKRhl119dMElD4HTygiaTQ9GTHiGqCgOfBAj9ZFIWPPxSvzNU7SFP9WBVD
ocwm++rQOwJHurS6uEQKG+M9+YpxAtPydN8DmRQqHGSOtmMEetiyRxfKKXzv
9Ncn21ECCXsVZwWVFJT7SiUdIwSmKn+Xvq6mYEd/oMzS23yl6r3HNQolarPL
A8MENs1fTr+hpDDSrxv+7RWBhs4L8Y8eUyhfr7F3GSQgXFTHSFVRKHWcsOxV
E1AFtExZPaUQleJkWqD3ZP2/uV+/oNA47PalZoAAo9S9YmSUgiDwm8rafn1f
Dz/12BsKoxf7h6V6C5eE8dw0FNb9mu1C03t7zt6HKVoKYbNe7ftf6vuUR4pp
0xQiSH9XZ72zZk7F1c9QkFYkFz17QcB03WUX6hOFzOYmowK9z++s187OUlig
ccvi6f0fngYujg==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwV0Hs0lAkYBnDpbGK7uGRHmbRyqTBuxffNzTyD0kzGujRk8q1cpuxZ1Yak
9pRbG62obZZaXZY5s13IJce2ssqs2sQWJTEpKYawlREjozp29o/3POf3z/Oc
89rG7g6VGhoYGIj0939OPW+5bZ9328dr9i6vz4KPzvNW+/kqOW9L3j2XKnM+
YNkea6Wq4b3yLExNN+MjNbise66qiRfnfW+F7WI+zN7STuq6O3jWMWtvJ5jw
0dcQtHuyu5+3XhHobjyHjw32o73j3e94Jv6GqflvAV03UajpNoRrTL7xmVbg
lt9FxUO5BTp9+VqjTIDed30o1mU5vE8oxnj6+SWJ0WVGfnaYaSM/ezYPOOmx
4c8g8Wo4f/dm+fZTPDw57a4cN2UgjLtVYeHOQ54ivd1wqQesFhvX05t9QPt5
4Kjs3FoMBczRZGz3Qc5mgU/HlBcUm15Hl5r5IJlZGt2SRWK6Yu1gRz0X/mMz
B3YNsPBphAwW7uIikxMSs4zkYkdD16jDKi5Ylb/UHmrkoToujabr5SBxejzj
7kI+VAZ/32Cc40DnbPqcIfZFwMq8ohQJB5zyKyVFRX7o29Oa7EPnYNxcuC28
yR++vsa6CTUb6mPbwpOMNqCESLukLGdDMLZPMOgdgNpDhdda0th4HTc/uTZ9
IxwiugKM/Nn6f9IMc5oEKF91yuy4ORvm9x0LqseE2Hb0klYyxAI9tyrY2zsQ
gTJ+2Ld1LJx2Zppa7BChxvSRj+A4C63L+F4TPwWhv/gylZXAAovedMKt6yuI
8tskFmBh0Vx5SkxWMLi2sc6t1izYZK7gRDqGoLZesWBCy4SxQ9S10OYQ8LKk
UWQHE67cpVX7qFCoVc+GaTVMJD03vyU0CMOg8JD84AkmxiaOiQWnw+Bsk3yU
mcREgNudYgFjM3ryP1fnipm4OcH+8L5tMxwLZ9ckEUzscvHseSgVQx3SWiWi
M8F9G98ZaRyOPBPfL1SzJNbbW4kWysPR0P/PA9shEqszfkxrIiLgIet9evU+
CScps9GhJwKM7IYyw1oS0psJh2v3bEH0h45bd86SaCzpjB+3jER7gTibOkxi
8tLse7c/IjG/wKPZbieJOIdy42KRBB/PPCCst5AYd5J512gkEOt6s7V8EnWK
Dy+1uVshD26jvWCQkPjbgW0TBfWV0KV1y0hY78y57qqMQlebYjJzHglLk8Sr
oggKRhl119dMElD4HTygiaTQ9GTHiGqCgOfBAj9ZFIWPPxSvzNU7SFP9WBVD
ocwm++rQOwJHurS6uEQKG+M9+YpxAtPydN8DmRQqHGSOtmMEetiyRxfKKXzv
9Ncn21ECCXsVZwWVFJT7SiUdIwSmKn+Xvq6mYEd/oMzS23yl6r3HNQolarPL
A8MENs1fTr+hpDDSrxv+7RWBhs4L8Y8eUyhfr7F3GSQgXFTHSFVRKHWcsOxV
E1AFtExZPaUQleJkWqD3ZP2/uV+/oNA47PalZoAAo9S9YmSUgiDwm8rafn1f
Dz/12BsKoxf7h6V6C5eE8dw0FNb9mu1C03t7zt6HKVoKYbNe7ftf6vuUR4pp
0xQiSH9XZ72zZk7F1c9QkFYkFz17QcB03WUX6hOFzOYmowK9z++s187OUlig
ccvi6f0fngYujg==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 120}, {23.87596906347612, 
               34.15525052370359}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 23.875969063476173`}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 120}, {23.87596906347612, 34.15525052370359}},
             "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 23.875969063476173`}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwV0Hs0lAkYBnDpbGK7uGRHmbRyqTBuxffNzTyD0kzGujRk8q1cpuxZ1Yak
9pRbG62obZZaXZY5s13IJce2ssqs2sQWJTEpKYawlREjozp29o/3POf3z/Oc
89rG7g6VGhoYGIj0939OPW+5bZ9328dr9i6vz4KPzvNW+/kqOW9L3j2XKnM+
YNkea6Wq4b3yLExNN+MjNbise66qiRfnfW+F7WI+zN7STuq6O3jWMWtvJ5jw
0dcQtHuyu5+3XhHobjyHjw32o73j3e94Jv6GqflvAV03UajpNoRrTL7xmVbg
lt9FxUO5BTp9+VqjTIDed30o1mU5vE8oxnj6+SWJ0WVGfnaYaSM/ezYPOOmx
4c8g8Wo4f/dm+fZTPDw57a4cN2UgjLtVYeHOQ54ivd1wqQesFhvX05t9QPt5
4Kjs3FoMBczRZGz3Qc5mgU/HlBcUm15Hl5r5IJlZGt2SRWK6Yu1gRz0X/mMz
B3YNsPBphAwW7uIikxMSs4zkYkdD16jDKi5Ylb/UHmrkoToujabr5SBxejzj
7kI+VAZ/32Cc40DnbPqcIfZFwMq8ohQJB5zyKyVFRX7o29Oa7EPnYNxcuC28
yR++vsa6CTUb6mPbwpOMNqCESLukLGdDMLZPMOgdgNpDhdda0th4HTc/uTZ9
IxwiugKM/Nn6f9IMc5oEKF91yuy4ORvm9x0LqseE2Hb0klYyxAI9tyrY2zsQ
gTJ+2Ld1LJx2Zppa7BChxvSRj+A4C63L+F4TPwWhv/gylZXAAovedMKt6yuI
8tskFmBh0Vx5SkxWMLi2sc6t1izYZK7gRDqGoLZesWBCy4SxQ9S10OYQ8LKk
UWQHE67cpVX7qFCoVc+GaTVMJD03vyU0CMOg8JD84AkmxiaOiQWnw+Bsk3yU
mcREgNudYgFjM3ryP1fnipm4OcH+8L5tMxwLZ9ckEUzscvHseSgVQx3SWiWi
M8F9G98ZaRyOPBPfL1SzJNbbW4kWysPR0P/PA9shEqszfkxrIiLgIet9evU+
CScps9GhJwKM7IYyw1oS0psJh2v3bEH0h45bd86SaCzpjB+3jER7gTibOkxi
8tLse7c/IjG/wKPZbieJOIdy42KRBB/PPCCst5AYd5J512gkEOt6s7V8EnWK
Dy+1uVshD26jvWCQkPjbgW0TBfWV0KV1y0hY78y57qqMQlebYjJzHglLk8Sr
oggKRhl119dMElD4HTygiaTQ9GTHiGqCgOfBAj9ZFIWPPxSvzNU7SFP9WBVD
ocwm++rQOwJHurS6uEQKG+M9+YpxAtPydN8DmRQqHGSOtmMEetiyRxfKKXzv
9Ncn21ECCXsVZwWVFJT7SiUdIwSmKn+Xvq6mYEd/oMzS23yl6r3HNQolarPL
A8MENs1fTr+hpDDSrxv+7RWBhs4L8Y8eUyhfr7F3GSQgXFTHSFVRKHWcsOxV
E1AFtExZPaUQleJkWqD3ZP2/uV+/oNA47PalZoAAo9S9YmSUgiDwm8rafn1f
Dz/12BsKoxf7h6V6C5eE8dw0FNb9mu1C03t7zt6HKVoKYbNe7ftf6vuUR4pp
0xQiSH9XZ72zZk7F1c9QkFYkFz17QcB03WUX6hOFzOYmowK9z++s187OUlig
ccvi6f0fngYujg==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 120}, {23.87596906347612, 34.15525052370359}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 23.875969063476173`}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 23.875969063476173`},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 120}, {23.87596906347612, 34.15525052370359}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVkGk41AkcgGXajXqqScnRsDaUjXF0yNnvx7hmaoQcjfxXrt3q0VSosEVq
/mOMcQ6Tq9nyzNo2oaxKIpYOahMyzZhto2Q7N6zB0JZtP7zP++398H4dfSAo
TltLS4v9mf899bTrlkX2rS2eeZ39Lk+k0C81TPFQVgJl2ayGp5AC6j+MNlTW
g00HNaenTwpHAi4oKMp2EFLZ2vFdUlj23qBwRtEHQvqvSxquSmGw2f+AWvEc
RFlUU0GBFHws3vw5rvgHkpzYla5+UphRbC4eU2gj2zhaXnP9DHQwfpb1Vi7H
5Lz7eq+KK4A2eP2vaBsTpMYn/6ApKYcV8ZEXFjDMcdEr+djey2VQ6OBzwz/E
ChuLEmcf3CmFgRL7tnEqHf0kcsroTAlky9Ifahs54Cfmypjub0rAoGg4S3xm
AxotlW+FfachM5i5pW9qExYIXQwnf5NAovO5yK6TTvhiUJ0j15eA1+hsKnfY
BUXdtdUr0oohwy0wytjJHZtqHZPnjxeBS21pQ1orYH3EsbB3kUUQrxk/0bnY
A1emrwpLGBTDjDX1KT3EE43mx22y3CUGt+qLZyUSBpZvL2feGyyEcT3W7tB2
LwwN53hbJRTCC9Hu0IQFPvg7Y9dMs1YhMEePMkccfdF6aeL8uvICeBejk9iQ
7oeBqe2aZRsKPv800M5sZ+LlvYdez/bkg96DNbmXRlk4wgt9G5ySDzRBXYCj
4zY86G14HEzzocTambr8ezYWl/HNdpfmwT1jj00TBf5Y2GIZWTqXCy609ny7
x9uxsNO6CiNzYQmlMinqZACa1T+6G/4wB0wzvnLjrAnEnXds5SznHNC1jLga
dDcQJ6IClpZVi8DW3ajuKBGEz7KHxOttRJDwVK+DpbUDzx4Lvj1WlQ2jE6IQ
ZskOrHDp4LyxzQZfuztlTHownrfwHzZvEcLNCdcP093B+FJKiev1FgLXZr2q
Ny4EnTpH5tmqssD9fWw/RzcUW/sWNgTuzQJvC0P24spQ3HPtdkE4JQusTgiT
2zeHYYbOorRDlQJYF+fcaqkKw6HXw1yJmwDibu7hNRzaidxPJlqJQ5nQerY/
dlyfgx6Wrqdk6ZmgPj83bXeNgwFmJy5mmWdCjGW1bhk7HFtkId5mPXwYXyd2
rB8Lx5SkC/rbkvnQKPvwbFKwC+kBZsNVVnwI9zJHV9MIHBjmYt0TElbtz7xu
2xaBc73TLIGIBP2F8ZfZYQS+UjcVdTJIkDGOp45xCCTvy4wEniSsP57LEEcQ
OBHkd8vXgwT/sUtyZRSBgr5zwrtbSOA/npyJiSfQPO2FqtOZBE1lumdqBoEb
J56c6rMjQeUqflRVTWCodl7XPBoJew7LKpi1BIoGRjS3jUmYqr0S9+4SgVHe
FmyhEQl6q5XTDlcJTJlzj11uQMJWHRNaS9vnnpf9trV6JDT3V8U+khNo73/g
Y4gOCawljfQjSgIlF12SaQtIUPp2TRn+QSBXxTcY/oIEddNbwbdDBN5bI+g4
SCGBfs6+5vUbAjn7jvXkfOJBs8rjiOhvAteaVXBDPvKAtWIH2I0ReKNX18Hk
Xx58l3m4N2mSwP0DV1bXzPBA3cYvM9AQ6CN6GXhYw4OTs6djmmYJdFOzf3Kf
5gF14y82xEcCWR3PaV9O8UC6v2lybo5A45ofG7vVPPgPxgg+oA==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVkGk41AkcgGXajXqqScnRsDaUjXF0yNnvx7hmaoQcjfxXrt3q0VSosEVq
/mOMcQ6Tq9nyzNo2oaxKIpYOahMyzZhto2Q7N6zB0JZtP7zP++398H4dfSAo
TltLS4v9mf899bTrlkX2rS2eeZ39Lk+k0C81TPFQVgJl2ayGp5AC6j+MNlTW
g00HNaenTwpHAi4oKMp2EFLZ2vFdUlj23qBwRtEHQvqvSxquSmGw2f+AWvEc
RFlUU0GBFHws3vw5rvgHkpzYla5+UphRbC4eU2gj2zhaXnP9DHQwfpb1Vi7H
5Lz7eq+KK4A2eP2vaBsTpMYn/6ApKYcV8ZEXFjDMcdEr+djey2VQ6OBzwz/E
ChuLEmcf3CmFgRL7tnEqHf0kcsroTAlky9Ifahs54Cfmypjub0rAoGg4S3xm
AxotlW+FfachM5i5pW9qExYIXQwnf5NAovO5yK6TTvhiUJ0j15eA1+hsKnfY
BUXdtdUr0oohwy0wytjJHZtqHZPnjxeBS21pQ1orYH3EsbB3kUUQrxk/0bnY
A1emrwpLGBTDjDX1KT3EE43mx22y3CUGt+qLZyUSBpZvL2feGyyEcT3W7tB2
LwwN53hbJRTCC9Hu0IQFPvg7Y9dMs1YhMEePMkccfdF6aeL8uvICeBejk9iQ
7oeBqe2aZRsKPv800M5sZ+LlvYdez/bkg96DNbmXRlk4wgt9G5ySDzRBXYCj
4zY86G14HEzzocTambr8ezYWl/HNdpfmwT1jj00TBf5Y2GIZWTqXCy609ny7
x9uxsNO6CiNzYQmlMinqZACa1T+6G/4wB0wzvnLjrAnEnXds5SznHNC1jLga
dDcQJ6IClpZVi8DW3ajuKBGEz7KHxOttRJDwVK+DpbUDzx4Lvj1WlQ2jE6IQ
ZskOrHDp4LyxzQZfuztlTHownrfwHzZvEcLNCdcP093B+FJKiev1FgLXZr2q
Ny4EnTpH5tmqssD9fWw/RzcUW/sWNgTuzQJvC0P24spQ3HPtdkE4JQusTgiT
2zeHYYbOorRDlQJYF+fcaqkKw6HXw1yJmwDibu7hNRzaidxPJlqJQ5nQerY/
dlyfgx6Wrqdk6ZmgPj83bXeNgwFmJy5mmWdCjGW1bhk7HFtkId5mPXwYXyd2
rB8Lx5SkC/rbkvnQKPvwbFKwC+kBZsNVVnwI9zJHV9MIHBjmYt0TElbtz7xu
2xaBc73TLIGIBP2F8ZfZYQS+UjcVdTJIkDGOp45xCCTvy4wEniSsP57LEEcQ
OBHkd8vXgwT/sUtyZRSBgr5zwrtbSOA/npyJiSfQPO2FqtOZBE1lumdqBoEb
J56c6rMjQeUqflRVTWCodl7XPBoJew7LKpi1BIoGRjS3jUmYqr0S9+4SgVHe
FmyhEQl6q5XTDlcJTJlzj11uQMJWHRNaS9vnnpf9trV6JDT3V8U+khNo73/g
Y4gOCawljfQjSgIlF12SaQtIUPp2TRn+QSBXxTcY/oIEddNbwbdDBN5bI+g4
SCGBfs6+5vUbAjn7jvXkfOJBs8rjiOhvAteaVXBDPvKAtWIH2I0ReKNX18Hk
Xx58l3m4N2mSwP0DV1bXzPBA3cYvM9AQ6CN6GXhYw4OTs6djmmYJdFOzf3Kf
5gF14y82xEcCWR3PaV9O8UC6v2lybo5A45ofG7vVPPgPxgg+oA==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 120}, {0.0102325582592671, 
               0.03013698505141283}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.010232558259267123`}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 120}, {0.0102325582592671, 
              0.03013698505141283}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.010232558259267123`}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVkGk41AkcgGXajXqqScnRsDaUjXF0yNnvx7hmaoQcjfxXrt3q0VSosEVq
/mOMcQ6Tq9nyzNo2oaxKIpYOahMyzZhto2Q7N6zB0JZtP7zP++398H4dfSAo
TltLS4v9mf899bTrlkX2rS2eeZ39Lk+k0C81TPFQVgJl2ayGp5AC6j+MNlTW
g00HNaenTwpHAi4oKMp2EFLZ2vFdUlj23qBwRtEHQvqvSxquSmGw2f+AWvEc
RFlUU0GBFHws3vw5rvgHkpzYla5+UphRbC4eU2gj2zhaXnP9DHQwfpb1Vi7H
5Lz7eq+KK4A2eP2vaBsTpMYn/6ApKYcV8ZEXFjDMcdEr+djey2VQ6OBzwz/E
ChuLEmcf3CmFgRL7tnEqHf0kcsroTAlky9Ifahs54Cfmypjub0rAoGg4S3xm
AxotlW+FfachM5i5pW9qExYIXQwnf5NAovO5yK6TTvhiUJ0j15eA1+hsKnfY
BUXdtdUr0oohwy0wytjJHZtqHZPnjxeBS21pQ1orYH3EsbB3kUUQrxk/0bnY
A1emrwpLGBTDjDX1KT3EE43mx22y3CUGt+qLZyUSBpZvL2feGyyEcT3W7tB2
LwwN53hbJRTCC9Hu0IQFPvg7Y9dMs1YhMEePMkccfdF6aeL8uvICeBejk9iQ
7oeBqe2aZRsKPv800M5sZ+LlvYdez/bkg96DNbmXRlk4wgt9G5ySDzRBXYCj
4zY86G14HEzzocTambr8ezYWl/HNdpfmwT1jj00TBf5Y2GIZWTqXCy609ny7
x9uxsNO6CiNzYQmlMinqZACa1T+6G/4wB0wzvnLjrAnEnXds5SznHNC1jLga
dDcQJ6IClpZVi8DW3ajuKBGEz7KHxOttRJDwVK+DpbUDzx4Lvj1WlQ2jE6IQ
ZskOrHDp4LyxzQZfuztlTHownrfwHzZvEcLNCdcP093B+FJKiev1FgLXZr2q
Ny4EnTpH5tmqssD9fWw/RzcUW/sWNgTuzQJvC0P24spQ3HPtdkE4JQusTgiT
2zeHYYbOorRDlQJYF+fcaqkKw6HXw1yJmwDibu7hNRzaidxPJlqJQ5nQerY/
dlyfgx6Wrqdk6ZmgPj83bXeNgwFmJy5mmWdCjGW1bhk7HFtkId5mPXwYXyd2
rB8Lx5SkC/rbkvnQKPvwbFKwC+kBZsNVVnwI9zJHV9MIHBjmYt0TElbtz7xu
2xaBc73TLIGIBP2F8ZfZYQS+UjcVdTJIkDGOp45xCCTvy4wEniSsP57LEEcQ
OBHkd8vXgwT/sUtyZRSBgr5zwrtbSOA/npyJiSfQPO2FqtOZBE1lumdqBoEb
J56c6rMjQeUqflRVTWCodl7XPBoJew7LKpi1BIoGRjS3jUmYqr0S9+4SgVHe
FmyhEQl6q5XTDlcJTJlzj11uQMJWHRNaS9vnnpf9trV6JDT3V8U+khNo73/g
Y4gOCawljfQjSgIlF12SaQtIUPp2TRn+QSBXxTcY/oIEddNbwbdDBN5bI+g4
SCGBfs6+5vUbAjn7jvXkfOJBs8rjiOhvAteaVXBDPvKAtWIH2I0ReKNX18Hk
Xx58l3m4N2mSwP0DV1bXzPBA3cYvM9AQ6CN6GXhYw4OTs6djmmYJdFOzf3Kf
5gF14y82xEcCWR3PaV9O8UC6v2lybo5A45ofG7vVPPgPxgg+oA==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 120}, {0.0102325582592671, 0.03013698505141283}},
          "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.010232558259267123`}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.010232558259267123`},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 120}, {0.0102325582592671, 0.03013698505141283}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVkns01AkcxS3b2V4sajKJdiU2eZU0ksf3y5Ada4x3S/NrPMsWKRXRSuTE
LFukh5VN+GHMjGfjmYlDp02LNo9m4oRi62wv7HjMEHb2j3vuuf98zrn3XIPQ
GJ8IVRUVFaZS//vcSNfD7ZkPHfd+WJRxhGIYuENNcJIWg9gGEqTlYkDK01Cq
tA72BDoF+5SIIc6LL1GTdkC/36KXe74YtD7pXFNI+sCXIRS4Z4hhtNUzZkby
GkbYsS1Z4WI4sP3dy2nJv+DWIJzR2ioGhcTmxpREFdvO+3WuXG+FTno5+ax4
A472Lj+P/fk+6I02vwk108e3R7trHbgtsDGKw/+KbojjlT3UW/xmuLb7wH1P
/x3IFa7f9kVXE7zI29U+rWmOrhwmW+3LJsgkk5+qbt6Ntql/fR63awSd6+Pc
3N/3IJu6rHbvUgOk+zEc++b2YqGQ0/fqVT2cti3idKXuw/XGyatD7OvBZXIh
8cT4fhyMZwXE8UWQYu8dorvPASnj32r1bxPB/qrfRBfaAN+UW11l3boHUfLp
i4/VnXBd2uCVR1vugcJUc8Tc3xnhZA8lu6AO7AXCuzdv0vGj7GOrzKgOprXd
gwM6XFCNuWTBba2FiazggNivDmCZ4crdRFYtMCbjGX/T3FBeXyFgfaqBD2Gr
T4uSv0dtqQu/iVuj3FNHNb2DgTsvsY4dNa0B7R7jKzWT7jj6ni7FqmrQy6j2
otE8sJPWXaSzUgV5praaG44y0ZdnNeEYWgVPdJ32ynI8cUJD5hDaWwn79Tqy
LZ+zULVR1dvauhI01IrPhKR64dPHnxmSCiFsTfnGPtDYG58ohGNZm4Wwxojd
4POHN/70tR6NlSMAC4fN1fGED+pzWkx7NwkgdkS7013FF20K5SeEN/kwKcvy
Z+T54vruuG66IR/cLB/lM8z98HF7yY2X9RXwQGa3ON/rh2bYN2NAr4ATZlZD
zyL8MQ0Z4cXDPHD4FD4QuCYAs69e9NOP4YHrdipTvTgA17mITLTVebDj4i/n
OmwOYsm7Obfx6nLYGWHbZjR0EHuMhrfImOUQ8SAyTXTqR0xavvY6aLYM2u4O
hE9TAvGQ01iOa14ZzPBW5i0bAzF43aqCeiiDMCPBmnxmEALvQVLKZClM78yl
1U0Foa3B4EaN26XQRC6+ms04hL9Wx1MSPEshyMUQ7bay0SvLMiZ6VSlsiU5v
tmhnY2d/Jv9QEwmUtVG1zIMENhY4YGQsCSQ9KXEqkEAuk0e1PkWCVdIVei6b
QC37QIrKSRI8p2oGpSEEimlnzudFk3D5+awiLIpAtmhY8SSSBHlxsnNiCoEs
j5FmGoeEIbvc/jIBgUfkx3VNPEiIPEsWMKoI/NPEN0bhTsJcVX3EhxoCE3Ma
3nYxSNDeJp3f3UDgmPEL5+NuJPywWl9P3E7gWnK0qNqZhNaBsvD+QQJ1szOW
HG1JcNdoMo+TKrOeR7rWPhKkbl1z1GFlVjexnqCRMNPyPuPwGIGnb2+a51qT
YF60q/KfdwRamFIMJJZK3pBTXNZHZb8b8g6+hZK30Rcsp5T90h6mXzAn4Uj6
2WdnZgkcLFxKMDZV8tov5+vICTxGHi5fMCEhdeFWWMsCgctjV+d7d5CgaV1h
RiwRWOiaeazkOxLuRLfMrqwQuKh83TljEv4DXChGng==
            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ]}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVkns01AkcxS3b2V4sajKJdiU2eZU0ksf3y5Ada4x3S/NrPMsWKRXRSuTE
LFukh5VN+GHMjGfjmYlDp02LNo9m4oRi62wv7HjMEHb2j3vuuf98zrn3XIPQ
GJ8IVRUVFaZS//vcSNfD7ZkPHfd+WJRxhGIYuENNcJIWg9gGEqTlYkDK01Cq
tA72BDoF+5SIIc6LL1GTdkC/36KXe74YtD7pXFNI+sCXIRS4Z4hhtNUzZkby
GkbYsS1Z4WI4sP3dy2nJv+DWIJzR2ioGhcTmxpREFdvO+3WuXG+FTno5+ax4
A472Lj+P/fk+6I02vwk108e3R7trHbgtsDGKw/+KbojjlT3UW/xmuLb7wH1P
/x3IFa7f9kVXE7zI29U+rWmOrhwmW+3LJsgkk5+qbt6Ntql/fR63awSd6+Pc
3N/3IJu6rHbvUgOk+zEc++b2YqGQ0/fqVT2cti3idKXuw/XGyatD7OvBZXIh
8cT4fhyMZwXE8UWQYu8dorvPASnj32r1bxPB/qrfRBfaAN+UW11l3boHUfLp
i4/VnXBd2uCVR1vugcJUc8Tc3xnhZA8lu6AO7AXCuzdv0vGj7GOrzKgOprXd
gwM6XFCNuWTBba2FiazggNivDmCZ4crdRFYtMCbjGX/T3FBeXyFgfaqBD2Gr
T4uSv0dtqQu/iVuj3FNHNb2DgTsvsY4dNa0B7R7jKzWT7jj6ni7FqmrQy6j2
otE8sJPWXaSzUgV5praaG44y0ZdnNeEYWgVPdJ32ynI8cUJD5hDaWwn79Tqy
LZ+zULVR1dvauhI01IrPhKR64dPHnxmSCiFsTfnGPtDYG58ohGNZm4Wwxojd
4POHN/70tR6NlSMAC4fN1fGED+pzWkx7NwkgdkS7013FF20K5SeEN/kwKcvy
Z+T54vruuG66IR/cLB/lM8z98HF7yY2X9RXwQGa3ON/rh2bYN2NAr4ATZlZD
zyL8MQ0Z4cXDPHD4FD4QuCYAs69e9NOP4YHrdipTvTgA17mITLTVebDj4i/n
OmwOYsm7Obfx6nLYGWHbZjR0EHuMhrfImOUQ8SAyTXTqR0xavvY6aLYM2u4O
hE9TAvGQ01iOa14ZzPBW5i0bAzF43aqCeiiDMCPBmnxmEALvQVLKZClM78yl
1U0Foa3B4EaN26XQRC6+ms04hL9Wx1MSPEshyMUQ7bay0SvLMiZ6VSlsiU5v
tmhnY2d/Jv9QEwmUtVG1zIMENhY4YGQsCSQ9KXEqkEAuk0e1PkWCVdIVei6b
QC37QIrKSRI8p2oGpSEEimlnzudFk3D5+awiLIpAtmhY8SSSBHlxsnNiCoEs
j5FmGoeEIbvc/jIBgUfkx3VNPEiIPEsWMKoI/NPEN0bhTsJcVX3EhxoCE3Ma
3nYxSNDeJp3f3UDgmPEL5+NuJPywWl9P3E7gWnK0qNqZhNaBsvD+QQJ1szOW
HG1JcNdoMo+TKrOeR7rWPhKkbl1z1GFlVjexnqCRMNPyPuPwGIGnb2+a51qT
YF60q/KfdwRamFIMJJZK3pBTXNZHZb8b8g6+hZK30Rcsp5T90h6mXzAn4Uj6
2WdnZgkcLFxKMDZV8tov5+vICTxGHi5fMCEhdeFWWMsCgctjV+d7d5CgaV1h
RiwRWOiaeazkOxLuRLfMrqwQuKh83TljEv4DXChGng==
                "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 120}, {0.03935599330487346, 
               0.11591148096697242`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0.03935599330487355}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 120}, {0.03935599330487346, 
              0.11591148096697242`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0.03935599330487355}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVkns01AkcxS3b2V4sajKJdiU2eZU0ksf3y5Ada4x3S/NrPMsWKRXRSuTE
LFukh5VN+GHMjGfjmYlDp02LNo9m4oRi62wv7HjMEHb2j3vuuf98zrn3XIPQ
GJ8IVRUVFaZS//vcSNfD7ZkPHfd+WJRxhGIYuENNcJIWg9gGEqTlYkDK01Cq
tA72BDoF+5SIIc6LL1GTdkC/36KXe74YtD7pXFNI+sCXIRS4Z4hhtNUzZkby
GkbYsS1Z4WI4sP3dy2nJv+DWIJzR2ioGhcTmxpREFdvO+3WuXG+FTno5+ax4
A472Lj+P/fk+6I02vwk108e3R7trHbgtsDGKw/+KbojjlT3UW/xmuLb7wH1P
/x3IFa7f9kVXE7zI29U+rWmOrhwmW+3LJsgkk5+qbt6Ntql/fR63awSd6+Pc
3N/3IJu6rHbvUgOk+zEc++b2YqGQ0/fqVT2cti3idKXuw/XGyatD7OvBZXIh
8cT4fhyMZwXE8UWQYu8dorvPASnj32r1bxPB/qrfRBfaAN+UW11l3boHUfLp
i4/VnXBd2uCVR1vugcJUc8Tc3xnhZA8lu6AO7AXCuzdv0vGj7GOrzKgOprXd
gwM6XFCNuWTBba2FiazggNivDmCZ4crdRFYtMCbjGX/T3FBeXyFgfaqBD2Gr
T4uSv0dtqQu/iVuj3FNHNb2DgTsvsY4dNa0B7R7jKzWT7jj6ni7FqmrQy6j2
otE8sJPWXaSzUgV5praaG44y0ZdnNeEYWgVPdJ32ynI8cUJD5hDaWwn79Tqy
LZ+zULVR1dvauhI01IrPhKR64dPHnxmSCiFsTfnGPtDYG58ohGNZm4Wwxojd
4POHN/70tR6NlSMAC4fN1fGED+pzWkx7NwkgdkS7013FF20K5SeEN/kwKcvy
Z+T54vruuG66IR/cLB/lM8z98HF7yY2X9RXwQGa3ON/rh2bYN2NAr4ATZlZD
zyL8MQ0Z4cXDPHD4FD4QuCYAs69e9NOP4YHrdipTvTgA17mITLTVebDj4i/n
OmwOYsm7Obfx6nLYGWHbZjR0EHuMhrfImOUQ8SAyTXTqR0xavvY6aLYM2u4O
hE9TAvGQ01iOa14ZzPBW5i0bAzF43aqCeiiDMCPBmnxmEALvQVLKZClM78yl
1U0Foa3B4EaN26XQRC6+ms04hL9Wx1MSPEshyMUQ7bay0SvLMiZ6VSlsiU5v
tmhnY2d/Jv9QEwmUtVG1zIMENhY4YGQsCSQ9KXEqkEAuk0e1PkWCVdIVei6b
QC37QIrKSRI8p2oGpSEEimlnzudFk3D5+awiLIpAtmhY8SSSBHlxsnNiCoEs
j5FmGoeEIbvc/jIBgUfkx3VNPEiIPEsWMKoI/NPEN0bhTsJcVX3EhxoCE3Ma
3nYxSNDeJp3f3UDgmPEL5+NuJPywWl9P3E7gWnK0qNqZhNaBsvD+QQJ1szOW
HG1JcNdoMo+TKrOeR7rWPhKkbl1z1GFlVjexnqCRMNPyPuPwGIGnb2+a51qT
YF60q/KfdwRamFIMJJZK3pBTXNZHZb8b8g6+hZK30Rcsp5T90h6mXzAn4Uj6
2WdnZgkcLFxKMDZV8tov5+vICTxGHi5fMCEhdeFWWMsCgctjV+d7d5CgaV1h
RiwRWOiaeazkOxLuRLfMrqwQuKh83TljEv4DXChGng==
            "]]}, "Charting`Private`Tag#1"]}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 120}, {0.03935599330487346, 
           0.11591148096697242`}}, 
         "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0.03935599330487355}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0.03935599330487355},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 120}, {0.03935599330487346, 0.11591148096697242`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{{3.9381839312557545`*^9, 3.938184028894957*^9}},
 CellLabel->
  "Out[259]=",ExpressionUUID->"6f685ba2-3ea5-0249-9533-4ecb2ced7aa1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["f = 300, 50, 8", "Subsubsection",
 CellChangeTimes->{{3.9381839273580914`*^9, 3.938183929133024*^9}, {
  3.938184230636715*^9, 3.938184238686615*^9}, {3.9381842827204943`*^9, 
  3.938184283087326*^9}, {3.9382627051998386`*^9, 
  3.938262712231716*^9}},ExpressionUUID->"fb5168e1-e17c-ff4c-acde-\
2478f60df4ee"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"300", ",", "300", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "20", ",", "50", ",", "8", ",", "80", ",", "22"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "116"}], "]"}]}], "Input",
 CellChangeTimes->{{3.938184072740335*^9, 3.938184150100092*^9}, {
  3.938184295950194*^9, 3.9381842960532093`*^9}, {3.938262717456564*^9, 
  3.938262724362283*^9}, {3.938263091072033*^9, 3.938263095195671*^9}},
 CellLabel->
  "In[142]:=",ExpressionUUID->"d055a91b-a871-594e-953b-91a56fcec901"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"90.62286500739786`", "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm[90.62286500739786, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.9406816947878265`*^9, 3.9406817092093353`*^9}, 
   3.9406817862922916`*^9, 3.9406818166736393`*^9, 3.940682017106371*^9},
 CellLabel->
  "During evaluation of \
In[142]:=",ExpressionUUID->"dbe85059-c801-cd45-b338-309429693796"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH
lLHBUChRkqFkKqHMdEuGotQNjcp0FRpkvN33/rHXXp/1Xc93vfvZe2s5H7Dd
ISsjIxNGr//uNZdWlLxoqeSqNxRnPljIoKg25vghJonXr93nUUwtsul+wDK5
vJmXLxrnUctHKncTpoIn72BXkEzda6g3uohp5HEXLI/zp3byN5ygx3zg7V+d
9BbUcTfzQ3SYrzzpsZojhQYM8njDVvMZWajY6QQn6TMYNDbQtBhRQhJvfImG
LoN5T5puui+fjbdZRWnh8xmEDM0MS0/QRlmeemKdFoPZ262H0gN1cVQS7hI0
hwFnCnK6Zi1CxjU1HV11Bh6BGmtnBy2FOLh+9oyZDMrS5MqXDhhC1mwg8JIS
gzV7njS5mHKwSd+qokuBwY1X6kFXchjYOa+305nIgO0QvR4ZM0HyGttPY+MY
bIl9a1DFXQmfnTEDSiMExj+GVaKzuZi9ovTPdV8J9N6TZ7cLuXgQHmpnSK1a
dyjiWQUX8oqp1VOph5O7FZSbuPBe53PwYT9BkX2zXOQQF5LUxbcYatwpHDxr
wUPv9Mnlyn0EksNerWHPefDxNskv/Exwa3C4wdwHUKvQ25jfSTD6Y23Zcl+g
MyHjewi19be0TJ1TwKSmgf1bqXs+rw+bdA749stiVIZ6UVuuoOEaUGu5/w9x
B8GNOrd8pxpAs6ar5OkngrSk5viTaubo9ecGP/hAkGx9z7W4wBxzDWtec1oJ
TLVklsYWm2PDh/aoXy0EjT+Eg4cqzLEpKlmjmvpXQkOwXq05cvIX3txCvbm/
Mz3qrTk0YhzSTjQTTLsws2e3nAW6PlcN3f+LwOeth/sMewv8HNq6UamJwP7Q
kqMHei3QbxV9RbOOQF+uVDrwzQJjqnda39US/BO3Ovj4oAX61p5tu0qdXr4v
JmwcH16vXG3m/TeflpGXqszHgYIZifNq6PNk6X19y/Ah1DzTqFpNMNajtcdG
ykdD/LSQ5ip6fmnOoZcBfDjdyD0bTZ2mYu69LYSPhWsTNqymtl3pFLI3ko8Z
42QMyivpPCwhNTiZD02/0CfXKujcQP1j2SM+fnpde7q1jCDFVcVh2XQBbEv7
NS/dJ3gm+/qw2gwBjtmYDgqpZRKuh/6mLsDnyfVeffdoP89JQdN8AXRyMt0F
1Armm5S9jQXoSVm5qLOAwEMtobrCUYAMj0fr5twlsKjTJfaZAtSW77M2zyY4
sKvP2uy2AJnPGhTfZRHE/1a4fUGBAHJf9HadoB4wYSMGywX4JN/9vDCT9pWy
tye+SYBouYHQhbfo+5DmJH0aFUC/q+3BUDrBG0NTRU8rITbf9JRdeY2APb1q
h7yNEJFHru56lkSQ1+F4/6q9EFWlO7e4UYfHB7jWOgjx6E5V24WrBCZy9aVa
7kIYlB1x604kiH7l5F4bLcTScFGidzyBlfRUg9YbIdY8u1Nucp7gbnOsbv4H
IbI2FOmURxNoc24et+4QolaudVhEPdj1RN+zT4gjK1y/20XRfu1U/WplLdFj
wJ24I4JAVjfD0FPXEomVqx+6nSYoqGuIqnW3RJzNtsLRAIJjSzSGKv+wRMD1
sY0u1NyIXdvue1vC9yJXp8afoMr+l96NAEsUxxetvOBH8LRlUUlQrCUWl64g
2lKCzq6gTosyS7zTVs1XPEYwS45rVqgoQl2K19+G7gQtriFJ2SoimP6T+LvP
AYKE6uf/S1MVwfljcEXVfoL5p/c0XpgnwvY/c1bY7iNYqhLn6sGI4P/JsNjR
jUCs/T1iiaMILz3U8y1cCI5yb7RfzxShwkh3qsoGAj/Pjzqnbouwu7rnuMl6
2nf2nB07C0RoJ8mBDusIrmhHtS2oEKEru3v1VTuCR3I+71KbRDhz3tZlpg09
75NVzemjIog161fdE9O+HfvrbrFimMS7txUbE5TFLlQ4s0aM6uz9kZkMweOG
Hdb77cWYMNNgzWVCvwd+8+PF28RwGea2ehgRTNCrfJh1UAzPNyvTpyyl/2tf
dHlOrBiud990Ny4g+Co1zstrF2PKVv5wnBLBiqNFyy3+FoN355vvhukE/geR
W98rRsni93FK0whUnMVZHYNifJnxw8FXgYDwN6arTpFA0cdpNybSPiZ4XT6+
RIIY6xfFZmMcVIyNqE82kkBpgTjv6QgHkwdOXrxgLIFzvVGx0zAHF9uDYrLM
Jbg4se+V508Oih7GRLy3k2DT3Diubz8HMqH5gUIvCZZNau/++ZEDsZ/p+EYf
CQzN2FUb2jiI8C712+YrgdvQqNrt9xxo73l40jNUgu+9CY8c33DAt355ND1e
gsRIvnL4Sw5OTf25T6FcgnfGHS3zqzlQiCLrmyaxWK65l/c5jYPMyG9tlVNZ
aAY6jjubwsHqyOyDucoswtzkOQbJHJyJMDh9VoNFVPtxf+tEDqaem1MlWcbC
aNn9GLPz1KflDEs2shhRdMHdk3RfeGVphgOLtS1Nr9750H3h0lWXnFnUev5o
lfWm+8KGd3ntZVG41tRvkQfNh35JNJSyWGAuLZu+izrohUJqKgvbz2aWo6vo
vlNRl85nsHDMVa8JZum+Uzb6ATksvoz3r5gkovsCHwt+v8/iw+FGjU4ezQeU
HFN/wiL20axSxWU0739s0uTnLExzv6mZ/J/m/Y1jBv9i8dKhpcNen+b9cnOb
PrDY13owx1mL5n1Tus4OsAiKvX2hfhrNS7d7nhhhkdI8Tt1fnualcyfsk7EC
x+bhOd2JNH/y4lx2shUk1svbuL+MEKC0V+uWmhX6zjhvruo1wr+5fd6g
           "]], LineBox[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVkHk41Ikfx6nGliKLSqbaDCFdllw5Ph9mxsx8DVHq6SKRZX+lsG1D1Iwj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            "]], LineBox[CompressedData["
1:eJwVk2k4lAsfxpWcpKIsSaXtJJWynRai11/KVsPzzAwGzyk5WbqynMpSIjOU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            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, {{{
       0.9999999999999999, 0.}, {0., 
       26.86078980787497}}, {-4.440892098500626*^-16, 
       23.398399835339557`}}], {GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{0.20316584498479168`, 2.9931127007567917`}, {
            7.670985480481858, 23.139817059688838`}], 
           Offset[{4.0177379393575645`, 7.981633868684779}, {
            7.876032940462135, 23.367225616244617`}], 
           Offset[{33.07711870113641, 7.981633868684785}, {7.876032940462135, 
            23.367225616244617`}], 
           Offset[{33.07711870113641, 21.981633868684785`}, {
            7.876032940462135, 23.367225616244617`}], 
           Offset[{-28.92288129886359, 21.98163386868477}, {7.876032940462135,
             23.367225616244617`}], 
           Offset[{-28.92288129886359, 7.981633868684771}, {7.876032940462135,
             23.367225616244617`}], 
           Offset[{-3.4371919851893535`, 7.981633868684777}, {
            7.876032940462135, 23.367225616244617`}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{2.0771187011364107, 14.981633868684778}, \
{7.876032940462135, 23.367225616244617}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-0.47170504305298844`, 2.9626836402758863`}, {
             22.60493043280684, 0.012490917359899743`}], 
            Offset[{3.039808406282659, 7.900489707402366}, {22.12396705953786,
              0.020957107601599457`}], 
            Offset[{24.002588038756024`, 7.900489707402371}, {
             22.12396705953786, 0.020957107601599457`}], 
            Offset[{24.002588038756024`, 21.90048970740237}, {
             22.12396705953786, 0.020957107601599457`}], 
            Offset[{-31.997411961243976`, 21.900489707402357`}, {
             22.12396705953786, 0.020957107601599457`}], 
            Offset[{-31.997411961243976`, 7.900489707402358}, {
             22.12396705953786, 0.020957107601599457`}], 
            Offset[{-4.3795168833187805`, 7.900489707402365}, {
             22.12396705953786, 0.020957107601599457`}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], Offset[{-3.9974119612439765, 14.900489707402365}, 
          {22.12396705953786, 0.020957107601599457}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{0.9999999999999999, 0.}, {0., 
        26.86078980787497}}, {-4.440892098500626*^-16, 
        23.398399835339557`}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 20.93658986002173},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.8710987280232422 + 0.037228987202261005` #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -0.8710987280232422 + 0.037228987202261005` #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{-0.10211547871469381`, 0.10718025426903058`}, {
          20.655497425453635`, 26.27734611681458}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{21., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"21\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {22., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"22\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {23., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"23\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {24., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"24\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {26., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"26\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         20.712320854552058`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.10\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
-0.1`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 2]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {22.055360344945804`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.05\\\\\\\"\\\", Rule[ShowStringCharacters, False]], \
-0.05`15.954589770191003, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[DirectedInfinity[1], 2]]]], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {23.398399835339553`, 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {24.741439325733303`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
05\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.05`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {26.08447881612705, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
10\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 2]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {20.980928752630806`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.249536650709555`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.518144548788307`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.786752446867055`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.323968243024556`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.592576141103304`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.861184039182053`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.129791937260805`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.667007733418302`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.935615631497054`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.204223529575803`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.47283142765455, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.01004722381205, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.2786551218908, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.547263019969552`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.8158709180483, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"75\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"100\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 57.60546672344208}, {28.34375, 1.}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-2.416666666666667, 118.41666666666667`}, {
     20.655497425453635`, 26.27734611681458}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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            "]], LineBox[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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                "]], 
               Line[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {20.936589860021684`, 
               25.822529003703025`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 20.93658986002173}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {20.936589860021684`, 
              25.822529003703025`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 20.93658986002173}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH
lLHBUChRkqFkKqHMdEuGotQNjcp0FRpkvN33/rHXXp/1Xc93vfvZe2s5H7Dd
ISsjIxNGr//uNZdWlLxoqeSqNxRnPljIoKg25vghJonXr93nUUwtsul+wDK5
vJmXLxrnUctHKncTpoIn72BXkEzda6g3uohp5HEXLI/zp3byN5ygx3zg7V+d
9BbUcTfzQ3SYrzzpsZojhQYM8njDVvMZWajY6QQn6TMYNDbQtBhRQhJvfImG
LoN5T5puui+fjbdZRWnh8xmEDM0MS0/QRlmeemKdFoPZ262H0gN1cVQS7hI0
hwFnCnK6Zi1CxjU1HV11Bh6BGmtnBy2FOLh+9oyZDMrS5MqXDhhC1mwg8JIS
gzV7njS5mHKwSd+qokuBwY1X6kFXchjYOa+305nIgO0QvR4ZM0HyGttPY+MY
bIl9a1DFXQmfnTEDSiMExj+GVaKzuZi9ovTPdV8J9N6TZ7cLuXgQHmpnSK1a
dyjiWQUX8oqp1VOph5O7FZSbuPBe53PwYT9BkX2zXOQQF5LUxbcYatwpHDxr
wUPv9Mnlyn0EksNerWHPefDxNskv/Exwa3C4wdwHUKvQ25jfSTD6Y23Zcl+g
MyHjewi19be0TJ1TwKSmgf1bqXs+rw+bdA749stiVIZ6UVuuoOEaUGu5/w9x
B8GNOrd8pxpAs6ar5OkngrSk5viTaubo9ecGP/hAkGx9z7W4wBxzDWtec1oJ
TLVklsYWm2PDh/aoXy0EjT+Eg4cqzLEpKlmjmvpXQkOwXq05cvIX3txCvbm/
Mz3qrTk0YhzSTjQTTLsws2e3nAW6PlcN3f+LwOeth/sMewv8HNq6UamJwP7Q
kqMHei3QbxV9RbOOQF+uVDrwzQJjqnda39US/BO3Ovj4oAX61p5tu0qdXr4v
JmwcH16vXG3m/TeflpGXqszHgYIZifNq6PNk6X19y/Ah1DzTqFpNMNajtcdG
ykdD/LSQ5ip6fmnOoZcBfDjdyD0bTZ2mYu69LYSPhWsTNqymtl3pFLI3ko8Z
42QMyivpPCwhNTiZD02/0CfXKujcQP1j2SM+fnpde7q1jCDFVcVh2XQBbEv7
NS/dJ3gm+/qw2gwBjtmYDgqpZRKuh/6mLsDnyfVeffdoP89JQdN8AXRyMt0F
1Armm5S9jQXoSVm5qLOAwEMtobrCUYAMj0fr5twlsKjTJfaZAtSW77M2zyY4
sKvP2uy2AJnPGhTfZRHE/1a4fUGBAHJf9HadoB4wYSMGywX4JN/9vDCT9pWy
tye+SYBouYHQhbfo+5DmJH0aFUC/q+3BUDrBG0NTRU8rITbf9JRdeY2APb1q
h7yNEJFHru56lkSQ1+F4/6q9EFWlO7e4UYfHB7jWOgjx6E5V24WrBCZy9aVa
7kIYlB1x604kiH7l5F4bLcTScFGidzyBlfRUg9YbIdY8u1Nucp7gbnOsbv4H
IbI2FOmURxNoc24et+4QolaudVhEPdj1RN+zT4gjK1y/20XRfu1U/WplLdFj
wJ24I4JAVjfD0FPXEomVqx+6nSYoqGuIqnW3RJzNtsLRAIJjSzSGKv+wRMD1
sY0u1NyIXdvue1vC9yJXp8afoMr+l96NAEsUxxetvOBH8LRlUUlQrCUWl64g
2lKCzq6gTosyS7zTVs1XPEYwS45rVqgoQl2K19+G7gQtriFJ2SoimP6T+LvP
AYKE6uf/S1MVwfljcEXVfoL5p/c0XpgnwvY/c1bY7iNYqhLn6sGI4P/JsNjR
jUCs/T1iiaMILz3U8y1cCI5yb7RfzxShwkh3qsoGAj/Pjzqnbouwu7rnuMl6
2nf2nB07C0RoJ8mBDusIrmhHtS2oEKEru3v1VTuCR3I+71KbRDhz3tZlpg09
75NVzemjIog161fdE9O+HfvrbrFimMS7txUbE5TFLlQ4s0aM6uz9kZkMweOG
Hdb77cWYMNNgzWVCvwd+8+PF28RwGea2ehgRTNCrfJh1UAzPNyvTpyyl/2tf
dHlOrBiud990Ny4g+Co1zstrF2PKVv5wnBLBiqNFyy3+FoN355vvhukE/geR
W98rRsni93FK0whUnMVZHYNifJnxw8FXgYDwN6arTpFA0cdpNybSPiZ4XT6+
RIIY6xfFZmMcVIyNqE82kkBpgTjv6QgHkwdOXrxgLIFzvVGx0zAHF9uDYrLM
Jbg4se+V508Oih7GRLy3k2DT3Diubz8HMqH5gUIvCZZNau/++ZEDsZ/p+EYf
CQzN2FUb2jiI8C712+YrgdvQqNrt9xxo73l40jNUgu+9CY8c33DAt355ND1e
gsRIvnL4Sw5OTf25T6FcgnfGHS3zqzlQiCLrmyaxWK65l/c5jYPMyG9tlVNZ
aAY6jjubwsHqyOyDucoswtzkOQbJHJyJMDh9VoNFVPtxf+tEDqaem1MlWcbC
aNn9GLPz1KflDEs2shhRdMHdk3RfeGVphgOLtS1Nr9750H3h0lWXnFnUev5o
lfWm+8KGd3ntZVG41tRvkQfNh35JNJSyWGAuLZu+izrohUJqKgvbz2aWo6vo
vlNRl85nsHDMVa8JZum+Uzb6ATksvoz3r5gkovsCHwt+v8/iw+FGjU4ezQeU
HFN/wiL20axSxWU0739s0uTnLExzv6mZ/J/m/Y1jBv9i8dKhpcNen+b9cnOb
PrDY13owx1mL5n1Tus4OsAiKvX2hfhrNS7d7nhhhkdI8Tt1fnualcyfsk7EC
x+bhOd2JNH/y4lx2shUk1svbuL+MEKC0V+uWmhX6zjhvruo1wr+5fd6g
            "]], 
           Line[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {20.936589860021684`, 
           25.822529003703025`}}, "Frame" -> {{False, False}, {False, False}},
          "AxesOrigin" -> {0, 20.93658986002173}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 20.93658986002173},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 116}, {20.936589860021684`, 25.822529003703025`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVkHk41Ikfx6nGliKLSqbaDCFdllw5Ph9mxsx8DVHq6SKRZX+lsG1D1Iwj
dzLj1jQZwgzSjHOUctUWkRRt2Q5ROVZJ1yLZ9fvj/byf1/N6//XW8z2+w3+e
kpJS8lz+3/cubLv5+K9WB87ew0F0ERcaOrJPh1oVQPAJ0i29Qi4w3EdvE1aV
sCuEk/tvCReWCLRGLa1a4H0Rv7VRzoVxM+OZjVYP4ciKpcY7bnPBJ8aMZGw1
AJcYul2NY1zILatLXGf1Ef7Z977t0Boe1MC0i4HVPOzjbLW4F8yDSWuTn5y+
aSJhO32TvSUK9Lt6y4LNV2Hr3eafgieiIHFqRbJUREH5DGWXUXM0rPJjT0nP
GiHJ0H64SxEDFotRPqKzEXVKD4QZK2LhxNnVHqviTfFUhKtPw99noUmi0mz6
1Qz7SRFWPId42H6kq/ewrQUqe4+z+eIEKH1Kjs+XW+GG15r723YlATHEeP7t
uw0OB+pQHI1SYH/OS5NbDnaY5Pr8h0izVLD+Mq2dIXPA+kb9/Q1+aWD8yvJR
Vb0Dqg3/PW8qMA1WdobyH7U4IMcifoHNsTSYvjyqptXrgOH3VlFaw9KgwbNP
RTDlgHdFn/SUUtMAq+snzzsBdm5TkNfWpwHrt7BnyT2Ayu0JuhqafLgyOd3t
GImYGv67elQXH2a+eDSZRyH+wkWBxWM+sD9JKtbFIa7Zdshg/Bkfxt7tTl6U
hjitkZkUMsqHjYOVtO5CxH1yhnI1SQClnf+r87mHOKFu1bbVXgCSgj4hV9cR
B1zabTxkArjMvhZwQ+GI+i4rKb9J0sFWT8k054YjeoWutA2TpcPDL/TJ0Ja5
vd/MqxhFOvwr6k4w7nBENY5kquJuOuybGJamv3RED7K5xa6RdNDIWjH2q4oT
bjKVbh7ZkAGRL08EL/d0whuBJdKjtRngGbol/Pi4E+qlC2aVBzNhvUoj7+sn
J5wfeETCGMuE2Vy3hNOTTvhIv9U080smSJuDspOVqWgUoU9iLsyCWY3ymhIt
Kvp2P32qtjkLJFeNP760omL4m+bd+hFZ8H1M74g7j4qbXq8+30LOhoc8eeif
sVT8rrm8T8cwGyTajqe8E6kojLsWGGaaDTvsfBKPCqi4c79KzE76nE8WlSRc
puId3zT1iONz3oT8uukuFQt61N/k3c6G4gBtr59/pGH/xTP1p8Nz4NG857/p
LqfhlqTvFM24HFASFSXNJ9OwUXwlqkqQA/t6LBW9BjSMC1l0fHV5Dqg57tU6
ZU3DjPIqetrLHDihK2prOUjDY6lLPBawcsGp08jSs4KGX+OWtbcY5sHxwA9s
+yoa+mm4ktda5IFwfr2foYKGXZem7c5R8+CrDcGfbKahfZV4X7ZPHkiLj44J
e2n4YbPHaNCFPNDgyQvezNDw3UBihJ32BXhhZruU40JHU8KkbpOWEIhzrv5L
3Ol4J4WaIKYIoWbo4HWxJx0DV7j6G5oJIUUYG9DhRcdWrZhqPw8h2Kjcb9QL
puPWZ4L7V9OEkPHUJ7gjY46HNytLNC+CCy+uW+8FHQcXujP/MRBBbV+OUd0A
HR+xfKPuWoqAYlF2mj1ExyDhwOMKpggmR7rWcz7QMcLoS9D1oyIo3rkyumOe
MxJDEu6TGhHMMyo34xg5o9HMaiU6+xIoOrvTO4KdcTxyxd5Eej5EbFk91fq7
Mz55uqS43T0fHPiB3tdPOSPNouM8+UA+3PL817g01hlTP7s1jIXmw4O/Nt6M
z3HGA5Rla93F+TA8Ej/s1OSM7otJsTbKYtBRcbCvX8rA4Wa7nkv3xfBXQGKB
TJuBD9iGHPIzMYjaen6QrGRgDelMRtmIGAzOHXmYpc/AQkPz6UWkAjDVzg04
YcXA5dsFVbfsCoBJ+czfcpCBQyEf+r1kBRDuUPq2qIKB/QVxYrG0EKI5r9fF
VTHQSOLC+aO+EFJka/x/UTDwp1W+b0jthZBPSR80bGHguOny9N7RQrirEtlf
0svA0DW24sZNl0Gny7VPOsPABVlj72YUl6H24ETnFYKJ2m9/bqMNFUFTzga1
1O1M7D2kQdn+rQjau/3ZxzyZ6D+WyTyztBheUPvaN3szce+EajbbuhhIxq13
roYwcY9piaI6uRg8P2Q0y3OYGPCq0k57Wwl85FnX1LxlYrOO4iRHIYFt4Q3m
Tn8z0XZtvxbrgQRiQrDy/jgTJ2baWpnDEtD2ZV4dmmRivqTiZI+OFCype6Qr
F7Ow5sT7PRsjpRBOCrt4egsLlxkueezNLoWW79/IqltZmEJzZu0KKAXVr9y8
LGsWIvlHiIkuhby38dlXHVk4+zrXP6G+FBruZPNf7WThtV8bDVxMykApqe4s
PYyFRWWQu2dFOTCjbRc8jGThq5M/HF1jWQ78U43R3lEsfGJW9NloVzlQjtzh
cpJY+Klu8ZVFGeVAZf8ZLhWyUFs4gHrLrkCc+j9Bas0sPGm/fn3EugpQS7fc
3buIQMv3E7O7qTKoEHwabFUn0Kv2841re2XgJpCFVGoRyLZnhx0IlkEq3+Tc
+dUE7tx6c9xLJAP1tDW3WD8T+Dmx6fLJ73N8TsXs5h4C8z7GvFBuk0NFSmtj
uReBxsG3zDsG5eCWwnO94Eug59Z19UOzckhNng4MO0pgZpW5iY5lJagnvb9k
xiPwup4vL1Eyx/GP1UpKCAzIZi0wvFQFFXHpFzLLCSTbnHv3R2MVuMW5r4+V
E7hwlqHR218FqWfbaYeuE3N/fpM5GlSDeuzNCHIXgdKPvieFsmqoiIlYpNpD
IJN3ePBtTzW4xVhnTz4hUFtUwpNPVUNqdGVl7wCBCWXX1R/SakA9qnjk/FcC
dz94Skl7VQMVPD/OmW8Edo5+gQ2qteDGW0sKUnLB0x9cN3qb10IqN28toeqC
44ncjznxtbBHJau2QdcFmw6EaEbq1sF/MIj7iQ==
            "]], LineBox[CompressedData["
1:eJwVk2k4lAsfxpWcpKIsSaXtJJWynRai11/KVsPzzAwGzyk5WbqynMpSIjOU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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVkHk41Ikfx6nGliKLSqbaDCFdllw5Ph9mxsx8DVHq6SKRZX+lsG1D1Iwj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                "]], 
               Line[CompressedData["
1:eJwVk2k4lAsfxpWcpKIsSaXtJJWynRai11/KVsPzzAwGzyk5WbqynMpSIjOU
vFKWsYxlrGlGZMuSij9CkSZrak6KNhM6R2o6ltTr/XBf94f7vu7fp3uDuz/d
Y76MjMy1Of3fg/33ipuWE2BerxJ4MqgGKw+Wha7XJGB4ocRPkleN9f/Kh6ev
I0Dt5PjY++BqfFh4jKO6kQCvcCfBJVo1ipeqRMlrE8Dmt5Xwp6tQ5llg3Lg+
AV88cou7XauQ5mmS13CAgPztnayyPZXouDLp+l4rAubvOGzkolaJbu1jNypt
CJhcefJr8JfbGKCbVSS0IyDNk/pXrvw2pn+TqYpnze3HXFXSN7iNH6JaH7r5
EPCZTVovPFCB40br2sV+BIT+yeqd0a7AqZHgDuYpApY93DtzcEkFLrHf2mUd
RMB/NIyW9PWVo6F6rFifTQCft6iryqccwwXkJ5kkApZvNzzoLCzD7S25lH8K
AfGrUgX+CWUofvP58QCPANOvy+43h5ThzrWJN+/yCUg07JHRtitDSVK3V4CA
AP+awjj3f0qRiGC8Gb5LwPX9YkfdmyU4m51POtYRMC0rv8spsgRv1n1paEYC
LvDdZoaoElwwxc3ObSagMGRPlPryErzj30u5iggoPluy4GXYLVz/u0O/aIgA
k8nooCKvYnwSUmC57x0BjT39NUzLYgzhSauKPhCgtFhr8JBWMfb2JCdFjxJg
Pe5dtO5dEUbbPiP3SwnIseDlgkcRju9x6qiSJ+GBjqJnYsBNbFR2bszUI2Hg
JH88uVGIisvsiCEDEka88OfnQiG6LLV4rbWThBTygML5RCFOLNwxW2JEwsxA
tYrycSFumpUxbjQnoaPigb/lIiFGDQvL3jNIeEuatRxzFaDt/cls3bMksI/K
TrBX38CU2k+6Z0JIGLPa9uy6/A18U/2mriaUhFx5QYdEWoDnyzv+Ag4JorC4
oqedBVh8I0edETOXhw5FL4suQKUE67jgTBLKw5ser/l+HXs9eBcaGkjIjLie
FD6Zjx0ftqrtfkDC4NB0vmg4H5u97hUVtZCg/5QbYdyfj5UnXj1PaSfBaiEr
7Vh1Pib7bvrNt5eEeGuVri+B+egYWDasISHh+C80a8lUHvZffEScUaKD4on0
fWdV8rBTzmVYspwOG5zbItvl8vBR1GjYEVU6CJYu9jOYzMU70YpFNhp0sKBm
A0wHcpEXy5Rb/ysdzDn7HPcLc5GVNFjbsZsOrW0C92HzXBTnT27cfIQOLS/o
JuEROXh6gd6LU2500Fy0akd/cA4u8vCIq3Of45k29Jv65qDR5u4ZphcdbO9u
/1uflYPJwqLeyD/p4GdZf6hWNweJW0eihiLokNizdPbE/WxsrW7+mCmgg/dv
pLVPbBYeUZ/JlhTSwaxC3mlHSBZKgw0cdxbP8UT+mxZ4Z+Em46ymx2V0OLg4
2m3CIgs594IzpmvpQAmP737ynY+mDdtorA465F3MMKVO87G8Lb5M5TMd7J50
Jf9zMhPHkut7GF/osGqwf+8ZKhM3u49940rp8DOzpnohLRMzp632qU7Tod6G
3+Kum4nROj/bVGUZ8L5Pwf7V5ww8ctX3rZoaAxL+q2bRez4DFUjbFSuNGfCx
kTBclpGOBzXPGrNMGCCpfP0g7Go6sj8WULx9DKgSrNaeCk9HKWde/sr9DBgQ
RSpqeKTjYMUdPY1DDNh0ulpzRi8da1S1bVb9zgClmp2Fux+l4fHnsqFrOAyw
SNG8/8v8NLTdIrpxNZIBcSfff5eV8tDgLK/rxyUGqH1yb1CU8PCH+g7toRgG
/AwRnj8s4mGak2N3QRIDNjdKOJ4ZPBQ9E27REzLA2cfMVtaIh3v6aH3mTxng
cPjQPdeQVFToTtX10mSCgH9B/GJdCsbPW3iuZB0TOrN5t1grUnCFQdAD6QYm
9Ng1C14vScGN8UzWxc3Muf+ED8tNJ6Ox3fKIXD0mTLbcOlPRm4ze7TF9f5kz
QUlhYjziSjK2NoWFEp5MsHhl4Ff/Iwk5t/9oNy6dy0NjHtZMcbHC039NRTkT
1LfJXSI/c/Gdxnm/bZVMKD0ttp+QcNGanai8upYJilM6I9bPuahIa3T53sSE
utZmU5saLmZ+WDta/4wJqqm33l4L4mK1hnjxgR9M2P7uJUM6lYhj4QTNjuYA
ozqPzeKVE7FOeR5m2juA4gU/u01LEvFaQbn+KOkA7VdqR+/LJaL+Y2XVaEcH
eD08Vj8zmYABK/rEjUcdwKau07z0dQLOFDt77zrtAGUTwuyPtxJQQeweuSbV
AcJOd5jE0hJQe2dg7cigA+iadFrk8OLRrCvgj7xTjhAwv+GO/r1raOuc/DVD
0Qkk3OzrMadicXPbJz/NXCcIP98WyuHFoPRXr85BMxYo+sa9r3kejTle9/zx
LxbErK58OOJ4GddwrSa1fJ1h+OLtp9IVURhb+NVLpOACZqvG7+cMXsQOwYuG
H3wXeCV926n1MhI/XktzstV1hUv7ky7af43AKbeQvv52V/AMnDcZrxSB4lVc
008UBX/4uG1pOMzBxhXnLp87SoE8TSs63IaDQuWj3XLuFJhWNa0HSw4GKeh4
r/WiwPdE61SzGQdVppu49qcocJF9smfAkIOHX0yMlF+iwEfF9bCVBgfrU+lp
QSUUdE1W7pr9wMYCrtG7+eUUjGtJjr95y8bYuLV6cbcpCKx8V/NokI0ul0ea
BXfm9k3utPLEbPw3KGL8eRMFOsMOQZYiNuo7VliZ9FPwkk1y+6vYqE7nJT58
QcGVpc8qRRVs/EG7MMB4Odc3JMdbS9nYcdD2jM8QBfOYrRV3C9novetNFn+U
Am8ZGYdSPhvtDR593Po3BZ96YnaVprNx946SndXjFDQY03TKUtm4QCukXSSl
oNpyA7MqgY2j693UXCcp4BvKR9VeY2P3Gku34WkKqlhd7fVX2Hh35faiM7MU
1IZJNrREszFXVfnbz58UtKXWxnRcYuP/ALO3gi4=
                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {-0.09165069206550759, 
               0.09024787378563115}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {-0.09165069206550759, 
              0.09024787378563115}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVkHk41Ikfx6nGliKLSqbaDCFdllw5Ph9mxsx8DVHq6SKRZX+lsG1D1Iwj
dzLj1jQZwgzSjHOUctUWkRRt2Q5ROVZJ1yLZ9fvj/byf1/N6//XW8z2+w3+e
kpJS8lz+3/cubLv5+K9WB87ew0F0ERcaOrJPh1oVQPAJ0i29Qi4w3EdvE1aV
sCuEk/tvCReWCLRGLa1a4H0Rv7VRzoVxM+OZjVYP4ciKpcY7bnPBJ8aMZGw1
AJcYul2NY1zILatLXGf1Ef7Z977t0Boe1MC0i4HVPOzjbLW4F8yDSWuTn5y+
aSJhO32TvSUK9Lt6y4LNV2Hr3eafgieiIHFqRbJUREH5DGWXUXM0rPJjT0nP
GiHJ0H64SxEDFotRPqKzEXVKD4QZK2LhxNnVHqviTfFUhKtPw99noUmi0mz6
1Qz7SRFWPId42H6kq/ewrQUqe4+z+eIEKH1Kjs+XW+GG15r723YlATHEeP7t
uw0OB+pQHI1SYH/OS5NbDnaY5Pr8h0izVLD+Mq2dIXPA+kb9/Q1+aWD8yvJR
Vb0Dqg3/PW8qMA1WdobyH7U4IMcifoHNsTSYvjyqptXrgOH3VlFaw9KgwbNP
RTDlgHdFn/SUUtMAq+snzzsBdm5TkNfWpwHrt7BnyT2Ayu0JuhqafLgyOd3t
GImYGv67elQXH2a+eDSZRyH+wkWBxWM+sD9JKtbFIa7Zdshg/Bkfxt7tTl6U
hjitkZkUMsqHjYOVtO5CxH1yhnI1SQClnf+r87mHOKFu1bbVXgCSgj4hV9cR
B1zabTxkArjMvhZwQ+GI+i4rKb9J0sFWT8k054YjeoWutA2TpcPDL/TJ0Ja5
vd/MqxhFOvwr6k4w7nBENY5kquJuOuybGJamv3RED7K5xa6RdNDIWjH2q4oT
bjKVbh7ZkAGRL08EL/d0whuBJdKjtRngGbol/Pi4E+qlC2aVBzNhvUoj7+sn
J5wfeETCGMuE2Vy3hNOTTvhIv9U080smSJuDspOVqWgUoU9iLsyCWY3ymhIt
Kvp2P32qtjkLJFeNP760omL4m+bd+hFZ8H1M74g7j4qbXq8+30LOhoc8eeif
sVT8rrm8T8cwGyTajqe8E6kojLsWGGaaDTvsfBKPCqi4c79KzE76nE8WlSRc
puId3zT1iONz3oT8uukuFQt61N/k3c6G4gBtr59/pGH/xTP1p8Nz4NG857/p
LqfhlqTvFM24HFASFSXNJ9OwUXwlqkqQA/t6LBW9BjSMC1l0fHV5Dqg57tU6
ZU3DjPIqetrLHDihK2prOUjDY6lLPBawcsGp08jSs4KGX+OWtbcY5sHxwA9s
+yoa+mm4ktda5IFwfr2foYKGXZem7c5R8+CrDcGfbKahfZV4X7ZPHkiLj44J
e2n4YbPHaNCFPNDgyQvezNDw3UBihJ32BXhhZruU40JHU8KkbpOWEIhzrv5L
3Ol4J4WaIKYIoWbo4HWxJx0DV7j6G5oJIUUYG9DhRcdWrZhqPw8h2Kjcb9QL
puPWZ4L7V9OEkPHUJ7gjY46HNytLNC+CCy+uW+8FHQcXujP/MRBBbV+OUd0A
HR+xfKPuWoqAYlF2mj1ExyDhwOMKpggmR7rWcz7QMcLoS9D1oyIo3rkyumOe
MxJDEu6TGhHMMyo34xg5o9HMaiU6+xIoOrvTO4KdcTxyxd5Eej5EbFk91fq7
Mz55uqS43T0fHPiB3tdPOSPNouM8+UA+3PL817g01hlTP7s1jIXmw4O/Nt6M
z3HGA5Rla93F+TA8Ej/s1OSM7otJsTbKYtBRcbCvX8rA4Wa7nkv3xfBXQGKB
TJuBD9iGHPIzMYjaen6QrGRgDelMRtmIGAzOHXmYpc/AQkPz6UWkAjDVzg04
YcXA5dsFVbfsCoBJ+czfcpCBQyEf+r1kBRDuUPq2qIKB/QVxYrG0EKI5r9fF
VTHQSOLC+aO+EFJka/x/UTDwp1W+b0jthZBPSR80bGHguOny9N7RQrirEtlf
0svA0DW24sZNl0Gny7VPOsPABVlj72YUl6H24ETnFYKJ2m9/bqMNFUFTzga1
1O1M7D2kQdn+rQjau/3ZxzyZ6D+WyTyztBheUPvaN3szce+EajbbuhhIxq13
roYwcY9piaI6uRg8P2Q0y3OYGPCq0k57Wwl85FnX1LxlYrOO4iRHIYFt4Q3m
Tn8z0XZtvxbrgQRiQrDy/jgTJ2baWpnDEtD2ZV4dmmRivqTiZI+OFCype6Qr
F7Ow5sT7PRsjpRBOCrt4egsLlxkueezNLoWW79/IqltZmEJzZu0KKAXVr9y8
LGsWIvlHiIkuhby38dlXHVk4+zrXP6G+FBruZPNf7WThtV8bDVxMykApqe4s
PYyFRWWQu2dFOTCjbRc8jGThq5M/HF1jWQ78U43R3lEsfGJW9NloVzlQjtzh
cpJY+Klu8ZVFGeVAZf8ZLhWyUFs4gHrLrkCc+j9Bas0sPGm/fn3EugpQS7fc
3buIQMv3E7O7qTKoEHwabFUn0Kv2841re2XgJpCFVGoRyLZnhx0IlkEq3+Tc
+dUE7tx6c9xLJAP1tDW3WD8T+Dmx6fLJ73N8TsXs5h4C8z7GvFBuk0NFSmtj
uReBxsG3zDsG5eCWwnO94Eug59Z19UOzckhNng4MO0pgZpW5iY5lJagnvb9k
xiPwup4vL1Eyx/GP1UpKCAzIZi0wvFQFFXHpFzLLCSTbnHv3R2MVuMW5r4+V
E7hwlqHR218FqWfbaYeuE3N/fpM5GlSDeuzNCHIXgdKPvieFsmqoiIlYpNpD
IJN3ePBtTzW4xVhnTz4hUFtUwpNPVUNqdGVl7wCBCWXX1R/SakA9qnjk/FcC
dz94Skl7VQMVPD/OmW8Edo5+gQ2qteDGW0sKUnLB0x9cN3qb10IqN28toeqC
44ncjznxtbBHJau2QdcFmw6EaEbq1sF/MIj7iQ==
            "]], 
           Line[CompressedData["
1:eJwVk2k4lAsfxpWcpKIsSaXtJJWynRai11/KVsPzzAwGzyk5WbqynMpSIjOU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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {-0.09165069206550759, 
           0.09024787378563115}}, "Frame" -> {{False, False}, {False, False}},
          "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
         "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
         GoldenRatio^(-1), "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 116}, {-0.09165069206550759, 0.09024787378563115}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVyXk41AsbxnEJZZsWTgupaEFvJ0WWUvM8Y2bMzI/sLafepE2LsqUjxWkw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            "]], LineBox[CompressedData["
1:eJwVxXk8lAkfAHAWJUtKUnJUhEquTUJpf9U6UvQ8z4wjPckqV5G1FSWVo4dJ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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVyXk41AsbxnEJZZsWTgupaEFvJ0WWUvM8Y2bMzI/sLafepE2LsqUjxWkw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                "]], 
               Line[CompressedData["
1:eJwVxXk8lAkfAHAWJUtKUnJUhEquTUJpf9U6UvQ8z4wjPckqV5G1FSWVo4dJ
SuVmMsZgXLlGjsIP2Q5JSMrY2ngrRK3KtLLkfd8/vp/vau9gyucHKSmpK//z
/8OCrcWtiwmYNVZsu6jahNW2FRGrtAhQtVSO8pRrxKZ/5M9nriSgR/9bmHVn
A94v+jVKVYeAgFcxQe/SGlCstCRW3oCA2qijm7hGDSjVdzJxwpSAjFczcfO9
76CT75bc5l8I2Nj1hHd+rB5dlyfnWdsTIGEpbgnHevRqHy+o3kWATXej14Lk
ejxhnF1S6EwAJ8ZB1L+tHjO/St266k5AzF+2AZLMOnwXe+++VyABUvXqF0aO
1OKE5cp28TECpB0eq03a1eK392Ed7BACpp1OBwTp1qLi3nXdDqEEnDXyTuC/
rMGfliWITSMJyPrkNDXgWoPnheQHqWQChh/kamntv4Ub/uDTwakEfFCNXN5o
cwvFQ58evUwngBV1+MTNVbfQXPt68e0bBFCK1zeFD1fjSHKP3wkhAa+mdufx
T1UjEc0aGr5NQFOSxbP1hSKc5QlI10YCBj42zLdNFGFx45fmNiSAObpg9kao
CGW/JfH4bQR0Gs3EyNuJsC64l97fSUDUXfPdwuEqXHXA5XnnIAHl+YNC1qYq
fByeb2fzhoAxX7p4cmUVhqdLbpW8I8Az/gn3vkIV9j5NSeaMEVB382mW1GAl
chz7yB0SAuIU9teUJlbixGa3jlvyJDyS7vQ/LKnAFpV9LVwTEs72PFyl2ViO
Cxc5E4NmJGgPNls/zi5HD6Wdf+mZk8DrlpeqiyzHz/ONZsssSbgqkp3bbFuO
a2alrFq2k/DjPPmTXV1lGDtcWPGWRUJz7cfOvz7dRMeGKZ7xKRKWNCTr3HMr
xdT6D8bHw0lo+nYB0n8uxaGaocbaCBJ8vOIikgxK8UxlxwBEkaBjKFUmM1WC
pQU5y1jxJAyIg19iZgkqX3NIDOOScPzii5fUcDH2+qSfa24m4ei2tcYRmUXY
8W7dUou7JJT/4aykxhRhm9+dkpI/SPD8uybpaXARVge8epHaToL9ZhPzOtsi
TAlaszGol4RDGsDW/lKIricrhtVHSBAeUdJQYxfi8wsPiOPKFHAWHXEQbhBi
l5zH8MhiCkZE8m+0NIT4IHbsrKcqBcl7NL6WLRBiHWdhyS51CvLMAxNXDhdg
egJbbpUuBdoWStbmggJ0T35d32FBge/571XTKwtQLJjS0fekQOKzazZlfT7+
LmvSH+JFwb6a0DPjmvm4wMcnsdGbgs0e1DW2cj5a6vf8y/ajoHqwb8Z9Mg9T
Ckt6Y36j4PKJtRtNMA+Jm56xg9EUHAhS3iBxy8N7NW2jXCEF0l8SQ5elCNBz
2b+8kSIKfiPHfvG5KEBJmJmreSkFRauLZVrOCnCNVXbrowoKzqzW/JvvK8Co
O2FZ0/UU1Oqq986zEuDW5vVO7h0U+EVobHd4nYuVD69WLPlEQVbM33eULXNx
PKXpKesLBaNFSmd0jHNR33v8a5KEAsHhi3KwJhe50/Y2qtMUZF44ZZG1KBc5
hnMPVWVY4GYdr9c1ykfPy0H/WbqUBV8K0jL1svmoQDqqLbdigd4858+LFvLR
VuuUlfsWFiyP2ogH5PgYOZpPp9uwILmgz080k4OSKGnB8h0sKMNjaqfHcvB1
VZ2J+m4WCFWjTwY+zMFaVYNdKw6wIKFx79fh2Bw8/EImQjOKBV/5jR//nJ+D
jms7Cy7HsCDaG27+OMdDs1Pp3d8ZFtDNO58c+8jD78uMDAbjWWC15WK2/2Me
Zri59uQns8Cm6zZjkMDDzr7CtSaFLDiKjjINijzc/Mzp2fYnLOBX9AWmqmej
Qk+asZ8WGzJTGibcD3DxqvT802Ur2eArrR6xjuSimlnoXclqNlwyNT0ja8tF
nats9wv6bPBf/Dm7fwMXrZwXR/NN2HC79aTC3EwW+rfHPxvYzobE2nsGhrws
vNd6NoLwZQN9Uy+y6n0mRokOtVuVs+GFa0CwIjcDq3yDNasq2bCZWFFpfy0D
36ifOba+mg39on2zl2Iz0CHyuopGPRvCtbU5JiEZuNCpxWOmlQ0CjprRoF0G
ct9pjzX1sSFV663u2y/pWKMu/vGX72zgP4jv1Wen4/h5wsnZyQXaZXIHzhqm
YaOKNHL3uoDsT4Y2O3TT8Ep+pekY6QKS9COhihppaPpIRZXj6gKR4q1uVQpp
eELtmbjloAucW3JMf+f7VPy3dJ//pt9dQHlmru54cSoqiL1jNNNcYNCieM+I
cSoamJ+sf//aBfxHLcWTdin4c/eJQ7khrrDUgrNCRZSEjvtSJrMWuoFvZ2ae
cMt11H/44ZgW3w0YpZc7ghSvoUTXr+v1z+7Qdcn71zZxIub43QnGAXeoFWUH
649fRs0k+ym9oH1g8G3exGcyAROKJv06FTyAV5dor9YWjx3C/ubvNzyg+UWS
h27oRRy9kuHmaLwf3hp5W4/u4eA3r/Bnz9v3Q3f0zvUFBnEoXpG09QNNA2/T
WNGQUSy2qJ2OO32Qhszxp2a162KxUOVgj5w3DeU2PY6X9WIxVMHQX9uPhsOW
nA3btGJxyXRr0t4QGv5U2JtapRiLe/o/v69kaAhwUtn+dozBpjQqI7SMhucP
LGQCSxjMT7J880MlDXLuBbIhQgYTErVNEkU0cO4ZRoQJGPSIe98mrKNhZ9z2
dk4Wg/+ERk+8aKWBybbqaLjEoKlrlf2W5zQYbXWuCQhkcBmVfv1+Pw2Hwt/U
M/4Mfnc695L1Jw2SqCl9wWEGO2wdjwcO0vBBk2M9RDPov2ko+8YYDYNNb81C
nBjca/ZgdN1HGtzI+YHpuxi0MCozr5mgoXry6oIWWwZl9cLbOyU0RL4ZOKq2
jcGxVV5L90/R0LpR22SnNYM9mnZew9M0nGtup0IsGLy9fEPJ8Vka6Ejdvpyf
GOSrqnydm6PBtfBIXbcxg/8FFhRpjw==
                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {-0.11750088726347126`, 
               0.11570240228927069`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {-0.11750088726347126`, 
              0.11570240228927069`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVyXk41AsbxnEJZZsWTgupaEFvJ0WWUvM8Y2bMzI/sLafepE2LsqUjxWkw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            "]], 
           Line[CompressedData["
1:eJwVxXk8lAkfAHAWJUtKUnJUhEquTUJpf9U6UvQ8z4wjPckqV5G1FSWVo4dJ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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {-0.11750088726347126`, 
           0.11570240228927069`}}, 
         "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 116}, {-0.11750088726347126`, 0.11570240228927069`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{{3.938184084933811*^9, 3.9381841514192104`*^9}, 
   3.93818429695714*^9, 3.938262731930271*^9, 3.938263096343528*^9, 
   3.940600639001293*^9, {3.9406816996618195`*^9, 3.940681709889591*^9}, 
   3.940681786994751*^9, 3.940681817355723*^9, 3.940682017791296*^9},
 CellLabel->
  "Out[145]=",ExpressionUUID->"a851ee92-dcc8-fd45-9539-e023f0871756"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RangeAnyl", "[", 
   RowBox[{"Data", ",", "10", ",", "38"}], "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.9382628327568846`*^9, 3.9382628414093113`*^9}, {
  3.9382630355674934`*^9, 3.9382630518314686`*^9}, {3.93826360396738*^9, 
  3.938263613841213*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"de4cd76d-dfeb-ab49-a1a9-471731d9f780"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Image plane travel: \"\>", "\[InvisibleSpace]", 
   "0.3308270676691727`"}],
  SequenceForm["Image plane travel: ", 0.3308270676691727],
  Editable->False]], "Print",
 CellChangeTimes->{{3.938263236969629*^9, 3.938263329402548*^9}, {
   3.938263503601433*^9, 3.938263614592191*^9}, 3.9406006468095303`*^9},
 CellLabel->
  "During evaluation of \
In[160]:=",ExpressionUUID->"66af46a0-208b-6343-bed7-81ce1010a844"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Magnification: \"\>", "\[InvisibleSpace]", 
   "2.3157894736842106`"}],
  SequenceForm["Magnification: ", 2.3157894736842106`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.938263236969629*^9, 3.938263329402548*^9}, {
   3.938263503601433*^9, 3.938263614592191*^9}, 3.940600646813038*^9},
 CellLabel->
  "During evaluation of \
In[160]:=",ExpressionUUID->"a3570308-1033-d949-8c0e-b5682b405d03"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0.009285714285714286`", ",", "0.02150375939849624`"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.940600646818445*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"adc910af-c95a-654d-9525-5d9d01b5b6d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SizeLP2", "[", 
   RowBox[{"Data", ",", "10", ",", "38"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.940600674151787*^9, 3.9406006895576096`*^9}, {
  3.9406007817056465`*^9, 3.9406007867883472`*^9}},
 CellLabel->
  "In[174]:=",ExpressionUUID->"44592c2b-11d4-c246-aeb5-7446c335040e"],

Cell[CellGroupData[{

Cell[BoxData["0.4202799590400158`"], "Print",
 CellChangeTimes->{{3.9406007838218193`*^9, 3.940600787330353*^9}},
 CellLabel->
  "During evaluation of \
In[174]:=",ExpressionUUID->"c94b8e62-c0ee-1340-af97-d0ce8f8234bc"],

Cell[BoxData["0.08931998771200472`"], "Print",
 CellChangeTimes->{{3.9406007838218193`*^9, 3.940600787333458*^9}},
 CellLabel->
  "During evaluation of \
In[174]:=",ExpressionUUID->"07a46770-9fd0-c04f-98b5-22e10b77f2ca"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["100 \[Mu]m mask", "Subsection",
 CellChangeTimes->{{3.9409416400925255`*^9, 
  3.940941654567953*^9}},ExpressionUUID->"973aa253-d284-c542-b9bb-\
0f7338b63b69"],

Cell[CellGroupData[{

Cell["f = 100, 50, 8     ", "Subsubsection",
 CellChangeTimes->{{3.940598155915291*^9, 3.9405981857162514`*^9}, {
   3.940598216106943*^9, 3.940598218191399*^9}, {3.9406821514134045`*^9, 
   3.940682183059364*^9}, 
   3.9409416373820896`*^9},ExpressionUUID->"5eecf2c9-5573-bc47-a760-\
52436e3cfcc3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "100", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "20", ",", "50", ",", "8", ",", "80", ",", "22"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "116"}], "]"}]}], "Input",
 CellChangeTimes->{{3.9405982190884876`*^9, 3.940598320719406*^9}, {
  3.940598351162533*^9, 3.940598366374924*^9}, {3.940598513172994*^9, 
  3.940598514268841*^9}, {3.940599063799612*^9, 3.940599081390448*^9}, {
  3.940599134598995*^9, 3.940599144101332*^9}, {3.940599912281275*^9, 
  3.9405999129813156`*^9}, {3.940600119600811*^9, 3.940600119688692*^9}, {
  3.940600166747494*^9, 3.940600235381945*^9}, {3.940600323361793*^9, 
  3.94060043104417*^9}, {3.940681966825966*^9, 3.940681999234133*^9}, {
  3.940682055581423*^9, 3.9406820561755548`*^9}},
 CellLabel->
  "In[146]:=",ExpressionUUID->"3e7feca3-9393-a84e-b63e-69e10599b7b5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"10.069207223044211`", "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm[10.069207223044211`, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{3.940681745940405*^9, 3.94068200011697*^9, 
  3.9406820596511497`*^9},
 CellLabel->
  "During evaluation of \
In[146]:=",ExpressionUUID->"36bb08c2-78b1-8e46-b819-7b6be63131d9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
          Opacity[1.], LineBox[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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           "]], LineBox[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
     GeometricTransformationBox[{{{}, {}, 
        TagBox[
         TagBox[
          {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
           LineBox[CompressedData["
1:eJwVk3k41IsXxqVopcJVREXWlkuKaXXOLMzMl6SoW1QKLTe7ioSskbFlyDoh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            "]], LineBox[CompressedData["
1:eJwVkHk81IkfxnWtVrrk6KKbjk1YiY5fn1JEq77znRk5votlHftax8/myJUI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            "]]},
          Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
         Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, {{{
       0.9999999999999999, 0.}, {0., 
       8.953596602625042}}, {-4.440892098500626*^-16, 23.39839983533955}}], {
      GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{0.20316584498479168`, 2.9931127007567917`}, {
            7.670985480481858, 23.139817059688838`}], 
           Offset[{4.0177379393575645`, 7.981633868684779}, {
            7.876032940462135, 23.367225616244617`}], 
           Offset[{33.07711870113641, 7.981633868684785}, {7.876032940462135, 
            23.367225616244617`}], 
           Offset[{33.07711870113641, 21.981633868684785`}, {
            7.876032940462135, 23.367225616244617`}], 
           Offset[{-28.92288129886359, 21.98163386868477}, {7.876032940462135,
             23.367225616244617`}], 
           Offset[{-28.92288129886359, 7.981633868684771}, {7.876032940462135,
             23.367225616244617`}], 
           Offset[{-3.4371919851893535`, 7.981633868684777}, {
            7.876032940462135, 23.367225616244617`}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Plane\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{2.0771187011364107, 14.981633868684778}, \
{7.876032940462135, 23.367225616244617}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], 
      GeometricTransformationBox[GraphicsGroupBox[{
         {EdgeForm[{RGBColor[
          0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
          AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
           NCache[
            Rational[2, 3], 0.6666666666666666]]}], 
          PolygonBox[{
           Offset[{-0.47170504305318717`, 2.9626836402758547`}, {
             22.604930432807045`, 0.037472752079698794`}], 
            Offset[{3.039808406282364, 7.900489707402281}, {22.12396705953786,
              0.06287132280479779}], 
            Offset[{24.002588038755505`, 7.9004897074022855`}, {
             22.12396705953786, 0.06287132280479779}], 
            Offset[{24.002588038755505`, 21.900489707402286`}, {
             22.12396705953786, 0.06287132280479779}], 
            Offset[{-31.997411961244495`, 21.900489707402272`}, {
             22.12396705953786, 0.06287132280479779}], 
            Offset[{-31.997411961244495`, 7.900489707402273}, {
             22.12396705953786, 0.06287132280479779}], 
            Offset[{-4.37951688331904, 7.900489707402279}, {22.12396705953786,
              0.06287132280479779}]}]}, {}, InsetBox[
          StyleBox[
           RotationBox["\<\"Image Size\"\>",
            BoxRotation->0.],
           StripOnInput->False,
           LineOpacity->1,
           FrontFaceOpacity->1,
           BackFaceOpacity->1,
           Opacity->1,
           FontOpacity->1], 
          Offset[{-3.9974119612444934, 14.90048970740228}, \
{22.12396705953786, 0.06287132280479779}], NCache[
          ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
           ImageScaled[{0.5, 0.5}]]]}], {{{0.9999999999999999, 0.}, {0., 
        8.953596602625042}}, {-4.440892098500626*^-16, 23.39839983533955}}]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 20.93658986002173},
    CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
        FreeQ[#, Rule], 
        Apply[{{{Bottom, 1}, {Right, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -2.613296184069711 + 0.11168696160678235` #2}], {{
            Bottom, 1}, {Left, 1}} -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
      "DisplayFunction" -> Apply[Grid[{{
           Subscript[
            Style["\[RightArrow]", 20], 
            Style[1, 
             RGBColor[1, 0, 0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{
            0. + 1. #, -2.613296184069711 + 0.11168696160678235` #2}]}, {
           Subscript[
            Style["\[LeftArrow]", 20], 
            Style[1, 
             GrayLevel[0]]], ": ", 
           ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
         Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
         Spacings -> {0, 0.5}]& ]},
    DisplayFunction->Identity,
    Epilog->{{}, {}},
    Frame->{{True, True}, {True, True}},
    FrameLabel->{{None, None}, {None, None}},
    FrameStyle->{{None, 
       RGBColor[1, 0, 0]}, {None, None}},
    FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "TransformedTicks"[{-0.306346436144079, 0.3215407628070905}, {
          20.655497425453635`, 26.27734611681458}, 
          "CustomTicks"[True]]][
         SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
         "CustomTicks"[True]][
         SlotSequence[1]]& , ResourceFunction["CombinePlots"][
         "CustomTicks"[False]][
         SlotSequence[1]]& }}, {{{{21., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"21\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {22., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"22\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {23., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"23\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {24., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"24\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {26., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"26\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {20.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.4, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.6, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.8, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.2, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         20.712320854552036`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.3\\\\\\\"\\\", Rule[ShowStringCharacters, False]], -0.3`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {21.60768051481454, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.2\\\\\\\"\\\", Rule[ShowStringCharacters, False]], -0.2`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {22.503040175077047`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"-\
0.1\\\\\\\"\\\", Rule[ShowStringCharacters, False]], -0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {23.39839983533955, 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {24.293759495602053`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
1\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.1`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {25.18911915586456, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
2\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.2`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {26.084478816127064`, 
          FormBox[
          "\"\\!\\(\\*FormBox[TagBox[InterpretationBox[StyleBox[\\\"\\\\\\\"0.\
3\\\\\\\"\\\", Rule[ShowStringCharacters, False]], 0.3`15.954589770191003, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[DirectedInfinity[1], 1]]]], TraditionalForm]\\)\"", TraditionalForm], {
          0.01, 0.}}, {20.891392786604538`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.07046471865704, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.24953665070954, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.428608582762042`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.78675244686704, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         21.965824378919542`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.144896310972044`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.323968243024545`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.682112107129548`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         22.861184039182046`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.040255971234547`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.21932790328705, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.57747176739205, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.756543699444553`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         23.935615631497054`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.114687563549552`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.472831427654555`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.651903359707056`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         24.830975291759557`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.01004722381206, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.368191087917058`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.54726301996956, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.72633495202206, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         25.905406884074562`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         26.263550748179565`, 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
          0.}}}}, {{{0., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"25\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"50\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"75\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
          "\"\\!\\(\\*FormBox[\\\"100\\\", TraditionalForm]\\)\"", 
           TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
         0., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {25., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {50., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {75., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {100., 
          FormBox[
           TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {5., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         10., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         15., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         20., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         30., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         35., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         40., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         45., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         55., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         60., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         65., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         70., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         80., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         85., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         90., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         95., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         105., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         110., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
         115., 
          FormBox[
           TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
    FrameTicksStyle->{{None, None}, {None, None}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->{{28.246092796325684`, 46.482420325279236`}, {28.34375, 1.}},
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
    PlotRange->{{-2.416666666666667, 118.41666666666667`}, {
     20.655497425453635`, 26.27734611681458}},
    PlotRangeClipping->False,
    PlotRangePadding->None,
    Prolog->{{}, {}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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            "]], LineBox[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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                "]], 
               Line[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {20.936589860021684`, 
               25.822529003703025`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 20.93658986002173}, 
             "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
             "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
             "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {20.936589860021684`, 
              25.822529003703025`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 20.93658986002173}, 
            "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
            "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
            "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwV03k0VesfBnC55ddACqtCEiVD/RrkvJvknIdzjnPOphKaE1dKaVK5kVTH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            "]], 
           Line[CompressedData["
1:eJwV0ns0VtkfBvC3mUx3jVtlIhSZIjSqs0+mPGWkSM4574VylDSiJkmJSEm6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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {20.936589860021684`, 
           25.822529003703025`}}, "Frame" -> {{False, False}, {False, False}},
          "AxesOrigin" -> {0, 20.93658986002173}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 20.93658986002173},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Plane\"", TraditionalForm],
    PlotRange->{{0, 116}, {20.936589860021684`, 25.822529003703025`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVk3k41IsXxqVopcJVREXWlkuKaXXOLMzMl6SoW1QKLTe7ioSskbFlyDoh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            "]], LineBox[CompressedData["
1:eJwVkHk81IkfxnWtVrrk6KKbjk1YiY5fn1JEq77znRk5votlHftax8/myJUI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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVk3k41IsXxqVopcJVREXWlkuKaXXOLMzMl6SoW1QKLTe7ioSskbFlyDoh
lZmxmzEMoUFKMiZqUkratbntQouf3x/nOc95Pu95n/efV8/db/tBRQUFhcTJ
+f++nbeh+f6jNmt/mK1WU5sFjV1Z4YGkIohRm+a0uyEL6I7v2gmSAGzYWsKJ
piyYw1Z/Z0VqBdH68t6t7Vnw0cLk10pSL3zbPjv/990s2B9joWRCeg5SodOj
1M9ZkFNal2BI+gJGrFcV7FXZIIJxOwOSIjqJu2Xm/GwYXbd8CeWnGo7vCl78
9UYOLJPJS/3X6KBLVZGZybtcSBhbkMjP18cbQTUTDXoc0PGwH+OfMUZ2netj
0vkLYDkbq98uXImJUxJrNmkUwPEzutt04s1Rb/EGhtS/ECQ85RbzEQv0pXBM
n/pehK1eMrnnRkvsOiMcWxlSBCUPF8UXVpNQcYXDtH8kl4AYog/8/L0e7zuw
H/rrXgHX7MHl1603YezYK6WBK8Ww7vu4RkaVNXYXiM7mnueByTOru8J6azR+
dCD2xAUeaEkD0+62WmN9d2fcjis8GL/8TkVdbo3jq1cIDUQ8aHTuV2aPWWOC
77CFgpwHWFM/mkoBPLArw7TqLz4wj518nHgPUPtvqfHCPD6Uj473kMMQl5Cq
zpPrSuDX922SNVGIhc37XR1bSsD+K6/CMA5RrS+t9tDtEvgwvDNx5jlEo9zB
rSWDJbDyhYDWcwnRlvV+SsqMUiiRHq3bfxsx+3zvKplrKfCK+jkR2mRkBFbe
D5lRBpftGw43iclY9MlQWBZWDhv1FMyzm8hYurx4V83Zcuj9bjMa2EpGbsZ4
b3tGOUzk95w16SLje2FYkHJ5Obh8fsNPHySjjNslmxgoh3mZCz78q0xB547f
7QPkCggbPO6v6UzBazqhf4rmV4JzoFmI30cKyoaHT5OPVoGp8rXIka8UlCQ7
NlsGVMGfHIez4aMUbHBhvzQ7WQX8Fp+sxClU3M3pn2oVN8nnlYm46lSU7PHw
YBVVAa/S5MsgiYq63vOjXB5Xwe8Pel6OkVTM89r5vse5GnojqwP7YqlISzl3
ib2nGnga5FP7Eqj45mWig4tnNWzftD/Bm01Fz+u0oj/HJnliPvfsZSq+ZX4g
OOmTfPmil5IOKpotub1i7b1qKD6ssXf1fBq6jiy2W+wqgLuKA8e0NWlobmyd
m+wpAIX8K6ypi2iotJ5yUdlXAC73rMRyAxpGaNDVNaMEoELerX5qHQ0zW2zX
lnEFcFw7/1arGw2Djt7a1DYiAIrU2Mq5goY3DM4tULsgBL8jn+w3C2lo1RWi
8YArBM7Ueg8jMQ3njl4d5guEMLKeSBttoSHXdiwmoEMI/GLvDxw5DYeeN/qx
vwlhXmR10atfNCw4yt2zamsNPLHYODfYzgbnid2Y7qoiIJK3HJzjaIOafAuj
MS0RiIbcrl50tkGt3rHbHEMRJHFiD3fttUGfre43Z20WwXrl7mt6/jZYYPBf
f4y3CDIe7vfvypj0W/VC4Y9UBHaRcT16T2ywV2lTUH1eLdT2ZxvXPbeZ7O/M
A5r8WtC3LA23H7LBA99M9WJqa2H0rcw0+JMN+g8Es5N6aqHYSSu6S9EWd5U3
u7nPqANF4zKLYGNbrAnTlKwJqQOxtCe9y98WF268pORwRAyhZrpjbScmua36
mFmIGKzTjuy7esoWSY6Cf0xZYrjuPGFSEmuLh3yDtD3KxHDn0crm+GxbNKpZ
Yj76WQxv3sa/oUhskUibbns/qh4WKltvrp9LxyB91+aPogZ4dDihqEqDjtWB
9RamnQ2Qf+vedJ4WHUkzm/ZFPWkAg2Sv3sxldKyrt/+RMv0qmGvkHD5OomP/
CVcVY9erwND/lmbmRscFpUd6kmY0Qoh1yesrFXS88ZUZGHi6CaKDXxrGCenI
Cv0s4Gc2QVLV4oOHxHSsXK7+YEZlExTqp78waqXjdubFPfi0CTqUw55y5XSc
KH8QUEBrhoWyLf38X3SMffrcM/Sva1Dr9llaTjCww/tV5jEfCUiyV6ikbGWg
MzNpd2iYBDp7Dtr7OjNwToB/bX6iBJ5Q+zv/3sdAqiUjYH2JBJRM2m5WBjBw
p2c46+YbCTh/ymipzmZgokncqlSvFvgSuU4kes3AE2qzcnazWmFDSOMaynsG
Wi58023FaYWYABR0f2RgYXgf26qiFTTcGZVDowzU/KO4u6C3Fayou/has5ko
7RNQ9HTbIETp5IVwMyYSOglL6fVt0Pr756JZa5moJPw2EiFtg1kjEbmZ65i4
+Z693/NnbZD7Oj6rksxEudcae6PZ16HxZlbaMycmHklNdRW7XQcFVt0Zm5NM
LJV8DIye3w6M6I3TesMm/3OUejJN2iHt1LXofVFMXPU69McAtIO+182IYNak
/lYHebpfO1Dt+0L4HCaqfed/eiBrhzjVHz4qLUz8Nvxknw7nBqikW+2UzyTw
9KujpxUPdkAF++uLNlUCOfM/6mTHdYADuypAoE7ghGtgDYvXASlpy5NTdQkM
cbgwlDTcAarnFl9nribwZ/fSH6vDboFqsrJF8y4CR963S6PLO6Eiqe1a2V4C
CV7xFoG8ExySIrfkuROY3F133vVPJ6Qkjh856U2gb/IWMNh2G1RZ/xVYRBLI
tUjH7l+Td/x9FS6XQEMPX+V6XylUxKXnnS8jsEbu5FlSIAWHOEfT2GoC5/72
yoYeKaSc6aQduEpgXF9IgrtVN6jGNocukhGo6J1R/W6GDCpiQmfOukdggERz
hwvIwCFmXdboAwItfX4iK0gGKdECgfw5gQ5RWpobh2SgGlX8NnWEQMaeZdor
/70DFZEewad/TubxH/UrjL8DDpFLlXwU7PDA8Q0X44rvQEpE7lJilh0GcQdF
gld3YIdyZm2jth1GKMlVBpx64H9gOhpr
                "]], 
               Line[CompressedData["
1:eJwVkHk81IkfxnWtVrrk6KKbjk1YiY5fn1JEq77znRk5votlHftax8/myJUI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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {-0.27495207619652057`, 
               0.2707436213568925}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {-0.27495207619652057`, 
              0.2707436213568925}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVk3k41IsXxqVopcJVREXWlkuKaXXOLMzMl6SoW1QKLTe7ioSskbFlyDoh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            "]], 
           Line[CompressedData["
1:eJwVkHk81IkfxnWtVrrk6KKbjk1YiY5fn1JEq77znRk5votlHftax8/myJUI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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {-0.27495207619652057`, 
           0.2707436213568925}}, "Frame" -> {{False, False}, {False, False}}, 
         "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
         "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
         GoldenRatio^(-1), "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Image Size\"", TraditionalForm],
    PlotRange->{{0, 116}, {-0.27495207619652057`, 0.2707436213568925}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    InterpretationBox[{
      TagBox[{{{}, {}, 
         TagBox[
          {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
           Opacity[1.], LineBox[CompressedData["
1:eJwVi3k81Akfx61dY1MjG1uOdCiapBQxUs33O5eZ+ZFVRk+XqB6pjXLUypVJ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            "]], LineBox[CompressedData["
1:eJwVjHk0lIsfh+XSolKWLIVESZslZLktX22WLt55Z+xvkjB1W1CMkorcpH6K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            "]]},
          Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {}},
       {"WolframDynamicHighlight", <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>}], 
      StyleBox[
       DynamicBox[(Charting`HighlightActionBox["DynamicHighlight", {}, 
         Slot["HighlightElements"], 
         Slot["LayoutOptions"], 
         Slot["Meta"], 
         Charting`HighlightActionFunction["DynamicHighlight", {{{{}, {}, 
             Annotation[{
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]], 
               Line[CompressedData["
1:eJwVi3k81Akfx61dY1MjG1uOdCiapBQxUs33O5eZ+ZFVRk+XqB6pjXLUypVJ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                "]], 
               Line[CompressedData["
1:eJwVjHk0lIsfh+XSolKWLIVESZslZLktX22WLt55Z+xvkjB1W1CMkorcpH6K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                "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
          "HighlightElements" -> <|
            "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
           "LayoutOptions" -> <|
            "PanelPlotLayout" -> <||>, 
             "PlotRange" -> {{0, 116}, {-0.352502661790411, 
               0.34710720686781094`}}, 
             "Frame" -> {{False, False}, {False, False}}, 
             "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
             "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
             GoldenRatio^(-1), "DefaultStyle" -> {
               Directive[
                Opacity[1.], 
                RGBColor[0.368417, 0.506779, 0.709798], 
                AbsoluteThickness[2]]}, 
             "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                 Identity[
                  Part[#, 1]], 
                 Identity[
                  Part[#, 2]]}& ), 
               "ScalingFunctions" -> {{Identity, Identity}, {
                 Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
             False|>, 
           "Meta" -> <|
            "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, 
             "Function" -> Plot, "GroupHighlight" -> False|>|>]]& )[<|
         "HighlightElements" -> <|
           "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
          "LayoutOptions" -> <|
           "PanelPlotLayout" -> <||>, 
            "PlotRange" -> {{0, 116}, {-0.352502661790411, 
              0.34710720686781094`}}, 
            "Frame" -> {{False, False}, {False, False}}, 
            "AxesOrigin" -> {0, 0}, "ImageSize" -> {360, 360/GoldenRatio}, 
            "Axes" -> {True, True}, "LabelStyle" -> {}, "AspectRatio" -> 
            GoldenRatio^(-1), "DefaultStyle" -> {
              Directive[
               Opacity[1.], 
               RGBColor[0.368417, 0.506779, 0.709798], 
               AbsoluteThickness[2]]}, 
            "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
                Identity[
                 Part[#, 1]], 
                Identity[
                 Part[#, 2]]}& ), 
              "ScalingFunctions" -> {{Identity, Identity}, {
                Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> 
            False|>, 
          "Meta" -> <|
           "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
            Plot, "GroupHighlight" -> False|>|>],
        ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
         4.503599627370496*^15, -4.503599627370496*^15}}],
       Selectable->False]},
     Annotation[{{{{}, {}, 
         Annotation[{
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]], 
           Line[CompressedData["
1:eJwVi3k81Akfx61dY1MjG1uOdCiapBQxUs33O5eZ+ZFVRk+XqB6pjXLUypVJ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            "]], 
           Line[CompressedData["
1:eJwVjHk0lIsfh+XSolKWLIVESZslZLktX22WLt55Z+xvkjB1W1CMkorcpH6K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            "]]}, "Charting`Private`Tag#1"], {}}}, {}}, <|
      "HighlightElements" -> <|
        "Label" -> {"XYLabel"}, "Ball" -> {"InterpolatedBall"}|>, 
       "LayoutOptions" -> <|
        "PanelPlotLayout" -> <||>, 
         "PlotRange" -> {{0, 116}, {-0.352502661790411, 
           0.34710720686781094`}}, 
         "Frame" -> {{False, False}, {False, False}}, "AxesOrigin" -> {0, 0}, 
         "ImageSize" -> {360, 360/GoldenRatio}, "Axes" -> {True, True}, 
         "LabelStyle" -> {}, "AspectRatio" -> GoldenRatio^(-1), 
         "DefaultStyle" -> {
           Directive[
            Opacity[1.], 
            RGBColor[0.368417, 0.506779, 0.709798], 
            AbsoluteThickness[2]]}, 
         "HighlightLabelingFunctions" -> <|"CoordinatesToolOptions" -> ({
             Identity[
              Part[#, 1]], 
             Identity[
              Part[#, 2]]}& ), 
           "ScalingFunctions" -> {{Identity, Identity}, {
             Identity, Identity}}|>, "Primitives" -> {}, "GCFlag" -> False|>, 
       "Meta" -> <|
        "DefaultHighlight" -> {"Dynamic", None}, "Index" -> {}, "Function" -> 
         Plot, "GroupHighlight" -> False|>|>, "DynamicHighlight"]],
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    ImageSize->"Medium",
    Method->{
     "DefaultBoundaryStyle" -> Automatic, 
      "DefaultGraphicsInteraction" -> {
       "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
        "Effects" -> {
         "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
          "Droplines" -> {
           "freeformCursorMode" -> True, 
            "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
      "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None, 
      "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotLabel->FormBox["\"Magnification\"", TraditionalForm],
    PlotRange->{{0, 116}, {-0.352502661790411, 0.34710720686781094`}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.05], 
       Scaled[0.05]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{{3.940598260935992*^9, 3.940598322078579*^9}, 
   3.940598354602793*^9, 3.940598468504858*^9, 3.940598519579092*^9, 
   3.940598996579439*^9, 3.940599065473797*^9, {3.940599127524618*^9, 
   3.940599145320309*^9}, 3.940599914813137*^9, 3.940600120949419*^9, {
   3.940600168764374*^9, 3.94060023678309*^9}, {3.940600328760094*^9, 
   3.940600432507372*^9}, 3.9406817464699802`*^9, 3.940682000806309*^9, 
   3.9406820603180027`*^9},
 CellLabel->
  "Out[149]=",ExpressionUUID->"75b53ff9-c9f3-484e-b22a-6aa338ac54f0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RangeAnyl", "[", 
    RowBox[{"Data", ",", "10", ",", "38"}], "]"}], "//", "N"}]}]], "Input",
 CellChangeTimes->{{3.9405984973063602`*^9, 
  3.9405984989026833`*^9}},ExpressionUUID->"c604558e-6081-cf43-8a6d-\
8b7636e0d91d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["f = 100, 50, 50     ", "Subsubsection",
 CellChangeTimes->{{3.940681591732252*^9, 3.9406815929780293`*^9}, {
  3.9409431625922546`*^9, 3.940943174012577*^9}, {3.9409432147426033`*^9, 
  3.9409432414010887`*^9}},ExpressionUUID->"14842fc3-b8c8-664c-9fca-\
e3166cac7636"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"V", ",", "Data"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", 
   RowBox[{"FringeHeight", "[", 
    RowBox[{"100", ",", "150", ",", "780"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"{", 
    RowBox[{"V", ",", 
     RowBox[{"{", 
      RowBox[{
      "100", ",", "20", ",", "200", ",", "100", ",", "80", ",", "22"}], 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PlotTrack", "[", 
  RowBox[{"Data", ",", "0", ",", "100"}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.940943183130048*^9, 3.9409431843735027`*^9}, {
  3.940943223401533*^9, 3.940943436536091*^9}, {3.9409442434730186`*^9, 
  3.940944243622875*^9}, {3.940944721852869*^9, 3.940944777992955*^9}, {
  3.940946973929025*^9, 3.9409469861565228`*^9}, {3.940947046178444*^9, 
  3.9409470901989136`*^9}, {3.940947234547085*^9, 3.940947236781948*^9}, {
  3.9409473739512253`*^9, 3.940947379165195*^9}, {3.940947638258646*^9, 
  3.9409476384154854`*^9}, {3.9409476855780544`*^9, 3.940947690324936*^9}, {
  3.940947791898051*^9, 3.940947798288733*^9}, {3.94094796888686*^9, 
  3.9409482727645817`*^9}, {3.94094830740114*^9, 3.94094841671735*^9}, {
  3.940948453116138*^9, 3.940948535018923*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"2c789a2e-bb92-eb4b-b9af-5c055befdc55"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"22.655716251849466`", "\[InvisibleSpace]", "\<\" mm\"\>"}],
  SequenceForm[22.655716251849466`, " mm"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.940943224236784*^9, 3.9409434372084*^9}, 
   3.940944244453554*^9, {3.940944735714773*^9, 3.9409447787088203`*^9}, {
   3.940946966634472*^9, 3.940946986783897*^9}, {3.9409470496690235`*^9, 
   3.940947090673977*^9}, 3.940947238036843*^9, {3.94094727819236*^9, 
   3.940947288572359*^9}, {3.940947350201094*^9, 3.940947379657032*^9}, {
   3.940947420299282*^9, 3.9409474456369495`*^9}, 3.940947507295908*^9, {
   3.9409476033028336`*^9, 3.940947639358801*^9}, 3.940947686446297*^9, 
   3.94094779908498*^9, {3.940947971247177*^9, 3.940948078357577*^9}, {
   3.940948108399589*^9, 3.940948200211321*^9}, {3.9409482302900333`*^9, 
   3.9409482734519024`*^9}, {3.9409483084082947`*^9, 
   3.9409484172075005`*^9}, {3.9409484555373*^9, 3.940948535738844*^9}, 
   3.9410293111220284`*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"92092343-5d90-234b-b87d-859b3af12111"],

Cell[BoxData[
 RowBox[{"{", 
  GraphicsBox[{{}, {{{}, {}, 
      TagBox[
       TagBox[
        {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[2], 
         Opacity[1.], LineBox[CompressedData["
1:eJwVVGk41QkfvfYlTJoUTckUUqMppIj4ue5+/5ZE2V2ue3HJvi9ZblEoS9IM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          "]], LineBox[CompressedData["
1:eJwVVHk0lYsX9UrJayKkjCUVougppcF+eSEV9/u+i0+ZrvtcUxfX7D6zMpQQ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          "]]},
        Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
       Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, 
    GeometricTransformationBox[{{{}, {}, 
       TagBox[
        TagBox[
         {RGBColor[1, 0, 0], AbsoluteThickness[2], Opacity[1.], 
          LineBox[CompressedData["
1:eJwVVWk0lQsbdU7HlHkemhCZUkQlDefBcebkdiPk0iVTlDkVRakMSSpNCk0k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           "]], LineBox[CompressedData["
1:eJwVjnk4lIsDhWWdss5kb2wjGqUsTVr5Tqlo41sGn0i7RPZWl1IhUqhbRKFF
aXURaROt2pTUTQtCElFXaGay/vr9cZ7zz/uc95itCaXXy8vJycX9yf+7N/LO
J41DJDbP7UoVDgpR4FadQh8m8T0hjfuoQQjj636znI+QWBCx6QSnWIhUs+4v
U9NJyE8WD3xOECKsj+eok0Vi+rG99ay9EPZZbGfdKRLxu0NdOlIn4NqXzy4r
ikhIVbgv6bWWsHTf0rvsKglZXmhHHWGJjOvKuU6lJFAUW/Wcb4ntyVYSkxsk
zsQqnB+qs8Asu9C8lkoSb2d2nFzAWKA8ul8uoIZE0aqG9Caf8ZD809a9p5aE
47dvp0bPGQ/bz7VN2W9IBLuoXTjKH4+8RZcqX78jwQqZ5JeN5tiv6xtLNJMw
mP9N+/gGc3gWlo/o9pC4VbPllShJgLTPF/6z6yNReGp59PMQAZ7opn9aKiEx
zOMNFIgFmBMTUrGnn4Tv+5tJ7mYCCBab7PohT0G0uGCoodwM/32OHX44lsIv
fyVDRwUzCPWCfzTpUDB5r5s/0GWKNYu9Gwf0KBxYOiDoe2uKt4V2d+z4FJ4t
3bch9ZIpbse0xGSPpxDjMTHby8sUiXrzhzZPo7BNLuj9SJgJzJaoDJp7UWii
42O+zDCC6F/nWkNvChIH+WOzDY2wcGXsea7Pn72fYU9eDfARGPlbPOJH4c6j
H8ytCj5Kjnde+eBP4fHwh67gxXws7Hq58tBWCt1+q8yKA8ch8OCx+8NHKXx0
vjXiWmuAaL1/M39lUMifZyQT3zRAyiluWFcmhWus9YyDpw1wtXQ//0M2hQqv
kvzYSAMMNkRvKT1Lof5qtru/ngFSp6yesKmUQqUtufmpvz5KXlolv39DQTOD
3WFrpoc087tn+99SWN6kb7lcTQ9B29jKce8pbCxZP+eCVBcCk32/VjRQ2G4e
pHPthS5SQ1pXtnyhQCvvf7Nrpy4C1XNFnRIKOQ6C/D2tOjBdot04qE+j4KCr
aLBKG4M5l2RG42j8kHQeEZZpo65n3ljCiMZFzmqTsHPaSMkKd91tRmPr5aWX
3eO1MdDxolhpIo3eIfcri+Zr421i0j6N2TQsPGWqfY/G4sCjYVvTFTRcfTeq
ZjfwgPA2O6OVNBbK6MjzNTz0jXthb7iaxhkT+6yH93nwDc8Waa+nYadU8bfo
Ig+T+XNmcIJpfO+QMc3beHgRvoPojqZxuvzmJFaXBy2jvmWVJ2iscB3WaPTj
4kHVR7fyHBo6Z0VlzQwX2yPuu988SWN0ZsvsXlcumqoOUyV5NN4FzIwgpnJR
FGHncf4yjaldvEc7OFzQj0N8027TkN/gE76qVAt/R3YErqqnUWUR1SPW14Lh
wqhwppHGhSeG83Q0tXBaX3X7wiYap1TvWjcpaaG43DreupUG/3av9qSvmqhR
CcuVdf75d0PULsvRhMYJyeu0ARreE32fe/E0kfhAwfGuIYP2HEVzqGhAK+OI
cwmfwbYncdWWUnVkbLRYnG/MwNW5tcj4qzrOabh4HRQw2ECZ3JxbpY6H7P5w
74kMeh8ztVSiOuS/a537OZNB/pUW4V51dUTrGGsKvBlYOWXuijFXQ3XR6OWE
D4PuN3GThNpqMHb7lee7goHPE4+4z4pqqEh4PitjNYO8ILea5DZVyMui/NUC
GcRXtnzNvaiKfR/qyiVRDJZoh8ZWTFPF4dxDm56dYNDStSrW3msMLlgpPd3c
xGB5yF8c+3sc1PLnDgS3MPiec6WIX8bBoGaM9YZWBuutKudxL3PgJulL8W5n
ENiT/lUvnYO+e62MUzcDtXc5LzIDOYDvgwYVOTEGt276uU6Hg3cpe39mmYjB
nVLYcz9cBcp9owzu+omxJ05kDGdlyAqPpbSuEsMivr43aaYyOoNtFDlrxVgy
vdWp3kYZNV99/3PbIEbbNKXRWXxlZH0se1gfKkZKuafjDokSptwPjpDFimHZ
KGy+fUkJnoffP7M5I8b68Q0JPL4S8m2LduZ8FcP/3NMeCVcRITo/f5d1iPEp
9Xy1wxhFiPptt7zqFGOB48XT0fKKqLxfGKTYLUaAaoKJYa8C3nkWsoEyMTSO
d5w9/kYBnJh/7B1GeyCxLpJ79ZgCAp5caaue6AFSYvNY2UIBVmsuug0Fe8Al
U5ntXyqPj4tuFHt0euChNKGkt10OtWeiJhORnrjBOOe8cBohZFepOYIeT3CG
TlSNsR4iRq5HlCaEeKFhzvLB9rUDxBLbhQuif3lBdeh7kKDwN1G1wmZjUCSL
jiiTrssuMoK3NuBW9hYWNj2Xx5bPlRF+AafUa7axSHevMquZLSMkEWOLRdEs
UoSWHcM2MmJ8orR/KI5FcklGx059GRFbXHEgLZ3FhVK3JuVvUmKWCllYeoOF
fN21OGGqlEhQS5Jvv8Ui1ZTedyhJSrzi3hMb3mEhjvG2HdorJQL4ot8777EY
ZW8ZUr9dSmTY6c9zfcZitjB03c01UqLPp+n1h/o//LYZuT0OUgKrDSzVP7HY
RP41Md5OSiT709uJZhaI+OhkaC0lBOEP+Hlf/vjXfRxYYiYlqITz64N/sNDR
PXi0WlVKnEhuLsvtZvEtc/WMzcpSoj3NcExtD4vGgmWeRqOkROzxAwUOUhYO
WxMHt0okxPOTD+U2/mZxzGDj7gk/JYTeuWH6+AALP+v4qA+dEmLNpelnq4dY
lGRZtaW2SYiCwjDpyAgLXkvePZdmCfE/0ka8vw==
           "]]},
         Annotation[#, {{Callout}, Charting`Private`Tag, {}}]& ],
        Annotation[#, "Charting`Private`Tag#1"]& ], {}}, {{}, {}}}, {{{1., 
      0.}, {0., 50.366300366300365`}}, {0., 2.176190476190527}}], {
     GraphicsGroupBox[{
       {EdgeForm[{RGBColor[
        0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
        AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
         NCache[
          Rational[2, 3], 0.6666666666666666]]}], 
        PolygonBox[{
         Offset[{0.13586323096605002`, 2.9969219513479937`}, {
           7.361280779958484, -48.142235898464776`}], 
          Offset[{3.922815103118364, 7.991791870261317}, {7.4793387417777035`,
            10.612394109655114`}], 
          Offset[{31.3623019492428, 7.9917918702613235`}, {
           7.4793387417777035`, 10.612394109655114`}], 
          Offset[{31.3623019492428, 21.991791870261324`}, {
           7.4793387417777035`, 10.612394109655114`}], 
          Offset[{-30.6376980507572, 21.99179187026131}, {7.4793387417777035`,
            10.612394109655114`}], 
          Offset[{-30.6376980507572, 7.991791870261309}, {7.4793387417777035`,
            10.612394109655114`}], 
          Offset[{-3.536544829678665, 7.9917918702613155`}, {
           7.4793387417777035`, 10.612394109655114`}]}]}, {}, InsetBox[
        StyleBox[
         RotationBox["\<\"Image Plane\"\>",
          BoxRotation->0.],
         StripOnInput->False,
         LineOpacity->1,
         FrontFaceOpacity->1,
         BackFaceOpacity->1,
         Opacity->1,
         FontOpacity->1], 
        Offset[{0.3623019492428, 14.991791870261316}, \
{7.4793387417777035, 10.612394109655114}], NCache[
        ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
         ImageScaled[{0.5, 0.5}]]]}], 
     GeometricTransformationBox[GraphicsGroupBox[{
        {EdgeForm[{RGBColor[
         0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
         AbsoluteThickness[1.25]}], FaceForm[{GrayLevel[1], Opacity[
          NCache[
           Rational[2, 3], 0.6666666666666666]]}], 
         PolygonBox[{
          Offset[{0.3737437100685289, 2.976628233284132}, {
            27.15236108942809, -1.5687193978074778`}], 
           Offset[{4.250348738762818, 7.937675288757685}, {
            27.479338741777696`, -0.40217292564626095`}], 
           Offset[{31.723333019027482`, 7.937675288757691}, {
            27.479338741777696`, -0.40217292564626095`}], 
           Offset[{31.723333019027482`, 21.937675288757692`}, {
            27.479338741777696`, -0.40217292564626095`}], 
           Offset[{-24.276666980972518`, 21.937675288757678`}, {
            27.479338741777696`, -0.40217292564626095`}], 
           Offset[{-24.276666980972518`, 7.937675288757679}, {
            27.479338741777696`, -0.40217292564626095`}], 
           Offset[{-3.1853409476477688`, 7.937675288757683}, {
            27.479338741777696`, -0.40217292564626095`}]}]}, {}, InsetBox[
         StyleBox[
          RotationBox["\<\"Image Size\"\>",
           BoxRotation->0.],
          StripOnInput->False,
          LineOpacity->1,
          FrontFaceOpacity->1,
          BackFaceOpacity->1,
          Opacity->1,
          FontOpacity->1], 
         Offset[{3.7233330190274816, 14.937675288757685}, \
{27.479338741777696, -0.40217292564626095}], NCache[
         ImageScaled[{Rational[1, 2], Rational[1, 2]}], 
          ImageScaled[{0.5, 0.5}]]]}], {{{1., 0.}, {0., 
       50.366300366300365`}}, {0., 2.176190476190527}}]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   CoordinatesToolOptions:>{"CopiedValueFunction" -> (If[
       FreeQ[#, Rule], 
       Apply[{{{Bottom, 1}, {Right, 1}} -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )[{
           0. + 1. #, -0.04320727272727272 + 0.019854545454545455` #2}], {{
           Bottom, 1}, {Left, 1}} -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}& ][#], #]& ), 
     "DisplayFunction" -> Apply[Grid[{{
          Subscript[
           Style["\[RightArrow]", 20], 
           Style[1, 
            RGBColor[1, 0, 0]]], ": ", 
          ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )[{
           0. + 1. #, -0.04320727272727272 + 0.019854545454545455` #2}]}, {
          Subscript[
           Style["\[LeftArrow]", 20], 
           Style[1, 
            GrayLevel[0]]], ": ", 
          ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )[{0. + 1. #, 0. + 1. #2}]}}, 
        Dividers -> {None, Center}, FrameStyle -> Opacity[0.5], 
        Spacings -> {0, 0.5}]& ]},
   DisplayFunction->Identity,
   Epilog->{{}, {}},
   Frame->{{True, True}, {True, True}},
   FrameLabel->{{None, None}, {None, None}},
   FrameStyle->{{None, 
      RGBColor[1, 0, 0]}, {None, None}},
   FrameTicks->FrontEndValueCache[{{ResourceFunction["CombinePlots"][
        "CustomTicks"[True]][
        SlotSequence[1]]& , ResourceFunction["CombinePlots"][
        "TransformedTicks"[{-14.013024860737032`, 
         14.825589909339566`}, {-703.6080287001251, 748.8863049575788}, 
         "CustomTicks"[True]]][
        SlotSequence[1]]& }, {ResourceFunction["CombinePlots"][
        "CustomTicks"[True]][
        SlotSequence[1]]& , ResourceFunction["CombinePlots"][
        "CustomTicks"[False]][
        SlotSequence[1]]& }}, {{{{-500., 
         FormBox[
         "\"\\!\\(\\*FormBox[RowBox[{\\\"-\\\", \\\"500\\\"}], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {-250., 
         FormBox[
         "\"\\!\\(\\*FormBox[RowBox[{\\\"-\\\", \\\"250\\\"}], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {0., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {250., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"250\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {500., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"500\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {-700., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-650., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-600., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-550., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-450., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-400., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-350., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-300., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-200., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-150., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-100., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-50., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        50., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        100., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        150., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        200., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        300., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        350., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        400., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        450., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        550., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        600., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        650., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        700., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}}, {{-501.4868131868132, 
         FormBox[
         "\"\\!\\(\\*FormBox[RowBox[{\\\"-\\\", \\\"10\\\"}], \
TraditionalForm]\\)\"", TraditionalForm], {0.01, 0.}}, {-249.65531135531137`, 
         FormBox[
         "\"\\!\\(\\*FormBox[RowBox[{\\\"-\\\", \\\"5\\\"}], TraditionalForm]\
\\)\"", TraditionalForm], {0.01, 0.}}, {2.1761904761904756`, 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {254.0076923076923, 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"5\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {505.83919413919415`, 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"10\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {-702.9520146520146, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-652.5857142857142, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-602.2194139194138, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-551.8531135531135, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-451.12051282051283`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-400.75421245421245`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-350.38791208791207`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-300.0216117216117, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-199.289010989011, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-148.9227106227106, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-98.55641025641026, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}, {-48.19010989010989, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        52.54249084249084, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        102.9087912087912, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        153.27509157509155`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        203.64139194139193`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        304.37399267399263`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        354.740293040293, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        405.1065934065934, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        455.47289377289377`, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        556.2054945054946, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        606.5717948717949, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        656.9380952380952, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        707.3043956043956, 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 
         0.}}}}, {{{0., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"0\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {20., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"20\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {40., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"40\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {60., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"60\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {80., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"80\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {100., 
         FormBox[
         "\"\\!\\(\\*FormBox[\\\"100\\\", TraditionalForm]\\)\"", 
          TraditionalForm], {0.01, 0.}}, {5., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        10., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        15., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        25., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        30., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        35., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        45., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        50., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        55., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        65., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        70., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        75., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        85., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        90., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        95., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}, {{
        0., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {20., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {40., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {60., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {80., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {100., 
         FormBox[
          TemplateBox[{0}, "Spacer1"], TraditionalForm], {0.01, 0.}}, {5., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        10., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        15., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        25., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        30., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        35., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        45., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        50., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        55., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        65., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        70., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        75., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        85., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        90., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}, {
        95., 
         FormBox[
          TemplateBox[{0, 0}, "Spacer2"], TraditionalForm], {0.005, 0.}}}}}],
   FrameTicksStyle->{{None, None}, {None, None}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   ImagePadding->{{52.04882621765137, 40.925779819488525`}, {28.34375, 1.}},
   ImageSize->"Medium",
   Method->{
    "DefaultBoundaryStyle" -> Automatic, 
     "DefaultGraphicsInteraction" -> {
      "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
       "Effects" -> {
        "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
         "Droplines" -> {
          "freeformCursorMode" -> True, 
           "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
     "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{-2.0833333333333335`, 
    102.08333333333333`}, {-703.6080287001251, 748.8863049575788}},
   PlotRangeClipping->False,
   PlotRangePadding->None,
   Prolog->{{}, {}},
   Ticks->{Automatic, Automatic}], "}"}]], "Output",
 CellChangeTimes->{{3.9409432276357594`*^9, 3.940943437453209*^9}, 
   3.940944244693241*^9, {3.940944737375254*^9, 3.9409447789227977`*^9}, {
   3.940946966876011*^9, 3.940946986786899*^9}, {3.940947049673035*^9, 
   3.940947090676976*^9}, 3.940947238041468*^9, {3.940947278205452*^9, 
   3.940947288577368*^9}, {3.9409473502041435`*^9, 3.940947379661236*^9}, {
   3.9409474203032837`*^9, 3.940947445652968*^9}, 3.9409475072999096`*^9, {
   3.940947603306351*^9, 3.9409476393627357`*^9}, 3.94094768668632*^9, 
   3.9409477991068745`*^9, {3.9409479713444576`*^9, 3.940948078559767*^9}, {
   3.940948108595501*^9, 3.940948200415186*^9}, {3.9409482304961033`*^9, 
   3.940948273654316*^9}, {3.9409483086074295`*^9, 3.940948417415415*^9}, {
   3.940948455762997*^9, 3.940948535969452*^9}, 3.9410293131459866`*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"895e6de5-1402-ae49-9155-d16fc5ab5499"]
}, Open  ]]
}, Open  ]],

Cell["f = 100 ,", "Subsubsection",
 CellChangeTimes->{{3.9409431867237587`*^9, 
  3.940943193112982*^9}},ExpressionUUID->"e51b237d-2430-8342-8d4e-\
7db4227630f2"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1428, 825.75},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"14.0 for Microsoft Windows (64-bit) (December 12, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"8b463d3b-1b8c-4623-ab24-b89d2bd5eea4"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 159, 3, 136, "Chapter",ExpressionUUID->"49b7a2a3-31ae-a847-952e-7a54602de5ae"],
Cell[742, 27, 389, 6, 171, "Input",ExpressionUUID->"94d0ae31-7e0e-b546-8ad5-6082cf2a0823"],
Cell[CellGroupData[{
Cell[1156, 37, 165, 3, 107, "Subsection",ExpressionUUID->"d0873a22-6a31-bb41-8f74-55162f8575c1"],
Cell[1324, 42, 11309, 225, 2282, "Input",ExpressionUUID->"b1a920e6-41a0-4653-8f38-866faed145d1"]
}, Closed]],
Cell[CellGroupData[{
Cell[12670, 272, 156, 3, 71, "Subsection",ExpressionUUID->"2974aa56-2387-274c-801b-2f6091763d78"],
Cell[12829, 277, 3295, 86, 915, "Input",ExpressionUUID->"5050bf6b-da81-fb40-8429-67c560ee19b7"]
}, Closed]],
Cell[CellGroupData[{
Cell[16161, 368, 156, 3, 71, "Subsection",ExpressionUUID->"fb0bdda2-b75d-554a-b0e1-98024afd388d"],
Cell[16320, 373, 6641, 185, 1802, "Input",ExpressionUUID->"0e4bff7f-536c-254d-ad7d-654b76caf7b2"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23010, 564, 154, 3, 136, "Chapter",ExpressionUUID->"6d3c128e-6c1c-7449-8ba2-9aabecee55a4"],
Cell[CellGroupData[{
Cell[23189, 571, 212, 4, 134, "Section",ExpressionUUID->"80f6f11b-bf74-b745-9ea7-191353ed1eb3"],
Cell[CellGroupData[{
Cell[23426, 579, 627, 17, 209, "Input",ExpressionUUID->"53e0791d-82a3-4d0c-b675-78e47eea0364"],
Cell[CellGroupData[{
Cell[24078, 600, 345, 8, 44, "Print",ExpressionUUID->"9dc6d8d2-e57e-2947-bc92-beb38abb7671"],
Cell[24426, 610, 412, 9, 44, "Print",ExpressionUUID->"fa5849d9-5bbf-1e4e-92c6-8039958ed7ed"],
Cell[24841, 621, 341, 8, 44, "Print",ExpressionUUID->"91b0fc5e-d553-8e43-a759-27b02296b819"],
Cell[25185, 631, 382, 9, 44, "Print",ExpressionUUID->"3025dbc9-1230-7b4e-9919-af6cb96ff204"],
Cell[25570, 642, 380, 9, 44, "Print",ExpressionUUID->"b3c27ca9-d116-fa49-8117-4d7c0bf194f7"],
Cell[25953, 653, 412, 9, 44, "Print",ExpressionUUID->"bbbf560e-ebf3-0043-b1bb-d38bc3f83896"],
Cell[26368, 664, 378, 9, 44, "Print",ExpressionUUID->"d88ee3a3-2066-8a44-9f74-8dbe4a2dcc51"],
Cell[26749, 675, 414, 9, 44, "Print",ExpressionUUID->"2fb1cdab-066a-7947-9af4-4d6d18e865f8"]
}, Open  ]]
}, Open  ]],
Cell[27190, 688, 2154, 54, 305, "Input",ExpressionUUID->"5bcb484c-3eb6-4552-aa42-f5989cd40979"],
Cell[CellGroupData[{
Cell[29369, 746, 824, 15, 95, "Input",ExpressionUUID->"d64db146-2381-45a9-89ad-cbbdb9812174"],
Cell[30196, 763, 552, 10, 68, "Output",ExpressionUUID->"06c27c28-0035-7c4b-8a51-b82dd0def797"],
Cell[30751, 775, 566, 11, 68, "Output",ExpressionUUID->"29ff8833-9890-d244-b6cc-74bc4342894c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31354, 791, 709, 18, 202, "Input",ExpressionUUID->"11bca0e4-5e91-49a4-aada-fd17b7a9d947"],
Cell[32066, 811, 529, 13, 54, "Message",ExpressionUUID->"0dfb409f-83ee-f644-9978-d5267c523978"],
Cell[32598, 826, 287, 6, 64, "Output",ExpressionUUID->"49cdaf63-337d-aa49-bae1-5703be667bae"],
Cell[32888, 834, 252, 5, 64, "Output",ExpressionUUID->"37fa5998-7c32-f848-bef2-75342f735e77"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[33189, 845, 166, 3, 102, "Section",ExpressionUUID->"7b34875f-b1d7-a447-aa78-14e87ec3c519"],
Cell[CellGroupData[{
Cell[33380, 852, 160, 3, 107, "Subsection",ExpressionUUID->"f2503128-8ddd-6249-b8e4-fd5e41355f86"],
Cell[CellGroupData[{
Cell[33565, 859, 7016, 191, 1199, "Input",ExpressionUUID->"2db6999e-cc3b-480b-ad78-c4255b6ab7ae"],
Cell[CellGroupData[{
Cell[40606, 1054, 431, 11, 49, "Print",ExpressionUUID->"28fd5a7c-7f8f-c34d-a406-9b8242ea3204"],
Cell[41040, 1067, 338, 8, 44, "Print",ExpressionUUID->"23aaf81c-02c9-1641-8fff-4033cace41e2"]
}, Open  ]],
Cell[41393, 1078, 162, 3, 64, "Output",ExpressionUUID->"4d903836-18ae-3644-aeba-3d54ef96546c"],
Cell[CellGroupData[{
Cell[41580, 1085, 489, 12, 49, "Print",ExpressionUUID->"67fb04f4-6e33-0d4b-9f94-9f308a683059"],
Cell[42072, 1099, 366, 9, 44, "Print",ExpressionUUID->"eebeee02-22cd-a449-920b-7aa66e9a9e45"],
Cell[42441, 1110, 344, 8, 44, "Print",ExpressionUUID->"61bceea0-a418-2248-b00f-2ba83c39abd7"]
}, Open  ]],
Cell[42800, 1121, 164, 3, 64, "Output",ExpressionUUID->"16fc79c6-32ac-9b42-8c0e-6c1748097706"],
Cell[CellGroupData[{
Cell[42989, 1128, 489, 12, 49, "Print",ExpressionUUID->"0230ef35-988e-0142-a77d-9693c358216e"],
Cell[43481, 1142, 366, 9, 44, "Print",ExpressionUUID->"c2a390d5-d896-6345-aa28-79f7130fc570"],
Cell[43850, 1153, 344, 8, 44, "Print",ExpressionUUID->"b17eeccc-25ed-a142-8d60-f295f161ce34"]
}, Open  ]],
Cell[44209, 1164, 162, 3, 64, "Output",ExpressionUUID->"fa808d37-f82b-824b-896d-9a5ac4844f6e"],
Cell[CellGroupData[{
Cell[44396, 1171, 487, 12, 49, "Print",ExpressionUUID->"5ee041c1-f0e3-024b-aaa5-4086aeaa1943"],
Cell[44886, 1185, 366, 9, 44, "Print",ExpressionUUID->"6ebb9534-3715-e542-9766-7a29ccba94ec"],
Cell[45255, 1196, 346, 8, 44, "Print",ExpressionUUID->"bddfac44-9880-4d4b-be08-f2270c64f49e"]
}, Open  ]],
Cell[45616, 1207, 162, 3, 64, "Output",ExpressionUUID->"13aa3ee8-2850-1344-97cb-e5a7767978a6"],
Cell[CellGroupData[{
Cell[45803, 1214, 489, 12, 49, "Print",ExpressionUUID->"07443348-3fd8-3240-aecf-8b6c1820c514"],
Cell[46295, 1228, 368, 9, 44, "Print",ExpressionUUID->"162f3e33-8900-e941-a516-27c7e9343473"],
Cell[46666, 1239, 346, 8, 44, "Print",ExpressionUUID->"c06c5393-6b53-8840-8d44-6eada31d14f9"]
}, Open  ]],
Cell[47027, 1250, 161, 3, 64, "Output",ExpressionUUID->"d9f4cd6c-d25a-dc44-8110-c583cddfefe4"],
Cell[CellGroupData[{
Cell[47213, 1257, 487, 12, 49, "Print",ExpressionUUID->"b8f2a631-7472-7947-b3b3-ef6ff52773ff"],
Cell[47703, 1271, 366, 9, 44, "Print",ExpressionUUID->"d80dafec-ab09-8043-a56d-be3e2c4b8a79"],
Cell[48072, 1282, 344, 8, 44, "Print",ExpressionUUID->"47a0db45-bb19-8f48-a4c6-a98a16020a62"]
}, Open  ]],
Cell[48431, 1293, 162, 3, 64, "Output",ExpressionUUID->"a8e65990-b604-4045-9664-44036c79bc52"],
Cell[CellGroupData[{
Cell[48618, 1300, 487, 12, 49, "Print",ExpressionUUID->"14023cf1-6b57-a24c-a957-104f835299c6"],
Cell[49108, 1314, 368, 9, 44, "Print",ExpressionUUID->"666efe08-b946-1d4f-84dc-1f6e17386992"],
Cell[49479, 1325, 344, 8, 44, "Print",ExpressionUUID->"5e76dea5-89c5-8143-9a81-fdadf623a6b3"]
}, Open  ]],
Cell[49838, 1336, 164, 3, 64, "Output",ExpressionUUID->"7c78ec65-40ee-7e46-aec7-0aac2845a74f"],
Cell[CellGroupData[{
Cell[50027, 1343, 489, 12, 49, "Print",ExpressionUUID->"19c84bbf-3c03-2149-bc57-76c5ae3e47cc"],
Cell[50519, 1357, 366, 9, 44, "Print",ExpressionUUID->"efea75f2-cd3c-2646-951b-fe28a06e46ba"],
Cell[50888, 1368, 346, 8, 44, "Print",ExpressionUUID->"9d64d292-2cfb-6443-b4e8-a5996b839864"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[51295, 1383, 163, 3, 71, "Subsection",ExpressionUUID->"9fc6f7c8-8a3a-e645-96c1-2b9d8a942df1"],
Cell[CellGroupData[{
Cell[51483, 1390, 4855, 135, 856, "Input",ExpressionUUID->"2b2f3ace-a947-6b4d-9bb5-3ad77807d95f"],
Cell[CellGroupData[{
Cell[56363, 1529, 578, 14, 49, "Print",ExpressionUUID->"4c6a26b7-42fe-0248-bfec-0042bba6b60d"],
Cell[56944, 1545, 487, 11, 44, "Print",ExpressionUUID->"d8bcc708-95ef-4e4e-bb90-03d59c6210a6"]
}, Open  ]],
Cell[57446, 1559, 308, 6, 64, "Output",ExpressionUUID->"8b309280-91c5-1c4a-9539-a0845067a1de"],
Cell[CellGroupData[{
Cell[57779, 1569, 636, 15, 49, "Print",ExpressionUUID->"b2ccbdb0-8521-3f47-ab44-890d9130b5d7"],
Cell[58418, 1586, 515, 12, 44, "Print",ExpressionUUID->"8887e6bb-f798-ca45-9a37-69ecb95b586c"],
Cell[58936, 1600, 495, 11, 44, "Print",ExpressionUUID->"559c3d58-9520-ea40-a326-76ef15e54df0"]
}, Open  ]],
Cell[59446, 1614, 306, 6, 64, "Output",ExpressionUUID->"58037777-cce8-464f-aa9d-c8dd58d8a210"],
Cell[CellGroupData[{
Cell[59777, 1624, 634, 15, 49, "Print",ExpressionUUID->"8d8a9e96-0768-f94d-b70f-fe2d73b53694"],
Cell[60414, 1641, 515, 12, 44, "Print",ExpressionUUID->"ccc2bc23-f1be-3d46-b8da-f9c9630ce923"],
Cell[60932, 1655, 493, 11, 44, "Print",ExpressionUUID->"61cd8fa3-b62b-344c-8f50-0a0418215d09"]
}, Open  ]],
Cell[61440, 1669, 306, 6, 64, "Output",ExpressionUUID->"2debda8b-553b-a142-a085-94382685b9f5"],
Cell[61749, 1677, 388, 9, 64, "Output",ExpressionUUID->"6d44c353-af6d-2d41-9fc5-a18555c69f58"],
Cell[CellGroupData[{
Cell[62162, 1690, 638, 15, 49, "Print",ExpressionUUID->"11cd60e7-f44e-934b-b509-97928b7fb21e"],
Cell[62803, 1707, 515, 12, 44, "Print",ExpressionUUID->"78738fb5-f6d2-1f4a-b868-00ce10b5cdf6"],
Cell[63321, 1721, 493, 11, 44, "Print",ExpressionUUID->"6a34dfeb-6c13-5e4e-8ed6-c2ebb8898d98"]
}, Open  ]],
Cell[63829, 1735, 306, 6, 64, "Output",ExpressionUUID->"404d5282-9cf9-c940-814e-261d1466a0a3"],
Cell[64138, 1743, 386, 9, 64, "Output",ExpressionUUID->"fa5fdf2a-3c4a-e94d-9acb-3d12edcad2ed"],
Cell[CellGroupData[{
Cell[64549, 1756, 638, 15, 49, "Print",ExpressionUUID->"fc49705b-6f79-cf41-bc3a-9e59385a2e51"],
Cell[65190, 1773, 517, 12, 44, "Print",ExpressionUUID->"2b8a7fe1-8ce3-6741-bf19-f85b3112f1ec"],
Cell[65710, 1787, 495, 11, 44, "Print",ExpressionUUID->"5db597d8-65d9-524f-b4c9-b1aa5a9f6eb8"]
}, Open  ]],
Cell[66220, 1801, 306, 6, 64, "Output",ExpressionUUID->"0b3577e4-cd4b-4045-88a7-3b960fa552c0"],
Cell[66529, 1809, 386, 9, 64, "Output",ExpressionUUID->"18e5276e-3aa1-7741-a55b-44f3e0637b14"],
Cell[CellGroupData[{
Cell[66940, 1822, 636, 15, 49, "Print",ExpressionUUID->"eb3f7593-312f-0c41-82da-503d0977b6d2"],
Cell[67579, 1839, 515, 12, 44, "Print",ExpressionUUID->"e7cf3681-b1c6-5d4c-acd9-35c4def86a47"],
Cell[68097, 1853, 493, 11, 44, "Print",ExpressionUUID->"80795f05-1812-e841-a514-1fdb4ca81e8e"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[68663, 1872, 184, 3, 134, "Section",ExpressionUUID->"1f3f89c4-e667-0c4b-8ffa-f68a61f97f42"],
Cell[CellGroupData[{
Cell[68872, 1879, 5517, 156, 1122, "Input",ExpressionUUID->"15c58ed4-cc32-944d-94ab-0f32bfcde788"],
Cell[CellGroupData[{
Cell[74414, 2039, 476, 12, 49, "Print",ExpressionUUID->"85b827ff-9dba-f145-9f38-76e45b2bec3b"],
Cell[74893, 2053, 387, 9, 44, "Print",ExpressionUUID->"5aacbc85-345e-8b4a-83da-cf4faaa158b0"]
}, Open  ]],
Cell[75295, 2065, 211, 4, 64, "Output",ExpressionUUID->"dcf63b49-5525-d743-99a8-a5790fd2344c"],
Cell[CellGroupData[{
Cell[75531, 2073, 559, 14, 49, "Print",ExpressionUUID->"0070606b-df4f-2743-b0a7-4f2e26cd20ce"],
Cell[76093, 2089, 431, 10, 44, "Print",ExpressionUUID->"fc7888aa-775e-974a-84a1-c32eeb4c42d9"],
Cell[76527, 2101, 393, 9, 44, "Print",ExpressionUUID->"a26c47ba-de85-6c45-a30c-a922060d478b"]
}, Open  ]],
Cell[76935, 2113, 213, 4, 64, "Output",ExpressionUUID->"4a3aa5d6-527d-e343-a5d5-208b5dcec1e8"],
Cell[CellGroupData[{
Cell[77173, 2121, 559, 14, 49, "Print",ExpressionUUID->"c35d2823-d048-8943-8c26-fc81d70645a7"],
Cell[77735, 2137, 431, 10, 44, "Print",ExpressionUUID->"55a6a103-b0cf-d44c-995a-838332bb9562"],
Cell[78169, 2149, 389, 9, 44, "Print",ExpressionUUID->"a7a0a720-6627-d748-a966-9ed207ad4849"]
}, Open  ]],
Cell[78573, 2161, 211, 4, 64, "Output",ExpressionUUID->"0570cad7-926e-d34a-8638-7a88e0fecc8c"],
Cell[CellGroupData[{
Cell[78809, 2169, 559, 14, 49, "Print",ExpressionUUID->"ba3d00ae-fff1-3441-b9c8-4625ddc447f6"],
Cell[79371, 2185, 429, 10, 44, "Print",ExpressionUUID->"18439bde-9e60-c749-b31d-062e8800e3ca"],
Cell[79803, 2197, 391, 9, 44, "Print",ExpressionUUID->"0d90bec6-e876-c941-a20f-0919a815bcb5"]
}, Open  ]],
Cell[80209, 2209, 210, 4, 64, "Output",ExpressionUUID->"65b9dd67-f1be-b34f-a661-ba9115219a8e"],
Cell[CellGroupData[{
Cell[80444, 2217, 561, 14, 49, "Print",ExpressionUUID->"2f380a9b-a4d7-b24b-8f98-a5d09a899236"],
Cell[81008, 2233, 429, 10, 44, "Print",ExpressionUUID->"e1c6f2ed-cba6-5849-ae07-23b112db522c"],
Cell[81440, 2245, 391, 9, 44, "Print",ExpressionUUID->"70a5c180-2b6f-5046-be76-914843a4b60a"]
}, Open  ]],
Cell[81846, 2257, 211, 4, 64, "Output",ExpressionUUID->"7c184888-88a1-e044-a544-e4dc2a22d0ae"],
Cell[CellGroupData[{
Cell[82082, 2265, 559, 14, 49, "Print",ExpressionUUID->"174502c3-a57c-c64d-8a65-4c6d037a98e6"],
Cell[82644, 2281, 429, 10, 44, "Print",ExpressionUUID->"888b4d7a-5b63-0740-be5b-d3c7083ee074"],
Cell[83076, 2293, 391, 9, 44, "Print",ExpressionUUID->"02a75893-8da9-5343-b504-feda6e533ea3"]
}, Open  ]],
Cell[83482, 2305, 211, 4, 64, "Output",ExpressionUUID->"b7ee0291-b9a9-1045-947d-8c3c64340ba9"],
Cell[CellGroupData[{
Cell[83718, 2313, 559, 14, 49, "Print",ExpressionUUID->"da3051aa-1383-7142-85e9-2ba940782003"],
Cell[84280, 2329, 428, 10, 44, "Print",ExpressionUUID->"b3af22a7-74f9-f34b-b817-daebb5cd0194"],
Cell[84711, 2341, 391, 9, 44, "Print",ExpressionUUID->"eb1fe897-d9c1-ef40-8a88-18de5626c744"]
}, Open  ]],
Cell[85117, 2353, 213, 4, 64, "Output",ExpressionUUID->"4fc903f9-0ff7-d245-9670-f4ecd6e67681"],
Cell[CellGroupData[{
Cell[85355, 2361, 561, 14, 49, "Print",ExpressionUUID->"443b44ed-d170-0d4b-ba35-5998e508134e"],
Cell[85919, 2377, 427, 10, 44, "Print",ExpressionUUID->"936fe6ee-6128-ae4e-946d-5ef58163208c"],
Cell[86349, 2389, 393, 9, 44, "Print",ExpressionUUID->"93633334-555e-f643-9c38-a7b482e9a719"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[86803, 2405, 210, 4, 102, "Section",ExpressionUUID->"a1cadae2-578f-5342-b46d-85b1c1ae2531"],
Cell[CellGroupData[{
Cell[87038, 2413, 1114, 24, 95, "Input",ExpressionUUID->"39e4c2e7-941f-c042-90da-263b3580fb98"],
Cell[CellGroupData[{
Cell[88177, 2441, 745, 16, 49, "Print",ExpressionUUID->"147bcbe4-f520-434c-ac88-aeb511e9aa87"],
Cell[88925, 2459, 654, 13, 44, "Print",ExpressionUUID->"d1fb32be-b66f-b744-bcdd-365daf01ce63"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[89628, 2478, 1161, 25, 95, "Input",ExpressionUUID->"e1b38662-468a-824e-a15e-838e7d090b46"],
Cell[CellGroupData[{
Cell[90814, 2507, 813, 18, 49, "Print",ExpressionUUID->"7ffc9973-662e-ec4b-9d46-084e9e1c815d"],
Cell[91630, 2527, 663, 14, 44, "Print",ExpressionUUID->"f7d060dd-7566-1d44-a27f-02bb4230c52b"],
Cell[92296, 2543, 766, 17, 49, "Print",ExpressionUUID->"bcc7283f-844b-6643-b500-03ca5d5e1e18"],
Cell[93065, 2562, 665, 14, 44, "Print",ExpressionUUID->"610bdc36-8e21-f74d-84d5-6cc8445284c8"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[93791, 2583, 247, 4, 102, "Section",ExpressionUUID->"cd6166ee-10bf-074c-80c9-811d95dfa377"],
Cell[CellGroupData[{
Cell[94063, 2591, 158, 3, 107, "Subsection",ExpressionUUID->"25c6c617-bddd-864b-8d3f-c7c46c1273ad"],
Cell[CellGroupData[{
Cell[94246, 2598, 2213, 48, 247, "Input",ExpressionUUID->"4377990e-fc65-2a41-90a1-917831cb6d14"],
Cell[CellGroupData[{
Cell[96484, 2650, 432, 11, 49, "Print",ExpressionUUID->"051ea527-772b-fc49-bacf-963d3e714e44"],
Cell[96919, 2663, 339, 8, 44, "Print",ExpressionUUID->"d856dab2-c5ee-154f-bf0f-510a027a4aa3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[97307, 2677, 631, 18, 133, "Input",ExpressionUUID->"54e232ec-759f-1443-ad4d-283047328f6e"],
Cell[CellGroupData[{
Cell[97963, 2699, 435, 11, 49, "Print",ExpressionUUID->"06a02f05-771c-d049-b94f-92cf9818b3fe"],
Cell[98401, 2712, 340, 8, 44, "Print",ExpressionUUID->"eac7eb70-887b-4d4f-b60c-b6b2b3d8df25"]
}, Open  ]]
}, Open  ]],
Cell[98768, 2724, 175, 3, 56, "Input",ExpressionUUID->"86bf5893-901b-8148-9c36-667581f91742"],
Cell[CellGroupData[{
Cell[98968, 2731, 3729, 87, 552, "Input",ExpressionUUID->"ec7e2ce5-2294-7949-b444-c7c892aa870d"],
Cell[102700, 2820, 41397, 727, 449, "Output",ExpressionUUID->"68befb49-8bc2-0543-946e-0c7ad0ff4eab"],
Cell[144100, 3549, 742, 13, 64, "Output",ExpressionUUID->"a118778e-1ef3-d048-b566-6f4d9bea15c4"],
Cell[144845, 3564, 20427, 378, 477, "Output",ExpressionUUID->"7bc3636a-1378-1341-9623-3d31177a40f7"],
Cell[165275, 3944, 722, 12, 64, "Output",ExpressionUUID->"437b5d94-4f5c-804d-963d-f34628fc1f43"],
Cell[166000, 3958, 23584, 437, 405, "Output",ExpressionUUID->"47dd44cd-ec4a-c648-b28a-cecb22d3ea7e"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[189633, 4401, 179, 3, 71, "Subsection",ExpressionUUID->"309125aa-b490-2546-b759-ee6c92e009c8"],
Cell[CellGroupData[{
Cell[189837, 4408, 1536, 38, 247, "Input",ExpressionUUID->"beeac471-b8a8-224f-996d-559bed1108e0"],
Cell[CellGroupData[{
Cell[191398, 4450, 609, 14, 49, "Print",ExpressionUUID->"336a35c5-f151-6446-ae5c-09dbc0845319"],
Cell[192010, 4466, 517, 11, 44, "Print",ExpressionUUID->"857b3d83-2e1c-da41-be75-3677b2daff4a"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[192576, 4483, 4589, 115, 666, "Input",ExpressionUUID->"9156d21a-4d5e-294d-8d4f-34f929ddbb7b"],
Cell[197168, 4600, 30839, 553, 477, "Output",ExpressionUUID->"f79c6a59-7cf3-fd40-b72c-2db628323fba"],
Cell[228010, 5155, 543, 11, 64, "Output",ExpressionUUID->"5bb5774b-ed2a-8c4a-ba8f-a419fc1e7f42"],
Cell[228556, 5168, 21001, 392, 477, "Output",ExpressionUUID->"fb1299bf-8811-064b-b3f7-e1a1e87663e6"],
Cell[249560, 5562, 541, 11, 64, "Output",ExpressionUUID->"fb0bbd7f-9437-7146-a5cf-df3beb1b51d3"],
Cell[250104, 5575, 23145, 427, 467, "Output",ExpressionUUID->"2bcfb418-6baa-ef46-8d9c-1674ca0ce645"],
Cell[273252, 6004, 23145, 427, 467, "Output",ExpressionUUID->"1856eca9-24cd-4944-851a-d9e6ba03051d"],
Cell[296400, 6433, 521, 10, 64, "Output",ExpressionUUID->"dd815c78-503d-0745-b041-2a0ceb906b19"],
Cell[296924, 6445, 29960, 598, 468, "Output",ExpressionUUID->"6af84522-0f7e-884a-9a85-678c2dd1717b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[326921, 7048, 460, 11, 95, "Input",ExpressionUUID->"0d90d5cb-fc12-924e-9ce8-90fc7f731480"],
Cell[327384, 7061, 13561, 252, 385, "Output",ExpressionUUID->"4da63560-5513-8449-8bb0-3b6503046d67"]
}, Open  ]],
Cell[CellGroupData[{
Cell[340982, 7318, 418, 10, 95, "Input",ExpressionUUID->"90a3dc1e-df9b-5c42-87c2-65c58bbbb455"],
Cell[341403, 7330, 21876, 407, 460, "Output",ExpressionUUID->"721308d6-adcf-d14d-a49c-ae897a17fac5"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[363352, 7745, 214, 4, 110, "Chapter",ExpressionUUID->"2c2f2d4e-1d29-564a-bd35-fa02febacca7"],
Cell[CellGroupData[{
Cell[363591, 7753, 201, 4, 134, "Section",ExpressionUUID->"df5b616a-f935-934c-a61a-4b9143dad348"],
Cell[CellGroupData[{
Cell[363817, 7761, 737, 18, 133, "Input",ExpressionUUID->"33faf687-c04a-554a-ac5d-91ed1ab1defd"],
Cell[CellGroupData[{
Cell[364579, 7783, 459, 11, 49, "Print",ExpressionUUID->"1db2c193-44f4-d94d-b175-5faa74de1943"],
Cell[365041, 7796, 360, 8, 44, "Print",ExpressionUUID->"36350a3f-d4ea-b840-890e-ebfcba5ab2bd"]
}, Open  ]],
Cell[365416, 7807, 227, 5, 64, "Output",ExpressionUUID->"c68b0f8b-14b4-6247-aa35-7dca4ec438b3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[365680, 7817, 533, 10, 133, "Input",ExpressionUUID->"6bbc4f6e-03f0-1b45-9488-124b87dda1dc"],
Cell[366216, 7829, 294, 6, 64, "Output",ExpressionUUID->"34a75c6b-c7a6-c249-8948-d0e181279675"],
Cell[366513, 7837, 295, 6, 64, "Output",ExpressionUUID->"2bdd6b7d-567f-3b48-92e6-3cb2d077c645"],
Cell[366811, 7845, 292, 6, 64, "Output",ExpressionUUID->"11e6048a-c078-124e-97ca-c3d70cf5301b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[367140, 7856, 277, 6, 56, "Input",ExpressionUUID->"1e950e44-6144-8441-9911-ae54242a2ba6"],
Cell[CellGroupData[{
Cell[367442, 7866, 485, 12, 49, "Print",ExpressionUUID->"fe4f41d5-5a6a-4340-94d3-a451b2989a14"],
Cell[367930, 7880, 364, 8, 44, "Print",ExpressionUUID->"b3331f0e-ec11-a04a-988c-0f4bf6f1bda7"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[368343, 7894, 717, 20, 93, "Input",ExpressionUUID->"e1505723-2ea1-bf4a-a768-1c7d8bdae6e9"],
Cell[369063, 7916, 261, 4, 72, "Output",ExpressionUUID->"c9b4dda3-11c5-bd4f-8750-a9508bb53c6a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[369361, 7925, 171, 3, 95, "Input",ExpressionUUID->"0afcb17b-7475-c44c-b9ef-8abe91374141"],
Cell[369535, 7930, 270, 7, 86, "Output",ExpressionUUID->"fdbe2ef1-7f1b-c447-b7a0-4851f197dba8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[369842, 7942, 413, 11, 133, "Input",ExpressionUUID->"06ed59e6-5481-1e48-91dc-bfe112a15ee0"],
Cell[CellGroupData[{
Cell[370280, 7957, 344, 8, 44, "Print",ExpressionUUID->"8dbb7e2c-1b7b-d249-aa6b-08ef0e900124"],
Cell[370627, 7967, 414, 9, 44, "Print",ExpressionUUID->"6233c07a-cd73-ce4d-825b-c3b8df5f2465"],
Cell[371044, 7978, 344, 8, 44, "Print",ExpressionUUID->"088a7b82-1e9a-8240-899c-0b065f5fae30"],
Cell[371391, 7988, 411, 9, 44, "Print",ExpressionUUID->"9ddffccc-9c16-4046-911a-b4c5874ea99c"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[371863, 8004, 153, 3, 102, "Section",ExpressionUUID->"19e8b363-5247-ba44-9dd6-fcdcee8a4eb3"],
Cell[372019, 8009, 156, 3, 56, "Input",ExpressionUUID->"de671ca7-1322-ce4d-a320-e5f105e4c026"],
Cell[CellGroupData[{
Cell[372200, 8016, 159, 3, 107, "Subsection",ExpressionUUID->"9cc79d4b-8aea-5e4d-95bd-5cb4abd7ac1c"],
Cell[CellGroupData[{
Cell[372384, 8023, 4945, 117, 361, "Input",ExpressionUUID->"8a1f3525-d625-6043-8dab-fbf5aa5afc0e"],
Cell[CellGroupData[{
Cell[377354, 8144, 1495, 26, 49, "Print",ExpressionUUID->"cde0b363-56c5-924e-b2e3-19c5b2d6151f"],
Cell[378852, 8172, 1405, 23, 44, "Print",ExpressionUUID->"6a4dc297-e79b-a54a-95f3-6ed0e68dc86b"]
}, Open  ]],
Cell[380272, 8198, 991, 15, 64, "Output",ExpressionUUID->"29cdd064-89b1-a049-abbf-c92b153adada"]
}, Open  ]],
Cell[CellGroupData[{
Cell[381300, 8218, 968, 24, 133, "Input",ExpressionUUID->"a90d7474-8035-b246-8a80-13fb764bde8f"],
Cell[382271, 8244, 11634, 238, 477, "Output",ExpressionUUID->"fc481bc7-a340-e442-8c31-eaa16584507c"],
Cell[393908, 8484, 11743, 240, 464, "Output",ExpressionUUID->"0670a595-e677-6d4e-ace6-25ca0e8bb0e2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[405688, 8729, 790, 22, 133, "Input",ExpressionUUID->"1f4826c7-65ab-ad46-aac0-29cb6a948a43"],
Cell[406481, 8753, 11399, 234, 469, "Output",ExpressionUUID->"53528173-ddf4-9d47-8b7d-c38591891cc4"],
Cell[417883, 8989, 24133, 447, 463, "Output",ExpressionUUID->"bf8eee12-1002-d04d-a2b8-d055c27255c1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[442053, 9441, 212, 4, 95, "Input",ExpressionUUID->"6fdeaf84-61c1-5245-b9c3-f23079657581"],
Cell[442268, 9447, 158, 3, 64, "Output",ExpressionUUID->"e3d0cc7e-ac02-7046-8341-2e7139c081f4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[442463, 9455, 785, 22, 133, "Input",ExpressionUUID->"4d1aa3e8-04ca-204c-adcd-c9fe257987f3"],
Cell[443251, 9479, 11394, 233, 473, "Output",ExpressionUUID->"8d16ee83-8ef9-5840-a76a-1ac29d5f7679"],
Cell[454648, 9714, 11372, 232, 473, "Output",ExpressionUUID->"9db9ecf5-f0a6-0e49-844d-cf8fef90dea3"]
}, Open  ]],
Cell[466035, 9949, 1525, 44, 247, "Input",ExpressionUUID->"c5fb642c-764e-0543-ab1a-68e7b2517593"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[467609, 9999, 164, 3, 102, "Section",ExpressionUUID->"9610ee42-6fda-7e48-a848-8784fc4cc3bd"],
Cell[CellGroupData[{
Cell[467798, 10006, 232, 7, 160, "Subsection",ExpressionUUID->"2d42191e-3c04-8c4e-ab03-0df70c96b660"],
Cell[CellGroupData[{
Cell[468055, 10017, 4146, 78, 437, "Input",ExpressionUUID->"c115544c-8533-6246-a076-f950f334afa7"],
Cell[472204, 10097, 1174, 17, 64, "Output",ExpressionUUID->"84e67cf1-09af-e547-befb-39934de2eb64"],
Cell[473381, 10116, 15500, 297, 478, "Output",ExpressionUUID->"c6f395bd-f6e9-d046-8144-94a3437e7345"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[488930, 10419, 1391, 19, 71, "Subsection",ExpressionUUID->"4a905e24-23f6-6643-b8e9-5a6e55c74437"],
Cell[CellGroupData[{
Cell[490346, 10442, 2067, 50, 399, "Input",ExpressionUUID->"b6380b88-b2db-ae48-a53b-891d502e0ac3"],
Cell[492416, 10494, 275, 4, 64, "Output",ExpressionUUID->"1f4fdc97-3ca3-d042-bd00-c1ab3d77eb34"],
Cell[492694, 10500, 14430, 282, 480, "Output",ExpressionUUID->"9fde0170-39d6-e34b-89b6-6b8d21117ab1"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[507173, 10788, 172, 3, 71, "Subsection",ExpressionUUID->"8131f867-070c-a041-97a3-1f5f27be866b"],
Cell[CellGroupData[{
Cell[507370, 10795, 2205, 51, 361, "Input",ExpressionUUID->"f1757b15-40aa-d84e-b044-c399d197aea0"],
Cell[509578, 10848, 11218, 230, 473, "Output",ExpressionUUID->"5f72af37-deca-c749-85a5-2d5a6d03d891"]
}, Open  ]],
Cell[CellGroupData[{
Cell[520833, 11083, 203, 4, 56, "Input",ExpressionUUID->"be86a78d-2244-594b-af25-7724a094c291"],
Cell[521039, 11089, 371, 9, 72, "Message",ExpressionUUID->"4c00383a-dd8f-0c4b-8c24-07530deb13de"],
Cell[521413, 11100, 217, 3, 64, "Output",ExpressionUUID->"5c20073b-6147-1145-8422-d00e73067969"]
}, Open  ]],
Cell[CellGroupData[{
Cell[521667, 11108, 506, 12, 133, "Input",ExpressionUUID->"d5d647cf-b447-6844-9100-fbabef2e7460"],
Cell[522176, 11122, 341, 7, 64, "Output",ExpressionUUID->"06bf874b-49ae-7840-96c4-5a09591a310e"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[522590, 11137, 157, 3, 110, "Chapter",ExpressionUUID->"4adc9176-ccff-6e4c-ad9a-b29b45135ba4"],
Cell[522750, 11142, 3434, 80, 590, "Input",ExpressionUUID->"f89b27bd-2368-4d40-adcc-ddc178a0bff2"],
Cell[CellGroupData[{
Cell[526209, 11226, 2770, 66, 628, "Input",ExpressionUUID->"37905c51-4148-3942-a3cc-63b0ab6da134"],
Cell[528982, 11294, 23880, 491, 465, "Output",ExpressionUUID->"da18500d-f059-9e48-b626-b39560e4d911"],
Cell[552865, 11787, 14840, 288, 471, "Output",ExpressionUUID->"96b7264a-b21c-2f46-9e5f-2592954002eb"],
Cell[567708, 12077, 24463, 452, 473, "Output",ExpressionUUID->"61b7448f-7165-1e4c-8795-c5b5b5e101b3"],
Cell[592174, 12531, 11361, 231, 466, "Output",ExpressionUUID->"97f66a00-fcf4-e44a-9d48-ffd49abb5957"]
}, Open  ]],
Cell[CellGroupData[{
Cell[603572, 12767, 151, 3, 56, "Input",ExpressionUUID->"48d8123e-cedc-384a-8910-b2b87e693d27"],
Cell[603726, 12772, 24367, 450, 473, "Output",ExpressionUUID->"65e80ec7-bca1-5645-b2db-cd33dbc58352"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[628142, 13228, 177, 3, 110, "Chapter",ExpressionUUID->"ea61edb6-faaa-b741-9ca7-86fe5da5e473"],
Cell[CellGroupData[{
Cell[628344, 13235, 1493, 40, 323, "Input",ExpressionUUID->"abc7998e-40b4-4043-b854-274c9c8f7c2a"],
Cell[CellGroupData[{
Cell[629862, 13279, 526, 12, 49, "Print",ExpressionUUID->"ac3ec62a-3fe8-354e-8b41-ed3e99d9eaa7"],
Cell[630391, 13293, 436, 9, 44, "Print",ExpressionUUID->"aca803de-5de4-ac4f-bf5e-fe95653cba4b"]
}, Open  ]],
Cell[630842, 13305, 261, 5, 64, "Output",ExpressionUUID->"2e0f8e7a-ee3f-8b4b-b919-f9544d167e29"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[631152, 13316, 156, 3, 110, "Chapter",ExpressionUUID->"44f37645-283a-6641-bebb-57c12be10d20"],
Cell[CellGroupData[{
Cell[631333, 13323, 162, 3, 107, "Subsection",ExpressionUUID->"7f8a02a3-1df1-d446-99ec-c8f3dc5557c3"],
Cell[631498, 13328, 20515, 454, 3825, "Input",ExpressionUUID->"0446db09-358a-ae4c-a901-e339d8f65751"],
Cell[652016, 13784, 687, 10, 56, "Input",ExpressionUUID->"1f101efc-1e84-0d48-86d2-16d2baa19aa0"],
Cell[652706, 13796, 154, 3, 56, "Input",ExpressionUUID->"0d20bbcc-b72d-3940-bdfe-000e7436ab15"]
}, Open  ]],
Cell[CellGroupData[{
Cell[652897, 13804, 157, 3, 107, "Subsection",ExpressionUUID->"f799a4df-7641-c04d-9a24-2544fd331708"],
Cell[653057, 13809, 629, 21, 93, "Input",ExpressionUUID->"cb6e08d8-4796-664e-938f-24d95e5f67c4"],
Cell[653689, 13832, 1715, 45, 663, "Input",ExpressionUUID->"8d2b93c7-c1db-5e4e-9bae-a77c755f3181"]
}, Closed]],
Cell[CellGroupData[{
Cell[655441, 13882, 160, 3, 71, "Subsection",ExpressionUUID->"b2f74721-8aa7-0a4a-a9f4-14fdfce3adc6"],
Cell[CellGroupData[{
Cell[655626, 13889, 166, 3, 89, "Subsubsection",ExpressionUUID->"b537f931-ec2a-b54f-8105-42b68aae6ca5"],
Cell[CellGroupData[{
Cell[655817, 13896, 3145, 67, 476, "Input",ExpressionUUID->"7f7052de-99a9-e644-b212-e0ae8289d009"],
Cell[658965, 13965, 347, 8, 44, "Print",ExpressionUUID->"f9a07cd7-ff3a-1544-b95b-2be8fd7ce616"],
Cell[659315, 13975, 290, 7, 75, "Output",ExpressionUUID->"a62671ad-11d2-3948-9b35-d955b261f563"]
}, Open  ]],
Cell[CellGroupData[{
Cell[659642, 13987, 2794, 75, 399, "Input",ExpressionUUID->"35b00336-4de0-2846-8274-62792a3bc77e"],
Cell[662439, 14064, 28547, 572, 435, "Output",ExpressionUUID->"4a4d2b68-8495-814b-a66d-c21a5ecf1ac2"],
Cell[690989, 14638, 24232, 447, 503, "Output",ExpressionUUID->"3cd2953f-2eb3-194a-882b-8dece1df196b"],
Cell[715224, 15087, 24664, 456, 479, "Output",ExpressionUUID->"d55d94b9-bc7c-1e44-b64d-7203510c6d6d"],
Cell[739891, 15545, 24614, 454, 486, "Output",ExpressionUUID->"edce925a-10bf-0c47-838e-c316fb5511f0"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[764554, 16005, 373, 6, 69, "Subsubsection",ExpressionUUID->"393e8d62-45b7-6b49-852a-142bed70f9e7"],
Cell[CellGroupData[{
Cell[764952, 16015, 1030, 26, 209, "Input",ExpressionUUID->"35326e73-b428-e345-bc6a-4ee05e02c38c"],
Cell[765985, 16043, 101400, 1921, 2004, "Output",ExpressionUUID->"22691d1b-de08-f447-889e-9f6dc1793257"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[867434, 17970, 218, 4, 69, "Subsubsection",ExpressionUUID->"48da975d-1325-f644-a5b7-bbd5e55810fc"],
Cell[CellGroupData[{
Cell[867677, 17978, 966, 24, 209, "Input",ExpressionUUID->"872ccae9-476c-fe4a-b3e6-95917e3298dd"],
Cell[868646, 18004, 60554, 1292, 2007, "Output",ExpressionUUID->"c32582b2-33a6-0c45-8ad6-5cd2395aec9b"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[929249, 19302, 313, 5, 69, "Subsubsection",ExpressionUUID->"a7062b32-c093-f142-b732-77a709070168"],
Cell[CellGroupData[{
Cell[929587, 19311, 788, 21, 171, "Input",ExpressionUUID->"1ca93689-4b5a-d94a-9cd3-d1326a60e5bd"],
Cell[930378, 19334, 58689, 1245, 2025, "Output",ExpressionUUID->"212169c4-6eda-d64c-be5d-26cd7116512a"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[989116, 20585, 269, 5, 69, "Subsubsection",ExpressionUUID->"c1dde6cc-cbd8-1543-9bc1-11c748ccb31d"],
Cell[CellGroupData[{
Cell[989410, 20594, 1207, 29, 247, "Input",ExpressionUUID->"3467e28e-52d1-eb48-a420-ebf9f196dee7"],
Cell[990620, 20625, 613, 11, 64, "Output",ExpressionUUID->"9b24502d-602d-9540-9eb0-315a6631ef5f"],
Cell[991236, 20638, 613, 11, 64, "Output",ExpressionUUID->"f099db0e-19aa-6445-8399-a99f9a6cd202"],
Cell[991852, 20651, 544, 8, 64, "Output",ExpressionUUID->"aa7acac6-6464-2645-9b6a-09a5a4ab9f7a"],
Cell[992399, 20661, 544, 8, 64, "Output",ExpressionUUID->"3692ec3b-5880-d741-a126-598c70f12606"],
Cell[992946, 20671, 71492, 1464, 2011, "Output",ExpressionUUID->"a3515007-87fb-4d41-9468-cc9a49f6494b"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1064487, 22141, 321, 5, 69, "Subsubsection",ExpressionUUID->"eee0b744-3d1d-c040-a856-716650512007"],
Cell[CellGroupData[{
Cell[1064833, 22150, 1100, 27, 209, "Input",ExpressionUUID->"bb529ee4-fa45-a24d-8e7c-48425e37405f"],
Cell[1065936, 22179, 376, 9, 64, "Output",ExpressionUUID->"127aad23-20cd-ff47-984b-9fecbb30e291"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1066361, 22194, 314, 5, 69, "Subsubsection",ExpressionUUID->"f4d9294e-1397-cc4f-b3ad-53aa7bd0af4a"],
Cell[CellGroupData[{
Cell[1066700, 22203, 735, 20, 171, "Input",ExpressionUUID->"4d2879b0-0838-1643-a5a4-068cdd0cf013"],
Cell[1067438, 22225, 57896, 1226, 2007, "Output",ExpressionUUID->"6f685ba2-3ea5-0249-9533-4ecb2ced7aa1"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1125383, 23457, 315, 5, 69, "Subsubsection",ExpressionUUID->"fb5168e1-e17c-ff4c-acde-2478f60df4ee"],
Cell[CellGroupData[{
Cell[1125723, 23466, 879, 22, 171, "Input",ExpressionUUID->"d055a91b-a871-594e-953b-91a56fcec901"],
Cell[1126605, 23490, 425, 9, 44, "Print",ExpressionUUID->"dbe85059-c801-cd45-b338-309429693796"],
Cell[1127033, 23501, 105042, 2008, 1996, "Output",ExpressionUUID->"a851ee92-dcc8-fd45-9539-e023f0871756"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1232112, 25514, 379, 8, 56, "Input",ExpressionUUID->"de4cd76d-dfeb-ab49-a1a9-471731d9f780"],
Cell[CellGroupData[{
Cell[1232516, 25526, 461, 10, 44, "Print",ExpressionUUID->"66af46a0-208b-6343-bed7-81ce1010a844"],
Cell[1232980, 25538, 450, 10, 44, "Print",ExpressionUUID->"a3570308-1033-d949-8c0e-b5682b405d03"]
}, Open  ]],
Cell[1233445, 25551, 264, 7, 64, "Output",ExpressionUUID->"adc910af-c95a-654d-9525-5d9d01b5b6d4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1233746, 25563, 321, 7, 56, "Input",ExpressionUUID->"44592c2b-11d4-c246-aeb5-7446c335040e"],
Cell[CellGroupData[{
Cell[1234092, 25574, 219, 4, 44, "Print",ExpressionUUID->"c94b8e62-c0ee-1340-af97-d0ce8f8234bc"],
Cell[1234314, 25580, 220, 4, 44, "Print",ExpressionUUID->"07a46770-9fd0-c04f-98b5-22e10b77f2ca"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1234607, 25592, 165, 3, 107, "Subsection",ExpressionUUID->"973aa253-d284-c542-b9bb-0f7338b63b69"],
Cell[CellGroupData[{
Cell[1234797, 25599, 299, 5, 89, "Subsubsection",ExpressionUUID->"5eecf2c9-5573-bc47-a760-52436e3cfcc3"],
Cell[CellGroupData[{
Cell[1235121, 25608, 1219, 27, 171, "Input",ExpressionUUID->"3e7feca3-9393-a84e-b63e-69e10599b7b5"],
Cell[1236343, 25637, 374, 9, 44, "Print",ExpressionUUID->"36bb08c2-78b1-8e46-b819-7b6be63131d9"],
Cell[1236720, 25648, 106949, 2050, 2024, "Output",ExpressionUUID->"75b53ff9-c9f3-484e-b22a-6aa338ac54f0"]
}, Open  ]],
Cell[1343684, 27701, 293, 7, 95, "Input",ExpressionUUID->"c604558e-6081-cf43-8a6d-8b7636e0d91d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1344014, 27713, 274, 4, 69, "Subsubsection",ExpressionUUID->"14842fc3-b8c8-664c-9fca-e3166cac7636"],
Cell[CellGroupData[{
Cell[1344313, 27721, 1403, 30, 209, "Input",ExpressionUUID->"2c789a2e-bb92-eb4b-b9af-5c055befdc55"],
Cell[1345719, 27753, 1089, 19, 44, "Print",ExpressionUUID->"92092343-5d90-234b-b87d-859b3af12111"],
Cell[1346811, 27774, 31707, 670, 424, "Output",ExpressionUUID->"895e6de5-1402-ae49-9155-d16fc5ab5499"]
}, Open  ]]
}, Open  ]],
Cell[1378545, 28448, 162, 3, 89, "Subsubsection",ExpressionUUID->"e51b237d-2430-8342-8d4e-7db4227630f2"]
}, Open  ]]
}, Open  ]]
}
]
*)

